c-----------------------------------------------------------------------------------c
	subroutine ndf_read_IDF_test(idf_file_in,idf_file_out,u_out,verbose)
c-----------------------------------------------------------------------------------c
	use IDFCOM
!DEC$ ATTRIBUTES DLLIMPORT::initialise_idf,validate_file_idf,get_nsamples_idf,read_file_idf
!DEC$ ATTRIBUTES DLLIMPORT::allocate_idf_tags,allocate_secondary_variables_idf
!DEC$ ATTRIBUTES DLLIMPORT::deallocate_idf_tags,deallocate_idf_all,deallocate_auxiliary_variables_idf
!DEC$ ATTRIBUTES DLLIMPORT::write_file_idf,get_auxiliary_variables_idf
	implicit none
	integer i,j,k,k1,u_out
	character file1*12
	character idf_file_in*(*),idf_file_out*(*)
	logical verbose
c-----------------------------------------------------------------------
      call initialise_idf
c      idf_file='xaxa.idf'
      write(*,*)'ndf validate_file_idf: ',trim(adjustl(idf_file_in))
      call validate_file_idf(idf_file_in)
      write(*,*)'ndf validate result:',idf_ok
      if (.not.idf_ok) stop 'not ok'
      write(*,*)'ndf get_nsamples_idf'
      call get_nsamples_idf(idf_file_in)
      write(*,1)trim(adjustl(idf_file_in)),idf_nsamples
1     format(' The file ',a,' has ',i3,' samples. Which one do you want to read? '$)
      read(*,*)i
      verbose=.false.
      call read_file_idf(idf_file_in,i,verbose)
      write(*,*)'back to ndf from read_file_idf ',trim(adjustl(idf_error))
      if (.not.idf_ok) stop 'not ok'

      call deallocate_auxiliary_variables_idf
      call get_auxiliary_variables_idf
      call write_file_idf(u_out,idf_file_out)
      if (.not.verbose) goto 113
      goto 112

c     112/113 continue is the output that will be shown
112   continue

      write(*,*)'usersnotes%users%n,usersnotes%notes%n',usersnotes%users%n,usersnotes%notes%n
      do i=1,usersnotes%users%n
      write(*,*)'usersnotes%user:',i,trim(adjustl(usersnotes%users%user(i)))
      end do
      do i=1,usersnotes%notes%n
      write(*,*)'usersnotes%note:',i,trim(adjustl(usersnotes%notes%note(i)))
      end do
      write(*,*)'attributes%idfversion:',trim(adjustl(attributes%idfversion))
      write(*,*)'attributes%filename:',trim(adjustl(attributes%filename))
      write(*,*)'attributes%createtime:',trim(adjustl(attributes%createtime))
      write(*,*)'attributes%updatetimes%n',attributes%updatetimes%n
      do i=1,attributes%updatetimes%n
      write(*,*)'attributes%updatetimes%updatetime:',i,trim(adjustl(attributes%updatetimes%updatetime(i)))
      end do
      write(*,*)'attributes%code:',trim(adjustl(attributes%code))
      write(*,*)'attributes%version:',trim(adjustl(attributes%version))

      write(*,*)'description ',sample%description
      do i=1,idfnelements
      write(*,*)'sample%elementsandmolecules%elements%element ',i,sample%elementsandmolecules%elements%element(i)
      end do
      do i=1,idfnmolecules
      write(*,*)'sample%elementsandmolecules%elements%element ',i,sample%elementsandmolecules%molecules%molecule(i)
      end do
      write(*,*)'nlayers_idf ',nlayers_idf
      do i=1,nlayers_idf
      write(*,*)'layerthickness ',i,sample%structure%layeredstructure%layers%layer(i)%layerthickness
      write(*,*)'layeruniformity ',i,sample%structure%layeredstructure%layers%layer(i)%layeruniformity
      write(*,*)'layerdensity ',i,sample%structure%layeredstructure%layers%layer(i)%layerdensity
      write(*,*)'nlayerelements ',sample%structure%layeredstructure%layers%layer(i)%layerelements%n
      do j=1,sample%structure%layeredstructure%layers%layer(i)%layerelements%n
      write(*,*)'layerelement ',j,sample%structure%layeredstructure%layers%layer(i)%layerelements%layerelement(j)
      end do
      write(*,*)'n ',sample%structure%layeredstructure%layers%layer(i)%layermolecules%n
      do j=1,sample%structure%layeredstructure%layers%layer(i)%layermolecules%n
      write(*,*)'layemolecule ',j,sample%structure%layeredstructure%layers%layer(i)%layermolecules%layermolecule(j)
      end do
      end do
      write(*,*)'equationoverlays ',trim(adjustl(sample%structure%layeredstructure%equationoverlays))
      write(*,*)'roughness ',trim(adjustl(sample%structure%layeredstructure%roughness))
      write(*,*)'npbp ',npbp_element_idf,npbp_idf(1:npbp_element_idf)

      do i=1,npbp_element_idf
      do j=1,npbp_idf(i)
      if (sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%n.gt.0) then
      write(*,*)'pbp',i,j,trim(adjustl(sample%structure%pointbypointstructure%pbpelement(i)%elementname)),
     +sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%n,
     +sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%ndfidf_iong
      write(*,*)'x',sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%x(1:
     +sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%n)
      write(*,*)'xerror',sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%xerror(1:
     +sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%n)
      write(*,*)'y',sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%y(1:
     +sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%n)
      write(*,*)'yerror',sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%yerror(1:
     +sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%n)
      end if
      end do
      end do

      do i=1,idfnspectra
      write(*,*)'log',trim(adjustl(sample%spectra%spectrum(i)%log%realtime)),trim(adjustl(sample%spectra%spectrum(i)%log%livetime))
     +,trim(adjustl(sample%spectra%spectrum(i)%log%deadtime)),trim(adjustl(sample%spectra%spectrum(i)%log%starttime))
     +,trim(adjustl(sample%spectra%spectrum(i)%log%stoptime))
      write(*,*)'temperature',sample%spectra%spectrum(i)%environment%temperature
      write(*,*)'pressure',sample%spectra%spectrum(i)%environment%pressure
      end do

      do i=1,idfnspectra
      write(*,*)'beamparticle',i,trim(adjustl(sample%spectra%spectrum(i)%beam%beamparticle))
      write(*,*)'beamZ',i,sample%spectra%spectrum(i)%beam%beamZ
      write(*,*)'beammass',i,sample%spectra%spectrum(i)%beam%beammass
      write(*,*)'beamenergy',i,sample%spectra%spectrum(i)%beam%beamenergy
      write(*,*)'beamenergyspread',i,sample%spectra%spectrum(i)%beam%beamenergyspread
      if (sample%spectra%spectrum(i)%beam%beamchargestate%n.gt.0) then
      write(*,*)'beamchargestate x',i,sample%spectra%spectrum(i)%beam%beamchargestate%x
      write(*,*)'beamchargestate y',i,sample%spectra%spectrum(i)%beam%beamchargestate%y
      end if
      end do
      do i=1,idfnspectra
      if (sample%spectra%spectrum(i)%beam%beamshape%shape(1:3).ne.'   ') then
      write(*,*)'beamshape shape',i,trim(adjustl(sample%spectra%spectrum(i)%beam%beamshape%shape))
      write(*,*)'beamshape l1',i,sample%spectra%spectrum(i)%beam%beamshape%l1
      write(*,*)'beamshape l2',i,sample%spectra%spectrum(i)%beam%beamshape%l2
      end if
      end do
c     spectra - beamfoil
      do i=1,idfnspectra
      if (nbeamfoillayers_idf(i).gt.0)
     +write(*,*)'beamfoil foildistancetosample',i,sample%spectra%spectrum(i)%beam%beamfoil%foildistancetosample
      do j=1,nbeamfoillayers_idf(i)
      write(*,*)'beamfoil layerthickness',i,j,sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layerthickness
      write(*,*)'beamfoil layeruniformity',i,j,sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layeruniformity
      write(*,*)'beamfoil layerdensity',i,j,sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layerdensity
      do k=1,nbeamfoilels_idf(i,j)
      write(*,*)'beamfoil beamfoilels',k,trim(adjustl(sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%
     +layerelements%layerelement(k)%name))
      write(*,*)'beamfoil beamfoilels',k,sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%
     +layerelements%layerelement(k)%concentration
      end do
      end do
      end do
c     slitsbeforesample
      do i=1,idfnspectra
      do j=1,nslitsbeforesample_idf(i)
      write(*,*)'slitsbeforesample shape',i,j,trim(adjustl(sample%spectra%spectrum(i)%beam%slitsbeforesample%slit(j)%
     +slitshape%shape))
      write(*,*)'slitsbeforesample l1',i,j,sample%spectra%spectrum(i)%beam%slitsbeforesample%slit(j)%
     +slitshape%l1
      write(*,*)'slitsbeforesample l2',i,j,sample%spectra%spectrum(i)%beam%slitsbeforesample%slit(j)%
     +slitshape%l2
      write(*,*)'slitsbeforesample l3',i,j,sample%spectra%spectrum(i)%beam%slitsbeforesample%slit(j)%
     +slitshape%l3
      write(*,*)'slitdistancetosample',i,j,sample%spectra%spectrum(i)%beam%slitsbeforesample%slit(j)%
     +slitdistancetosample
      end do
      end do
c     spectra - geometry
      do i=1,idfnspectra
      write(*,*)'geometrytype',i,sample%spectra%spectrum(i)%geometry%geometrytype
      write(*,*)'incidenceangle',i,sample%spectra%spectrum(i)%geometry%incidenceangle
      write(*,*)'scatteringangle',i,sample%spectra%spectrum(i)%geometry%scatteringangle
      write(*,*)'exitangle',i,sample%spectra%spectrum(i)%geometry%exitangle
      write(*,*)'shape',i,trim(adjustl(sample%spectra%spectrum(i)%geometry%spot%shape))
      write(*,*)'l1',i,sample%spectra%spectrum(i)%geometry%spot%l1
      write(*,*)'l2',i,sample%spectra%spectrum(i)%geometry%spot%l2
      end do

c     spectra - instrument
      do i=1,idfnspectra
      write(*,*)'ionsource',i,trim(adjustl(sample%spectra%spectrum(i)%instrument%ionsource))
      write(*,*)'accelerator',i,trim(adjustl(sample%spectra%spectrum(i)%instrument%accelerator))
      write(*,*)'beamline',i,trim(adjustl(sample%spectra%spectrum(i)%instrument%beamline))
      write(*,*)'chamber',i,trim(adjustl(sample%spectra%spectrum(i)%instrument%chamber))
      write(*,*)'sampleholder',i,trim(adjustl(sample%spectra%spectrum(i)%instrument%sampleholder))
      end do

c     slitsaftersample
      do i=1,idfnspectra
      do j=1,nslitsaftersample_idf(i)
      write(*,*)'slitsaftersample shape',i,j,trim(adjustl(sample%spectra%spectrum(i)%detection%slitsaftersample%slit(j)%
     +slitshape%shape))
      write(*,*)'slitsaftersample l1',i,j,sample%spectra%spectrum(i)%detection%slitsaftersample%slit(j)%
     +slitshape%l1
      write(*,*)'slitsaftersample l2',i,j,sample%spectra%spectrum(i)%detection%slitsaftersample%slit(j)%
     +slitshape%l2
      write(*,*)'slitsaftersample l3',i,j,sample%spectra%spectrum(i)%detection%slitsaftersample%slit(j)%
     +slitshape%l3
      write(*,*)'slitdistancetosample',i,j,sample%spectra%spectrum(i)%detection%slitsaftersample%slit(j)%
     +slitdistancetosample
      end do
      end do
c     spectra - stoppingfoil
      do i=1,idfnspectra
      if (nstoppingfoillayers_idf(i).gt.0) then
      write(*,*)'stoppingfoil foildistancetosample',i,sample%spectra%spectrum(i)%detection%stoppingfoil%foildistancetosample
      do j=1,nstoppingfoillayers_idf(i)
      write(*,*)'stoppingfoil layerthickness',i,j,sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%
     +layerthickness
      write(*,*)'stoppingfoil layeruniformity',i,j,sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%
     +layeruniformity
      write(*,*)'stoppingfoil layerdensity',i,j,sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%layerdensity
      do k=1,nstoppingfoilels_idf(i,j)
      write(*,*)'stoppingfoil stoppingfoilels',k,trim(adjustl(sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%
     +layerelements%layerelement(k)%name))
      write(*,*)'stoppingfoil stoppingfoilels',k,sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%
     +layerelements%layerelement(k)%concentration
      end do
      end do
      end if
      end do

c     detector
      do i=1,idfnspectra
      write(*,*)'detectortype',i,trim(adjustl(sample%spectra%spectrum(i)%detection%detector%detectortype))
      write(*,*)'solidangle',i,sample%spectra%spectrum(i)%detection%detector%solidangle
      write(*,*)'detectorshape',i,trim(adjustl(sample%spectra%spectrum(i)%detection%detector%detectorshape%shape))
      write(*,*)'detectorshape l1',i,sample%spectra%spectrum(i)%detection%detector%detectorshape%l1
      write(*,*)'detectorshape l2',i,sample%spectra%spectrum(i)%detection%detector%detectorshape%l2
      write(*,*)'detectorshape l3',i,sample%spectra%spectrum(i)%detection%detector%detectorshape%l3
      end do
c     detector - deadlayer
      do i=1,idfnspectra
      if (ndeadlayer_idf(i).gt.0) then
      write(*,*)'deadlayer layerthickness',i,j,sample%spectra%spectrum(i)%detection%detector%deadlayer%
     +layerthickness
      write(*,*)'deadlayer layeruniformity',i,j,sample%spectra%spectrum(i)%detection%detector%deadlayer%
     +layeruniformity
      write(*,*)'deadlayer layerdensity',i,j,sample%spectra%spectrum(i)%detection%detector%deadlayer%layerdensity
      do k=1,ndeadlayerels_idf(i)
      write(*,*)'deadlayer deadlayerels',k,trim(adjustl(sample%spectra%spectrum(i)%detection%detector%deadlayer%
     +layerelements%layerelement(k)%name))
      write(*,*)'deadlayer deadlayerels',k,sample%spectra%spectrum(i)%detection%detector%deadlayer%
     +layerelements%layerelement(k)%concentration
      end do
      end if
      end do
c     detector - entrancewindow
      do i=1,idfnspectra
      if (nentrancewindow_idf(i).gt.0) then
      do j=1,nentrancewindow_idf(i)
      write(*,*)'entrancewindow layerthickness',i,j,sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%
     +layerthickness
      write(*,*)'entrancewindow layeruniformity',i,j,sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%
     +layeruniformity
      write(*,*)'entrancewindow layerdensity',i,j,sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%layerdensity
      do k=1,nentrancewindowels_idf(i,j)
      write(*,*)'entrancewindow stoppingfoilels',k,trim(adjustl(sample%spectra%spectrum(i)%detection%detector%entrancewindow%
     +layer(j)%layerelements%layerelement(k)%name))
      write(*,*)'entrancewindow stoppingfoilels',k,sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%
     +layerelements%layerelement(k)%concentration
      end do
      end do
      end if
      end do
c     detector - detectorlayers
      do i=1,idfnspectra
      if (ndetectorlayers_idf(i).gt.0) then
      do j=1,ndetectorlayers_idf(i)
      write(*,*)'detectorlayers layerthickness',i,j,sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%
     +layerthickness
      write(*,*)'detectorlayers layeruniformity',i,j,sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%
     +layeruniformity
      write(*,*)'detectorlayers layerdensity',i,j,sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%layerdensity
      do k=1,ndetectorlayersels_idf(i,j)
      write(*,*)'detectorlayers stoppingfoilels',k,trim(adjustl(sample%spectra%spectrum(i)%detection%detector%detectorlayers%
     +layer(j)%layerelements%layerelement(k)%name))
      write(*,*)'detectorlayers stoppingfoilels',k,sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%
     +layerelements%layerelement(k)%concentration
      end do
      end do
      end if
      end do
c     detector - tof
      do i=1,idfnspectra
      write(*,*)'toflength',i,sample%spectra%spectrum(i)%detection%detector%tof%toflength
      write(*,*)'toftimeresolution',i,sample%spectra%spectrum(i)%detection%detector%tof%toftimeresolution
      end do
c     detector - startfoil
      do i=1,idfnspectra
      if (ntofstartfoil_idf(i).gt.0) then
      do j=1,ntofstartfoil_idf(i)
      write(*,*)'startfoil layerthickness',i,j,sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%
     +layerthickness
      write(*,*)'startfoil layeruniformity',i,j,sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%
     +layeruniformity
      write(*,*)'startfoil layerdensity',i,j,sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%layerdensity
      do k=1,ntofstartfoilels_idf(i,j)
      write(*,*)'startfoil stoppingfoilels',k,trim(adjustl(sample%spectra%spectrum(i)%detection%detector%tof%startfoil%
     +layer(j)%layerelements%layerelement(k)%name))
      write(*,*)'startfoil stoppingfoilels',k,sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%
     +layerelements%layerelement(k)%concentration
      end do
      end do
      end if
      end do
c     detector - stopfoil
      do i=1,idfnspectra
      if (ntofstopfoil_idf(i).gt.0) then
      do j=1,ntofstopfoil_idf(i)
      write(*,*)'stopfoil layerthickness',i,j,sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%
     +layerthickness
      write(*,*)'stopfoil layeruniformity',i,j,sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%
     +layeruniformity
      write(*,*)'stopfoil layerdensity',i,j,sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%layerdensity
      do k=1,ntofstopfoilels_idf(i,j)
      write(*,*)'stopfoil stoppingfoilels',k,trim(adjustl(sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%
     +layer(j)%layerelements%layerelement(k)%name))
      write(*,*)'stopfoil stoppingfoilels',k,sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%
     +layerelements%layerelement(k)%concentration
      end do
      end do
      end if
      end do

c     detection - electronics - amplifier
      do i=1,idfnspectra
        write(*,*)'amplifier amplifiertype',i,sample%spectra%spectrum(i)%detection%electronics%amplifier%amplifiertype
        write(*,*)'amplifier pulseshape',i,sample%spectra%spectrum(i)%detection%electronics%amplifier%pulseshape
        write(*,*)'amplifier shapingtime',i,sample%spectra%spectrum(i)%detection%electronics%amplifier%shapingtime
        write(*,*)'amplifier risetime',i,sample%spectra%spectrum(i)%detection%electronics%amplifier%risetime
        write(*,*)'amplifier flattoptime',i,sample%spectra%spectrum(i)%detection%electronics%amplifier%flattoptime
        write(*,*)'amplifier pur',i,sample%spectra%spectrum(i)%detection%electronics%amplifier%pur
        write(*,*)'amplifier purtime',i,sample%spectra%spectrum(i)%detection%electronics%amplifier%purtime
      end do

c     spectrum - calibrations - detectorefficiencies
      do i=1,idfnspectra
      do j=1,ndetectorefficiency_idf(i)
      write(*,*)'efficiencyion',i,j,
     +trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiencyion))
      write(*,*)'efficiencymode',i,j,
     +trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiencymode))
c     for energy/efficiency
      if (trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiencymode)).eq.
     +'energy') then
        write(*,*)'xaxis',trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +  efficiency%xaxis%axisname))
        write(*,*)'xaxis',trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +  efficiency%xaxis%axisunit))
        write(*,*)'xerroraxis',trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +  efficiency%xerroraxis%axisname))
        write(*,*)'xerroraxis',trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +  efficiency%xerroraxis%axisunit))
        write(*,*)'yaxis',trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +  efficiency%yaxis%axisname))
        write(*,*)'yaxis',trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +  efficiency%yaxis%axisunit))
        write(*,*)'yerroraxis',trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +  efficiency%yerroraxis%axisname))
        write(*,*)'yerroraxis',trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +  efficiency%yerroraxis%axisunit))
        write(*,*)'x',sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +  efficiency%x(1:ndetectorefficiencyentries_idf(i,j))
        write(*,*)'xerror',sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +  efficiency%xerror(1:ndetectorefficiencyentries_idf(i,j))
        write(*,*)'y',sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +  efficiency%y(1:ndetectorefficiencyentries_idf(i,j))
        write(*,*)'yerror',sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +  efficiency%yerror(1:ndetectorefficiencyentries_idf(i,j))
c     for line/efficiency
      else if (trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiencymode)).eq.
     +'line') then
        write(*,*)'xaxis',trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +  lineefficiency%xaxis%axisname))
        write(*,*)'xaxis',trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +  lineefficiency%xaxis%axisunit))
        write(*,*)'yaxis',trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +  lineefficiency%yaxis%axisname))
        write(*,*)'yaxis',trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +  lineefficiency%yaxis%axisunit))
        write(*,*)'yerroraxis',trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +  lineefficiency%yerroraxis%axisname))
        write(*,*)'yerroraxis',trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +  lineefficiency%yerroraxis%axisunit))
        write(*,*)'line',sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +  lineefficiency%line(1:ndetectorefficiencyentries_idf(i,j))
        write(*,*)'y',sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +  lineefficiency%y(1:ndetectorefficiencyentries_idf(i,j))
        write(*,*)'yerror',sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +  lineefficiency%yerror(1:ndetectorefficiencyentries_idf(i,j))
      end if
      end do
      end do

c     spectrum - calibrations - detectorresolutions
      do i=1,idfnspectra
      do j=1,ndetectorresolution_idf(i)
      write(*,*)'efficiencyion',i,j,
     +trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%resolutionion))
      do k=1,nresolutionparameter_idf(i,j)
      write(*,*)'unit',i,j,trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%
     +resolutionparameters%resolutionparameter(k)%units))
      write(*,*)'mode',i,j,trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%
     +resolutionparameters%resolutionparameter(k)%mode))
      write(*,*)'quantity',i,j,trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%
     +resolutionparameters%resolutionparameter(k)%quantity))
      write(*,*)'value',i,j,sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%
     +resolutionparameters%resolutionparameter(k)%value
      write(*,*)'uncertainty',i,j,sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%
     +resolutionparameters%resolutionparameter(k)%uncertainty
      end do
      end do
      end do

c     spectrum - calibrations - energycalibrations
      do i=1,idfnspectra
      do j=1,nenergycalibration_idf(i)
      write(*,*)'calibrationion',i,j,
     +trim(adjustl(sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%calibrationion))
      write(*,*)'calibrationmode',i,j,
     +trim(adjustl(sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%calibrationmode))
      do k=1,ncalibrationparameter_idf(i,j)
      write(*,*)'unit',i,j,trim(adjustl(sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%
     +calibrationparameters%calibrationparameter(k)%units))
      write(*,*)'mode',i,j,trim(adjustl(sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%
     +calibrationparameters%calibrationparameter(k)%mode))
      write(*,*)'quantity',i,j,trim(adjustl(sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%
     +calibrationparameters%calibrationparameter(k)%quantity))
      write(*,*)'value',i,j,sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%
     +calibrationparameters%calibrationparameter(k)%value
      write(*,*)'uncertainty',i,j,sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%
     +calibrationparameters%calibrationparameter(k)%uncertainty
      end do
      end do
      end do

c     spectrum - reactions
      do i=1,idfnspectra
      write(*,*)'technique',i,trim(adjustl(sample%spectra%spectrum(i)%reactions%technique))
      if (nreaction_idf(i).gt.0) then
      do j=1,nreaction_idf(i)
      write(*,*)'initialtargetparticle',i,j,trim(adjustl(sample%spectra%spectrum(i)%reactions%reactionlist%reaction(j)%
     +initialtargetparticle))
      write(*,*)'incidentparticle',i,j,trim(adjustl(sample%spectra%spectrum(i)%reactions%reactionlist%reaction(j)%
     +incidentparticle))
      write(*,*)'exitparticle',i,j,trim(adjustl(sample%spectra%spectrum(i)%reactions%reactionlist%reaction(j)%
     +exitparticle))
      write(*,*)'finaltargetparticle',i,j,trim(adjustl(sample%spectra%spectrum(i)%reactions%reactionlist%reaction(j)%
     +finaltargetparticle))
      write(*,*)'reactionQ value',i,j,sample%spectra%spectrum(i)%reactions%reactionlist%reaction(j)%
     +reactionQ%value
      write(*,*)'reactionQ unit',i,j,trim(adjustl(sample%spectra%spectrum(i)%reactions%reactionlist%reaction(j)%
     +reactionQ%units))
      write(*,*)'reactionQ uncertainty',i,j,sample%spectra%spectrum(i)%reactions%reactionlist%reaction(j)%
     +reactionQ%uncertainty
      end do
      end if
      end do

c     spectrum - data
      do i=1,idfnspectra
      write(*,*)'datamode',i,trim(adjustl(sample%spectra%spectrum(i)%data%datamode))
      write(*,*)'channelmode',i,trim(adjustl(sample%spectra%spectrum(i)%data%channelmode))
c     spectrum - data - simpledata
      if (trim(adjustl(sample%spectra%spectrum(i)%data%datamode)).eq.'simple') then
        write(*,*)'xaxis',trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%xaxis%axisname))
        write(*,*)'xaxis',trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%xaxis%axisunit))
        write(*,*)'xerroraxis',trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%xerroraxis%axisname))
        write(*,*)'xerroraxis',trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%xerroraxis%axisunit))
        write(*,*)'yaxis',trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%yaxis%axisname))
        write(*,*)'yaxis',trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%yaxis%axisunit))
        write(*,*)'yerroraxis',trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%yerroraxis%axisname))
        write(*,*)'yerroraxis',trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%yerroraxis%axisunit))
        write(*,*)'x',sample%spectra%spectrum(i)%data%simpledata%x(1:ndatapoints_idf(i))
        write(*,*)'xerror',sample%spectra%spectrum(i)%data%simpledata%xerror(1:ndatapoints_idf(i))
        write(*,*)'y',sample%spectra%spectrum(i)%data%simpledata%y(1:ndatapoints_idf(i))
        write(*,*)'yerror',sample%spectra%spectrum(i)%data%simpledata%yerror(1:ndatapoints_idf(i))
c     for line/efficiency
      else if (trim(adjustl(sample%spectra%spectrum(i)%data%datamode)).eq.'line') then
        write(*,*)'xaxis',trim(adjustl(sample%spectra%spectrum(i)%data%linedata%xaxis%axisname))
        write(*,*)'xaxis',trim(adjustl(sample%spectra%spectrum(i)%data%linedata%xaxis%axisunit))
        write(*,*)'yaxis',trim(adjustl(sample%spectra%spectrum(i)%data%linedata%yaxis%axisname))
        write(*,*)'yaxis',trim(adjustl(sample%spectra%spectrum(i)%data%linedata%yaxis%axisunit))
        write(*,*)'yerroraxis',trim(adjustl(sample%spectra%spectrum(i)%data%linedata%yerroraxis%axisname))
        write(*,*)'yerroraxis',trim(adjustl(sample%spectra%spectrum(i)%data%linedata%yerroraxis%axisunit))
        write(*,*)'line',sample%spectra%spectrum(i)%data%linedata%x(1:ndatapoints_idf(i))
        write(*,*)'y',sample%spectra%spectrum(i)%data%linedata%y(1:ndatapoints_idf(i))
        write(*,*)'yerror',sample%spectra%spectrum(i)%data%linedata%yerror(1:ndatapoints_idf(i))
c     spectrum - data - complexdata
      else if (trim(adjustl(sample%spectra%spectrum(i)%data%datamode)).eq.'complex') then
        write(*,*)'datadimensions x y ',i,sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensionx,
     +  sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensiony
        do j=1,sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensionx
        write(*,*)'xaxes axisname:',i,j,trim(adjustl(sample%spectra%spectrum(i)%data%complexdata%xaxes%axis(j)%axisname))
        write(*,*)'xaxes axisunit:',i,j,trim(adjustl(sample%spectra%spectrum(i)%data%complexdata%xaxes%axis(j)%axisunit))
        end do
        do j=1,sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensiony
        write(*,*)'yaxes axisname:',i,j,trim(adjustl(sample%spectra%spectrum(i)%data%complexdata%yaxes%axis(j)%axisname))
        write(*,*)'yaxes axisunit:',i,j,trim(adjustl(sample%spectra%spectrum(i)%data%complexdata%yaxes%axis(j)%axisunit))
        end do
        do j=1,ndatapoints_idf(i)
        write(*,*)'timestamp:',i,j,trim(adjustl(sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry(j)%timestamp))
        write(*,*)'line:',i,j,trim(adjustl(sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry(j)%line))
        do k=1,sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensionx+
     +  sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensiony
        write(*,*)'dataentry:',i,j,k,sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry(j)%dataitem(k)
        end do
        end do
c     spectrum - data - datafile
      else if (trim(adjustl(sample%spectra%spectrum(i)%data%datamode)).eq.'datafile') then
        write(*,*)'datafile filename:',trim(adjustl(sample%spectra%spectrum(i)%data%datafile%filename))
        write(*,*)'datafile fileformat:',trim(adjustl(sample%spectra%spectrum(i)%data%datafile%fileformat))
        write(*,*)'datafile filesource:',trim(adjustl(sample%spectra%spectrum(i)%data%datafile%filesource))
      end if
      end do

c     process - physicsdefaults - crosssectiondefault
      do i=1,idfnspectra
      write(*,*)'Rutherford: ',trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%crosssectiondefault%Rutherford))
      write(*,*)'screening: ',trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%crosssectiondefault%screening))
      write(*,*)'name: ',trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%crosssectiondefault%computercode%name))
      write(*,*)'version: ',trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%crosssectiondefault%
     +computercode%version))
      write(*,*)'builddate: ',trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%crosssectiondefault%
     +computercode%builddate))
      write(*,*)'releasedate: ',trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%crosssectiondefault%
     +computercode%releasedate))
      end do
c     process - physicsdefaults - crosssectiondefault
      do i=1,idfnspectra
      write(*,*)'stoppingpowerdefault name: ',trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%
     +stoppingpowerdefault%computercode%name))
      write(*,*)'stoppingpowerdefault version: ',trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%
     +stoppingpowerdefault%computercode%version))
      write(*,*)'stoppingpowerdefault builddate: ',trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%
     +stoppingpowerdefault%computercode%builddate))
      write(*,*)'stoppingpowerdefault releasedate: ',trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%
     +stoppingpowerdefault%computercode%releasedate))
      end do
c     process - physicsdefaults - energyspreaddefault
      do i=1,idfnspectra
      write(*,*)'energylossstraggling: ',i,
     +trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%energylossstraggling))
      write(*,*)'multiplescattering: ',i,
     +trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%multiplescattering))
      write(*,*)'Dopplereffect: ',i,
     +trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%Dopplereffect))
      write(*,*)'beamangularspread: ',i,
     +trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%beamangularspread))
      write(*,*)'beamsize: ',i,
     +trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%geometricspread%beamsize))
      write(*,*)'detectoraperture: ',i,
     +trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%geometricspread%detectoraperture))
      write(*,*)'Tschalareffect: ',i,
     +trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%Tschalareffect))
      write(*,*)'energyspreaddefault name: ',trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%
     +energyspreaddefault%computercode%name))
      write(*,*)'energyspreaddefault version: ',trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%
     +energyspreaddefault%computercode%version))
      write(*,*)'energyspreaddefault builddate: ',trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%
     +energyspreaddefault%computercode%builddate))
      write(*,*)'energyspreaddefault releasedate: ',trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%
     +energyspreaddefault%computercode%releasedate))
      end do

c     process - crosssections
      do i=1,idfnspectra
      do j=1,nsimulation_idf(i)
      do k=1,ncrosssection_idf(i,j)
      write(*,*)'crosssectionframe: ',i,j,k,trim(adjustl(
     +sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%crosssectionframe))
      write(*,*)'crosssectiontype: ',i,j,k,trim(adjustl(
     +sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%crosssectiontype))
      write(*,*)'energyminimum value',i,j,k,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +crosssections%crosssection(k)%energyminimum%value
      write(*,*)'energyminimum unit',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +crosssections%crosssection(k)%energyminimum%units))
      write(*,*)'energyminimum uncertainty',i,j,k,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +crosssections%crosssection(k)%energyminimum%uncertainty
      write(*,*)'energymaximum value',i,j,k,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +crosssections%crosssection(k)%energymaximum%value
      write(*,*)'energymaximum unit',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +crosssections%crosssection(k)%energymaximum%units))
      write(*,*)'energymaximum uncertainty',i,j,k,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +crosssections%crosssection(k)%energymaximum%uncertainty
      write(*,*)'initialtargetparticle',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +crosssections%crosssection(k)%reaction%initialtargetparticle))
      write(*,*)'incidentparticle',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +crosssections%crosssection(k)%reaction%incidentparticle))
      write(*,*)'exitparticle',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +crosssections%crosssection(k)%reaction%exitparticle))
      write(*,*)'finaltargetparticle',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +crosssections%crosssection(k)%reaction%finaltargetparticle))
      write(*,*)'reactionQ value',i,j,k,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +crosssections%crosssection(k)%reaction%reactionQ%value
      write(*,*)'reactionQ unit',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +crosssections%crosssection(k)%reaction%reactionQ%units))
      write(*,*)'reactionQ uncertainty',i,j,k,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +crosssections%crosssection(k)%reaction%reactionQ%uncertainty
      write(*,*)'filename',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +crosssections%crosssection(k)%crosssectionfile%filename))
      write(*,*)'fileformat',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +crosssections%crosssection(k)%crosssectionfile%fileformat))
      write(*,*)'filesource',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +crosssections%crosssection(k)%crosssectionfile%filesource))
        write(*,*)'xaxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%crosssections%crosssection(k)%crosssectiondata%xaxis%axisname))
        write(*,*)'xaxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%crosssections%crosssection(k)%crosssectiondata%xaxis%axisunit))
        write(*,*)'xerroraxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%crosssections%crosssection(k)%crosssectiondata%
     +xerroraxis%axisname))
        write(*,*)'xerroraxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%crosssections%crosssection(k)%crosssectiondata%
     +xerroraxis%axisunit))
        write(*,*)'yaxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%crosssections%crosssection(k)%crosssectiondata%
     +yaxis%axisname))
        write(*,*)'yaxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%crosssections%crosssection(k)%crosssectiondata%
     +yaxis%axisunit))
        write(*,*)'yerroraxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%crosssections%crosssection(k)%crosssectiondata%
     +yerroraxis%axisname))
        write(*,*)'yerroraxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%crosssections%crosssection(k)%crosssectiondata%
     +yerroraxis%axisunit))
        write(*,*)'x',sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%crosssections%crosssection(k)%crosssectiondata%
     +x(1:ncrosssectionpoints_idf(i,j,k))
        write(*,*)'xerror',sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%crosssections%crosssection(k)%crosssectiondata%
     +xerror(1:ncrosssectionpoints_idf(i,j,k))
        write(*,*)'y',sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%crosssections%crosssection(k)%crosssectiondata%
     +y(1:ncrosssectionpoints_idf(i,j,k))
        write(*,*)'yerror',sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%crosssections%crosssection(k)%crosssectiondata%
     +yerror(1:ncrosssectionpoints_idf(i,j,k))
      write(*,*)'Rutherford',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +crosssections%crosssection(k)%crosssectionoverride%Rutherford))
      write(*,*)'name',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +crosssections%crosssection(k)%crosssectionoverride%computercode%name))
      write(*,*)'version',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +crosssections%crosssection(k)%crosssectionoverride%computercode%version))
      write(*,*)'builddate',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +crosssections%crosssection(k)%crosssectionoverride%computercode%builddate))
      write(*,*)'releasedate',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +crosssections%crosssection(k)%crosssectionoverride%computercode%releasedate))
      end do
      end do
      end do

c     process - stoppingpowers
      do i=1,idfnspectra
      do j=1,nsimulation_idf(i)
      do k=1,nstoppingpower_idf(i,j)
      write(*,*)'ion: ',i,j,k,trim(adjustl(
     +sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower(k)%ion))
      write(*,*)'ionchargestate value',i,j,k,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +stoppingpowers%stoppingpower(k)%ionchargestate%value
      write(*,*)'ionchargestate unit',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +stoppingpowers%stoppingpower(k)%ionchargestate%units))
      write(*,*)'ionchargestate uncertainty',i,j,k,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +stoppingpowers%stoppingpower(k)%ionchargestate%uncertainty
      write(*,*)'targetelement',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +stoppingpowers%stoppingpower(k)%targetelement))
      write(*,*)'targetmolecule',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +stoppingpowers%stoppingpower(k)%targetmolecule))
      write(*,*)'stoppingmode',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +stoppingpowers%stoppingpower(k)%stoppingmode))
      write(*,*)'filename',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +stoppingpowers%stoppingpower(k)%stoppingpowerfile%filename))
      write(*,*)'fileformat',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +stoppingpowers%stoppingpower(k)%stoppingpowerfile%fileformat))
      write(*,*)'filesource',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +stoppingpowers%stoppingpower(k)%stoppingpowerfile%filesource))
        write(*,*)'xaxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%stoppingpowers%stoppingpower(k)%stoppingpowerdata%xaxis%axisname))
        write(*,*)'xaxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%stoppingpowers%stoppingpower(k)%stoppingpowerdata%xaxis%axisunit))
        write(*,*)'xerroraxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%stoppingpowers%stoppingpower(k)%stoppingpowerdata%
     +xerroraxis%axisname))
        write(*,*)'xerroraxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%stoppingpowers%stoppingpower(k)%stoppingpowerdata%
     +xerroraxis%axisunit))
        write(*,*)'yaxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%stoppingpowers%stoppingpower(k)%stoppingpowerdata%
     +yaxis%axisname))
        write(*,*)'yaxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%stoppingpowers%stoppingpower(k)%stoppingpowerdata%
     +yaxis%axisunit))
        write(*,*)'yerroraxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%stoppingpowers%stoppingpower(k)%stoppingpowerdata%
     +yerroraxis%axisname))
        write(*,*)'yerroraxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%stoppingpowers%stoppingpower(k)%stoppingpowerdata%
     +yerroraxis%axisunit))
        write(*,*)'x',sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%stoppingpowers%stoppingpower(k)%stoppingpowerdata%
     +x(1:nstoppingpowerpoints_idf(i,j,k))
        write(*,*)'xerror',sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%stoppingpowers%stoppingpower(k)%stoppingpowerdata%
     +xerror(1:nstoppingpowerpoints_idf(i,j,k))
        write(*,*)'y',sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%stoppingpowers%stoppingpower(k)%stoppingpowerdata%
     +y(1:nstoppingpowerpoints_idf(i,j,k))
        write(*,*)'yerror',sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%stoppingpowers%stoppingpower(k)%stoppingpowerdata%
     +yerror(1:nstoppingpowerpoints_idf(i,j,k))
      write(*,*)'name',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +stoppingpowers%stoppingpower(k)%stoppingpoweroverride%computercode%name))
      write(*,*)'version',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +stoppingpowers%stoppingpower(k)%stoppingpoweroverride%computercode%version))
      write(*,*)'builddate',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +stoppingpowers%stoppingpower(k)%stoppingpoweroverride%computercode%builddate))
      write(*,*)'releasedate',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +stoppingpowers%stoppingpower(k)%stoppingpoweroverride%computercode%releasedate))
      end do
      end do
      end do

c     process - energyspreads
      do i=1,idfnspectra
      do j=1,nsimulation_idf(i)
      do k=1,nenergyspread_idf(i,j)
      write(*,*)'ion: ',i,j,k,trim(adjustl(
     +sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread(k)%ion))
      write(*,*)'ionchargestate value',i,j,k,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +energyspreads%energyspread(k)%ionchargestate%value
      write(*,*)'ionchargestate unit',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +energyspreads%energyspread(k)%ionchargestate%units))
      write(*,*)'ionchargestate uncertainty',i,j,k,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +energyspreads%energyspread(k)%ionchargestate%uncertainty
      write(*,*)'targetelement',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +energyspreads%energyspread(k)%targetelement))
      write(*,*)'energyspreadmode',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +energyspreads%energyspread(k)%energyspreadmode))
      write(*,*)'filename',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +energyspreads%energyspread(k)%energyspreadfile%filename))
      write(*,*)'fileformat',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +energyspreads%energyspread(k)%energyspreadfile%fileformat))
      write(*,*)'filesource',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +energyspreads%energyspread(k)%energyspreadfile%filesource))
        write(*,*)'xaxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%energyspreads%energyspread(k)%energyspreaddata%xaxis%axisname))
        write(*,*)'xaxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%energyspreads%energyspread(k)%energyspreaddata%xaxis%axisunit))
        write(*,*)'xerroraxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%energyspreads%energyspread(k)%energyspreaddata%
     +xerroraxis%axisname))
        write(*,*)'xerroraxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%energyspreads%energyspread(k)%energyspreaddata%
     +xerroraxis%axisunit))
        write(*,*)'yaxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%energyspreads%energyspread(k)%energyspreaddata%
     +yaxis%axisname))
        write(*,*)'yaxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%energyspreads%energyspread(k)%energyspreaddata%
     +yaxis%axisunit))
        write(*,*)'yerroraxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%energyspreads%energyspread(k)%energyspreaddata%
     +yerroraxis%axisname))
        write(*,*)'yerroraxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%energyspreads%energyspread(k)%energyspreaddata%
     +yerroraxis%axisunit))
        write(*,*)'x',sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%energyspreads%energyspread(k)%energyspreaddata%
     +x(1:nenergyspreadpoints_idf(i,j,k))
        write(*,*)'xerror',sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%energyspreads%energyspread(k)%energyspreaddata%
     +xerror(1:nenergyspreadpoints_idf(i,j,k))
        write(*,*)'y',sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%energyspreads%energyspread(k)%energyspreaddata%
     +y(1:nenergyspreadpoints_idf(i,j,k))
        write(*,*)'yerror',sample%spectra%spectrum(i)%process%simulations%simulation
     +  (j)%physics%energyspreads%energyspread(k)%energyspreaddata%
     +yerror(1:nenergyspreadpoints_idf(i,j,k))
      write(*,*)'energylossstraggling',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +energyspreads%energyspread(k)%energyspreadoverride%energylossstraggling))
      write(*,*)'multiplescattering',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +energyspreads%energyspread(k)%energyspreadoverride%multiplescattering))
      write(*,*)'Dopplereffect',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +energyspreads%energyspread(k)%energyspreadoverride%Dopplereffect))
      write(*,*)'beamangularspread',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +energyspreads%energyspread(k)%energyspreadoverride%beamangularspread))
      write(*,*)'geometricspread',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +energyspreads%energyspread(k)%energyspreadoverride%geometricspread%beamsize))
      write(*,*)'geometricspread',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +energyspreads%energyspread(k)%energyspreadoverride%geometricspread%detectoraperture))
      write(*,*)'Tschalareffect',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +energyspreads%energyspread(k)%energyspreadoverride%Tschalareffect))
      write(*,*)'name',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +energyspreads%energyspread(k)%energyspreadoverride%computercode%name))
      write(*,*)'version',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +energyspreads%energyspread(k)%energyspreadoverride%computercode%version))
      write(*,*)'builddate',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +energyspreads%energyspread(k)%energyspreadoverride%computercode%builddate))
      write(*,*)'releasedate',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +energyspreads%energyspread(k)%energyspreadoverride%computercode%releasedate))
      end do
      end do
      end do

c     process - simulation data
      do i=1,idfnspectra
      do j=1,nsimulation_idf(i)
      write(*,*)'simulationtype',i,j,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simulationtype))
      write(*,*)'initialtargetparticle',i,j,
     +trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%initialtargetparticle))
      write(*,*)'reaction initialtargetparticle',i,j,
     +trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%reaction%initialtargetparticle))
      write(*,*)'reaction incidentparticle',i,j,
     +trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%reaction%incidentparticle))
      write(*,*)'reaction exitparticle',i,j,
     +trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%reaction%exitparticle))
      write(*,*)'reaction finaltargetparticle',i,j,
     +trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%reaction%finaltargetparticle))
      write(*,*)'targetlayer',i,j,sample%spectra%spectrum(i)%process%simulations%simulation(j)%targetlayer
      write(*,*)'datamode',i,j,
     +trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%datamode))
      write(*,*)'channelmode',i,j,
     +trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%channelmode))

c     spectrum - data - simpledata
      if (trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%datamode)).eq.'simple') then
        write(*,*)'xaxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%
     +  simpledata%xaxis%axisname))
        write(*,*)'xaxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%xaxis%axisunit))
        write(*,*)'xerroraxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%
     +  simpledata%xerroraxis%axisname))
        write(*,*)'xerroraxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%
     +  simpledata%xerroraxis%axisunit))
        write(*,*)'yaxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yaxis%axisname))
        write(*,*)'yaxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yaxis%axisunit))
        write(*,*)'yerroraxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%
     +  simpledata%yerroraxis%axisname))
        write(*,*)'yerroraxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%
     +  simpledata%yerroraxis%axisunit))
        write(*,*)'x',sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%x(1:nsimpoints_idf(i,j))
        write(*,*)'xerror',sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%xerror(1:nsimpoints_idf(i,j))
        write(*,*)'y',sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%y(1:nsimpoints_idf(i,j))
        write(*,*)'yerror',sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yerror(1:nsimpoints_idf(i,j))
c     for line/efficiency
      else if (trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%datamode)).eq.'line') then
        write(*,*)'xaxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%xaxis%axisname))
        write(*,*)'xaxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%xaxis%axisunit))
        write(*,*)'yaxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yaxis%axisname))
        write(*,*)'yaxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yaxis%axisunit))
        write(*,*)'yerroraxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%
     +  linedata%yerroraxis%axisname))
        write(*,*)'yerroraxis',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%
     +  linedata%yerroraxis%axisunit))
        write(*,*)'line',sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%x(1:nsimpoints_idf(i,j))
        write(*,*)'y',sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%y(1:nsimpoints_idf(i,j))
        write(*,*)'yerror',sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yerror(1:nsimpoints_idf(i,j))
c     spectrum - data - complexdata
      else if (trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%datamode)).eq.'complex') then
        write(*,*)'datadimensions x y ',i,sample%spectra%spectrum(i)%process%simulations%simulation(j)%
     +  complexdata%datadimensions%datadimensionx,
     +  sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensiony
        do k=1,sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensionx
        write(*,*)'xaxes axisname:',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%
     +  complexdata%xaxes%axis(k)%axisname))
        write(*,*)'xaxes axisunit:',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%
     +  complexdata%xaxes%axis(k)%axisunit))
        end do
        do k=1,sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensiony
        write(*,*)'yaxes axisname:',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%
     +  complexdata%yaxes%axis(k)%axisname))
        write(*,*)'yaxes axisunit:',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%
     +  complexdata%yaxes%axis(k)%axisunit))
        end do
        do k=1,nsimpoints_idf(i,j)
        write(*,*)'timestamp:',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%
     +  complexdata%dataentries%dataentry(k)%timestamp))
        write(*,*)'line:',i,j,k,trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%
     +  complexdata%dataentries%dataentry(k)%line))
        do k1=1,sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensionx+
     +  sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensiony
        write(*,*)'dataentry:',i,j,k,k1,sample%spectra%spectrum(i)%process%simulations%simulation(j)%
     +  complexdata%dataentries%dataentry(k)%dataitem(k1)
        end do
        end do
c     spectrum - data - datafile
      else if (trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%datamode)).eq.'datafile') then
        write(*,*)'datafile filename:',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%datafile%filename))
        write(*,*)'datafile fileformat:',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%
     +  datafile%fileformat))
        write(*,*)'datafile filesource:',trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%
     +  datafile%filesource))
      end if

      end do
      end do

c     112/113 continue is the output that will be shown
      goto 113


113   continue

      call deallocate_idf_all

      write(*,*)'ndf stop idf ',idf_nsamples
      stop ' '
c-----------------------------------------------------------------------------------------------------------------------------------------------------------------
c-----------------------------------------------------------------------------------------------------------------------------------------------------------------
c-----------------------------------------------------------------------------------------------------------------------------------------------------------------
111   continue

	return
	end
