c	Copyright (C) 2008-2013 and onwards  Nuno Pessoa Barradas
c	Campus Tecnolgico e Nuclear / Instituto Superior Tcnico
c	E.N. 10, Apartado 21, 2686-953 Sacavm, Portugal
c	Tel. +351 219946150 e-mail: nunoni@ctn.ist.utl.pt

c	This program is free software: you can redistribute it and/or modify
c	it under the terms of the GNU General Public License as published by
c	the Free Software Foundation, either version 3 of the License, or
c	any later version.

c	This program is distributed in the hope that it will be useful,
c	but WITHOUT ANY WARRANTY; without even the implied warranty of
c	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c	GNU General Public License for more details.

c	You should have received a copy of the GNU General Public License
c	along with this program.  If not, see <http://www.gnu.org/licenses/>.

c	The copyright owner (N.P. Barradas) is also the author of the non-GPL code NDF.
c	These routines are also used by NDF under a special agreement.

c     Release 1.02 13 february 2013
c-----------------------------------------------------------------------
	subroutine read_file_idf_dimensions(idf_file,nsample)
c     call the routine that determines the dimensions of the problem for the given sample nsample in the idf_file
	use IDFCOM
	implicit none
	external is_tag_open_idf
	real aux1
	integer nsample,i
	character idf_file*300,tag_dummy1*72,tag_dummy2*72,tag_dummy3*72
	logical nlayers_flag,is_tag_open_idf
c	type(idf_sample)::sample
c-----------------------------------------------------------------------
      idf_tagopen=.false.
      idf_ok=.false.
      idf_error=' '
      idf_entry_leftover=' '
      if (.not.defined_tags_idf) then
        idf_error='routine define_tags_idf has not been successfully called beforehand'
        return
      end if
      if (.not.defined_units_idf) then
        idf_error='routine define_units_idf has not been successfully called beforehand'
        return
      end if

      open(idffileunit,file=idf_file,status='old',err=1000)

      i=0
10    continue
c     read entries until sample nsample is found
      call read_next_entry_idf
      if (.not.idf_ok) goto 1001
      if (trim(adjustl(idf_tag%name)).eq.'sample'.and.idf_openingtaginentry) then
        i=i+1
        if (i.eq.nsample) goto 11
      end if
      goto 10
11    continue

c     tag sample is open
      idfnopentags=1
      idfopentags(idfnopentags)='sample'
      call get_idfntag_idf(idfopentags(idfnopentags),idfntag)
      idf_tagopen(idfntag)=.true.
      idfopennamespace(idfnopentags)='idf'

c     number of usersnotes in sample set to zero
      sample%usersnotes%users%n=0
      sample%usersnotes%notes%n=0
c     number of experimental geometries (data spectra) in the problem. This has been set before, but we need to set it again because it is used as counting variable
      idfnspectra=0
c     flag needed for nlayers, because it can be declared, but if actual layers are given this supercedes the direct declaration
      nlayers_flag=.false.
      nlayers_idf=0
      nbeamchargestate_idf=0
      ndatapoints_intag_idf=0
c      nnr_max_idf=0
c      ndatapointsaux_idf=0
c     number of data in points in each data set
      ndatapoints_idf=0
c     number of x and y axes in a complex data set
      datadimensionx_idf=0
      datadimensiony_idf=0
c      ndatapoints_flag=.false.
      nsimpoints_flag=.false.
c     npbp_element_idf counts the number of elements with pbp profile
      npbp_element_idf=0
c     for a given element with pbp profiles, npbp_max_idf counts how many pbp profiles there are
      npbp_idf=0
c     for a given element with pbp profiles, and given pbp profile, nlayerspbp_idf counts how many data points there are in the pbp profile
      nlayerspbp_idf=0
      nslitsbeforesample_idf=0
      nslitsaftersample_idf=0
      nlayerfoil_flag=.false.
      nlayerfoil_aux_idf=0
      nbeamfoillayers_idf=0
      nbeamfoilels_idf=0
      nstoppingfoillayers_idf=0
      nstoppingfoilels_idf=0
      ndeadlayer_idf=0
      ndeadlayerels_idf=0
      nentrancewindow_idf=0
      nentrancewindowels_idf=0
      ndetectorlayers_idf=0
      ndetectorlayersels_idf=0
      ntofstartfoil_idf=0
      ntofstartfoilels_idf=0
      ntofstopfoil_idf=0
      ntofstopfoilels_idf=0
c     number of detectorefficiency entries in each geometry
      ndetectorefficiency_idf=0
c     number of detectorresolution entries in each geometry
      ndetectorresolution_idf=0
c     number of resolutionparameter entries in each detectorresolution in each geometry
      nresolutionparameter_idf=0
c     number of reactions in the reaction list of one geometry
      nreaction_idf=0
c     datamode for each geometry
      datamode_idf=' '
c     number of simulations made for one given geometry
      nsimulation_idf=0
c     number of crossection entries in one simulation for one geometry
      ncrosssection_idf=0
c     number of crossection data points in one crosssection entry in one simulation for one geometry
      ncrosssectionpoints_idf=0
c     number of stoppingpower entries in one simulation for one geometry
      nstoppingpower_idf=0
c     number of stoppingpower data points in one stoppingpower entry in one simulation for one geometry
      nstoppingpowerpoints_idf=0
c     number of energyspread entries in one simulation for one geometry
      nenergyspread_idf=0
c     number of energyspread data points in one energyspread entry in one simulation for one geometry
      nenergyspreadpoints_idf=0
c     simmode_idf for each geometry and each simulation
      simmode_idf=' '

c     correct opening sample has been found, now read the content, until the closing tag </sample> comes
100   continue
c     read the nex entry. It returns the entire entry as idf_entry, the tag as idf_tag%name and idf_tag%content, and its number idfntag of the tag in the idftags(idfntags) list
c      write(*,*)'idfnopentags a:',idfnopentags,trim(adjustl(idfopentags(idfnopentags)))
      call read_next_entry_idf
c      write(*,*)'idf_entry:',trim(adjustl(idf_entry)),':',trim(adjustl(idf_entry_leftover)),idf_ok,idfntag
c      idfntag=1
c     there was a problem reading the next entry. idf_error has been set in the called routine
      if (.not.idf_ok) goto 1001

c     first consider the regular case that it is an idf flag
      if (idfntag.gt.0) then
c      write(*,*)'idfflaggroup:',idfflaggroup(idfntag),idf_fulltaginentry,idf_openingtaginentry,idf_closingtaginentry
c       get the attributes in the idf tag, puts their name and content in idf_attributes%attribute(i)%name and idf_attributes%attribute(i)%content, and their number in idf_attributes%n
        call get_attributes_idf
c     idfflaggroup(idfntag) is true if the tag is a group of tags, and false if it is a data tag
c     first, consider the case that it is a group of tags
      if (idfflaggroup(idfntag)) then
c       the tag may have been opened and closed in the same entry; in this case, for a group tag, it must be empty, e.g. <sample></sample>. No content besides tags is allowed in group tags
        if (idf_fulltaginentry) then
c       a new group tag was opened
        else if (idf_openingtaginentry) then
          idfnopentags=idfnopentags+1
          idfopentags(idfnopentags)=trim(adjustl(idf_tag%name))
          idfopennamespace(idfnopentags)='idf'
          idf_tagopen(idfntag)=.true.
c       a previously open group tag is now closed, check that it is the same
        else if (idf_closingtaginentry) then
c         it is the same, need to close it.
          if (trim(adjustl(idf_tag%name)).eq.trim(adjustl(idfopentags(idfnopentags)))) then
            idfopentags(idfnopentags)=' '
            idfopennamespace(idfnopentags)=' '
            idfnopentags=idfnopentags-1
            idf_tagopen(idfntag)=.false.
c           it is the closing sample tag correctly closing the open sample tag: finished
            if (trim(adjustl(idf_tag%name)).eq.'sample') then
c      write(*,*)'successfully read file, sample ',nsample
              idf_ok=.true.
              goto 1001
            end if
          end if
        end if
c     it was not a group tag, so it must have been a data tag. This is where we have to read actual content and assign it to actual variables!
      else
      end if

      if (idf_openingtaginentry.or.idf_fulltaginentry) then

c       do this the lazy way: check for the required tags one by one.

c       spectrum within spectra
        if (trim(adjustl(idf_tag%name)).eq.'spectrum') then
          tag_dummy1='spectra'
c          tag_dummy2='spectra'
          if (is_tag_open_idf(tag_dummy1)) then
            idfnspectra=idfnspectra+1
          end if
        end if

c       user within users within sample
        if (trim(adjustl(idf_tag%name)).eq.'user'.and.idfnopentags.eq.2) then
          tag_dummy1='sample'
          tag_dummy2='users'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2))
     +    sample%usersnotes%users%n=sample%usersnotes%users%n+1
c      write(*,*)'sample%usersnotes%users%n',sample%usersnotes%users%n
        end if

c       note within notes within sample
        if (trim(adjustl(idf_tag%name)).eq.'note'.and.idfnopentags.eq.2) then
          tag_dummy1='sample'
          tag_dummy2='notes'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2))
     +    sample%usersnotes%notes%n=sample%usersnotes%notes%n+1
c      write(*,*)'sample%usersnotes%notes%n',sample%usersnotes%notes%n
        end if

c       nlayers within layeredstructure within structure
        if (trim(adjustl(idf_tag%name)).eq.'nlayers') then
          tag_dummy1='structure'
          tag_dummy2='layeredstructure'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            tag_dummy1=trim(adjustl(idf_tag%content))
            read(tag_dummy1,*)nlayers_idf
          end if
        end if
c       nlayers derived from layerthickness<>0 within layer layeredstructure within structure
        if (trim(adjustl(idf_tag%name)).eq.'layerthickness') then
          tag_dummy1=trim(adjustl(idf_tag%content))
          read(tag_dummy1,*)aux1
          if (aux1.gt.0.) then
          tag_dummy1='structure'
          tag_dummy2='layeredstructure'
          tag_dummy3='layer'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2).and.is_tag_open_idf(tag_dummy3)) then
            if (nlayers_flag) then
              nlayers_idf=nlayers_idf+1
            else
              nlayers_flag=.true.
              nlayers_idf=1
            end if
          end if
          end if
        end if

c       pbpelement within pointbypointstructure
        if (trim(adjustl(idf_tag%name)).eq.'pbpelement') then
          tag_dummy1='pointbypointstructure'
          if (is_tag_open_idf(tag_dummy1)) then
            if (idf_openingtaginentry) then
              npbp_element_idf=npbp_element_idf+1
            end if
          end if
        end if
c       x within pbpelement within pointbypointstructure
        if (trim(adjustl(idf_tag%name)).eq.'x') then
          tag_dummy1='pbpelement'
          tag_dummy2='pointbypointstructure'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            npbp_idf(npbp_element_idf)=npbp_idf(npbp_element_idf)+1
            call get_ndatapoints_intag_idf
            nlayerspbp_idf(npbp_element_idf,npbp_idf(npbp_element_idf))=ndatapoints_intag_idf
         end if
        end if

c       x within beamchargestate within beam
        if (trim(adjustl(idf_tag%name)).eq.'x') then
          tag_dummy1='beamchargestate'
          tag_dummy2='beam'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            call get_ndatapoints_intag_idf
            nbeamchargestate_idf(idfnspectra)=ndatapoints_intag_idf
          end if
        end if

cc       x within crosssectiondata within simulations
c        if (trim(adjustl(idf_tag%name)).eq.'x') then
c          tag_dummy1='crosssectiondata'
c          tag_dummy2='simulations'
c          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
c            call get_ndatapoints_intag_idf
c            if (ndatapoints_intag_idf.gt.nnr_max_idf) nnr_max_idf=ndatapoints_intag_idf
c          end if
c        end if
c       spectrum within spectra
c       initialise nlayerfoil_flag in each section where layerfoils are used, i.e. in each foillayers section
        if (trim(adjustl(idf_tag%name)).eq.'foillayers'.or.trim(adjustl(idf_tag%name)).eq.'entrancewindow'.or.
     +  trim(adjustl(idf_tag%name)).eq.'detectorlayers'.or.trim(adjustl(idf_tag%name)).eq.'startfoil'.or.
     +  trim(adjustl(idf_tag%name)).eq.'stopfoil') then
          nlayerfoil_flag=.false.
        end if

c       get maximum number of data points in data, from simple data
c       y within simpledata within data; good for both simpledata and linedata
        if (trim(adjustl(idf_tag%name)).eq.'y') then
          tag_dummy2='data'
          if (is_tag_open_idf(tag_dummy2)) then
          tag_dummy1='simpledata'
          tag_dummy2='linedata'
          if (is_tag_open_idf(tag_dummy1).or.is_tag_open_idf(tag_dummy2)) then
            call get_ndatapoints_intag_idf
            ndatapoints_idf(idfnspectra)=ndatapoints_intag_idf
          end if
          end if
        end if
c       get maximum number of data points in data, from complexdata data
c       complexdata within data within spectrum -- each new one is a new spectrum
        if (trim(adjustl(idf_tag%name)).eq.'complexdata') then
          tag_dummy1='spectrum'
          tag_dummy2='data'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            if (idf_openingtaginentry) then
              ndatapoints_idf(idfnspectra)=0
            end if
          end if
        end if
c       dataentry within  complexdata within data
        if (trim(adjustl(idf_tag%name)).eq.'dataentry'.and.idf_openingtaginentry) then
          tag_dummy1='complexdata'
          tag_dummy2='data'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
c            if (ndatapoints_flag) then
              ndatapoints_idf(idfnspectra)=ndatapoints_idf(idfnspectra)+1
c            else
c              ndatapoints_flag=.true.
c              ndatapointsaux_idf=1
c            end if
          end if
        end if
c       get datadimensionx_max_idf, from complexdata
c       datadimensionx within complexdata within data; good for complexdata
        if (trim(adjustl(idf_tag%name)).eq.'datadimensionx') then
          tag_dummy1='complexdata'
          tag_dummy2='data'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            tag_dummy1=trim(adjustl(idf_tag%content))
            read(tag_dummy1,*)datadimensionx_idf(idfnspectra)
          end if
        end if
c       get datadimensiony_max_idf, from complexdata
c       datadimensionx within simpledata within data; good for complexdata
        if (trim(adjustl(idf_tag%name)).eq.'datadimensiony') then
          tag_dummy1='complexdata'
          tag_dummy2='data'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            tag_dummy1=trim(adjustl(idf_tag%content))
            read(tag_dummy1,*)datadimensiony_idf(idfnspectra)
          end if
        end if

c       get maximum number of data points in simulations
c       y within simulation within simulations; good for both simpledata and linedata
        if (trim(adjustl(idf_tag%name)).eq.'y') then
          tag_dummy1='simulation'
          tag_dummy2='simulations'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            call get_ndatapoints_intag_idf
            nsimpoints_idf(idfnspectra,nsimulation_idf(idfnspectra))=ndatapoints_intag_idf
c           also simdimensions!
c            tag_dummy1='linedata'
c            if (simdimensionx_max_idf.eq.0.and..not.is_tag_open_idf(tag_dummy1)) simdimensionx_max_idf=1
c            if (simdimensiony_max_idf.eq.0) simdimensiony_max_idf=1
          end if
        end if
c       get simdimensionx_max_idf, from complexdata
c       simdimensionx within complexdata within simulation
        if (trim(adjustl(idf_tag%name)).eq.'datadimensionx') then
          tag_dummy1='complexdata'
          tag_dummy2='simulation'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            tag_dummy1=trim(adjustl(idf_tag%content))
            read(tag_dummy1,*)simdimensionx_idf(idfnspectra,nsimulation_idf(idfnspectra))
          end if
        end if
c       get simdimensiony_max_idf, from complexdata
c       simdimensiony within complexdata within simulation
        if (trim(adjustl(idf_tag%name)).eq.'datadimensiony') then
          tag_dummy1='complexdata'
          tag_dummy2='simulation'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            tag_dummy1=trim(adjustl(idf_tag%content))
            read(tag_dummy1,*)simdimensiony_idf(idfnspectra,nsimulation_idf(idfnspectra))
          end if
        end if

c       get number of data points in data, from complexdata data
c       dataentry within complexdata within simulation
        if (trim(adjustl(idf_tag%name)).eq.'dataentry') then
          tag_dummy1='complexdata'
          tag_dummy2='simulation'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            nsimpoints_idf(idfnspectra,nsimulation_idf(idfnspectra))=
     +      nsimpoints_idf(idfnspectra,nsimulation_idf(idfnspectra))+1
          end if
        end if
c       slit within slitsbeforesample or slitsaftersample within spectrum
        if (trim(adjustl(idf_tag%name)).eq.'slit') then
          tag_dummy1='slitsbeforesample'
          tag_dummy2='spectrum'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            nslitsbeforesample_idf(idfnspectra)=nslitsbeforesample_idf(idfnspectra)+1
          end if
          tag_dummy1='slitsaftersample'
          tag_dummy2='spectrum'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            nslitsaftersample_idf(idfnspectra)=nslitsaftersample_idf(idfnspectra)+1
          end if
        end if

c       layer within beamfoil within beam or withing stoppingfoil within detection
        if (trim(adjustl(idf_tag%name)).eq.'layer') then
          tag_dummy1='beamfoil'
          tag_dummy2='beam'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            nbeamfoillayers_idf(idfnspectra)=nbeamfoillayers_idf(idfnspectra)+1
            if (nlayerfoil_flag) then
              nlayerfoil_aux_idf=nlayerfoil_aux_idf+1
            else
              nlayerfoil_flag=.true.
              nlayerfoil_aux_idf=1
            end if
          else
          tag_dummy1='stoppingfoil'
          tag_dummy2='detection'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            nstoppingfoillayers_idf(idfnspectra)=nstoppingfoillayers_idf(idfnspectra)+1
            if (nlayerfoil_flag) then
              nlayerfoil_aux_idf=nlayerfoil_aux_idf+1
            else
              nlayerfoil_flag=.true.
              nlayerfoil_aux_idf=1
            end if
          else
          tag_dummy1='entrancewindow'
          tag_dummy2='detection'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            nentrancewindow_idf(idfnspectra)=nentrancewindow_idf(idfnspectra)+1
            if (nlayerfoil_flag) then
              nlayerfoil_aux_idf=nlayerfoil_aux_idf+1
            else
              nlayerfoil_flag=.true.
              nlayerfoil_aux_idf=1
            end if
          else
          tag_dummy1='detectorlayers'
          tag_dummy2='detection'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            ndetectorlayers_idf(idfnspectra)=ndetectorlayers_idf(idfnspectra)+1
            if (nlayerfoil_flag) then
              nlayerfoil_aux_idf=nlayerfoil_aux_idf+1
            else
              nlayerfoil_flag=.true.
              nlayerfoil_aux_idf=1
            end if
          else
          tag_dummy1='startfoil'
          tag_dummy2='detection'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            ntofstartfoil_idf(idfnspectra)=ntofstartfoil_idf(idfnspectra)+1
            if (nlayerfoil_flag) then
              nlayerfoil_aux_idf=nlayerfoil_aux_idf+1
            else
              nlayerfoil_flag=.true.
              nlayerfoil_aux_idf=1
            end if
          else
          tag_dummy1='stopfoil'
          tag_dummy2='detection'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            ntofstopfoil_idf(idfnspectra)=ntofstopfoil_idf(idfnspectra)+1
            if (nlayerfoil_flag) then
              nlayerfoil_aux_idf=nlayerfoil_aux_idf+1
            else
              nlayerfoil_flag=.true.
              nlayerfoil_aux_idf=1
            end if
          end if
          end if
          end if
          end if
          end if
          end if
        end if
c       deadlayer within detection
        if (trim(adjustl(idf_tag%name)).eq.'deadlayer') then
          ndeadlayer_idf(idfnspectra)=1
        end if
c       layerelement within beamfoil within beam or withing stoppingfoil within detection
        if (trim(adjustl(idf_tag%name)).eq.'layerelement') then
          tag_dummy1='beamfoil'
          tag_dummy2='beam'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            nbeamfoilels_idf(idfnspectra,nlayerfoil_aux_idf)=nbeamfoilels_idf(idfnspectra,nlayerfoil_aux_idf)+1
          else
          tag_dummy1='stoppingfoil'
          tag_dummy2='detection'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            nstoppingfoilels_idf(idfnspectra,nlayerfoil_aux_idf)=nstoppingfoilels_idf(idfnspectra,nlayerfoil_aux_idf)+1
          else
          tag_dummy1='deadlayer'
          tag_dummy2='detection'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            ndeadlayerels_idf(idfnspectra)=ndeadlayerels_idf(idfnspectra)+1
          else
          tag_dummy1='entrancewindow'
          tag_dummy2='detection'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            nentrancewindowels_idf(idfnspectra,nlayerfoil_aux_idf)=nentrancewindowels_idf(idfnspectra,nlayerfoil_aux_idf)+1
          else
          tag_dummy1='detectorlayers'
          tag_dummy2='detection'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            ndetectorlayersels_idf(idfnspectra,nlayerfoil_aux_idf)=ndetectorlayersels_idf(idfnspectra,nlayerfoil_aux_idf)+1
          else
          tag_dummy1='startfoil'
          tag_dummy2='detection'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            ntofstartfoilels_idf(idfnspectra,nlayerfoil_aux_idf)=ntofstartfoilels_idf(idfnspectra,nlayerfoil_aux_idf)+1
          else
          tag_dummy1='stopfoil'
          tag_dummy2='detection'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            ntofstopfoilels_idf(idfnspectra,nlayerfoil_aux_idf)=ntofstopfoilels_idf(idfnspectra,nlayerfoil_aux_idf)+1
          else
          end if
          end if
          end if
          end if
          end if
          end if
          end if
        end if
c       layer within stoppingfoil within detection
c        if (trim(adjustl(idf_tag%name)).eq.'layer') then
c          tag_dummy1='stoppingfoil'
c          tag_dummy2='detection'
c          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
c            nstoppingfoillayers_idf(idfnspectra)=nstoppingfoillayers_idf(idfnspectra)+1
c          end if
c        end if

c       get number of detectorefficiency entries within the detectorefficiencies tag in calibrations tag for a given geometry
        if (trim(adjustl(idf_tag%name)).eq.'detectorefficiency') then
          tag_dummy1='calibrations'
          if (is_tag_open_idf(tag_dummy1)) then
            ndetectorefficiency_idf(idfnspectra)=ndetectorefficiency_idf(idfnspectra)+1
          end if
        end if
c       now get number of points in detectorefficiency
        if (trim(adjustl(idf_tag%name)).eq.'y') then
          tag_dummy1='detectorefficiency'
          if (is_tag_open_idf(tag_dummy1)) then
            call get_ndatapoints_intag_idf
            ndetectorefficiencyentries_idf(idfnspectra,ndetectorefficiency_idf(idfnspectra))=ndatapoints_intag_idf
          end if
        end if
c       now determine whether a detectorefficiency is a efficiency or a lineefficiency
        if (trim(adjustl(idf_tag%name)).eq.'efficiencymode') then
          tag_dummy1='detectorefficiency'
          if (is_tag_open_idf(tag_dummy1)) then
            efficiencymode_idf(idfnspectra,ndetectorefficiency_idf(idfnspectra))=trim(adjustl(idf_tag%content))
          end if
        end if

c       get number of detectorresolution entries within the detectorresolutions tag in calibrations tag for a given geometry
        if (trim(adjustl(idf_tag%name)).eq.'detectorresolution') then
          tag_dummy1='calibrations'
          if (is_tag_open_idf(tag_dummy1)) then
            ndetectorresolution_idf(idfnspectra)=ndetectorresolution_idf(idfnspectra)+1
          end if
        end if
c       get number of detectorresolution entries within the detectorresolutions tag in calibrations tag for a given geometry
        if (trim(adjustl(idf_tag%name)).eq.'resolutionparameter') then
          tag_dummy1='calibrations'
          if (is_tag_open_idf(tag_dummy1)) then
            nresolutionparameter_idf(idfnspectra,ndetectorresolution_idf(idfnspectra))=
     +      nresolutionparameter_idf(idfnspectra,ndetectorresolution_idf(idfnspectra))+1
          end if
        end if

c       get number of energycalibration entries within the energycalibrations tag in calibrations tag for a given geometry
        if (trim(adjustl(idf_tag%name)).eq.'energycalibration') then
          tag_dummy1='calibrations'
          if (is_tag_open_idf(tag_dummy1)) then
            nenergycalibration_idf(idfnspectra)=nenergycalibration_idf(idfnspectra)+1
          end if
        end if
c       get number of calibrationparameter entries within the calibrationparameters tag in calibrations tag for a given geometry
        if (trim(adjustl(idf_tag%name)).eq.'calibrationparameter') then
          tag_dummy1='calibrations'
          if (is_tag_open_idf(tag_dummy1)) then
            ncalibrationparameter_idf(idfnspectra,nenergycalibration_idf(idfnspectra))=
     +      ncalibrationparameter_idf(idfnspectra,nenergycalibration_idf(idfnspectra))+1
          end if
        end if

c       get number of reaction entries in reactions tag for a given geometry
        if (trim(adjustl(idf_tag%name)).eq.'reaction') then
          tag_dummy1='reactions'
          if (is_tag_open_idf(tag_dummy1)) then
            nreaction_idf(idfnspectra)=nreaction_idf(idfnspectra)+1
          end if
        end if

c       determine whether a data group tag is simpledata, linedata, complexdata, or datafile
        if (trim(adjustl(idf_tag%name)).eq.'datamode') then
          tag_dummy1='data'
          if (is_tag_open_idf(tag_dummy1)) then
            datamode_idf(idfnspectra)=trim(adjustl(idf_tag%content))
          end if
        end if
c       determine whether a simulation group tag is simpledata, linedata, complexdata, or datafile
        if (trim(adjustl(idf_tag%name)).eq.'simmode') then
          tag_dummy1='simulation'
          if (is_tag_open_idf(tag_dummy1)) then
            simmode_idf(idfnspectra,nsimulation_idf(idfnspectra))=trim(adjustl(idf_tag%content))
          end if
        end if
c       actual presence of a given tag that defines a data mode overrides the datamode tag
        if (trim(adjustl(idf_tag%name)).eq.'simpledata') then
          tag_dummy1='data'
          if (is_tag_open_idf(tag_dummy1)) then
            datamode_idf(idfnspectra)='simple'
          else
          tag_dummy1='simulation'
          if (is_tag_open_idf(tag_dummy1)) then
            simmode_idf(idfnspectra,nsimulation_idf(idfnspectra))='simple'
          end if
          end if
        else if (trim(adjustl(idf_tag%name)).eq.'linedata') then
          tag_dummy1='data'
          if (is_tag_open_idf(tag_dummy1)) then
            datamode_idf(idfnspectra)='line'
          else
          tag_dummy1='simulation'
          if (is_tag_open_idf(tag_dummy1)) then
            simmode_idf(idfnspectra,nsimulation_idf(idfnspectra))='line'
          end if
          end if
        else if (trim(adjustl(idf_tag%name)).eq.'complexdata') then
          tag_dummy1='data'
          if (is_tag_open_idf(tag_dummy1)) then
            datamode_idf(idfnspectra)='complex'
          else
          tag_dummy1='simulation'
          if (is_tag_open_idf(tag_dummy1)) then
            simmode_idf(idfnspectra,nsimulation_idf(idfnspectra))='complex'
          end if
          end if
        else if (trim(adjustl(idf_tag%name)).eq.'datafile') then
          tag_dummy1='data'
          if (is_tag_open_idf(tag_dummy1)) then
            datamode_idf(idfnspectra)='datafile'
          else
          tag_dummy1='simulation'
          if (is_tag_open_idf(tag_dummy1)) then
            simmode_idf(idfnspectra,nsimulation_idf(idfnspectra))='datafile'
          end if
          end if
        end if

c     process - physics - crosssections - simulation
        if (trim(adjustl(idf_tag%name)).eq.'simulation') then
          tag_dummy1='process'
          tag_dummy2='simulations'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            nsimulation_idf(idfnspectra)=nsimulation_idf(idfnspectra)+1
          end if
        end if
c     process - physics - crosssections - crosssection
        if (trim(adjustl(idf_tag%name)).eq.'crosssection') then
          tag_dummy1='process'
          tag_dummy2='physics'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            ncrosssection_idf(idfnspectra,nsimulation_idf(idfnspectra))=
     +      ncrosssection_idf(idfnspectra,nsimulation_idf(idfnspectra))+1
          end if
        end if
c     process - physics - crosssections - crosssection - crosssectiondata
c       y within simpledata within data; good for both simpledata and linedata
        if (trim(adjustl(idf_tag%name)).eq.'y') then
          tag_dummy1='physics'
          tag_dummy2='crosssectiondata'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            call get_ndatapoints_intag_idf
            ncrosssectionpoints_idf(idfnspectra,nsimulation_idf(idfnspectra),
     +      ncrosssection_idf(idfnspectra,nsimulation_idf(idfnspectra)))=ndatapoints_intag_idf
          end if
        end if
c     process - physics - crosssections - stoppingpower
        if (trim(adjustl(idf_tag%name)).eq.'stoppingpower') then
          tag_dummy1='process'
          tag_dummy2='physics'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            nstoppingpower_idf(idfnspectra,nsimulation_idf(idfnspectra))=
     +      nstoppingpower_idf(idfnspectra,nsimulation_idf(idfnspectra))+1
          end if
        end if
c     process - physics - crosssections - stoppingpower - stoppingpowerdata
c       y within simpledata within data; good for both simpledata and linedata
        if (trim(adjustl(idf_tag%name)).eq.'y') then
          tag_dummy1='physics'
          tag_dummy2='stoppingpowerdata'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            call get_ndatapoints_intag_idf
            nstoppingpowerpoints_idf(idfnspectra,nsimulation_idf(idfnspectra),
     +      nstoppingpower_idf(idfnspectra,nsimulation_idf(idfnspectra)))=ndatapoints_intag_idf
          end if
        end if
c     process - physics - crosssections - energyspread
        if (trim(adjustl(idf_tag%name)).eq.'energyspread') then
          tag_dummy1='process'
          tag_dummy2='physics'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            nenergyspread_idf(idfnspectra,nsimulation_idf(idfnspectra))=
     +      nenergyspread_idf(idfnspectra,nsimulation_idf(idfnspectra))+1
          end if
        end if
c     process - physics - crosssections - energyspread - energyspreaddata
c       y within simpledata within data; good for both simpledata and linedata
        if (trim(adjustl(idf_tag%name)).eq.'y') then
          tag_dummy1='physics'
          tag_dummy2='energyspreaddata'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            call get_ndatapoints_intag_idf
            nenergyspreadpoints_idf(idfnspectra,nsimulation_idf(idfnspectra),
     +      nenergyspread_idf(idfnspectra,nsimulation_idf(idfnspectra)))=ndatapoints_intag_idf
          end if
        end if




      else if (idf_closingtaginentry) then

      end if


c     now consider the case that it is not an idf flag
      else if (idfntag.eq.0) then
        if (idf_fulltaginentry) then
c       a new group tag was opened
        else if (idf_openingtaginentry) then
          idfnopentags=idfnopentags+1
          idfopentags(idfnopentags)=trim(adjustl(idf_tag%name))
          idfopennamespace(idfnopentags)=trim(adjustl(namespaceinentry))
c       a previously open group tag is now closed, check that it is the same
        else if (idf_closingtaginentry) then
c         it is the same, need to close it.
          if (trim(adjustl(idf_tag%name)).eq.trim(adjustl(idfopentags(idfnopentags)))) then
            idfopentags(idfnopentags)=' '
            idfopennamespace(idfnopentags)=' '
            idfnopentags=idfnopentags-1
          end if
        end if

      end if


c      if (trim(adjustl(idf_entry)).ne.'</idf>') write(*,*)'idfnopentags b:',idfnopentags,trim(adjustl(idfopentags(idfnopentags)))
c      write(*,*)' '
c      write(*,*)'finished one entry, go to next'
c      write(*,*)' '
c      pause

      if (trim(adjustl(idf_entry)).ne.'</idf>') goto 100
      idf_error='unspecified error reading file '//trim(adjustl(idf_file))


1001  continue
      close(idffileunit)
	return
1000  continue
      idf_error='file '//trim(adjustl(idf_file))//' does not exist'
      close(idffileunit)
	return
	end

c-----------------------------------------------------------------------
      subroutine read_file_idf_usersnotes_attributes(idf_file)
c     reads the usersnotes and attributes of the idf_file - this is not from sample nsample, these are the general usersnotes and attributes children of tag idf
	use IDFCOM
	implicit none
	external is_tag_open_idf
	real aux1
	integer nsample,i
	character idf_file*300,tag_dummy1*72,tag_dummy2*72,tag_dummy3*72
	logical nlayers_flag,is_tag_open_idf
c	type(idf_sample)::sample
c-----------------------------------------------------------------------
      idf_tagopen=.false.
      idf_ok=.false.
      idf_error=' '
      idf_entry_leftover=' '
      if (.not.defined_tags_idf) then
        idf_error='routine define_tags_idf has not been successfully called beforehand'
        return
      end if
      if (.not.defined_units_idf) then
        idf_error='routine define_units_idf has not been successfully called beforehand'
        return
      end if

      open(idffileunit,file=idf_file,status='old',err=1000)

c     first count the number of occurrences
      usersnotes%users%n=0
      usersnotes%notes%n=0
      attributes%updatetimes%n=0
10    continue
c     read entries until sample nsample is found
      call read_next_entry_idf
c     there was a problem reading the next entry. idf_error has been set in the called routine
      if (.not.idf_ok) goto 1001
      if (trim(adjustl(idf_tag%name)).eq.'sample'.or.trim(adjustl(idf_tag%name)).eq.'repository'.or.
     +(trim(adjustl(idf_tag%name)).eq.'idf'.and.idf_closingtaginentry))  goto 11
c     count number of notes
      if (trim(adjustl(idf_tag%name)).eq.'user') then
        usersnotes%users%n=usersnotes%users%n+1
      end if
c     count number of users
      if (trim(adjustl(idf_tag%name)).eq.'note') then
        usersnotes%notes%n=usersnotes%notes%n+1
      end if
      if (trim(adjustl(idf_tag%name)).eq.'updatetime') then
        attributes%updatetimes%n=attributes%updatetimes%n+1
      end if
      goto 10

11    continue
      rewind(idffileunit)
c     now allocate sample usersnotes and attributes
	if (allocated(usersnotes%notes%note)) deallocate(usersnotes%notes%note)
	if (usersnotes%notes%n.gt.0) then
	  allocate(usersnotes%notes%note(usersnotes%notes%n))
	  if (.not.allocated(usersnotes%notes%note)) then
	    idf_error='problem allocating usersnotes%notes%note'
	    goto 1000
	  end if
	  usersnotes%notes%note=' '
	end if
	if (allocated(usersnotes%users%user)) deallocate(usersnotes%users%user)
	if (usersnotes%users%n.gt.0) then
	  allocate(usersnotes%users%user(usersnotes%users%n))
	  if (.not.allocated(usersnotes%users%user)) then
	    idf_error='problem allocating usersnotes%users%user'
	    goto 1000
	  end if
	  usersnotes%users%user=' '
	end if
c	write(*,*)
c     then actualy read
      usersnotes%users%n=0
      usersnotes%notes%n=0
      attributes%updatetimes%n=0
      usersnotes%users%user=' '
      usersnotes%notes%note=' '
      attributes%updatetimes%updatetime=' '
      attributes%idfversion=' '
      attributes%filename=' '
      attributes%createtime=' '
      attributes%code=' '
      attributes%version=' '
20    continue
c     read entries until sample nsample is found
      call read_next_entry_idf
c     there was a problem reading the next entry. idf_error has been set in the called routine
      if (.not.idf_ok) goto 1001
      if (trim(adjustl(idf_tag%name)).eq.'sample'.or.trim(adjustl(idf_tag%name)).eq.'repository'.or.
     +(trim(adjustl(idf_tag%name)).eq.'idf'.and.idf_closingtaginentry))  goto 1001
c     count number of notes
      if (trim(adjustl(idf_tag%name)).eq.'user') then
        usersnotes%users%n=usersnotes%users%n+1
        usersnotes%users%user(usersnotes%users%n)=trim(adjustl(idf_tag%content))
      end if
c     count number of users
      if (trim(adjustl(idf_tag%name)).eq.'note') then
        usersnotes%notes%n=usersnotes%notes%n+1
        usersnotes%notes%note(usersnotes%notes%n)=trim(adjustl(idf_tag%content))
      end if
      if (trim(adjustl(idf_tag%name)).eq.'idfversion') attributes%idfversion=trim(adjustl(idf_tag%content))
      if (trim(adjustl(idf_tag%name)).eq.'filename') attributes%filename=trim(adjustl(idf_tag%content))
      if (trim(adjustl(idf_tag%name)).eq.'createtime') attributes%createtime=trim(adjustl(idf_tag%content))
      if (trim(adjustl(idf_tag%name)).eq.'code') attributes%code=trim(adjustl(idf_tag%content))
      if (trim(adjustl(idf_tag%name)).eq.'version') attributes%version=trim(adjustl(idf_tag%content))
      if (trim(adjustl(idf_tag%name)).eq.'updatetime') then
        attributes%updatetimes%n=attributes%updatetimes%n+1
        attributes%updatetimes%updatetime(attributes%updatetimes%n)=trim(adjustl(idf_tag%content))
      end if

      goto 20

1001  continue
      close(idffileunit)
	return
1000  continue
      idf_error='file '//trim(adjustl(idf_file))//' does not exist'
      close(idffileunit)
	return
	end

c-----------------------------------------------------------------------
	subroutine read_file_idf_dimensions_ngeometries(idf_file,nsample)
c     call the routine that determines the number of geometries (etc) of the problem for the given sample nsample in the idf_file, to allocate basic variables
	use IDFCOM
	implicit none
	external is_tag_open_idf
	real aux1
	integer nsample,i
	character idf_file*300,tag_dummy1*72,tag_dummy2*72,tag_dummy3*72
	logical nlayers_flag,is_tag_open_idf
c	type(idf_sample)::sample
c-----------------------------------------------------------------------
      idf_tagopen=.false.
      idf_ok=.false.
      idf_error=' '
      idf_entry_leftover=' '
      if (.not.defined_tags_idf) then
        idf_error='routine define_tags_idf has not been successfully called beforehand'
        return
      end if
      if (.not.defined_units_idf) then
        idf_error='routine define_units_idf has not been successfully called beforehand'
        return
      end if

      open(idffileunit,file=idf_file,status='old',err=1000)

      i=0
10    continue
c     read entries until sample nsample is found
      call read_next_entry_idf
      if (.not.idf_ok) goto 1001
      if (trim(adjustl(idf_tag%name)).eq.'sample'.and.idf_openingtaginentry) then
        i=i+1
        if (i.eq.nsample) goto 11
      end if
      goto 10
11    continue

c     tag sample is open
      idfnopentags=1
      idfopentags(idfnopentags)='sample'
      call get_idfntag_idf(idfopentags(idfnopentags),idfntag)
      idf_tagopen(idfntag)=.true.
      idfopennamespace(idfnopentags)='idf'

c     number of elements in the problem
      idfnelements=0
c     number of molecules in the problem
      idfnmolecules=0
c     number of experimental geometries (data spectra) in the problem
      idfnspectra=0
c     npbp_element_idf counts the number of elements with pbp profile
      npbp_element_idf=0

c     correct opening sample has been found, now read the content, until the closing tag </sample> comes
100   continue
c     read the nex entry. It returns the entire entry as idf_entry, the tag as idf_tag%name and idf_tag%content, and its number idfntag of the tag in the idftags(idfntags) list
      call read_next_entry_idf
c     there was a problem reading the next entry. idf_error has been set in the called routine
      if (.not.idf_ok) goto 1001

c     first consider the regular case that it is an idf flag
      if (idfntag.gt.0) then
c      write(*,*)'idfflaggroup:',idfflaggroup(idfntag),idf_fulltaginentry,idf_openingtaginentry,idf_closingtaginentry
c       get the attributes in the idf tag, puts their name and content in idf_attributes%attribute(i)%name and idf_attributes%attribute(i)%content, and their number in idf_attributes%n
        call get_attributes_idf
c     idfflaggroup(idfntag) is true if the tag is a group of tags, and false if it is a data tag
c     first, consider the case that it is a group of tags
      if (idfflaggroup(idfntag)) then
c       the tag may have been opened and closed in the same entry; in this case, for a group tag, it must be empty, e.g. <sample></sample>. No content besides tags is allowed in group tags
        if (idf_fulltaginentry) then
c       a new group tag was opened
        else if (idf_openingtaginentry) then
          idfnopentags=idfnopentags+1
          idfopentags(idfnopentags)=trim(adjustl(idf_tag%name))
          idfopennamespace(idfnopentags)='idf'
          idf_tagopen(idfntag)=.true.
c       a previously open group tag is now closed, check that it is the same
        else if (idf_closingtaginentry) then
c         it is the same, need to close it.
          if (trim(adjustl(idf_tag%name)).eq.trim(adjustl(idfopentags(idfnopentags)))) then
            idfopentags(idfnopentags)=' '
            idfopennamespace(idfnopentags)=' '
            idfnopentags=idfnopentags-1
            idf_tagopen(idfntag)=.false.
c           it is the closing sample tag correctly closing the open sample tag: finished
            if (trim(adjustl(idf_tag%name)).eq.'sample') then
c      write(*,*)'successfully read file, sample ',nsample
              idf_ok=.true.
              goto 1001
            end if
          end if
        end if
c     it was not a group tag, so it must have been a data tag. This is where we have to read actual content and assign it to actual variables!
      else
      end if

      if (idf_openingtaginentry.or.idf_fulltaginentry) then

c       do this the lazy way: check for the required tags one by one.
c       element within elements within elementsandmolecules
        if (trim(adjustl(idf_tag%name)).eq.'element') then
          tag_dummy1='elementsandmolecules'
          tag_dummy2='elements'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) idfnelements=idfnelements+1
        end if
c       molecule within molecules within elementsandmolecules
        if (trim(adjustl(idf_tag%name)).eq.'molecule') then
          tag_dummy1='elementsandmolecules'
          tag_dummy2='molecules'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) idfnmolecules=idfnmolecules+1
        end if

c       pbpelement within pointbypointstructure
        if (trim(adjustl(idf_tag%name)).eq.'pbpelement') then
          tag_dummy1='pointbypointstructure'
          if (is_tag_open_idf(tag_dummy1)) then
            if (idf_openingtaginentry) then
              npbp_element_idf=npbp_element_idf+1
            end if
          end if
        end if
c       x within pbpelement within pointbypointstructure
        if (trim(adjustl(idf_tag%name)).eq.'x') then
          tag_dummy1='pbpelement'
          tag_dummy2='pointbypointstructure'
          if (is_tag_open_idf(tag_dummy1).and.is_tag_open_idf(tag_dummy2)) then
            call get_ndatapoints_intag_idf
            nlayerspbpmax_idf=max(ndatapoints_intag_idf,nlayerspbpmax_idf)
         end if
        end if

c       spectrum within spectra
        if (trim(adjustl(idf_tag%name)).eq.'spectrum') then
          tag_dummy1='spectra'
c          tag_dummy2='spectra'
          if (is_tag_open_idf(tag_dummy1)) then
            idfnspectra=idfnspectra+1
          end if
        end if

      else if (idf_closingtaginentry) then

      end if


c     now consider the case that it is not an idf flag
      else if (idfntag.eq.0) then
        if (idf_fulltaginentry) then
c       a new group tag was opened
        else if (idf_openingtaginentry) then
          idfnopentags=idfnopentags+1
          idfopentags(idfnopentags)=trim(adjustl(idf_tag%name))
          idfopennamespace(idfnopentags)=trim(adjustl(namespaceinentry))
c       a previously open group tag is now closed, check that it is the same
        else if (idf_closingtaginentry) then
c         it is the same, need to close it.
          if (trim(adjustl(idf_tag%name)).eq.trim(adjustl(idfopentags(idfnopentags)))) then
            idfopentags(idfnopentags)=' '
            idfopennamespace(idfnopentags)=' '
            idfnopentags=idfnopentags-1
          end if
        end if

      end if

      if (trim(adjustl(idf_entry)).ne.'</idf>') goto 100
      idf_error='unspecified error reading file '//trim(adjustl(idf_file))

1001  continue
      close(idffileunit)
	return
1000  continue
      idf_error='file '//trim(adjustl(idf_file))//' does not exist'
      close(idffileunit)
	return
	end

c-----------------------------------------------------------------------
	subroutine validate_file_idf(idf_file)
      !DEC$ ATTRIBUTES DLLEXPORT::validate_file_idf
c     validates a given idf file 
c     requires that define_tags_idf has been called beforehand
c     laso returns the numbers of samples in the idf file, in idf_nsamples
	use IDFCOM
	implicit none
	integer i
	character idf_file*300
c	type(idf_sample)::sample
c-----------------------------------------------------------------------
      idf_tag%name=' '
      idf_tag%content=' '
c      write(*,*)'validate_file_idf enter'
      idf_ok=.false.
      validated_file_idf=.false.
      idf_error=' '
      idf_entry_leftover=' '
      if (.not.defined_tags_idf) then
        idf_error='routine define_tags_idf has not been successfully called beforehand'
c      write(*,*)'validate_file_idf:',trim(adjustl(idf_error))
        return
      end if
      if (.not.defined_units_idf) then
        idf_error='routine define_units_idf has not been successfully called beforehand'
c      write(*,*)'validate_file_idf:',trim(adjustl(idf_error))
        return
      end if

      open(idffileunit,file=idf_file,status='old',err=1000)

c     first deal with the mandatory initial tags
c     read the next entry. It returns the entire entry as idf_entry, the tag as idf_tag%name and idf_tag%content, and its number idfntag of the tag in the idftags(idfntags) list
      call read_next_entry_idf
c      write(*,*)'validate_file_idf idf_tag%name:',trim(adjustl(idf_tag%name))
c     there was a problem reading the next entry. idf_error has been set in the called routine
      if (.not.idf_ok) goto 1001
c     first entry in file must be the xml version
      if (trim(adjustl(idf_tag%name)).ne.'?xml') then
        idf_error='first entry in file is not the xml version'
        goto 1001
      end if
      call read_next_entry_idf
c     there was a problem reading the next entry. idf_error has been set in the called routine
      if (.not.idf_ok) goto 1001
c     second entry in file must be the idf tag
c      write(*,*)'second entry in file is not the idf tag:',trim(adjustl(idf_tag%name)),':'
c      pause
      if (trim(adjustl(idf_tag%name)).ne.'idf') then
        idf_error='second entry in file is not the idf tag'
        goto 1001
      end if
c     get the attributes in the idf tag, puts their name and content in idf_attributes%attribute(i)%name and idf_attributes%attribute(i)%content, and their number in idf_attributes%n
      call get_attributes_idf
      idf_attribute%name='xmlns:xsi'
c     looks in the array idf_attributes%name for idf_attribute%name, and puts the content into idf_attribute%content
      call get_attribute_idf
c     the attribute is missing or it could not be read. idf_error has been set in the called routine
      if (.not.idf_ok) goto 1001
c      write(*,*)'idf_attribute%content a:',trim(adjustl(idf_attribute%content))
      if (trim(adjustl(idf_attribute%content)).ne.'http://www.w3.org/2001/XMLSchema-instance'.and.
     +trim(adjustl(idf_attribute%content)).ne.'http://www.w3.org/2001/XMLSchema-instance/') then
        idf_error='idf tag attribute xmlns:xsi is not set to http://www.w3.org/2001/XMLSchema-instance'
ccc        goto 1001
      end if
      idf_attribute%name='xmlns'
      call get_attribute_idf
c     the attribute is missing or it could not be read. idf_error has been set in the called routine
      if (.not.idf_ok) goto 1001
c      write(*,*)'idf_attribute%content b:',trim(adjustl(idf_attribute%content))
      if (trim(adjustl(idf_attribute%content)).ne.'http://idf.schemas.itn.pt/'.and.
     +trim(adjustl(idf_attribute%content)).ne.'http://idf.schemas.itn.pt') then
        idf_error='idf tag attribute xmlns:xsi is not set to http://idf.schemas.itn.pt/'
ccc        goto 1001
      end if
      idf_attribute%name='xsi:schemaLocation'
      call get_attribute_idf
c     the attribute is missing or it could not be read. idf_error has been set in the called routine
      if (.not.idf_ok) goto 1001
c      write(*,*)'idf_attribute%content c:',trim(adjustl(idf_attribute%content))
      if (index(idf_attribute%content,'http://idf.schemas.itn.pt/').eq.0.and.
     +index(idf_attribute%content,'http://idf.schemas.itn.pt').eq.0) then
        idf_error='idf tag attribute xsi:schemaLocation is not set to http://idf.schemas.itn.pt/ http://idf.schemas.itn.pt/'
ccc        goto 1001
      end if
c     idf_idf_attributes are the attributes of the idf flag. This is needed to check for different namespaces, if some is found in some flag, it needs to be defined here
c     idf_idf_attributes%n is their number, idf_idf_attributes%attribute(i)%name and idf_idf_attributes%attribute(i)%content their name and content
      idf_idf_attributes=idf_attributes
c     previous line also copies empty attributes, it could be replaced by the following lines that would not do that
c     idf_idf_attributes%n=idf_attributes%n
c     idf_idf_attributes%attribute(1:idf_attributes%n)%name=idf_attributes%attribute(1:idf_attributes%n)%name
c     idf_idf_attributes%attribute(1:idf_attributes%n)%content=idf_attributes%attribute(1:idf_attributes%n)%content
c     gets the namespaces declared and puts them into idfnamespaces
      call get_namespaces_idf

c      write(*,*)' '
c      write(*,*)'finished header'
c      write(*,*)' '

c     initially, the idf taf is open
      idfnopentags=1
      idfopentags(1)='idf'
      call get_idfntag_idf(idfopentags(1),idfntag_opentag)
c      write(*,*)'idfntag_opentag',idfntag_opentag,trim(adjustl(idfopentags(idfnopentags)))

c     how many samples in the idf file
      idf_nsamples=0
c     mandatory initial tags are read. Now deal with everything else, until the closing tag </idf> comes
100   continue
c     read the nex entry. It returns the entire entry as idf_entry, the tag as idf_tag%name and idf_tag%content, and its number idfntag of the tag in the idftags(idfntags) list
c      write(*,*)'idfnopentags a:',idfnopentags,trim(adjustl(idfopentags(idfnopentags)))
      call read_next_entry_idf
c      write(*,*)'idf_entry:',trim(adjustl(idf_entry)),':',trim(adjustl(idf_entry_leftover)),idf_ok,idfntag
c      idfntag=1
c     there was a problem reading the next entry. idf_error has been set in the called routine
      if (.not.idf_ok) goto 1001

c     first consider the regular case that it is an idf flag
      if (idfntag.gt.0) then
c      write(*,*)'idfflaggroup:',idfflaggroup(idfntag),idf_fulltaginentry,idf_openingtaginentry,idf_closingtaginentry
c       get the attributes in the idf tag, puts their name and content in idf_attributes%attribute(i)%name and idf_attributes%attribute(i)%content, and their number in idf_attributes%n
        call get_attributes_idf
c       check whether it the content of the tag must be from a given allowed list
        if (idfncontentallowed(idfntag).gt.0) then
          call check_contentallowed_idf
          if (.not.idf_ok) goto 1001
        end if
c       quantities and spreads must have the units attribute
        if (idfquantitytype(idfntag).eq.'q'.or.idfquantitytype(idfntag).eq.'s') then
          call check_attribute_units_idf
          if (.not.idf_ok) goto 1001
        end if
c       spreads must have the mode attribute
        if (idfquantitytype(idfntag).eq.'s') then
          call check_attribute_mode_idf
          if (.not.idf_ok) goto 1001
        end if
c     idfflaggroup(idfntag) is true if the tag is a group of tags, and false if it is a data tag
c     first, consider the case that it is a group of tags
      if (idfflaggroup(idfntag)) then
c       the tag may have been opened and closed in the same entry; in this case, for a group tag, it must be empty, e.g. <sample></sample>. No content besides tags is allowed in group tags
        if (idf_fulltaginentry) then
          if (len_trim(trim(adjustl(idf_tag%content(1:100)))).gt.0) then
            idf_ok=.false.
            idf_error='group tag '//trim(adjustl(idf_tag%name))//' has content '//trim(adjustl(idf_tag%content(1:100)))
            goto 1001
          end if
c       a new group tag was opened
        else if (idf_openingtaginentry) then
          idfnopentags=idfnopentags+1
          idfopentags(idfnopentags)=trim(adjustl(idf_tag%name))
          idfopennamespace(idfnopentags)='idf'
          if (trim(adjustl(idf_tag%name)).eq.'sample') idf_nsamples=idf_nsamples+1
c         checks if the newly read tag can be a child of the previously open tag
          call get_check_valid_child_idf(idfntag_opentag,idfntag)
c      write(*,*)'get_check_valid_child_idf:',idfntag_opentag,idfntag,idf_ok,trim(adjustl(idftags(idfntag_opentag))),':',
c     +trim(adjustl(idftags(idfntag)))
          if (.not.idf_ok) goto 1001
c         assign to idfntag_opentag the newly read opening tag
          call get_idfntag_idf(idfopentags(idfnopentags),idfntag_opentag)
c      write(*,*)'get_idfntag_idf open:',idfnopentags,trim(adjustl(idfopentags(idfnopentags))),idfntag_opentag
c       a previously open group tag is now closed, check that it is the same
        else if (idf_closingtaginentry) then
c         it is the same, need to close it.
          if (trim(adjustl(idf_tag%name)).eq.trim(adjustl(idfopentags(idfnopentags)))) then
            idfopentags(idfnopentags)=' '
            idfopennamespace(idfnopentags)=' '
            idfnopentags=idfnopentags-1
            if (idfnopentags.eq.0.and.trim(adjustl(idf_tag%name)).eq.'idf') then
              idf_ok=.true.
              goto 1001
            end if
c           assign to idfntag_opentag the previously read opening tag
c      write(*,*)'get_idfntag_idf close:',idfnopentags,trim(adjustl(idf_tag%name))
            call get_idfntag_idf(idfopentags(idfnopentags),idfntag_opentag)
c      write(*,*)'get_idfntag_idf close:',idfnopentags,trim(adjustl(idfopentags(idfnopentags))),idfntag_opentag
          else
            idf_ok=.false.
            idf_error='group tag '//trim(adjustl(idf_tag%name))//' closed but tag '//trim(adjustl(idfopentags(idfnopentags)))//
     +      ' was open'
            goto 1001
          end if
        else
          idf_ok=.false.
          idf_error='group tag '//trim(adjustl(idf_tag%name))//' with content '//trim(adjustl(idf_tag%content(1:100)))//
     +    ' has a problem'
          goto 1001
        end if
c     it was not a group tag, so it must have been a data tag. Need to check that it has all the right attributes!
      else
c       data tags need to open and close in one single entry
        if (.not.idf_fulltaginentry) then
          idf_ok=.false.
          idf_error='group tag '//trim(adjustl(idf_tag%name))//' does not open and close in entry '//
     +    trim(adjustl(idf_tag%content(1:100)))
          goto 1001
        end if
c       now check for attributes
      end if

c     now consider the case that it is not an idf flag
      else if (idfntag.eq.0) then
c       check that the namespace of the tag has been declared
        call check_namespace_idf
        if (.not.idf_ok) goto 1001
c       checks if the newly read namespace can be a child of the previously open namespace
        call get_check_valid_child_namespace
        if (.not.idf_ok) goto 1001
        if (idf_fulltaginentry) then
c       a new group tag was opened
        else if (idf_openingtaginentry) then
          idfnopentags=idfnopentags+1
          idfopentags(idfnopentags)=trim(adjustl(idf_tag%name))
          idfopennamespace(idfnopentags)=trim(adjustl(namespaceinentry))
c         assign to idfntag_opentag the newly read opening tag
          call get_idfntag_idf(idfopentags(idfnopentags),idfntag_opentag)
c       a previously open group tag is now closed, check that it is the same
        else if (idf_closingtaginentry) then
c         it is the same, need to close it.
          if (trim(adjustl(idf_tag%name)).eq.trim(adjustl(idfopentags(idfnopentags)))) then
            idfopentags(idfnopentags)=' '
            idfopennamespace(idfnopentags)=' '
            idfnopentags=idfnopentags-1
c           assign to idfntag_opentag the previously read opening tag
            call get_idfntag_idf(idfopentags(idfnopentags),idfntag_opentag)
          else
            idf_ok=.false.
            idf_error='tag '//trim(adjustl(idf_tag%name))//' closed but tag '//trim(adjustl(idfopentags(idfnopentags)))//
     +      ' was open'
            goto 1001
          end if
        else
          idf_ok=.false.
          idf_error='tag '//trim(adjustl(idf_tag%name))//' with content '//trim(adjustl(idf_tag%content(1:100)))//
     +    ' has a problem'
          goto 1001
        end if

      end if


c      if (trim(adjustl(idf_entry)).ne.'</idf>') write(*,*)'idfnopentags b:',idfnopentags,trim(adjustl(idfopentags(idfnopentags)))
c      write(*,*)' '
c      write(*,*)'finished one entry, go to next'
c      write(*,*)' '
c      pause

      if (trim(adjustl(idf_entry)).ne.'</idf>') goto 100
c      write(*,*)'validated file idf!'



      idf_ok=.true.
      validated_file_idf=.true.
1001  continue
      close(idffileunit)
      write(*,*)'validate_file_idf:',trim(adjustl(idf_error))
	return
1000  continue
      idf_error='file '//trim(adjustl(idf_file))//' does not exist'
      close(idffileunit)
      write(*,*)'validate_file_idf:',trim(adjustl(idf_error))
	return
	end

c-----------------------------------------------------------------------
      subroutine check_attribute_units_idf
c     quantities and spreads must have the units attribute
	use IDFCOM
	implicit none
	integer i,j,k
c-----------------------------------------------------------------------
      idf_error=' '
      idf_ok=.false.
      if (idfquantitytype(idfntag).ne.'q'.and.idfquantitytype(idfntag).ne.'s') then
        idf_ok=.true.
        goto 1001
      end if

      do i=1,idf_attributes%n
        if (trim(adjustl(idf_attributes%attribute(i)%name)).eq.'units') then
          if (len_trim(idf_attributes%attribute(i)%content).eq.0) then
            idf_error='tag '//trim(adjustl(idf_tag%name))//' has empty units attribute'
            goto 1001
          end if
          goto 1002
        end if
      end do
      idf_error='tag '//trim(adjustl(idf_tag%name))//' does not have units attribute'
      goto 1001

1002  continue
c     check whether the units are correct for quantity in question
c     first, if there was no quantity defined for the tag, all OK
      if (len_trim(adjustl(idftagquantities(idfntag))).eq.0) then
        idf_ok=.true.
        goto 1001
      end if
      do k=1,idfnquantities
        if (trim(adjustl(idfquantities(k))).eq.trim(adjustl(idftagquantities(idfntag)))) goto 1003
      end do
      idf_error='tag '//trim(adjustl(idf_tag%name))//' is in file idf_tags has quantity '//trim(adjustl(idftagquantities(idfntag)))
     +//' which is not in idf_units file'
      goto 1001

1003  continue
c     quantity has been recognised in the list given in idf_units file, now check whether the unit is in the list for this quantity
      do j=1,idfnunits(k)
        if (trim(adjustl(idfunits(k,j))).eq.'0'.or.
     +  trim(adjustl(idfunits(k,j))).eq.trim(adjustl(idf_attributes%attribute(i)%content))) then
          idf_ok=.true.
          goto 1001
        end if
      end do
      idf_error='tag '//trim(adjustl(idf_tag%name))//' in file idf_tags has quantity '//trim(adjustl(idftagquantities(idfntag)))
     +//' with units '//trim(adjustl(idf_attributes%attribute(i)%content))//' which is not in idf_units file'

1001  continue
	return
	end

c-----------------------------------------------------------------------
      subroutine check_attribute_mode_idf
c     spreads must have the mode attribute
	use IDFCOM
	implicit none
	integer i
c-----------------------------------------------------------------------
      idf_error=' '
      idf_ok=.false.
      if (idfquantitytype(idfntag).ne.'s') then
        idf_ok=.true.
        goto 1001
      end if

      do i=1,idf_attributes%n
        if (trim(adjustl(idf_attributes%attribute(i)%name)).eq.'mode') then
          if (len_trim(idf_attributes%attribute(i)%content).eq.0) then
            idf_error='tag '//trim(adjustl(idf_tag%name))//' has empty mode attribute'
            goto 1001
          end if
          idf_ok=.true.
          goto 1001
        end if
      end do

      idf_error='tag '//trim(adjustl(idf_tag%name))//' does not have mode attribute'

1001  continue
	return
	end

c-----------------------------------------------------------------------
      subroutine check_contentallowed_idf
c     check whether it the content of the tag must be from a given allowed list
	use IDFCOM
	implicit none
	integer i
c-----------------------------------------------------------------------
      idf_error=' '
      idf_ok=.false.
      if (idfncontentallowed(idfntag).eq.0) then
        idf_ok=.true.
        goto 1001
      end if

      do i=1,idfncontentallowed(idfntag)
        if (trim(adjustl(idf_tag%content)).eq.trim(adjustl(idfcontentallowed(idfntag,i)))) then
          idf_ok=.true.
          goto 1001
        end if
      end do

      idf_error='tag '//trim(adjustl(idf_tag%name))//' has content '//trim(adjustl(idf_tag%content))//
     +' which is not in the allowed content list'
1001  continue
	return
	end

c-----------------------------------------------------------------------
      subroutine get_check_valid_child_namespace
c       checks if the newly read namespace can be a child of the previously open namespace
	use IDFCOM
	implicit none
c-----------------------------------------------------------------------
      idf_error=' '
      idf_ok=.false.
c     idf namespace can have any declared namespace as child
      if (trim(adjustl(idfopennamespace(idfnopentags))).eq.'idf') then
        idf_ok=.true.
        goto 1001
      end if
c     otherwise it has to be the same namespace
      if (trim(adjustl(idfopennamespace(idfnopentags))).eq.trim(adjustl(namespaceinentry))) then
        idf_ok=.true.
        goto 1001
      end if
      idf_error='namespace in non-idf tag not a valid child of previous namespace:'//trim(adjustl(namespaceinentry))
1001  continue
	return
	end

c-----------------------------------------------------------------------
      subroutine check_namespace_idf
c     check that the namespace of the tag has been declared
	use IDFCOM
	implicit none
	integer l,i1,i2,i3
c-----------------------------------------------------------------------
      idf_error=' '
      idf_ok=.false.
      namespaceinentry=' '

      i1=index(idf_tag%name,':')
      if (i1.eq.0) goto 1000

      do l=2,idfnnamespaces
        if (trim(adjustl(idf_tag%name(1:i1-1))).eq.trim(adjustl(idfnamespaces(l)))) then
          namespaceinentry=trim(adjustl(idfnamespaces(l)))
c      write(*,*)'  namespaceinentry:',trim(adjustl(idfnamespaces(l)))
          idf_ok=.true.
          goto 1001
        end if
      end do

      idf_error='namespace in non-idf tag not declared:'//trim(adjustl(idf_tag%name))
1001  continue
	return
1000  continue
      idf_error='no namespace in non-idf tag:'//trim(adjustl(idf_tag%name))

	return
	end

c-----------------------------------------------------------------------
      subroutine get_namespaces_idf
c     gets the namespaces declared and puts them into idfnamespaces
	use IDFCOM
	implicit none
	integer l,i1,i2,i3
c-----------------------------------------------------------------------
      idf_error=' '
      idf_ok=.false.
      idfnnamespaces=1
      idfnamespaces(idfnnamespaces)='idf'

      do l=1,idf_attributes%n
        i1=index(idf_attributes%attribute(l)%name,'xmlns:')
        if (i1.gt.0) then
          if (idfnnamespaces.eq.idfnamespacesmax) then
            idf_error='too many declared namespaces'
          else
            idfnnamespaces=idfnnamespaces+1
            i2=len_trim(idf_attributes%attribute(l)%name)
            idfnamespaces(idfnnamespaces)=trim(adjustl(idf_attributes%attribute(l)%name(i1+6:i2)))
c      write(*,*)'  ns:',idfnamespaces(idfnnamespaces)
          end if
        end if
      end do

      idf_ok=.true.
1001  continue
	return
1000  continue
      idf_error='problem in getting namespaces in opening idf tag '

	return
	end

c-----------------------------------------------------------------------
      subroutine get_attributes_idf
c     get the attributes in the current idf_tag, puts their name and content in idf_attributes%attribute(i)%name and idf_attributes%attribute(i)%content, and their number in idf_attributes%n
c     uses idf_entry, which is the entire entry last read
	use IDFCOM
	implicit none
	integer l,i1,i2,i3
c-----------------------------------------------------------------------
      idf_error=' '
      idf_ok=.false.

      idf_attributes%n=0
      do l=1,idfnattrmax
        idf_attributes%attribute(l)%name=' '
        idf_attributes%attribute(l)%content=' '
      end do

      l=len_trim(idf_tag%name)
      if (l.eq.0) then
        idf_error='can not get atributes because no tag was supplied, in entry '//trim(adjustl(idf_entry(1:100)))
        goto 1001
      end if
      i1=index(idf_entry,trim(adjustl(idf_tag%name)))
      if (i1.eq.0) then
        idf_error='tag '//trim(adjustl(idf_tag%name))//' not found in entry '//trim(adjustl(idf_entry(1:100)))
        goto 1001
      end if
      i2=index(idf_entry,'>')
      if (i2.eq.0) then
        idf_error='no closing symbol > found in entry '//trim(adjustl(idf_entry(1:100)))
        goto 1001
      end if

      idf_entry_aux=trim(adjustl(idf_entry(i1+l:i2-1)))
10    continue
      i1=index(idf_entry_aux,'=')
      if (i1.gt.0) then
        l=len_trim(idf_entry_aux)
        idf_attributes%n=idf_attributes%n+1
        idf_attributes%attribute(idf_attributes%n)%name=idf_entry_aux(1:i1-1)
        i2=index(idf_entry_aux,'"')
        if (i2.gt.0) then
          i3=index(idf_entry_aux(i2+1:l),'"')
          if (i3.gt.0) then
            idf_attributes%attribute(idf_attributes%n)%content=trim(adjustl(idf_entry_aux(i2+1:i2+i3-1)))
            idf_entry_aux=idf_entry_aux(i2+i3+1:l)
            goto 10
          end if
        end if
      end if

      do l=1,idf_attributes%n
c      write(*,*)'  tag ',trim(adjustl(idf_tag%name)),':',
c     +trim(adjustl(idf_attributes%attribute(l)%name)),':',trim(adjustl(idf_attributes%attribute(l)%content))
      end do

      idf_ok=.true.
1001  continue
	return
1000  continue
      idf_error='problem in getting atributes in tag '//trim(adjustl(idf_tag%name))//' from entry '//trim(adjustl(idf_entry(1:100)))

	return
	end

c-----------------------------------------------------------------------
      subroutine get_attribute_idf
c     looks in the array idf_attributes%name for idf_attribute%name, and puts the content into idf_attribute%content
	use IDFCOM
	implicit none
	integer i
c-----------------------------------------------------------------------
c      write(*,*)'get_attribute_idf:',trim(adjustl(idf_attribute%name))
      idf_attribute%content=' '
      idf_ok=.false.
      idf_error=' '

      do i=1,idf_attributes%n
        if (trim(adjustl(idf_attribute%name)).eq.trim(adjustl(idf_attributes%attribute(i)%name))) then
c      write(*,*)'  found attribute:',i
          idf_attribute%content=trim(adjustl(idf_attributes%attribute(i)%content))
          idf_ok=.true.
          goto 1001
        end if
      end do
      goto 1000

1001  continue
	return
1000  continue
      idf_error='idf_attribute '//trim(adjustl(idf_attribute%name))//' not found in tag '//trim(adjustl(idf_tag%name))

	return
	end

c-----------------------------------------------------------------------
      subroutine get_check_valid_child_idf(idftag1,idftag2)
c     checks if the tag with number idftag2 can be a child of tag with number idftag1
	use IDFCOM
	implicit none
	integer i,idftag1,idftag2
c-----------------------------------------------------------------------
      idf_error=' '
      idf_ok=.false.

c     if idftag1 is not an idf tag, then idftag2 also cannot be
      if (idftag1.eq.0) then
        if (idftag2.eq.0) then
          idf_ok=.true.
          goto 1001
        else
          idf_error='non-idf tag cannot have as child an idf tag'
          goto 1001
        end if
      end if

c     all tags can be child of idf
      if (trim(adjustl(idftags(idftag1))).eq.'idf') then
        idf_ok=.true.
        goto 1001
      end if

      do i=1,idfnchildren(idftag1)
        if (trim(adjustl(idfchildren(idftag1,i))).eq.trim(adjustl(idftags(idftag2)))) then
          idf_ok=.true.
          goto 1001
        end if
      end do

      idf_error='tag '//trim(adjustl(idftags(idftag1)))//' cannot have as child tag '//trim(adjustl(idftags(idftag2)))

1001  continue
	return
1000  continue
	return
	end

c-----------------------------------------------------------------------
	subroutine read_next_entry_idf
c     read the nex entry. It returns the entire entry as idf_entry, the tag as idf_tag%name and idf_tag%content, and its number idfntag of the tag in the idftags(idfntags) list
c     idf_entry_leftover must be initialised as ' ' before the first call to this routine when reading each file.
c     only full lines can be commented out! This is a restriction to the idf standard.
c     each new line is read as idf_newline. Called auxiliary subroutines work on this variable. A full entry idf_entry can be the concatenation of several new lines
c     idf_fulltaginentry, idf_openingtaginentry, idf_closingtaginentry are true if there is a full tag, an opening tag only, or a closing tag only in the entry
	use IDFCOM
	implicit none
	integer t1i,t1e,t2i,t2e,i,l_tag,l
c-----------------------------------------------------------------------
c      write(*,*)'read_next_entry_idf enter'
      idf_fulltaginentry=.false.
      idf_openingtaginentry=.false.
      idf_closingtaginentry=.false.
      idf_error=' '
      idf_newline=' '
      idf_ok=.false.
      idf_tag%name=' '
      idf_tag%content=' '

20    continue
c     if there was a leftover bit of entry from previous call, it comes in front of what is now read
      if (len_trim(idf_entry_leftover).gt.0) then
c        l=len_trim(idf_entry_leftover)
c        idf_newline=idf_entry_leftover(1:l)
        idf_newline=trim(adjustl(idf_entry_leftover))
        idf_entry_leftover=' '
      else
        read(idffileunit,1,end=1000,err=1000)idf_newline
c       removes comments and tabs from idf_newline
        call remove_blanks_tabs_idf
c        idf_newline=trim(adjustl(idf_newline))
c       remove_comments_idf removes comments from idf_newline, that must be full lines. No partial lines can be removed! On exit, if everything went well, idf_newline has a new line that is not a comment
        call remove_comments_idf
        if (.not.idf_ok) goto 1001
      end if
      idf_entry=idf_newline
      if (len_trim(idf_newline).eq.0) then
        idf_entry_leftover=' '
        goto 20
      end if

c      write(*,*)'read_next_entry_idf a ',trim(adjustl(idf_newline(1:100)))

      if (idf_newline(1:1).ne.'<') then
        idf_error='all entries must start with a tag or end of tag. Check:'//trim(adjustl(idf_newline(1:100)))
        goto 1001
      end if
c      if (idf_newline(1:6).eq.'</idf>') then
c        idf_error='</idf>'
c        idf_ok=.true.
c        goto 1001
c      end if

c     get tag idf_tag1 in idf_newline - if there is no tag, idf_ok is false. if the tag opens and closes in the idf_newline, idf_fulltaginentry is true
c     if there is a single closing tag in entry, then idf_closingtaginentry is true
c     if two different tags are present, idf_ok is false
c     content in the flag is returned to idf_entry_aux
      call get_tag_in_entry_idf
c      write(*,*)'  idfflaggroup a:',idf_fulltaginline,idf_openingtaginline,idf_closingtaginline
      if (.not.idf_ok) goto 1001
      idf_tag%name=trim(adjustl(idf_tag1))
      idf_tag%content=trim(adjustl(idf_entry_aux))
c     if the line had a full tag, then it is an entry, and the entry also has a full tag; in any case, save the current flags in case this was an opening or closing group tag
      idf_fulltaginentry=idf_fulltaginline
      idf_openingtaginentry=idf_openingtaginline
      idf_closingtaginentry=idf_closingtaginline
c      idf_openingtaginentry=idf_openingtaginline
c      idf_closingtaginentry=idf_closingtaginline
c     if it was a full entry with tag opening and closing, job is done
      if (idf_fulltaginentry) then
        idf_ok=.true.
        goto 1001
      end if
c      idf_fulltaginline=idf_fulltaginline_save

10    continue
c     it was not a full entry, so read new line
      read(idffileunit,1,end=1000,err=1000)idf_newline
      call remove_blanks_tabs_idf
c      idf_newline=trim(adjustl(idf_newline))
      call remove_comments_idf
      if (.not.idf_ok) goto 1001
c     check for tags.
c      write(*,*)'  read_next_entry_idf call get_tag_in_entry_idf'
      call get_tag_in_entry_idf
c      write(*,*)'  idfflaggroup b:',idf_fulltaginline,idf_openingtaginline,idf_closingtaginline
c      write(*,*)'  idfflaggroup:',idf_fulltaginline,idf_openingtaginline,idf_closingtaginline
      if (.not.idf_ok) goto 1001
c     there were no tags: add content to already determined content of idf_tag
      if (idf_notaginline) then
        idf_tag%content=trim(adjustl(idf_tag%content(1:100)))//' '//trim(adjustl(idf_newline))
        idf_entry=trim(adjustl(idf_entry))//' '//trim(adjustl(idf_newline))
        goto 10
      end if
c     there were tags
c     if it was a full entry with tag opening and closing, then this is a child of main flag, that has been opened in the entry
      if (idf_fulltaginline) then
c        idf_openingtaginentry=.true.
        idf_entry_leftover=trim(adjustl(idf_newline))
        idf_error=' '
        idf_ok=.true.
        goto 1001
      end if
c     if it is a closing tag
      if (idf_closingtaginline) then
c       if it is a closing tag
        if (trim(adjustl(idf_tag1)).ne.trim(adjustl(idf_tag%name))) then
c         if it is a closing tag different from previous opened tag, then this is error
          if (idf_openingtaginentry) then
            idf_ok=.false.
            idf_error='closed a tag different from last open in entry containing '//trim(adjustl(idf_newline(1:100)))
            goto 1001
c         if it is a closing tag different from previous closing tag
          else
            idf_entry_leftover=trim(adjustl(idf_newline))
            idf_error=' '
            idf_ok=.true.
            goto 1001
          end if
c       if it is a closing the previoulsy open tag, job is done
        else
          idf_fulltaginentry=.true.
          idf_ok=.true.
          idf_error=' '
          idf_entry_leftover=' '
          idf_tag%content=trim(adjustl(idf_tag%content(1:100)))//' '//trim(adjustl(idf_entry_aux))
          idf_entry=trim(adjustl(idf_entry))//' '//trim(adjustl(idf_newline))
          goto 1001
        end if
      end if
c     if it is an opening tag, then this is a child of main flag or a new flag starting after a closing
      if (idf_openingtaginline) then
c     if it is an opening flag different from previous flag (that could be opening or closing), then this is a child of main flag or a new flag starting after a closing
c      if (trim(adjustl(idf_tag1)).ne.trim(adjustl(idf_tag%name))) then
c      if (idf_tag1.ne.idf_tag%name) then
c        idf_openingtaginentry=.true.
        idf_entry_leftover=trim(adjustl(idf_newline))
        idf_ok=.true.
        goto 1001
      end if
c      write(*,*)'read_next_entry_idf out of cases'
      idf_error='read_next_entry_idf out of cases'

1001  continue
c     determines the number of the tag in the list of tags. If it is not there, returns zero
      if (idf_ok) then
c      write(*,*)'read_next_entry_idf call get_idfntag_idf:',trim(adjustl(idf_tag%name))
        call get_idfntag_idf(idf_tag%name,idfntag)
      end if
	return
1000  continue
      idf_error='found end of file without </idf> tag appearing'
	return
1     format(a)
	end

c-----------------------------------------------------------------------
      subroutine get_idfntag_idf(tagaux,idfntagaux)
c     gets the idfntag for a given input tag
	use IDFCOM
	implicit none
	integer i,idfntagaux
	character tagaux*(*)
c-----------------------------------------------------------------------
c      write(*,*)'get_idfntag_idf enter:',trim(adjustl(idf_tag%name))
      idfntagaux=0
      do i=1,idfntags
c      write(*,*)'get_idfntag_idf a:',i,trim(adjustl(tagaux)),':',trim(adjustl(idftags(i)))
        if (trim(adjustl(tagaux)).eq.trim(adjustl(idftags(i)))) then
c      if (trim(adjustl(tagaux)).eq.'beamangularspread') 
c     +write(*,*)'get_idfntag_idf a:',i,':',trim(adjustl(tagaux)),':',trim(adjustl(idftags(i))),':',idfambiguous(i),':',
c     +trim(adjustl(idfambiguousparent(i))),':',trim(adjustl(idfopentags(idfnopentags)))
          if (.not.idfambiguous(i).or.idfnopentags.eq.0) then
            idfntagaux=i
            return
          else if (trim(adjustl(idfambiguousparent(i))).eq.trim(adjustl(idfopentags(idfnopentags)))) then
            idfntagaux=i
            return
          end if
        end if
      end do
      return
      end

c-----------------------------------------------------------------------
      subroutine get_tag_in_entry_idf
c     get tag idf_tag1 in idf_newline
c     if there is a single opening tag in entry, then idf_openingtaginline is true
c     if there is a single closing tag in entry, then idf_closingtaginline is true
c     if there is a full tag in entry (open and close), then idf_fulltaginline is true
c     if there is no tag in entry, then idf_notaginline is true
c     if two different tags are present, idf_ok is false
c     content in the flag is returned to idf_entry_aux
	use IDFCOM
	implicit none
	integer t1i,t1e,t2i,t2e,i
c-----------------------------------------------------------------------
      idf_error=' '
      idf_tag1=' '
      idf_entry_aux=' '
      idf_ok=.false.
      idf_fulltaginline=.false.
      idf_openingtaginline=.false.
      idf_closingtaginline=.false.
      idf_notaginline=.false.
      t1i=index(idf_newline,'<')
      t1e=index(idf_newline,'>')

c     ?xml tag
      i=index(idf_newline,'?xml')
      if (i.gt.0) then
        idf_ok=.true.
        idf_tag1='?xml'
        idf_entry_aux=' '
        idf_fulltaginline=.true.
        goto 1001
      end if

c     no tag in entry
      if (t1i.eq.0.and.t1e.eq.0) then
        idf_notaginline=.true.
        idf_entry_aux=trim(adjustl(idf_newline))
        idf_ok=.true.
        goto 1001
      end if

c     only > - error
      if (t1e.gt.0.and.t1i.eq.0) then
        idf_error='only > without < present in entry '//trim(adjustl(idf_newline))
        goto 1001
      end if
c     only < - error
      if (t1i.gt.0.and.t1e.eq.0) then
        idf_error='only < without > present in entry '//trim(adjustl(idf_newline))
        goto 1001
      end if
c     first > then < - error
      if (t1i.ge.t1e-1) then
        idf_error='> comes before < in entry '//trim(adjustl(idf_newline))
        goto 1001
      end if

      t2i=index(idf_newline,'<',back=.true.)
      t2e=index(idf_newline,'>',back=.true.)

c      write(*,*)'  get_tag_in_entry_idf',trim(adjustl(idf_newline)),':',trim(adjustl(idf_newline(t1i+1:t1e-1))),':',
c     +trim(adjustl(idf_newline(t2i+1:t2e-1)))
c     the first tag in entry is a closing tag.
      if (idf_newline(t1i+1:t1i+1).eq.'/') then
c      write(*,*)'  get_tag_in_entry_idf',t1i,t1e,t2i,t2e
c       single closing tag, fine
        if (t1i.eq.t2i.and.t1e.eq.t2e) then
          idf_tag1=trim(adjustl(idf_newline(t1i+2:t1e-1)))
          idf_entry_aux=idf_newline(1:t1i-1)
          idf_closingtaginline=.true.
          idf_ok=.true.
c      write(*,*)'  idf_closingtaginline',idf_fulltaginline,idf_openingtaginline,idf_closingtaginline
          goto 1001
c       multiple tags in entry that has as first tag a closing tag, error  
        else
          idf_error='multiple tags (at least one closing) in entry '//trim(adjustl(idf_newline))
          goto 1001
        end if
      end if

c     the first tag in entry is an opening tag.
      if (idf_newline(t1i+1:t1i+1).ne.'/') then
c       single opening tag, fine, must get what is the tag and what is the attributes
        if (t1i.eq.t2i.and.t1e.eq.t2e) then
          idf_tag1=trim(adjustl(idf_newline(t1i+1:t1e-1)))
          i=index(idf_tag1,' ')
          if (i.ne.0) idf_tag1=idf_tag1(1:i-1)
          idf_entry_aux=trim(adjustl(idf_newline(t1e+1:len_trim(idf_newline))))
          idf_openingtaginline=.true.
          idf_ok=.true.
          goto 1001
c       multiple opening tags in entry, error  
        else
          if (idf_newline(t2i+1:t2i+1).ne.'/') then
            idf_error='multiple opening tags in entry '//trim(adjustl(idf_newline))
            goto 1001
          else
            idf_tag1=trim(adjustl(idf_newline(t1i+1:t1e-1)))
            i=index(idf_tag1,' ')
            if (i.ne.0) idf_tag1=idf_tag1(1:i-1)
c           it is a full tag in entry, opening then closing
c      write(*,*)'get_tag_in_entry_idf:',trim(adjustl(idf_tag1)),':',idf_newline(t2i+2:t2e-1)
            if (trim(adjustl(idf_tag1)).eq.idf_newline(t2i+2:t2e-1)) then
              idf_entry_aux=trim(adjustl(idf_newline(t1e+1:t2i-1)))
              idf_fulltaginline=.true.
              idf_ok=.true.
              goto 1001
c           different opening and closing tags, error
            else
              idf_tag1=' '
              idf_error='different opening and closing tags in entry '//trim(adjustl(idf_newline))
              goto 1001
            end if
          end if
        end if
      end if


1001  continue
	return
	end

c-----------------------------------------------------------------------
      subroutine remove_blanks_tabs_idf
c     removes comments and tabs from idf_newline
	use IDFCOM
	implicit none
	integer i,j
c-----------------------------------------------------------------------
      idf_error=' '
      idf_ok=.true.
10    continue
      idf_newline=trim(adjustl(idf_newline))
      i=index(idf_newline,'	')
      j=len('	')
      if (i.eq.1) then
        idf_newline=idf_newline(i+j:len_trim(idf_newline))
        goto 10
      end if
      return
      end

c-----------------------------------------------------------------------
      subroutine remove_comments_idf
c     check that there is not a comment mark; if there is, remove everything between <!-- and -->
c     note that nested comments are not allowed and will lead to unpredictable results. This is a restriction to the idf standard. Current code does not check for nested comments
c     remove_comments_idf removes comments from idf_newline, and returns a new idf_newline without comments
	use IDFCOM
	implicit none
	integer i,j
c-----------------------------------------------------------------------
      idf_error=' '
      idf_ok=.false.
      idf_entry_aux=idf_newline
9     continue
      i=index(idf_newline,'<!--')
      if (i.gt.0) then
c       now must follow the file until the end of the comment comes
11      continue
        j=index(idf_newline,'-->')
c       that was the end of the comment    
        if (j.gt.0) then
          goto 10
        else
          read(idffileunit,1,err=1000,end=1000)idf_newline
c         removes comments and tabs from idf_newline
          call remove_blanks_tabs_idf
c          idf_newline=trim(adjustl(idf_newline))
        end if
        goto 11
10      continue
      else
        idf_ok=.true.
        return
      end if
      read(idffileunit,1,err=1000,end=1000)idf_newline
c     removes comments and tabs from idf_newline
      call remove_blanks_tabs_idf
c      idf_newline=trim(adjustl(idf_newline))
      goto 9
1000  continue
      idf_error='beginning of comment found but no end of the comment, near entry '//trim(adjustl(idf_entry_aux))
      return
1     format(a)
      end

c-----------------------------------------------------------------------
	subroutine get_nsamples_idf(idf_file)
      !DEC$ ATTRIBUTES DLLEXPORT::get_nsamples_idf
c     checks how many samples are there in a given idf file. 
c     idf_ok is false if the file does not exist or if there is a problem with the <sample> tags
	use IDFCOM
	implicit none
	integer nopen,nclose
	character idf_file*300,a3000*300  !does not need to be more than 300
c-----------------------------------------------------------------------
c      write(*,*)'get_nsamples_idf enter'
      idf_ok=.false.
      idf_error=' '
      open(idffileunit,file=idf_file,status='old',err=1000)

      nopen=0
      nclose=0
10    continue
      read(idffileunit,1,err=11,end=11)a3000
      if (index(a3000,'<sample>').ne.0) nopen=nopen+1
      if (index(a3000,'</sample>').ne.0) nclose=nclose+1
      goto 10
11    continue
      if (nopen.ne.nclose) then
        idf_error='tag <sample> opened and closed different number of times'
        goto 1001
      end if
      idf_nsamples=nopen
      idf_ok=.true.

1001  continue
      close(idffileunit)
c      write(*,*)'get_nsamples_idf:',trim(adjustl(idf_error)),idf_nsamples
	return
1000  continue
      idf_error='file '//trim(adjustl(idf_file))//' does not exist'
      close(idffileunit)
c      write(*,*)'get_nsamples_idf:',trim(adjustl(idf_error))
	return
1     format(a)
	end

c-----------------------------------------------------------------------
	subroutine initialise_idf
      !DEC$ ATTRIBUTES DLLEXPORT::initialise_idf
c     reads tags_idf and units_idf
	use IDFCOM
	implicit none
c-----------------------------------------------------------------------
      idf_ok=.false.
      idf_error=' '
      call define_tags_idf
      if (.not.idf_ok) goto 1000
      call define_units_idf
      if (.not.idf_ok) goto 1000
c      write(*,*)'IDF initialisation successfull'
	return
1000  continue
c      write(*,*)'IDF initialisation not successfull:',trim(adjustl(idf_error))
c      stop ' '
	return
	end
	
c-----------------------------------------------------------------------
	logical function is_tag_open_idf(tag_dummy)
c     checks whether tag with name tag_dummy is currently open or closed. Returns  .true. if it is open.
	use IDFCOM
	implicit none
	integer i,j,nparts
	character tag_dummy*(*)
c-----------------------------------------------------------------------
c      write(*,*)'get_idfntag_idf enter:',trim(adjustl(idf_tag%name))
      is_tag_open_idf=.false.
      do i=1,idfntags
        if (trim(adjustl(tag_dummy)).eq.trim(adjustl(idftags(i)))) then
          is_tag_open_idf=idf_tagopen(i)
          return
        end if
      end do
      return
      end

c-----------------------------------------------------------------------
      subroutine get_ndatapoints_intag_idf
c     gets the number of data points in a array tag entry.
	use IDFCOM
	implicit none
	integer i,j,eox78
c-----------------------------------------------------------------------
	idf_entry_aux=' '
	ndatapoints_intag_idf=0
c	i=ubound(parts(:),dim=1)
c	parts(:i)=' '
c	save input line, it will not be changed
	idf_entry_aux=trim(adjustl(idf_tag%content))
	
101	continue
	eox78=index(idf_entry_aux,char(9))
	if (eox78.gt.0) then
	  idf_entry_aux(eox78:eox78)=' '
	  goto 101
	end if

100	continue
c	check if there is still at least one word left
	if (verify(idf_entry_aux,' ').eq.0) return
c	cut out initial blanks
	idf_entry_aux=adjustl(idf_entry_aux)
c	end of a word
	eox78=index(idf_entry_aux,' ')-1
c     new word: increment number of words
	ndatapoints_intag_idf=ndatapoints_intag_idf+1
c	cut out word just read from the line
      idf_entry_aux=idf_entry_aux(eox78+1:len_trim(idf_entry_aux))
c	check for a new word
	goto 100

	end

c-----------------------------------------------------------------------
	subroutine define_tags_idf
c     reads the file idf_tags that has all the tags in IDF
c     each line in the file can have a maximum of 3000 characters. To change it to e.g. 5000, replace a3000*3000 by a3000*5000
c     each tag is allowed a maximum of 500 children. To change it to e.g. 100, change parts(502) to parts(102), and change also parts in routine parse_idf_a3000
c     each tag is allowed a maximum of 72 characters. To change it, all the routines where character variables are defined as *72 must be changed. This includes module IDFCOM
	use IDFCOM
	implicit none
	integer i,j,nparts
	character a3000*3000,parts(502)*72
c-----------------------------------------------------------------------
c      write(*,*)'define_tags_idf enter'
      idf_ok=.false.
      defined_tags_idf=.false.
      idf_path=' '
      idf_error=' '

      open(idffileunit,status='scratch')
      write(idffileunit,1)'=====HEADER START====='
      write(idffileunit,1)'DO NOT EDIT THIS FILE!!!!! IDF TAGS INCLUDED IN V1.02'
      write(idffileunit,1)'Each line is one IDF tag. All IDF tags have to be here, except for the main tag idf'
      write(idffileunit,1)'Tags from other schemas cannot be here'
      write(idffileunit,1)'First entry in one line is the tag;'
      write(idffileunit,1)'then, whether it is a group of tags (y) or a data tag (n);'
      write(idffileunit,1)'then for data tags, the type of content: c, i, r, l, ac, ai, at, al are:'
      write(idffileunit,1)'	0  is none'
      write(idffileunit,1)'	c  is character'
      write(idffileunit,1)'	i  is integer'
      write(idffileunit,1)'	r  is real'
      write(idffileunit,1)'	l  is logical'
      write(idffileunit,1)'	ac is an array of character'
      write(idffileunit,1)'	ai is an array of integer'
      write(idffileunit,1)'	ar is an array of real'
      write(idffileunit,1)'	al is an array of logical;'
      write(idffileunit,1)'then for groups of tags, come the names of all tags that can be children of the given tag, with the excep
     +tion of users and notes, which are assumed for all groups of tags.'
      write(idffileunit,1)'     for tags, comes a letter that tells whether the tag is a physical quantity, a quantity that describ
     +es a spread, or not a physical quantity:'
      write(idffileunit,1)'	q  means physical quantity'
      write(idffileunit,1)'	s  means quantity that describes a spread'
      write(idffileunit,1)'	0  means it is not a physical quantity'
      write(idffileunit,1)'	n  means it is a quantity name'
      write(idffileunit,1)'	u  means it is a unit'
      write(idffileunit,1)'	l  means it is a list of allowed values'
      write(idffileunit,1)'=====HEADER END====='
      write(idffileunit,1)''
      write(idffileunit,1)'?xml y'
      write(idffileunit,1)''
      write(idffileunit,1)'idf y attributes sample repository'
      write(idffileunit,1)''
      write(idffileunit,1)'users y user'
      write(idffileunit,1)'notes y note'
      write(idffileunit,1)'user n c 0'
      write(idffileunit,1)'note n c 0'
      write(idffileunit,1)''
      write(idffileunit,1)'attributes y idfversion filename createtime updatetimes code version'
      write(idffileunit,1)'idfversion n c 0'
      write(idffileunit,1)'filename n c 0'
      write(idffileunit,1)'createtime n c q time'
      write(idffileunit,1)'updatetimes y updatetime'
      write(idffileunit,1)'updatetime n c q time'
      write(idffileunit,1)'code n c 0'
      write(idffileunit,1)'version n c 0'
      write(idffileunit,1)''
      write(idffileunit,1)'sample y 0 description elementsandmolecules structure spectra'
      write(idffileunit,1)''
      write(idffileunit,1)'description n c 0'
      write(idffileunit,1)''
      write(idffileunit,1)'elementsandmolecules y 0 elements molecules'
      write(idffileunit,1)'elements y nelements element'
      write(idffileunit,1)'nelements n i 0'
      write(idffileunit,1)'element y name density'
      write(idffileunit,1)'name n c 0'
      write(idffileunit,1)'density n r q density '
      write(idffileunit,1)'molecules y nmolecules molecule'
      write(idffileunit,1)'nmolecules n i 0'
      write(idffileunit,1)'molecule y name density'
      write(idffileunit,1)'structure y crystalstructure layeredstructure pointbypointstructure'
      write(idffileunit,1)'crystalstructure n c 0'
      write(idffileunit,1)'layeredstructure y nlayers layers equationoverlays roughness'
      write(idffileunit,1)'nlayers n i 0'
      write(idffileunit,1)'layers y layer'
      write(idffileunit,1)'layer y layerthickness layeruniformity layerdensity layerelements layermolecules'
      write(idffileunit,1)'layerthickness n r q arealdensityorthickness'
      write(idffileunit,1)'layeruniformity n r s arealdensityorthickness'
      write(idffileunit,1)'layerdensity n r q density '
      write(idffileunit,1)'layerelements y layerelement'
      write(idffileunit,1)'layerelement y name concentration '
      write(idffileunit,1)'concentration n r q concentration'
      write(idffileunit,1)'layermolecules y layermolecule'
      write(idffileunit,1)'layermolecule y name concentration'
      write(idffileunit,1)'equationoverlays n c 0'
      write(idffileunit,1)'roughness n c 0'
      write(idffileunit,1)'pointbypointstructure y pbpelement'
      write(idffileunit,1)'pbpelement y elementname pbp'
      write(idffileunit,1)'elementname n c 0'
      write(idffileunit,1)'pbp y xaxis xerroraxis yaxis yerroraxis x xerror y yerror ndf:iong'
      write(idffileunit,1)'xaxis y axisname axisunit'
      write(idffileunit,1)'axisname n c n'
      write(idffileunit,1)'axisunit n c u'
      write(idffileunit,1)'xerroraxis y axisname axisunit'
      write(idffileunit,1)'yaxis y axisname axisunit'
      write(idffileunit,1)'yerroraxis y axisname axisunit'
      write(idffileunit,1)'x n ar 0 other'
      write(idffileunit,1)'xerror n ar 0 other'
      write(idffileunit,1)'y n ar 0 other'
      write(idffileunit,1)'yerror n ar 0 other'
      write(idffileunit,1)'spectra y spectrum'
      write(idffileunit,1)'spectrum y log environment beam geometry instrument detection calibrations reactions data process'
      write(idffileunit,1)'log y realtime livetime deadtime starttime stoptime'
      write(idffileunit,1)'realtime n r q timeinterval'
      write(idffileunit,1)'livetime n r q timeinterval'
      write(idffileunit,1)'deadtime n r q timeinterval'
      write(idffileunit,1)'starttime n r q time'
      write(idffileunit,1)'stoptime n r q time'
      write(idffileunit,1)'environment y temperature pressure '
      write(idffileunit,1)'temperature n r q temperature'
      write(idffileunit,1)'pressure n r q pressure'
      write(idffileunit,1)''
      write(idffileunit,1)'beam y beamparticle beamZ beammass beamenergy beamenergyspread beamchargestate beamfluence beamcurrent be
     +amangularspread beamshape slitsbeforesample beamfoil'
      write(idffileunit,1)'beamparticle n c 0'
      write(idffileunit,1)'beamZ n i 0'
      write(idffileunit,1)'beammass n r q mass'
      write(idffileunit,1)'beamenergy n r q energy'
      write(idffileunit,1)'beamenergyspread n r s energy'
      write(idffileunit,1)'beamchargestate y x xerror y yerror'
      write(idffileunit,1)'beamfluence n r q fluence'
      write(idffileunit,1)'beamcurrent n r q current'
      write(idffileunit,1)'beamangularspread n r s angle ambiguous beam'
      write(idffileunit,1)'beamshape y shape l1 l2'
      write(idffileunit,1)'shape n c l square circular rectangular elliptical other'
      write(idffileunit,1)'l1 n r q thickness'
      write(idffileunit,1)'l2 n r q thickness'
      write(idffileunit,1)'slitsbeforesample y slit'
      write(idffileunit,1)'slit y slitshape slitdistancetosample'
      write(idffileunit,1)'slitshape y shape l1 l2 l3'
      write(idffileunit,1)'l3 n r q thickness'
      write(idffileunit,1)'slitdistancetosample n r q thickness'
      write(idffileunit,1)'beamfoil y foildistancetosample foillayers'
      write(idffileunit,1)'foildistancetosample n r q thickness'
      write(idffileunit,1)'foillayers y layer'
      write(idffileunit,1)'geometry y geometrytype incidenceangle scatteringangle exitangle spot'
      write(idffileunit,1)'geometrytype n c l Cornell IBM general'
      write(idffileunit,1)'incidenceangle n r q angle'
      write(idffileunit,1)'scatteringangle n r q angle'
      write(idffileunit,1)'exitangle n r q angle'
      write(idffileunit,1)'spot y shape l1 l2'
      write(idffileunit,1)'instrument y ionsource accelerator beamline chamber sampleholder'
      write(idffileunit,1)'ionsource n c 0'
      write(idffileunit,1)'accelerator n c 0'
      write(idffileunit,1)'beamline n c 0'
      write(idffileunit,1)'chamber n c 0'
      write(idffileunit,1)'sampleholder n c 0'
      write(idffileunit,1)'detection y slitsaftersample stoppingfoil detector electronics '
      write(idffileunit,1)'slitsaftersample y slit'
      write(idffileunit,1)'stoppingfoil y foildistancetosample foillayers'
      write(idffileunit,1)'detector y detectortype solidangle detectorshape deadlayer entrancewindow detectorlayers tof distancedete
     +ctortosample'
      write(idffileunit,1)'detectortype n c l SSB SDD Si(Li) Ge(Li) HPGe ToF EdE Bragg MagSpec ElSpec other '
      write(idffileunit,1)'solidangle n r q solidangle'
      write(idffileunit,1)'detectorshape y shape l1 l2 l3'
      write(idffileunit,1)'deadlayer y layerthickness layeruniformity layerdensity layerelements layermolecules'
      write(idffileunit,1)'entrancewindow y layer'
      write(idffileunit,1)'detectorlayers y layer'
      write(idffileunit,1)'tof y toflength toftimeresolution startfoil stopfoil'
      write(idffileunit,1)'toflength n r q thickness'
      write(idffileunit,1)'toftimeresolution n r s timeinterval'
      write(idffileunit,1)'startfoil y layer'
      write(idffileunit,1)'stopfoil y layer'
      write(idffileunit,1)'distancedetectortosample n r q thickness'
      write(idffileunit,1)'electronics y amplifier'
      write(idffileunit,1)'amplifier y amplifiertype pulseshape shapingtime risetime flattoptime pur purtime '
      write(idffileunit,1)'amplifiertype n c l analogue DSP other '
      write(idffileunit,1)'pulseshape n c l Gaussian triangular trapezoidal other '
      write(idffileunit,1)'shapingtime n r q timeinterval'
      write(idffileunit,1)'risetime n r q timeinterval'
      write(idffileunit,1)'flattoptime n r q timeinterval'
      write(idffileunit,1)'pur n c l on off none'
      write(idffileunit,1)'purtime n r q timeinterval'
      write(idffileunit,1)'calibrations y detectorefficiencies detectorresolutions energycalibrations'
      write(idffileunit,1)'detectorefficiencies y detectorefficiency'
      write(idffileunit,1)'detectorefficiency y efficiencyion efficiencymode efficiency lineefficiency'
      write(idffileunit,1)'efficiencyion n c 0'
      write(idffileunit,1)'efficiencymode n c l energy line'
      write(idffileunit,1)'efficiency y xaxis xerroraxis yaxis yerroraxis x xerror y yerror'
      write(idffileunit,1)'lineefficiency y xaxis yaxis yerroraxis xline y yerror'
      write(idffileunit,1)'xline n ac 0'
      write(idffileunit,1)'detectorresolutions y detectorresolution'
      write(idffileunit,1)'detectorresolution y resolutionion resolutionparameters'
      write(idffileunit,1)'resolutionion n c 0'
      write(idffileunit,1)'resolutionparameters y resolutionparameter '
      write(idffileunit,1)'resolutionparameter n r s resolutionparameter'
      write(idffileunit,1)'energycalibrations y energycalibration'
      write(idffileunit,1)'energycalibration y calibrationion calibrationmode calibrationparameters'
      write(idffileunit,1)'calibrationion n c 0'
      write(idffileunit,1)'calibrationmode n c l energy PH time other'
      write(idffileunit,1)'calibrationparameters y calibrationparameter '
      write(idffileunit,1)'calibrationparameter n r q calibrationparameter'
      write(idffileunit,1)'reactions y technique reactionlist'
      write(idffileunit,1)'technique n c l RBS ERDA NRA NRP PIXE other'
      write(idffileunit,1)'reactionlist y reaction'
      write(idffileunit,1)'reaction y initialtargetparticle incidentparticle exitparticle finaltargetparticle reactionQ '
      write(idffileunit,1)'initialtargetparticle n c 0'
      write(idffileunit,1)'incidentparticle n c 0'
      write(idffileunit,1)'exitparticle n c 0'
      write(idffileunit,1)'finaltargetparticle n c 0'
      write(idffileunit,1)'reactionQ n r q energy'
      write(idffileunit,1)'=====HERE ENDS GROUP reactions ======================================= HERE ENDS GROUP reactions ====='
      write(idffileunit,1)''
      write(idffileunit,1)'=====HERE STARTS GROUP data ======================================= HERE STARTS GROUP data ====='
      write(idffileunit,1)'data y datamode channelmode simpledata complexdata linedata datafile'
      write(idffileunit,1)'datamode n c l simple complex line datafile'
      write(idffileunit,1)'channelmode n c l left right middle other unknown'
      write(idffileunit,1)'simpledata y xaxis xerroraxis yaxis yerroraxis x xerror y yerror'
      write(idffileunit,1)'complexdata y datadimensions xaxes yaxes dataentries'
      write(idffileunit,1)'datadimensions y datadimensionx datadimensiony'
      write(idffileunit,1)'datadimensionx n i 0'
      write(idffileunit,1)'datadimensiony n i 0'
      write(idffileunit,1)'xaxes y axis'
      write(idffileunit,1)'yaxes y axis'
      write(idffileunit,1)'axis y axisname axisunit'
      write(idffileunit,1)'dataentries y dataentry'
      write(idffileunit,1)'dataentry y timestamp line dataitem'
      write(idffileunit,1)'timestamp n c q time'
      write(idffileunit,1)'line n c 0'
      write(idffileunit,1)'dataitem n r 0'
      write(idffileunit,1)'linedata y lineaxis yaxis yerroraxis line y yerror'
      write(idffileunit,1)'lineaxis y axisname axisunit'
      write(idffileunit,1)'datafile y filename fileformat filesource'
      write(idffileunit,1)'fileformat n c 0'
      write(idffileunit,1)'filesource n c 0'
      write(idffileunit,1)'process y physicsdefaults simulations'
      write(idffileunit,1)''
      write(idffileunit,1)'physicsdefaults y crosssectiondefault stoppingpowerdefault energyspreaddefault PIXEdefault'
      write(idffileunit,1)'crosssectiondefault y Rutherford screening computercode'
      write(idffileunit,1)'Rutherford n l 0'
      write(idffileunit,1)'screening n c l Andersen Ecuyer none'
      write(idffileunit,1)'computercode y name version builddate releasedate'
      write(idffileunit,1)'builddate n c q time'
      write(idffileunit,1)'releasedate n c q time'
      write(idffileunit,1)'stoppingpowerdefault y computercode'
      write(idffileunit,1)'energyspreaddefault y energylossstraggling multiplescattering Dopplereffect beamangularspread geometricsp
     +read Tschalareffect computercode'
      write(idffileunit,1)'energylossstraggling n c l Bohr Chu Yang none'
      write(idffileunit,1)'multiplescattering n l 0'
      write(idffileunit,1)'Dopplereffect n l 0'
      write(idffileunit,1)'beamangularspread n l 0 ambiguous energyspreaddefault'
      write(idffileunit,1)'geometricspread y beamsize detectoraperture'
      write(idffileunit,1)'beamsize n l 0'
      write(idffileunit,1)'detectoraperture n l 0'
      write(idffileunit,1)'Tschalareffect n l 0'
      write(idffileunit,1)'PIXEdefault y ionizationcrosssectionsoverride Xrayproductioncrosssectionsoverride totalabsorptioncrosssec
     +tionsoverride massabsorptioncoeffficientsoverride fluorescenceyieldsoverride costerkroningyieldsoverride branchingratiosoverri
     +de transitionratiosoverride photoelectricionizationcrosssectionsoverride jumpratiosoverride'
      write(idffileunit,1)'ionizationcrosssectionsoverride y name builddate releasedate'
      write(idffileunit,1)'Xrayproductioncrosssectionsoverride y name builddate releasedate'
      write(idffileunit,1)'totalabsorptioncrosssectionsoverride y name builddate releasedate'
      write(idffileunit,1)'massabsorptioncoeffficientsoverride y name builddate releasedate'
      write(idffileunit,1)'fluorescenceyieldsoverride y name builddate releasedate'
      write(idffileunit,1)'costerkroningyieldsoverride y name builddate releasedate'
      write(idffileunit,1)'branchingratiosoverride y name builddate releasedate'
      write(idffileunit,1)'transitionratiosoverride y name builddate releasedate'
      write(idffileunit,1)'photoelectricionizationcrosssectionsoverride y name builddate releasedate'
      write(idffileunit,1)'jumpratiosoverride y name builddate releasedate'
      write(idffileunit,1)'simulations y simulation'
      write(idffileunit,1)'simulation y physics simulationtype initialtargetparticle reaction targetlayer datamode channelmode simpl
     +edata complexdata linedata datafile'
      write(idffileunit,1)''
      write(idffileunit,1)'=====HERE STARTS SUBGROUP physics ====================== HERE STARTS SUBGROUP physics ====='
      write(idffileunit,1)'physics y crosssections stoppingpowers energyspreads PIXE'
      write(idffileunit,1)'crosssections y crosssection'
      write(idffileunit,1)'crosssection y crosssectionframe crosssectiontype energyminimum energymaximum reaction crosssectionfile c
     +rosssectiondata crosssectionoverride'
      write(idffileunit,1)'crosssectionframe n c l cm lab'
      write(idffileunit,1)'crosssectiontype n c l total differential'
      write(idffileunit,1)'energyminimum n r q energy'
      write(idffileunit,1)'energymaximum n r q energy'
      write(idffileunit,1)'crosssectionfile y filename fileformat filesource'
      write(idffileunit,1)'crosssectiondata y xaxis xerroraxis yaxis yerroraxis x xerror y yerror'
      write(idffileunit,1)'crosssectionoverride y Rutherford computercode'
      write(idffileunit,1)'stoppingpowers y stoppingpower'
      write(idffileunit,1)'stoppingpower y ion ionchargestate targetelement targetmolecule stoppingmode stoppingpowerfile stoppingpo
     +werdata stoppingpoweroverride'
      write(idffileunit,1)'ion n c 0'
      write(idffileunit,1)'ionchargestate n r q charge'
      write(idffileunit,1)'targetelement n c 0'
      write(idffileunit,1)'targetmolecule n c 0'
      write(idffileunit,1)'stoppingmode n c l electronic nuclear total'
      write(idffileunit,1)'stoppingpowerfile y filename fileformat filesource'
      write(idffileunit,1)'stoppingpowerdata y xaxis xerroraxis yaxis yerroraxis x xerror y yerror'
      write(idffileunit,1)'stoppingpoweroverride y computercode'
      write(idffileunit,1)'energyspreads y energyspread'
      write(idffileunit,1)'energyspread y ion ionchargestate targetelement energyspreadmode energyspreadfile energyspreaddata energy
     +spreadoverride'
      write(idffileunit,1)'energyspreadmode n c l electronic nuclear total'
      write(idffileunit,1)'energyspreadfile y filename fileformat filesource'
      write(idffileunit,1)'energyspreaddata y xaxis xerroraxis yaxis yerroraxis x xerror y yerror'
      write(idffileunit,1)'energyspreadoverride y energylossstraggling multiplescattering Dopplereffect beamangularspread geometrics
     +pread Tschalareffect computercode'
      write(idffileunit,1)'beamangularspread n l 0 ambiguous energyspreadoverride'
      write(idffileunit,1)'PIXE y PIXEoverride massabsorptioncoeffficients totalabsorptioncrosssections fluorescenceyields costerkro
     +ningyields branchingratios transitionratios linewidths photoelectricionizationcrosssections jumpratios'
      write(idffileunit,1)'PIXEoverride y ionizationcrosssectionsoverride Xrayproductioncrosssectionsoverride totalabsorptioncrossse
     +ctionsoverride massabsorptioncoeffficientsoverride fluorescenceyieldsoverride costerkroningyieldsoverride branchingratiosoverr
     +ide transitionratiosoverride photoelectricionizationcrosssectionsoverride jumpratiosoverride'
      write(idffileunit,1)'massabsorptioncoeffficients y massabsorptioncoeffficient'
      write(idffileunit,1)'massabsorptioncoeffficient y atom massabsorptioncoeffficientdatabase massabsorptioncoeffficientfile massa
     +bsorptioncoeffficientdata'
      write(idffileunit,1)'atom n c 0'
      write(idffileunit,1)'massabsorptioncoeffficientdatabase y name version builddate releasedate'
      write(idffileunit,1)'massabsorptioncoeffficientfile y filename fileformat filesource'
      write(idffileunit,1)'massabsorptioncoeffficientndata y xaxis xerroraxis yaxis yerroraxis x xerror y yerror'
      write(idffileunit,1)'totalabsorptioncrosssections y totalabsorptioncrosssection'
      write(idffileunit,1)'totalabsorptioncrosssection y atom totalabsorptioncrosssectiondatabase totalabsorptioncrosssectionfile to
     +talabsorptioncrosssectiondata'
      write(idffileunit,1)'totalabsorptioncrosssectiondatabase y name version builddate releasedate'
      write(idffileunit,1)'totalabsorptioncrosssectionfile y filename fileformat filesource'
      write(idffileunit,1)'totalabsorptioncrosssectiondata y xaxis xerroraxis yaxis yerroraxis x xerror y yerror'
      write(idffileunit,1)'fluorescenceyields y fluorescenceyield'
      write(idffileunit,1)'fluorescenceyield y atom level value'
      write(idffileunit,1)'level n c q atomiclevel'
      write(idffileunit,1)'value n r q'
      write(idffileunit,1)'costerkroningyields y costerkroningyield'
      write(idffileunit,1)'costerkroningyield y atom level1 level2 value'
      write(idffileunit,1)'level1 n c q atomiclevel'
      write(idffileunit,1)'level2 n c q atomiclevel'
      write(idffileunit,1)'branchingratios y branchingratio'
      write(idffileunit,1)'branchingratio y atom level1 level2 value'
      write(idffileunit,1)'transitionratios y transitionratio'
      write(idffileunit,1)'transitionratio y atom transition1 transition2 value'
      write(idffileunit,1)'transition1 n c q atomictransition'
      write(idffileunit,1)'transition2 n c q atomictransition'
      write(idffileunit,1)'linewidths y linewidth'
      write(idffileunit,1)'linewidth y atom transition1 transition2 value'
      write(idffileunit,1)'photoelectricionizationcrosssections y photoelectricionizationcrosssection'
      write(idffileunit,1)'photoelectricionizationcrosssection y atom level value'
      write(idffileunit,1)'jumpratios y jumpratio'
      write(idffileunit,1)'jumpratio y atom level1 level2 value'
      write(idffileunit,1)'=====HERE ENDS SUBGROUP physics ====================== HERE ENDS SUBGROUP physics ====='
      write(idffileunit,1)''
      write(idffileunit,1)'simulationtype n c l total partialelement reaction'
      write(idffileunit,1)'targetlayer n i 0'
      write(idffileunit,1)'repository y elementsandmoleculesrepository beamrepository geometryrepository instrumentrepository detect
     +ionrepository calibrationsrepository'
      write(idffileunit,1)'elementsandmoleculesrepository y elementsandmolecules'
      write(idffileunit,1)'beamrepository y beam'
      write(idffileunit,1)'geometryrepository y geometry'
      write(idffileunit,1)'instrumentrepository y instrument'
      write(idffileunit,1)'detectionrepository y detection'
      write(idffileunit,1)'calibrationsrepository y calibrations'
      write(idffileunit,1)'=====HERE ENDS GROUP repository ============================= HERE ENDS GROUP repository ====='
      write(idffileunit,1)''
      write(idffileunit,1)''
      write(idffileunit,1)'=====HERE STARTS GROUP NDF variables ======================HERE STARTS GROUP NDF variables ====='
      write(idffileunit,1)'ndf:iong n i 0'
      write(idffileunit,1)'=====HERE ENDS GROUP NDF variables ======================HERE ENDS GROUP NDF variables ====='

c      open(idffileunit,file=trim(adjustl(idf_path))//'idf_tags',status='old',err=1000)
      rewind(idffileunit)

c     first, count how many tags are there, and what is the maximum number of children per tag; and maximum number of items in lists
      idfntags=0
      idfnchildrenmax=0
      idfncontentallowedmax=0
c     read header
10    continue
      read(idffileunit,1,err=999,end=999)a3000
      if (index(a3000,'=====HEADER END=====').eq.0) goto 10
c     read body with the tags. A blank or a = sign in the first character of a line is ignored, everything else is taken as a tag
c     So, as any tag entry has at least 3 words if it is a group tag, or 4 if it is a data tag, if this does not happen, the file is bad
20    continue
      read(idffileunit,1,err=999,end=999)a3000
      if (a3000(1:1).eq.' '.or.a3000(1:1).eq.'=') goto 20
      idfntags=idfntags+1
      call parse_idf_a3000(a3000,parts,nparts)
c     ok
      if ((parts(2)(1:1).eq.'y'.and.nparts.ge.2).or.
     +(parts(2)(1:1).eq.'n'.and.(nparts.eq.4.or.nparts.eq.5.or.(nparts.ge.6.and.parts(nparts-1)(1:9).eq.'ambiguous').or.
     +(parts(4)(1:1).eq.'l'.and.nparts.gt.4)))) then
c     not ok
      else if (parts(1)(1:1).ne.'?') then
        idf_error='file idf_tags has following entry wrong, will abort: '//trim(adjustl(a3000))
        goto 1001
      end if
      if (parts(2)(1:1).eq.'y') then
        i=nparts-2+2  !the +2 is for "users" and "notes", which all groups tags can have as children
        if (parts(nparts-1)(1:9).eq.'ambiguous') i=i-2
        if (i.gt.idfnchildrenmax) idfnchildrenmax=i
      end if
      if (parts(2)(1:1).eq.'n'.and.parts(4)(1:1).eq.'l') then
        i=nparts-4
        if (parts(nparts-1)(1:9).eq.'ambiguous') i=i-2
        if (i.gt.idfncontentallowedmax) idfncontentallowedmax=i
      end if
      goto 20
999   continue
      rewind(idffileunit)
c     tags are now counted

c      write(*,*)'define_tags_idf assign',idfntags,idfnchildrenmax,idfnattrmax,idfnopentagsmax,idffileunit,idfncontentallowedmax

c     deallocate idf control variables if they are allocated, then allocate them
      if (allocated(idfnchildren)) deallocate(idfnchildren)
      allocate(idfnchildren(idfntags))
      idfnchildren=0
      if (allocated(idfnattr)) deallocate(idfnattr)
      allocate(idfnattr(idfntags))
      idfnattr=0
      if (allocated(idfchildren)) deallocate(idfchildren)
      allocate(idfchildren(idfntags,idfnchildrenmax))
      idfchildren=' '
      if (allocated(idfattr)) deallocate(idfattr)
      allocate(idfattr(idfntags,idfnattrmax))
      idfattr=' '
      if (allocated(idftags)) deallocate(idftags)
      allocate(idftags(idfntags))
      idftags=' '
      if (allocated(idfopentags)) deallocate(idfopentags)
      allocate(idfopentags(-2:idfnopentagsmax))
      idfopentags=' '
      if (allocated(idfopennamespace)) deallocate(idfopennamespace)
      allocate(idfopennamespace(idfnopentagsmax))
      idfopennamespace=' '
      if (allocated(idfnamespaces)) deallocate(idfnamespaces)
      allocate(idfnamespaces(idfnamespacesmax))
      idfnamespaces=' '
      if (allocated(idfcontenttype)) deallocate(idfcontenttype)
      allocate(idfcontenttype(idfntags))
      idfcontenttype=' '
      if (allocated(idfcontentallowed)) deallocate(idfcontentallowed)
      allocate(idfcontentallowed(idfntags,idfncontentallowedmax))
      idfcontentallowed=' '
      if (allocated(idfncontentallowed)) deallocate(idfncontentallowed)
      allocate(idfncontentallowed(idfntags))
      idfncontentallowed=0
      if (allocated(idfquantitytype)) deallocate(idfquantitytype)
      allocate(idfquantitytype(idfntags))
      idfquantitytype=' '
      if (allocated(idfflaggroup)) deallocate(idfflaggroup)
      allocate(idfflaggroup(idfntags))
      idfflaggroup=.false.
      if (allocated(idf_tagopen)) deallocate(idf_tagopen)
      allocate(idf_tagopen(idfntags))
      idf_tagopen=.false.
      if (allocated(idftagquantities)) deallocate(idftagquantities)
      allocate(idftagquantities(idfntags))
      idftagquantities=' '
      if (allocated(idfambiguous)) deallocate(idfambiguous)
      allocate(idfambiguous(idfntags))
      idfambiguous=.false.
      if (allocated(idfambiguousparent)) deallocate(idfambiguousparent)
      allocate(idfambiguousparent(idfntags))
      idfambiguousparent=' '

c     now read the file. i is the number of the current tag

      i=0
c     read header
11    continue
      read(idffileunit,1,err=1001,end=1001)a3000
      if (index(a3000,'=====HEADER END=====').eq.0) goto 11

c     read body with the tags. A blank or a = sign in the first character of a line is ignored, everything else is taken as a tag
c     So, as any tag entry has at least 3 words if it is a group tag, or 4 if it is a data tag, if this does not happen, the file is bad
21    continue
      read(idffileunit,1,err=998,end=998)a3000
      if (a3000(1:1).eq.' '.or.a3000(1:1).eq.'=') goto 21
      call parse_idf_a3000(a3000,parts,nparts)
c     ok
      if ((parts(2)(1:1).eq.'y'.and.nparts.ge.2).or.
     +(parts(2)(1:1).eq.'n'.and.(nparts.eq.4.or.nparts.eq.5.or.(nparts.ge.5.and.parts(nparts-1)(1:9).eq.'ambiguous').or.
     +(parts(4)(1:1).eq.'l'.and.nparts.gt.4)))) then
        i=i+1
        if (parts(nparts-1)(1:9).eq.'ambiguous') then
          idfambiguous(i)=.true.
          idfambiguousparent(i)=trim(adjustl(parts(nparts)))
          nparts=nparts-2
        end if
c      if ((parts(2)(1:1).eq.'y'.and.nparts.ge.3).or.
c     +(parts(2)(1:1).eq.'n'.and.(nparts.eq.4.or.nparts.eq.5.or.(parts(4)(1:1).eq.'l'.and.nparts.gt.4)))) then
c     ok
      else if (parts(1)(1:1).ne.'?') then
        idf_error='file idf_tags has following entry wrong, will abort:'//trim(adjustl(a3000))
        goto 1001
      end if
      idftags(i)=trim(adjustl(parts(1)))
      idfncontentallowed(i)=0
      if (parts(2)(1:1).eq.'y') then
        idfflaggroup(i)=.true.
        idfnchildren(i)=nparts-2+2  !the +2 is for "users" and "notes", which all groups tags can have as children
        idfchildren(i,1)="users"
        idfchildren(i,2)="notes"
        do j=1+2,idfnchildren(i)
          idfchildren(i,j)=trim(adjustl(parts(j+2-2)))
        end do
        idfcontenttype(i)='0'
        idfquantitytype(i)='0'
      else if (parts(2)(1:1).eq.'n') then
        idfflaggroup(i)=.false.
        idfnchildren(i)=0
        idfcontenttype(i)=trim(adjustl(parts(3)))
c       there is a list of allowed possibilities
        idfquantitytype(i)=trim(adjustl(parts(4)))
        if (idfquantitytype(i).eq.'l') then
          do j=5,nparts
            idfcontentallowed(i,j-4)=trim(adjustl(parts(j)))
          end do
          idfncontentallowed(i)=nparts-4
        end if
      end if
c     get the quantity type associated with this tag
      if ((idfquantitytype(i).eq.'q'.or.idfquantitytype(i).eq.'s').and.nparts.eq.5) then
       idftagquantities(i)=trim(adjustl(parts(5)))
      else
       idftagquantities(i)=' '
      end if
c     read new tag
      goto 21
998   continue
      if (i.ne.idfntags) then
        idf_error='undefined error reading file idf_tags'
        goto 1001
      end if

c     now define number of attributes for each tag. Only data tags can have attributes. 
c     tags that are a physical quantity must have the "unit" attribute.
c     tags that are a physical quantity may have the followig attributes as well: "quantity, uncertainty,  uncertaintyA, uncertaintyB ,  uncertaintyplus,  uncertaintyminus
c     tags that are a physical quantity that describes a spread must have the "mode" attribute.
      do i=1,idfntags
c      write(*,*)'idfntags',i,trim(adjustl(idftags(i))),idfquantitytype(i)
        if (idfquantitytype(i).eq.'0') then
          idfnattr(i)=0
        else if (idfquantitytype(i).eq.'n') then
          idfnattr(i)=0
        else if (idfquantitytype(i).eq.'u') then
          idfnattr(i)=0
        else if (idfquantitytype(i).eq.'l') then
          idfnattr(i)=0
        else if (idfquantitytype(i).eq.'q') then
          idfnattr(i)=7
          idfattr(i,1)='units'
          idfattr(i,2)='quantity'
          idfattr(i,3)='uncertainty'
          idfattr(i,4)='uncertaintyA'
          idfattr(i,5)='uncertaintyB'
          idfattr(i,6)='uncertaintyplus'
          idfattr(i,7)='uncertaintyminus'
        else if (idfquantitytype(i).eq.'s') then
          idfnattr(i)=8
          idfattr(i,1)='units'
          idfattr(i,2)='quantity'
          idfattr(i,3)='uncertainty'
          idfattr(i,4)='uncertaintyA'
          idfattr(i,5)='uncertaintyB'
          idfattr(i,6)='uncertaintyplus'
          idfattr(i,7)='uncertaintyminus'
          idfattr(i,8)='mode'
        else
          idf_error='Undefined error reading file idf_tags'
          goto 1001
        end if
      end do

c     check that there are no duplicate tags
      do i=1,idfntags-1
      do j=i+1,idfntags
        if (trim(adjustl(idftags(i))).eq.trim(adjustl(idftags(j))).and..not.(idfambiguous(i).and.idfambiguous(j))) then
c          write(*,*)'tag '//trim(adjustl(idftags(i)))//' duplicated: ',i,j
          idf_error='tag '//trim(adjustl(idftags(i)))//' duplicated in idf_tags'
          goto 1001
        end if
      end do
      end do

c      do i=1,idfntags
c      write(*,*)'tag',i,trim(adjustl(idftags(i))),idfflaggroup(i),idfnchildren(i),idfncontentallowed(i)
c      end do


      defined_tags_idf=.true.
      idf_ok=.true.
1001  continue
      close(idffileunit)
c      write(*,*)'define_tags_idf:',trim(adjustl(idf_error))
	return
1000  continue
      idf_error='file idf_tags does not exist'
      close(idffileunit)
c      write(*,*)'define_tags_idf:',trim(adjustl(idf_error))
	return
1     format(a)
	end

c-----------------------------------------------------------------------
	subroutine define_units_idf
c     reads the file idf_units that has all the units for the quantities in IDF
c     each line in the file can have a maximum of 72 characters. To change it to e.g. 5000, replace a72*72 by a3000*5000
c     each quantity and unit is allowed a maximum of 72 characters. To change it, all the routines where character variables are defined as *72 must be changed. This includes module IDFCOM
	use IDFCOM
	implicit none
	integer i,j,nparts
	character a72*72
c-----------------------------------------------------------------------
c      write(*,*)'define_units_idf enter'
      idf_ok=.false.
      defined_units_idf=.false.
      idf_path=' '
      idf_error=' '
      open(idffileunit,status='scratch')
      write(idffileunit,1)'=====HEADER START====='
      write(idffileunit,1)'DO NOT EDIT THIS FILE!!!!! IDF UNITS INCLUDED IN V1.02'
      write(idffileunit,1)'=====HEADER END====='
      write(idffileunit,1)'timeinterval'
      write(idffileunit,1)'s'
      write(idffileunit,1)'ms '
      write(idffileunit,1)'us'
      write(idffileunit,1)'ns'
      write(idffileunit,1)'s^2'
      write(idffileunit,1)'ms^2'
      write(idffileunit,1)'us^2'
      write(idffileunit,1)'ns^2'
      write(idffileunit,1)' '
      write(idffileunit,1)'time'
      write(idffileunit,1)'0'
      write(idffileunit,1)' '
      write(idffileunit,1)'density'
      write(idffileunit,1)'g/cm3'
      write(idffileunit,1)'1e22at/cm3'
      write(idffileunit,1)' '
      write(idffileunit,1)'pressure '
      write(idffileunit,1)'atm'
      write(idffileunit,1)'bar'
      write(idffileunit,1)'mbar'
      write(idffileunit,1)'Torr'
      write(idffileunit,1)'mTorr'
      write(idffileunit,1)'mmHg'
      write(idffileunit,1)'Pa'
      write(idffileunit,1)' '
      write(idffileunit,1)'temperature'
      write(idffileunit,1)'C'
      write(idffileunit,1)'K'
      write(idffileunit,1)' '
      write(idffileunit,1)'solidangle'
      write(idffileunit,1)'sr'
      write(idffileunit,1)'msr'
      write(idffileunit,1)'srad'
      write(idffileunit,1)'msrad'
      write(idffileunit,1)' '
      write(idffileunit,1)'angle'
      write(idffileunit,1)'degree'
      write(idffileunit,1)'rad'
      write(idffileunit,1)'mrad'
      write(idffileunit,1)' '
      write(idffileunit,1)'fluence'
      write(idffileunit,1)'uC'
      write(idffileunit,1)'puC'
      write(idffileunit,1)'C'
      write(idffileunit,1)'pC'
      write(idffileunit,1)'uCoulomb'
      write(idffileunit,1)'puCoulomb'
      write(idffileunit,1)'Coulomb'
      write(idffileunit,1)'pCoulomb'
      write(idffileunit,1)'#particles'
      write(idffileunit,1)' '
      write(idffileunit,1)'current'
      write(idffileunit,1)'nA'
      write(idffileunit,1)'nAmpere'
      write(idffileunit,1)'Ampere'
      write(idffileunit,1)' '
      write(idffileunit,1)'mass'
      write(idffileunit,1)'amu'
      write(idffileunit,1)'g'
      write(idffileunit,1)'kg'
      write(idffileunit,1)' '
      write(idffileunit,1)'charge'
      write(idffileunit,1)'q'
      write(idffileunit,1)' '
      write(idffileunit,1)'stoppingpower'
      write(idffileunit,1)'eV/A'
      write(idffileunit,1)'keV/A'
      write(idffileunit,1)'MeV/A'
      write(idffileunit,1)'eV/Angstrom'
      write(idffileunit,1)'keV/Angstrom'
      write(idffileunit,1)'MeV/Angstrom'
      write(idffileunit,1)'eV/nm'
      write(idffileunit,1)'keV/nm'
      write(idffileunit,1)'MeV/nm'
      write(idffileunit,1)'eV/um'
      write(idffileunit,1)'keV/um'
      write(idffileunit,1)'MeV/um'
      write(idffileunit,1)'eV/cm'
      write(idffileunit,1)'keV/cm'
      write(idffileunit,1)'MeV/cm'
      write(idffileunit,1)'eV/m'
      write(idffileunit,1)'keV/m'
      write(idffileunit,1)'MeV/m '
      write(idffileunit,1)'eV/(ug/cm2)'
      write(idffileunit,1)'keV/(ug/cm2)'
      write(idffileunit,1)'MeV/(ug/cm2)'
      write(idffileunit,1)'eV/(mg/cm2)'
      write(idffileunit,1)'keV/(mg/cm2)'
      write(idffileunit,1)'MeV/(mg/cm2)'
      write(idffileunit,1)'eV/(1e15at/cm2)'
      write(idffileunit,1)'keV/(1e15at/cm2)'
      write(idffileunit,1)'MeV/(1e15at/cm2)'
      write(idffileunit,1)' '
      write(idffileunit,1)'crosssection'
      write(idffileunit,1)'barn'
      write(idffileunit,1)'b'
      write(idffileunit,1)'mbarn'
      write(idffileunit,1)'mb'
      write(idffileunit,1)'cm2'
      write(idffileunit,1)'rr'
      write(idffileunit,1)'cm2/mg'
      write(idffileunit,1)'cm2/ug'
      write(idffileunit,1)'cm2/(1e15at/cm2)'
      write(idffileunit,1)' '
      write(idffileunit,1)'concentration'
      write(idffileunit,1)'at%'
      write(idffileunit,1)'mol%'
      write(idffileunit,1)'wt%'
      write(idffileunit,1)'ug/g'
      write(idffileunit,1)'fraction'
      write(idffileunit,1)'relative'
      write(idffileunit,1)' '
      write(idffileunit,1)'energy '
      write(idffileunit,1)'eV'
      write(idffileunit,1)'keV'
      write(idffileunit,1)'MeV'
      write(idffileunit,1)'eV^2'
      write(idffileunit,1)'keV^2'
      write(idffileunit,1)'MeV^2'
      write(idffileunit,1)' '
      write(idffileunit,1)'areal density '
      write(idffileunit,1)'ug/cm2'
      write(idffileunit,1)'mg/cm2'
      write(idffileunit,1)'1e15at/cm2'
      write(idffileunit,1)' '
      write(idffileunit,1)'thickness'
      write(idffileunit,1)'A'
      write(idffileunit,1)'Angstrom'
      write(idffileunit,1)'nm'
      write(idffileunit,1)'um'
      write(idffileunit,1)'mm'
      write(idffileunit,1)'cm'
      write(idffileunit,1)'m'
      write(idffileunit,1)' '
      write(idffileunit,1)'arealdensityorthickness'
      write(idffileunit,1)'ug/cm2'
      write(idffileunit,1)'mg/cm2'
      write(idffileunit,1)'1e15at/cm2'
      write(idffileunit,1)'A'
      write(idffileunit,1)'Angstrom'
      write(idffileunit,1)'nm'
      write(idffileunit,1)'um'
      write(idffileunit,1)'mm'
      write(idffileunit,1)'cm'
      write(idffileunit,1)'m'
      write(idffileunit,1)' '
      write(idffileunit,1)'area'
      write(idffileunit,1)'A2'
      write(idffileunit,1)'Angstrom2'
      write(idffileunit,1)'nm2'
      write(idffileunit,1)'um2'
      write(idffileunit,1)'mm2'
      write(idffileunit,1)'cm2'
      write(idffileunit,1)'m2'
      write(idffileunit,1)'fraction'
      write(idffileunit,1)' '
      write(idffileunit,1)'volume'
      write(idffileunit,1)'A3'
      write(idffileunit,1)'Angstrom3'
      write(idffileunit,1)'nm3'
      write(idffileunit,1)'um3'
      write(idffileunit,1)'mm3'
      write(idffileunit,1)'cm3'
      write(idffileunit,1)'m3'
      write(idffileunit,1)'fraction'
      write(idffileunit,1)' '
      write(idffileunit,1)'yield'
      write(idffileunit,1)'counts'
      write(idffileunit,1)'counts/(uCmg/cm2)'
      write(idffileunit,1)'counts/(uC1e15at/cm2)'
      write(idffileunit,1)'counts/(uCug/cm2)'
      write(idffileunit,1)' '
      write(idffileunit,1)'efficiency'
      write(idffileunit,1)'fraction'
      write(idffileunit,1)'relative'
      write(idffileunit,1)' '
      write(idffileunit,1)'calibrationparameter'
      write(idffileunit,1)'eV'
      write(idffileunit,1)'eV/channel'
      write(idffileunit,1)'eV/channel^2'
      write(idffileunit,1)'eV/channel^3'
      write(idffileunit,1)'eV/channel^4'
      write(idffileunit,1)'eV/channel^5'
      write(idffileunit,1)'keV'
      write(idffileunit,1)'keV/channel'
      write(idffileunit,1)'keV/channel^2'
      write(idffileunit,1)'keV/channel^3'
      write(idffileunit,1)'keV/channel^4'
      write(idffileunit,1)'keV/channel^5'
      write(idffileunit,1)'MeV'
      write(idffileunit,1)'MeV/channel'
      write(idffileunit,1)'MeV/channel^2'
      write(idffileunit,1)'MeV/channel^3'
      write(idffileunit,1)'MeV/channel^4'
      write(idffileunit,1)'MeV/channel^5'
      write(idffileunit,1)'s'
      write(idffileunit,1)'s/channel'
      write(idffileunit,1)'s/channel^2'
      write(idffileunit,1)'s/channel^3'
      write(idffileunit,1)'s/channel^4'
      write(idffileunit,1)'s/channel^5'
      write(idffileunit,1)'s'
      write(idffileunit,1)'ns/channel'
      write(idffileunit,1)'ns/channel^2'
      write(idffileunit,1)'ns/channel^3'
      write(idffileunit,1)'ns/channel^4'
      write(idffileunit,1)'ns/channel^5'
      write(idffileunit,1)'us'
      write(idffileunit,1)'us/channel'
      write(idffileunit,1)'us/channel^2'
      write(idffileunit,1)'us/channel^3'
      write(idffileunit,1)'us/channel^4'
      write(idffileunit,1)'us/channel^5'
      write(idffileunit,1)'ms'
      write(idffileunit,1)'ms/channel'
      write(idffileunit,1)'ms/channel^2'
      write(idffileunit,1)'ms/channel^3'
      write(idffileunit,1)'ms/channel^4'
      write(idffileunit,1)'ms/channel^5'
      write(idffileunit,1)'none'
      write(idffileunit,1)' '
      write(idffileunit,1)'resolutionparameter'
      write(idffileunit,1)'eV'
      write(idffileunit,1)'eV^-1'
      write(idffileunit,1)'eV^-2'
      write(idffileunit,1)'eV^-3'
      write(idffileunit,1)'eV^-4'
      write(idffileunit,1)'keV'
      write(idffileunit,1)'keV^-1'
      write(idffileunit,1)'keV^-2'
      write(idffileunit,1)'keV^-3'
      write(idffileunit,1)'keV^-4'
      write(idffileunit,1)'MeV'
      write(idffileunit,1)'MeV^-1'
      write(idffileunit,1)'MeV^-2'
      write(idffileunit,1)'MeV^-3'
      write(idffileunit,1)'MeV^-4'
      write(idffileunit,1)'s'
      write(idffileunit,1)'s^-1'
      write(idffileunit,1)'s^-2'
      write(idffileunit,1)'s^-3'
      write(idffileunit,1)'s^-4'
      write(idffileunit,1)'ns'
      write(idffileunit,1)'ns^-1'
      write(idffileunit,1)'ns^-2'
      write(idffileunit,1)'ns^-3'
      write(idffileunit,1)'ns^-4'
      write(idffileunit,1)'us'
      write(idffileunit,1)'us^-1'
      write(idffileunit,1)'us^-2'
      write(idffileunit,1)'us^-3'
      write(idffileunit,1)'us^-4'
      write(idffileunit,1)'ms'
      write(idffileunit,1)'ms^-1'
      write(idffileunit,1)'ms^-2'
      write(idffileunit,1)'ms^-3'
      write(idffileunit,1)'ms^-4'
      write(idffileunit,1)'none'
      write(idffileunit,1)' '
      write(idffileunit,1)'atomiclevel'
      write(idffileunit,1)'0'
      write(idffileunit,1)' '
      write(idffileunit,1)'atomictransition'
      write(idffileunit,1)'0'

c      open(idffileunit,file=trim(adjustl(idf_path))//'idf_units',status='old',err=1000)
      rewind(idffileunit)

c     first, count how many quantities are there, and what is the maximum number of units per quantity
      idfnunitsmax=0
      idfnquantities=0
c     read header
10    continue
      read(idffileunit,1,err=999,end=999)a72
      if (index(a72,'=====HEADER END=====').eq.0) goto 10
c     read body with the quantities
20    continue
c     new quantity, comes either from header or from a blank line
      read(idffileunit,1,err=999,end=999)a72
      if (a72(1:1).eq.'=') goto 20
      if (a72(1:1).eq.' ') goto 999
      idfnquantities=idfnquantities+1
      i=0
21    continue
c     now come the units!
      read(idffileunit,1,err=999,end=999)a72
      if (a72(1:1).ne.' ') then
        i=i+1
        goto 21
      end if
      if (i.gt.idfnunitsmax) idfnunitsmax=i
      goto 20
999   continue
      rewind(idffileunit)
c     tags are now counted

c      write(*,*)'define_units_idf assign',idfnquantities,idfnunitsmax

c     deallocate idf variables if they are allocated, then allocate them
      if (allocated(idfquantities)) deallocate(idfquantities)
      if (allocated(idfunits)) deallocate(idfunits)
      if (allocated(idfnunits)) deallocate(idfnunits)
      allocate(idfquantities(idfnquantities))
      idfquantities=' '
      allocate(idfunits(idfnquantities,idfnunitsmax))
      idfunits=' '
      allocate(idfnunits(idfnquantities))
      idfnunits=0

c     now read the file. i is the number of the current unit

      i=0
c     read header
11    continue
      read(idffileunit,1,err=1001,end=1001)a72
      if (index(a72,'=====HEADER END=====').eq.0) goto 11

c     read body with the tags. A blank or a = sign in the first character of a line is ignored, everything else is taken as a tag
c     So, as any tag entry has at least 3 words if it is a group tag, or 4 if it is a data tag, if this does not happen, the file is bad
30    continue
c     new quantity, comes either from header or from a blank line
      read(idffileunit,1,err=998,end=998)a72
      if (a72(1:1).eq.'=') goto 30
      if (a72(1:1).eq.' ') goto 998
      i=i+1
      idfquantities(i)=trim(adjustl(a72))

31    continue
c     now come the units!
      read(idffileunit,1,err=998,end=998)a72
      if (a72(1:1).ne.' ') then
        idfnunits(i)=idfnunits(i)+1
        idfunits(i,idfnunits(i))=trim(adjustl(a72))
        goto 31
      end if
c      if (i.gt.idfnunitsmax) idfnunitsmax=i
c     read new quantity
      goto 30

998   continue
      if (i.ne.idfnquantities) then
        idf_error='undefined error reading file idf_units'
        goto 1001
      end if

c      do i=1,idfnquantities
c      write(*,*)'quantity',i,trim(adjustl(idfquantities(i))),(' '//trim(adjustl(idfunits(i,j))),j=1,idfnunits(i))
c      end do

      defined_units_idf=.true.
      idf_ok=.true.
1001  continue
      close(idffileunit)
c      write(*,*)'define_units_idf:',trim(adjustl(idf_error))
	return
1000  continue
      idf_error='file idf_units does not exist'
      close(idffileunit)
c      write(*,*)'define_units_idf:',trim(adjustl(idf_error))
	return
1     format(a)
	end

c-----------------------------------------------------------------------
	subroutine parse_idf_a3000(a78,parts,nparts)
c	separates a78 into individual components
c	a78 is input, nparts is the number of components, parts are the components,
c	and lparts is the length of each component
c-----------------------------------------------------------------------
      implicit none
      integer eox78,nparts !,i
      character a78*(*),x78*16384,parts(*)*(*)
c-----------------------------------------------------------------------
	x78=' '
	nparts=0
c	i=ubound(parts(:),dim=1)
c	parts(:i)=' '
c	save input line, it will not be changed
	x78=a78
	
101	continue
	eox78=index(x78,char(9))
	if (eox78.gt.0) then
	  x78(eox78:eox78)=' '
	  goto 101
	end if

100	continue
c	check if there is still at least one word left
	if (verify(x78,' ').eq.0) return
c	cut out initial blanks
	x78=adjustl(x78)
c	end of a word
	eox78=index(x78,' ')-1
c     new word: increment number of words
	nparts=nparts+1
	parts(nparts)=x78(1:eox78)
c	cut out word just read from the line
      x78=x78(eox78+1:len_trim(x78))
c	check for a new word
	goto 100

	end
