c	Copyright (C) 2008-2013 and onwards  Nuno Pessoa Barradas
c	Campus Tecnolgico e Nuclear / Instituto Superior Tcnico
c	E.N. 10, Apartado 21, 2686-953 Sacavm, Portugal
c	Tel. +351 219946150 e-mail: nunoni@ctn.ist.utl.pt

c	This program is free software: you can redistribute it and/or modify
c	it under the terms of the GNU General Public License as published by
c	the Free Software Foundation, either version 3 of the License, or
c	any later version.

c	This program is distributed in the hope that it will be useful,
c	but WITHOUT ANY WARRANTY; without even the implied warranty of
c	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c	GNU General Public License for more details.

c	You should have received a copy of the GNU General Public License
c	along with this program.  If not, see <http://www.gnu.org/licenses/>.

c	The copyright owner (N.P. Barradas) is also the author of the non-GPL code NDF.
c	These routines are also used by NDF under a special agreement.

c     Release 1.02 13 february 2013
c-----------------------------------------------------------------------
	subroutine read_file_idf(idf_file,nsample,verbosity)
      !DEC$ ATTRIBUTES DLLEXPORT::read_file_idf
c	reads a given idf file, for sample number nsample contained in the file
c     requires that define_tags_idf and define_units_idf have been called beforehand
c     does not check for validity of file
	use IDFCOM
	implicit none
	integer nsample,i
	character idf_file*300
	logical verbosity
c	type(idf_sample)::sample
c-----------------------------------------------------------------------
      verbosity_IDF=verbosity
      idf_ok=.false.
      idf_error=' '
      idf_entry_leftover=' '
      if (.not.defined_tags_idf) then
        idf_error='routine define_tags_idf has not been successfully called beforehand'
        return
      end if
      if (.not.defined_units_idf) then
        idf_error='routine define_units_idf has not been successfully called beforehand'
        return
      end if
      
c     call the routine that reads the usersnotes and attributes of the idf_file - this is not from sample nsample, these are the general usersnotes and attributes children of tag idf
      call read_file_idf_usersnotes_attributes(idf_file)

c     call the routine that determines the dimensions of the problem for the given sample nsample in the idf_file - number of geometries (etc)
      call read_file_idf_dimensions_ngeometries(idf_file,nsample)
c     allocate some variables needed for the routine that determines the dimensions of the problem for the given sample nsample in the idf_file
      call allocate_secondary_variables_idf
c     call the routine that determines the dimensions of the problem for the given sample nsample in the idf_file
      call read_file_idf_dimensions(idf_file,nsample)
c      pause
      if (.not.idf_ok) goto 1001
c      write(*,*)'dimension',idfnelements, idfnmolecules,nlayers_idf,idfnspectra
c      write(*,*)'nlayerspbpmax_idf',nlayerspbpmax_idf
c      write(*,*)'dimension sim ',nsimpoints_max_idf,simdimensionx_max_idf,simdimensiony_max_idf
c      write(*,*)'idf_error:',trim(adjustl(idf_error))

c     call the routine that allocates all the required variables for one single sample from file idf_file
      call allocate_idf_tags
      if (.not.idf_ok) goto 1001

      open(idffileunit,file=idf_file,status='old',err=1000)
      idf_entry_leftover=' '

      i=0
10    continue
c     read entries until sample nsample is found
      call read_next_entry_idf
c      write(*,*)'a ',trim(adjustl(idf_entry))
c      write(*,*)'a ',trim(adjustl(idf_tag%name))
      if (.not.idf_ok) goto 1001
      if (trim(adjustl(idf_tag%name)).eq.'sample'.and.idf_openingtaginentry) then
        i=i+1
        if (i.eq.nsample) goto 11
      end if
      goto 10
11    continue

      idfnopentags=1
      idfopentags(idfnopentags)='sample'
      idfopennamespace(idfnopentags)='idf'
c      write(*,*)'start',idfnopentags,trim(adjustl(idfopentags(idfnopentags)))

c     correct opening sample has been found, now read the content, until the closing tag </idf> comes
c     first initialise
      user_counter=0
      note_counter=0
      nels_idf_counter=0
      nmols_idf_counter=0
      nlayers_idf_counter=0
      nspectra_idf_counter=0
      nlayers_idf_counter=0
c     npbp_element_idf_counter counts the number of elements with pbp profile
      npbp_element_idf_counter=0
c     for a given element with pbp profile, npbp_max_idf_counter counts how many pbp profiles there are
      npbp_max_idf_counter=0
c     for a given geometry nspectra_idf_counter, this is the number of slits before the sample
      nslits_idf_counter=0
c      nels_idf_layeredstructure_counter=0
c     for a given geometry nspectra_idf_counter, this is the number of layers of the beamfoil between beam and sample
      nfoillayers_idf_counter=0
c     for a given geometry nspectra_idf_counter and given layer of a beamfoil, this is the number of element in the layer
      nfoilels_idf_counter=0
c     for a given geometry nspectra_idf_counter this is the number of detector efficiencies given; it can be one per ion, or whatever
      ndetectorefficiency_idf_counter=0
c     for a given geometry ndetectorresolution_idf_counter this is the number of detector resolutions given; it can be one per ion
      ndetectorresolution_idf_counter=0
c     for a given geometry ndetectorresolution_idf_counter this is the number of detector resolutions given; it can be one per ion
      nparameter_idf_counter=0
c     for the current geometry nreaction_idf_counter is the number of reaction entries in the reactionlist tag
      nreaction_idf_counter=0
c     for the current geometry ndatapoints_idf_counter is the number of data points in data
c     for the current geometry and simulation ndatapoints_idf_counter is the number of data points in simulation
      ndatapoints_idf_counter=0
c     for the current geometry datadimensionx_idf_counter is the number of x or y or total dimensions in data
      datadimension_idf_counter=0
c     for the current geometry nsimulation_idf_counter counts the simulation number
      nsimulation_idf_counter=0
c     for the current geometry and simulation, ncrosssection_idf_counter counts the cross section number
      ncrosssection_idf_counter=0
c     for the current geometry and simulation, nstoppingpower_idf_counter counts the stoppingpower number
      nstoppingpower_idf_counter=0
c     for the current geometry and simulation, nenergyspread_idf_counter counts the energyspread number
      nenergyspread_idf_counter=0

c     these are exceptions to the rule that auxiliaty variables are determined in the read_file_idf_dimensions routine of file os_idf.for
c     1/0 if there is/not timestamp in complexdata in data in each spectrum
      ndatatimestamp_idf=0
c     1/0 if there is/not line in complexdata in data in each spectrum
      ndataline_idf=0

      section_idf=' '

c     now finally start reading
100   continue
c     read the nex entry. It returns the entire entry as idf_entry, the tag as idf_tag%name and idf_tag%content, and its number idfntag of the tag in the idftags(idfntags) list
c      write(*,*)'idfnopentags a:',idfnopentags,trim(adjustl(idfopentags(idfnopentags)))
c      write(*,*)'start r0',idfnopentags,trim(adjustl(idfopentags(idfnopentags)))
      call read_next_entry_idf
c      write(*,*)'start r1',idfnopentags,trim(adjustl(idfopentags(idfnopentags)))
c      write(*,*)'idf_entry:',trim(adjustl(idf_entry)),':',trim(adjustl(idf_entry_leftover)),idf_ok,idfntag
c      idfntag=1
c     there was a problem reading the next entry. idf_error has been set in the called routine
      if (.not.idf_ok) goto 1001

c     first consider the regular case that it is an idf flag
      if (idfntag.gt.0) then
c      write(*,*)'idfflaggroup:',idfflaggroup(idfntag),idf_fulltaginentry,idf_openingtaginentry,idf_closingtaginentry
c       get the attributes in the idf tag, puts their name and content in idf_attributes%attribute(i)%name and idf_attributes%attribute(i)%content, and their number in idf_attributes%n
        call get_attributes_idf
c      write(*,*)'start r2',idfnopentags,trim(adjustl(idfopentags(idfnopentags)))
        if (.not.idf_ok) goto 1001
c     idfflaggroup(idfntag) is true if the tag is a group of tags, and false if it is a data tag
c     first, consider the case that it is a group of tags
      if (idfflaggroup(idfntag)) then
c       the tag may have been opened and closed in the same entry; in this case, for a group tag, it must be empty, e.g. <sample></sample>. No content besides tags is allowed in group tags
        if (idf_fulltaginentry) then

c       a new group tag was opened
        else if (idf_openingtaginentry) then
          idfnopentags=idfnopentags+1
          idfopentags(idfnopentags)=trim(adjustl(idf_tag%name))
          idfopennamespace(idfnopentags)='idf'
c         sometimes counter variables need to be initialised when opening a goup variable, these come now
          if (trim(adjustl(idf_tag%name)).eq.'structure') then
            section_idf='structure'
          else if (trim(adjustl(idf_tag%name)).eq.'spectra') then
            section_idf='spectra'
          else if (trim(adjustl(idf_tag%name)).eq.'instrument') then
            section_idf='instrument'
          end if
c         structure - pointbypointstructure
c         pbp within pointbypointstructure
          if ((trim(adjustl(idf_tag%name)).eq.'pbp'.and.trim(adjustl(idfopentags(3))).eq.'pointbypointstructure').or.
     +        (trim(adjustl(idf_tag%name)).eq.'efficiency'.and.trim(adjustl(idfopentags(7))).eq.'detectorefficiency').or.
     +        (trim(adjustl(idf_tag%name)).eq.'lineefficiency'.and.trim(adjustl(idfopentags(7))).eq.'detectorefficiency')
     +    ) then
            npbp_max_idf_counter=npbp_max_idf_counter+1
	      pbp_aux%xaxis%axisname=' '
	      pbp_aux%xaxis%axisunit=' '
	      pbp_aux%xerroraxis%axisname=' '
	      pbp_aux%xerroraxis%axisunit=' '
	      pbp_aux%yaxis%axisname=' '
	      pbp_aux%yaxis%axisunit=' '
	      pbp_aux%yerroraxis%axisname=' '
	      pbp_aux%yerroraxis%axisunit=' '
	      pbp_aux%ndfidf_iong=0
            pbp_aux%n=0
            pbp_aux%x=0.
            pbp_aux%line=' '
            pbp_aux%xerror=0.
            pbp_aux%y=0.
            pbp_aux%yerror=0.
          end if
c         spectrum: increase the geometry counter, reset counters that depend on geometry
          if (trim(adjustl(idf_tag%name)).eq.'spectrum') then
            nspectra_idf_counter=nspectra_idf_counter+1
            nsimulation_idf_counter=0
          end if
c         slitsbeforesample: initialise the slits counter for this geometry
          if (trim(adjustl(idf_tag%name)).eq.'slitsbeforesample'.or.trim(adjustl(idf_tag%name)).eq.'slitsaftersample') then
c            nslits_idf_counter(nspectra_idf_counter)=0
            nslits_idf_counter=0
          end if
c         slitsbeforesample: increase the slits counter for this geometry
          if (trim(adjustl(idf_tag%name)).eq.'slit'.and.
     +    (idfopentags(idfnopentags-1).eq.'slitsbeforesample'.or.idfopentags(idfnopentags-1).eq.'slitsaftersample')) then
c            nslits_idf_counter(nspectra_idf_counter)=nslits_idf_counter(nspectra_idf_counter)+1
            nslits_idf_counter=nslits_idf_counter+1
          end if
c         beamfoil or stoppingfoil: initialise the beamfoillayers counter for this geometry
          if ((trim(adjustl(idf_tag%name)).eq.'foillayers'.or.trim(adjustl(idf_tag%name)).eq.'entrancewindow'.or.
     +    trim(adjustl(idf_tag%name)).eq.'detectorlayers'.or.trim(adjustl(idf_tag%name)).eq.'startfoil'.or.
     +    trim(adjustl(idf_tag%name)).eq.'stopfoil').and.
     +    (idfopentags(idfnopentags-1).eq.'beamfoil'.or.idfopentags(idfnopentags-1).eq.'stoppingfoil'.or.
     +    idfopentags(idfnopentags-1).eq.'detector'.or.idfopentags(idfnopentags-1).eq.'tof')) then
          nfoillayers_idf_counter=0
c      write(*,*)'nfoillayers_idf_counter',nfoillayers_idf_counter,idfopentags(idfnopentags-1)
          end if
c         beamfoil or stoppingfoil: increase the nbeamfoillayers counter for this geometry
          if (trim(adjustl(idf_tag%name)).eq.'layer'.and.
     +    (idfopentags(idfnopentags-2).eq.'beamfoil'.or.idfopentags(idfnopentags-2).eq.'stoppingfoil'.or.
     +    idfopentags(idfnopentags-2).eq.'detector'.or.idfopentags(idfnopentags-2).eq.'tof')) then
          nfoillayers_idf_counter=nfoillayers_idf_counter+1
c      write(*,*)'nfoillayers_idf_counter',nfoillayers_idf_counter,idfopentags(idfnopentags-2)
          end if
c         beamfoilels or stoppingfoilels: initialise the nbeamfoilels counter for this geometry
          if (trim(adjustl(idf_tag%name)).eq.'layerelements'.and.
     +    (idfopentags(idfnopentags-3).eq.'beamfoil'.or.idfopentags(idfnopentags-3).eq.'stoppingfoil'.or.
     +    idfopentags(idfnopentags-3).eq.'detector'.or.idfopentags(idfnopentags-2).eq.'detector'.or.
     +    idfopentags(idfnopentags-3).eq.'tof')) then
          nfoilels_idf_counter=0
c      write(*,*)'nfoilels_idf_counter',nfoilels_idf_counter,idfopentags(idfnopentags-3)
          end if
c         beamfoilels or stoppingfoilels: increase the nbeamfoilels counter for this geometry
          if (trim(adjustl(idf_tag%name)).eq.'layerelement'.and.
     +    (idfopentags(idfnopentags-4).eq.'beamfoil'.or.idfopentags(idfnopentags-4).eq.'stoppingfoil'.or.
     +    idfopentags(idfnopentags-4).eq.'detector'.or.idfopentags(idfnopentags-3).eq.'detector'.or.
     +    idfopentags(idfnopentags-4).eq.'tof')) then
          nfoilels_idf_counter=nfoilels_idf_counter+1
c      write(*,*)'nfoilels_idf_counter',nfoilels_idf_counter,idfopentags(idfnopentags-4)
          end if

c         detectorefficiency in calibrations: initialise the ndetectorefficiency_idf counter that tells how many detectorefficiency so far
          if (trim(adjustl(idf_tag%name)).eq.'detectorefficiencies') then
          ndetectorefficiency_idf_counter=0
          end if
c         detectorefficiency in calibrations: increase the ndetectorefficiency_idf counter that tells how many detectorefficiency so far
          if (trim(adjustl(idf_tag%name)).eq.'detectorefficiency'.and.idfopentags(idfnopentags-1).eq.'detectorefficiencies') then
          ndetectorefficiency_idf_counter=ndetectorefficiency_idf_counter+1
          end if

c         detectorresolution in calibrations: initialise the ndetectorresolution_idf counter that tells how many detectorresolution so far
          if (trim(adjustl(idf_tag%name)).eq.'detectorresolutions') then
          ndetectorresolution_idf_counter=0
          end if
c         detectorresolution in calibrations: increase the ndetectorresolution_idf counter that tells how many detectorresolution so far
          if (trim(adjustl(idf_tag%name)).eq.'detectorresolution'.and.idfopentags(idfnopentags-1).eq.'detectorresolutions') then
          ndetectorresolution_idf_counter=ndetectorresolution_idf_counter+1
          end if
c         resolutionparameters in calibrations: initialise the nparameter_idf_counter counter that tells how many resolutionparameter so far
          if (trim(adjustl(idf_tag%name)).eq.'resolutionparameters') then
          nparameter_idf_counter=0
          end if

c         energycalibration in calibrations: initialise the nenergycalibration_idf counter that tells how many energycalibration so far
          if (trim(adjustl(idf_tag%name)).eq.'energycalibrations') then
          nenergycalibration_idf_counter=0
          end if
c         energycalibration in calibrations: increase the nenergycalibration_idf counter that tells how many energycalibration so far
          if (trim(adjustl(idf_tag%name)).eq.'energycalibration'.and.idfopentags(idfnopentags-1).eq.'energycalibrations') then
          nenergycalibration_idf_counter=nenergycalibration_idf_counter+1
          end if
c         calibrationparameters in calibrations: initialise the nparameter_idf_counter counter that tells how many calibrationparameter so far
          if (trim(adjustl(idf_tag%name)).eq.'calibrationparameters') then
          nparameter_idf_counter=0
          end if

c         reactionlist in reactions: initialise the nreaction_idf_counter counter that tells how many reaction entries so far
          if (trim(adjustl(idf_tag%name)).eq.'reactionlist'.and.idfopentags(idfnopentags-1).eq.'reactions') then
          nreaction_idf_counter=0
          end if
c         reaction in reactions: increase the nreaction_idf_counter counter that tells how many reaction entries so far
          if (trim(adjustl(idf_tag%name)).eq.'reaction'.and.idfopentags(idfnopentags-2).eq.'reactions') then
          nreaction_idf_counter=nreaction_idf_counter+1
          end if

c         complexdata in data or simulation: initialise the ndatapoints_idf_counter counter that tells how many data points so far
          if ((trim(adjustl(idf_tag%name)).eq.'complexdata'.and.idfopentags(idfnopentags-1).eq.'data').or.
     +    (trim(adjustl(idf_tag%name)).eq.'complexdata'.and.idfopentags(idfnopentags-1).eq.'simulation')) then
          ndatapoints_idf_counter=0
          end if
c         dataentry in data: increase the ndatapoints_idf_counter counter that tells how many data points so far
          if ((trim(adjustl(idf_tag%name)).eq.'dataentry'.and.idfopentags(idfnopentags-2).eq.'complexdata'.and.
     +    idfopentags(idfnopentags-3).eq.'data').or.
     +    (trim(adjustl(idf_tag%name)).eq.'dataentry'.and.idfopentags(idfnopentags-2).eq.'complexdata'.and.
     +    idfopentags(idfnopentags-3).eq.'simulation')) then
          ndatapoints_idf_counter=ndatapoints_idf_counter+1
          end if

c         xaxes or yaxes or dataentries in data: initialise the datadimension_idf_counter counter that tells the current datadmiension (x, y, or total)
          if (((trim(adjustl(idf_tag%name)).eq.'xaxes'.or.trim(adjustl(idf_tag%name)).eq.'yaxes').and.
     +    (idfopentags(idfnopentags-2).eq.'data'.or.idfopentags(idfnopentags-2).eq.'simulation')).or.
     +    (trim(adjustl(idf_tag%name)).eq.'dataentry'.and.
     +    (idfopentags(idfnopentags-3).eq.'data'.or.idfopentags(idfnopentags-3).eq.'simulation'))) then
          datadimension_idf_counter=0
c      write(*,*)'datadimension_idf_counter:',trim(adjustl(idf_tag%name))
          end if
c         axis or in complexdata in data: increase the datadimension_idf_counter counter that tells the current datadmiension (x, y, or total)
          if (trim(adjustl(idf_tag%name)).eq.'axis'.and.idfopentags(idfnopentags-2).eq.'complexdata'.and.
     +    (idfopentags(idfnopentags-3).eq.'data'.or.idfopentags(idfnopentags-3).eq.'simulation')) then
          datadimension_idf_counter=datadimension_idf_counter+1
          end if

c         simulation; increase the nsimulation_idf_counter counter, and reset tags that depend on simulation
          if (trim(adjustl(idf_tag%name)).eq.'simulation'.and.
     +    idfopentags(idfnopentags-1).eq.'simulations') then
          nsimulation_idf_counter=nsimulation_idf_counter+1
          ncrosssection_idf_counter=0
          nstoppingpower_idf_counter=0
          nenergyspread_idf_counter=0
          end if

c         simulation; increase the ncrosssection_idf_counter counter
          if (trim(adjustl(idf_tag%name)).eq.'crosssection'.and.
     +    idfopentags(idfnopentags-4).eq.'simulations') then
          ncrosssection_idf_counter=ncrosssection_idf_counter+1
          end if

c         simulation; increase the nstoppingpower_idf_counter counter
          if (trim(adjustl(idf_tag%name)).eq.'stoppingpower'.and.
     +    idfopentags(idfnopentags-4).eq.'simulations') then
          nstoppingpower_idf_counter=nstoppingpower_idf_counter+1
          end if

c         simulation; increase the nstoppingpower_idf_counter counter
          if (trim(adjustl(idf_tag%name)).eq.'energyspread'.and.
     +    idfopentags(idfnopentags-4).eq.'simulations') then
          nenergyspread_idf_counter=nenergyspread_idf_counter+1
          end if




c      write(*,*)'idf_openingtaginentry',idfnopentags,trim(adjustl(idfopentags(idfnopentags)))
c       a previously open group tag is now closed, check that it is the same
        else if (idf_closingtaginentry) then
c         it is the same, need to close it.
          if (trim(adjustl(idf_tag%name)).eq.trim(adjustl(idfopentags(idfnopentags)))) then
            idfopentags(idfnopentags)=' '
            idfopennamespace(idfnopentags)=' '
            idfnopentags=idfnopentags-1
c           sometimes counter variables need to be initialised when opening a goup variable, these come now
c           structure - pointbypointstructure
c           pbp within pointbypointstructure - put auxiliary variable pbp_aux into a pbp profile
            if (trim(adjustl(idf_tag%name)).eq.'pbp'.and.trim(adjustl(idfopentags(3))).eq.'pointbypointstructure') then
              sample%structure%pointbypointstructure%pbpelement(npbp_element_idf_counter)%pbp(npbp_max_idf_counter)=pbp_aux
            end if
c            if (trim(adjustl(idf_tag%name)).eq.'efficiency'.and.trim(adjustl(idfopentags(6))).eq.'detectorefficiency') then
c              sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%
c     +        detectorefficiency(ndetectorefficiency_idf_counter)%efficiency=pbp_aux
c            end if
c            if (trim(adjustl(idf_tag%name)).eq.'lineefficiency'.and.trim(adjustl(idfopentags(6))).eq.'detectorefficiency') then
c              sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%
c     +        detectorefficiency(ndetectorefficiency_idf_counter)%lineefficiency=pbp_aux
c            end if

c      write(*,*)'idf_closingtaginentry',idfnopentags,trim(adjustl(idfopentags(idfnopentags)))
c           it is the closing sample tag correctly closing the open sample tag: finished
            if (trim(adjustl(idf_tag%name)).eq.'sample') then
      write(*,*)'successfully read file, sample ',nsample
              idf_ok=.true.
              goto 1001
            end if
          end if
        end if

c     it was not a group tag, so it must have been a data tag. This is where we have to read actual content and assign it to actual variables!
      else
c       get the attributes in the idf tag, puts their name and content in idf_attributes%attribute(i)%name and idf_attributes%attribute(i)%content, and their number in idf_attributes%n
        call get_attributes_idf
c      write(*,*)'sample ',nsample,trim(adjustl(idf_tag%name))
c      write(*,*)'call name within layermolecule within layeredstructure:',nlayers_idf_counter,
c     +sample%structure%layeredstructure%layers%layer(nlayers_idf_counter)%layermolecules%n
        call read_file_idf_actuallyreadonevalue(nsample)
c      write(*,*)'start r3',idfnopentags,trim(adjustl(idfopentags(idfnopentags)))
        if (.not.idf_ok) goto 1001
      end if

c     now consider the case that it is not an idf flag
      else if (idfntag.eq.0) then
        if (idf_fulltaginentry) then
c       a new group tag was opened
        else if (idf_openingtaginentry) then
          idfnopentags=idfnopentags+1
          idfopentags(idfnopentags)=trim(adjustl(idf_tag%name))
          idfopennamespace(idfnopentags)=trim(adjustl(namespaceinentry))
c      write(*,*)'start x0',idfnopentags,trim(adjustl(idfopentags(idfnopentags)))
c       a previously open group tag is now closed, check that it is the same
        else if (idf_closingtaginentry) then
c         it is the same, need to close it.
          if (trim(adjustl(idf_tag%name)).eq.trim(adjustl(idfopentags(idfnopentags)))) then
            idfopentags(idfnopentags)=' '
            idfopennamespace(idfnopentags)=' '
            idfnopentags=idfnopentags-1
          end if
        end if

      end if


c      if (trim(adjustl(idf_entry)).ne.'</idf>') write(*,*)'idfnopentags b:',idfnopentags,trim(adjustl(idfopentags(idfnopentags)))
c      write(*,*)' '
c      write(*,*)'finished one entry, go to next'
c      write(*,*)' '
c      pause

      if (trim(adjustl(idf_entry)).ne.'</idf>') goto 100
      idf_error='unspecified error reading file '//trim(adjustl(idf_file))


1001  continue
      close(idffileunit)
	return
1000  continue
      idf_error='file '//trim(adjustl(idf_file))//' does not exist'
      close(idffileunit)
	return
	end

c---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
	subroutine read_file_idf_actuallyreadonevalue(nsample)
c	actually reads one value and puts it into an actual idf variable
c     must have called the entire sequence of preliminary routines, ending in allocate_idf_tags
	use IDFCOM
	implicit none
	integer nsample,i
	character tag_dummy1*72,tag_dummy2*72,tag_dummy3*72
c	type(idf_sample)::sample
c---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
      idf_ok=.false.
      idf_ok=.true.
      idf_error=' '

      goto 22
      if (trim(adjustl(section_idf)).eq.'structure') then
        goto 10
      else if (trim(adjustl(section_idf)).eq.'spectra') then
        goto 20
      else if (trim(adjustl(section_idf)).eq.'instrument') then
        goto 30
      end  if
22    continue
c      write(*,*)'tagname ',trim(adjustl(idf_tag%name)),trim(adjustl(idf_tag%content))

c     user within users within sample
      if (trim(adjustl(idf_tag%name)).eq.'user'.and.trim(adjustl(idfopentags(idfnopentags-1))).eq.'sample') then
        user_counter=user_counter+1
        sample%usersnotes%users%user(user_counter)=trim(adjustl(idf_tag%content))
      end if
c     note within notes within sample
      if (trim(adjustl(idf_tag%name)).eq.'note'.and.trim(adjustl(idfopentags(idfnopentags-1))).eq.'sample') then
        note_counter=note_counter+1
        sample%usersnotes%notes%note(note_counter)=trim(adjustl(idf_tag%content))
      end if

c     do this the lazy way: check for the required tags one by one.
c     description within sample
      if (trim(adjustl(idf_tag%name)).eq.'description'.and.trim(adjustl(idfopentags(idfnopentags))).eq.'sample') then
        sample%description=trim(adjustl(idf_tag%content))
c      write(*,*)'description ',sample%description
c      pause
        return
      end if

c     elementsandmolecules

c     no need to read nelements because it was read in allocate_idf_tags
c     name within element within elementsandmolecules
      if (trim(adjustl(idf_tag%name)).eq.'name') then   !.and.idfnopentags.eq.4) then
c      write(*,*)'idfnopentags',idfnopentags
c      do i=1,idfnopentags
c      write(*,*)i,trim(adjustl(idfopentags(i)))
c      end do
c      pause
        if (trim(adjustl(idfopentags(4))).eq.'element'.and.trim(adjustl(idfopentags(2))).eq.'elementsandmolecules') then
          nels_idf_counter=nels_idf_counter+1
          sample%elementsandmolecules%elements%element(nels_idf_counter)%name=trim(adjustl(idf_tag%content))
c      write(*,*)'sample%elementsandmolecules%elements%element name ',i,sample%elementsandmolecules%elements%element(nels_idf_counter)%name
          return
        end if
      end if
c     density within element within elementsandmolecules
      if (trim(adjustl(idf_tag%name)).eq.'density'.and.idfnopentags.eq.4) then
        if (trim(adjustl(idfopentags(4))).eq.'element'.and.trim(adjustl(idfopentags(2))).eq.'elementsandmolecules') then
          call read_idf_realquantity
          if (.not.idf_ok) goto 1001
          sample%elementsandmolecules%elements%element(nels_idf_counter)%density=idf_realquantity_aux
c      write(*,*)'sample%elementsandmolecules%elements%element density ',i,sample%elementsandmolecules%elements%element(nels_idf_counter)%density
c      pause
          return
        end if
      end if
c     no need to read nmolecules because it was read in allocate_idf_tags
c     name within molecule within elementsandmolecules
      if (trim(adjustl(idf_tag%name)).eq.'name'.and.idfnopentags.eq.4) then
        if (trim(adjustl(idfopentags(4))).eq.'molecule'.and.trim(adjustl(idfopentags(2))).eq.'elementsandmolecules') then
          nmols_idf_counter=nmols_idf_counter+1
          sample%elementsandmolecules%molecules%molecule(nmols_idf_counter)%name=trim(adjustl(idf_tag%content))
          return
        end if
      end if
c     density within molecule within elementsandmolecules
      if (trim(adjustl(idf_tag%name)).eq.'density'.and.idfnopentags.eq.4) then
        if (trim(adjustl(idfopentags(4))).eq.'molecule'.and.trim(adjustl(idfopentags(2))).eq.'elementsandmolecules') then
          call read_idf_realquantity
          if (.not.idf_ok) goto 1001
          sample%elementsandmolecules%molecules%molecule(nmols_idf_counter)%density=idf_realquantity_aux
          return
        end if
      end if

10    continue
c     structure

c     structure - layeredstructure

c     density within molecule within elementsandmolecules
      if (trim(adjustl(idfopentags(3))).eq.'layeredstructure'.and.trim(adjustl(idfopentags(2))).eq.'structure'.and.
     +idfnopentags.eq.5) then
        if (trim(adjustl(idf_tag%name)).eq.'layerthickness') then
          nlayers_idf_counter=nlayers_idf_counter+1
          sample%structure%layeredstructure%layers%layer(nlayers_idf_counter)%layerelements%n=0
          sample%structure%layeredstructure%layers%layer(nlayers_idf_counter)%layermolecules%n=0
          call read_idf_realquantity
          if (.not.idf_ok) goto 1001
          sample%structure%layeredstructure%layers%layer(nlayers_idf_counter)%layerthickness=idf_realquantity_aux
          return
        end if
        if (trim(adjustl(idf_tag%name)).eq.'layeruniformity') then
          call read_idf_realquantity
          if (.not.idf_ok) goto 1001
          sample%structure%layeredstructure%layers%layer(nlayers_idf_counter)%layeruniformity=idf_realquantity_aux
          return
        end if
        if (trim(adjustl(idf_tag%name)).eq.'layerdensity') then
          call read_idf_realquantity
          if (.not.idf_ok) goto 1001
          sample%structure%layeredstructure%layers%layer(nlayers_idf_counter)%layerdensity=idf_realquantity_aux
          return
        end if
      end if

c     name within layerelement within layeredstructure
      if (trim(adjustl(idf_tag%name)).eq.'name'.and.idfnopentags.eq.7) then   !.and.idfnopentags.eq.4) then
        if (trim(adjustl(idfopentags(7))).eq.'layerelement'.and.trim(adjustl(idfopentags(3))).eq.'layeredstructure') then
c         do not keep the same order as given in elementsandmolecules; it can even be completely different elements, the user will have to decide what to do
          sample%structure%layeredstructure%layers%layer(nlayers_idf_counter)%layerelements%n=
     +    sample%structure%layeredstructure%layers%layer(nlayers_idf_counter)%layerelements%n+1
          i=sample%structure%layeredstructure%layers%layer(nlayers_idf_counter)%layerelements%n
c      write(*,*)'i a',i
          sample%structure%layeredstructure%layers%layer(nlayers_idf_counter)%layerelements%layerelement(i)%name=
     +    trim(adjustl(idf_tag%content))
          return
        end if
      end if
c     concentration within layerelement within elementsandmolecules
      if (trim(adjustl(idf_tag%name)).eq.'concentration'.and.idfnopentags.eq.7) then
        if (trim(adjustl(idfopentags(7))).eq.'layerelement'.and.trim(adjustl(idfopentags(3))).eq.'layeredstructure') then
          call read_idf_realquantity
          if (.not.idf_ok) goto 1001
c      write(*,*)'i b',i
          sample%structure%layeredstructure%layers%layer(nlayers_idf_counter)%layerelements%layerelement(i)%concentration=
     +    idf_realquantity_aux
          return
        end if
      end if
c     no need to read nmolecules because it was read in allocate_idf_tags
c     name within layermolecule within layeredstructure
      if (trim(adjustl(idf_tag%name)).eq.'name'.and.idfnopentags.eq.7) then
c      write(*,*)'name within layermolecule within layeredstructure a:',trim(adjustl(idf_tag%content))
        if (trim(adjustl(idfopentags(7))).eq.'layermolecule'.and.trim(adjustl(idfopentags(3))).eq.'layeredstructure') then
c      write(*,*)'name within layermolecule within layeredstructure b:',
c     +sample%structure%layeredstructure%layers%layer(nlayers_idf_counter)%layermolecules%n
          sample%structure%layeredstructure%layers%layer(nlayers_idf_counter)%layermolecules%n=
     +    sample%structure%layeredstructure%layers%layer(nlayers_idf_counter)%layermolecules%n+1
          i=sample%structure%layeredstructure%layers%layer(nlayers_idf_counter)%layermolecules%n
c      write(*,*)'name within layermolecule within layeredstructure c:',i,nlayers_idf_counter !,':',trim(adjustl(idf_tag%content))
          sample%structure%layeredstructure%layers%layer(nlayers_idf_counter)%layermolecules%layermolecule(i)%name=
     +    trim(adjustl(idf_tag%content))
          return
        end if
      end if
c     concentration within layermolecule within elementsandmolecules
      if (trim(adjustl(idf_tag%name)).eq.'concentration'.and.idfnopentags.eq.7) then
        if (trim(adjustl(idfopentags(7))).eq.'layermolecule'.and.trim(adjustl(idfopentags(3))).eq.'layeredstructure') then
          call read_idf_realquantity
          if (.not.idf_ok) goto 1001
          sample%structure%layeredstructure%layers%layer(nlayers_idf_counter)%layermolecules%layermolecule(i)%concentration=
     +    idf_realquantity_aux
          return
        end if
      end if

c     equationoverlays within layeredstructure
      if (trim(adjustl(idf_tag%name)).eq.'equationoverlays'.and.trim(adjustl(idfopentags(3))).eq.'layeredstructure') then
        sample%structure%layeredstructure%equationoverlays=trim(adjustl(idf_tag%content))
        return
      end if
c     roughness within layeredstructure
      if (trim(adjustl(idf_tag%name)).eq.'roughness'.and.trim(adjustl(idfopentags(3))).eq.'layeredstructure') then
        sample%structure%layeredstructure%roughness=trim(adjustl(idf_tag%content))
        return
      end if

c     structure - pointbypointstructure

c     elementname within pointbypointstructure
      if (trim(adjustl(idf_tag%name)).eq.'elementname'.and.trim(adjustl(idfopentags(3))).eq.'pointbypointstructure') then
        npbp_max_idf_counter=0
        npbp_element_idf_counter=npbp_element_idf_counter+1
c      write(*,*)'npbp_max_idf_counter ',npbp_max_idf_counter,npbp_element_idf_counter
        sample%structure%pointbypointstructure%pbpelement(npbp_element_idf_counter)%elementname=trim(adjustl(idf_tag%content))
        return
      end if
c     axisname within pointbypointstructure
      if (trim(adjustl(idf_tag%name)).eq.'axisname'.and.trim(adjustl(idfopentags(3))).eq.'pointbypointstructure'.and.
     +idfnopentags.eq.6) then
        if (trim(adjustl(idfopentags(6))).eq.'xaxis') then
          pbp_aux%xaxis%axisname=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(6))).eq.'xerroraxis') then
          pbp_aux%xerroraxis%axisname=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(6))).eq.'yaxis') then
          pbp_aux%yaxis%axisname= trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(6))).eq.'yerroraxis') then
          pbp_aux%yerroraxis%axisname= trim(adjustl(idf_tag%content))
          return
        end if
      end if
c     axisunit within pointbypointstructure
      if (trim(adjustl(idf_tag%name)).eq.'axisunit'.and.trim(adjustl(idfopentags(3))).eq.'pointbypointstructure'.and.
     +idfnopentags.eq.6) then
        if (trim(adjustl(idfopentags(6))).eq.'xaxis') then
          pbp_aux%xaxis%axisunit=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(6))).eq.'xerroraxis') then
          pbp_aux%xerroraxis%axisunit=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(6))).eq.'yaxis') then
          pbp_aux%yaxis%axisunit= trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(6))).eq.'yerroraxis') then
          pbp_aux%yerroraxis%axisunit=trim(adjustl(idf_tag%content))
          return
        end if
      end if
c     x within pbp within pointbypointstructure
      if (trim(adjustl(idfopentags(5))).eq.'pbp'.and.trim(adjustl(idfopentags(3))).eq.'pointbypointstructure'.and.
     +idfnopentags.eq.5) then
        if (trim(adjustl(idf_tag%name)).eq.'x') then
          call get_real_array_intag_idf(pbp_aux%x)
          pbp_aux%n=ndatapoints_intag_idf
          return
        else if (trim(adjustl(idf_tag%name)).eq.'xerror') then
          call get_real_array_intag_idf(pbp_aux%xerror)
c          sample%structure%pointbypointstructure%pbpelement(npbp_element_idf_counter)%pbp(npbp_max_idf_counter)%n=ndatapoints_intag_idf
          return
        else if (trim(adjustl(idf_tag%name)).eq.'y') then
          call get_real_array_intag_idf(pbp_aux%y)
c          sample%structure%pointbypointstructure%pbpelement(npbp_element_idf_counter)%pbp(npbp_max_idf_counter)%n=ndatapoints_intag_idf
          return
        else if (trim(adjustl(idf_tag%name)).eq.'yerror') then
          call get_real_array_intag_idf(pbp_aux%yerror)
c          sample%structure%pointbypointstructure%pbpelement(npbp_element_idf_counter)%pbp(npbp_max_idf_counter)%n=ndatapoints_intag_idf
          return
        end if
      end if
c     elementname within pointbypointstructure
      if (trim(adjustl(idf_tag%name)).eq.'ndf:iong'.and.trim(adjustl(idfopentags(3))).eq.'pointbypointstructure') then
        read(idf_tag%content,*)pbp_aux%ndfidf_iong
        return
      end if

20    continue
c     spectra

c     spectra - log
      if (trim(adjustl(idfopentags(4))).eq.'log'.and.trim(adjustl(idfopentags(2))).eq.'spectra'.and.
     +idfnopentags.eq.4) then
        if (trim(adjustl(idf_tag%name)).eq.'realtime') then
          sample%spectra%spectrum(nspectra_idf_counter)%log%realtime=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'livetime') then
          sample%spectra%spectrum(nspectra_idf_counter)%log%livetime=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'deadtime') then
          sample%spectra%spectrum(nspectra_idf_counter)%log%deadtime=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'starttime') then
          sample%spectra%spectrum(nspectra_idf_counter)%log%starttime=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'stoptime') then
          sample%spectra%spectrum(nspectra_idf_counter)%log%stoptime=trim(adjustl(idf_tag%content))
          return
        end if
      end if
c     spectra - environment
      if (trim(adjustl(idfopentags(4))).eq.'environment'.and.trim(adjustl(idfopentags(2))).eq.'spectra'.and.
     +idfnopentags.eq.4) then
        if (trim(adjustl(idf_tag%name)).eq.'temperature') then
          call read_idf_realquantity
          if (.not.idf_ok) goto 1001
          sample%spectra%spectrum(nspectra_idf_counter)%environment%temperature=idf_realquantity_aux
          return
        else if (trim(adjustl(idf_tag%name)).eq.'pressure') then
          call read_idf_realquantity
          if (.not.idf_ok) goto 1001
          sample%spectra%spectrum(nspectra_idf_counter)%environment%pressure=idf_realquantity_aux
          return
        end if
      end if

c     spectra - beam
c     spectra - beamparticle
      if (trim(adjustl(idf_tag%name)).eq.'beamparticle'.and.trim(adjustl(idfopentags(2))).eq.'spectra') then
        sample%spectra%spectrum(nspectra_idf_counter)%beam%beamparticle=trim(adjustl(idf_tag%content))
        return
      end if
c     spectra - beamZ
      if (trim(adjustl(idf_tag%name)).eq.'beamZ'.and.trim(adjustl(idfopentags(2))).eq.'spectra') then
        read(idf_tag%content,*)sample%spectra%spectrum(nspectra_idf_counter)%beam%beamZ
        return
      end if
c     spectra - beammass
      if (trim(adjustl(idf_tag%name)).eq.'beammass'.and.trim(adjustl(idfopentags(2))).eq.'spectra') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%beam%beammass=idf_realquantity_aux
        return
      end if
c     spectra - beamenergy
      if (trim(adjustl(idf_tag%name)).eq.'beamenergy'.and.trim(adjustl(idfopentags(2))).eq.'spectra') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%beam%beamenergy=idf_realquantity_aux
        return
      end if
c     spectra - beamenergyspread
      if (trim(adjustl(idf_tag%name)).eq.'beamenergyspread'.and.trim(adjustl(idfopentags(2))).eq.'spectra') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%beam%beamenergyspread=idf_realquantity_aux
        return
      end if
c    spectra - beamchargestate: x within pbp within beamchargestate
      if (trim(adjustl(idfopentags(5))).eq.'beamchargestate'.and.trim(adjustl(idfopentags(2))).eq.'spectra'.and.
     +idfnopentags.eq.5) then
c      write(*,*)'a',nspectra_idf_counter,trim(adjustl(idf_tag%name))
c      pause
        if (trim(adjustl(idf_tag%name)).eq.'x') then
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%beam%beamchargestate%x)
          sample%spectra%spectrum(nspectra_idf_counter)%beam%beamchargestate%n=ndatapoints_intag_idf
          return
        else if (trim(adjustl(idf_tag%name)).eq.'xerror') then
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%beam%beamchargestate%xerror)
          return
        else if (trim(adjustl(idf_tag%name)).eq.'y') then
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%beam%beamchargestate%y)
          return
        else if (trim(adjustl(idf_tag%name)).eq.'yerror') then
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%beam%beamchargestate%yerror)
          return
        end if
      end if

c     spectra - beamshape
      if (trim(adjustl(idfopentags(5))).eq.'beamshape'.and.trim(adjustl(idfopentags(2))).eq.'spectra'.and.
     +idfnopentags.eq.5) then
      if (trim(adjustl(idf_tag%name)).eq.'shape') then
        sample%spectra%spectrum(nspectra_idf_counter)%beam%beamshape%shape=trim(adjustl(idf_tag%content))
        return
      else if (trim(adjustl(idf_tag%name)).eq.'l1') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%beam%beamshape%l1=idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'l2') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%beam%beamshape%l2=idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'l3') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%beam%beamshape%l3=idf_realquantity_aux
        return
      end if
      end if

c     spectra - slitsbeforesample
      if (trim(adjustl(idfopentags(5))).eq.'slitsbeforesample'.and.trim(adjustl(idfopentags(2))).eq.'spectra'.and.
     +idfnopentags.eq.7) then
      if (trim(adjustl(idfopentags(7))).eq.'slitshape') then
      if (trim(adjustl(idf_tag%name)).eq.'shape') then
        sample%spectra%spectrum(nspectra_idf_counter)%beam%slitsbeforesample%slit(nslits_idf_counter)%
     +  slitshape%shape=trim(adjustl(idf_tag%content))
        return
      else if (trim(adjustl(idf_tag%name)).eq.'l1') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%beam%slitsbeforesample%slit(nslits_idf_counter)%
     +  slitshape%l1=idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'l2') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%beam%slitsbeforesample%slit(nslits_idf_counter)%
     +  slitshape%l2=idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'l3') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%beam%slitsbeforesample%slit(nslits_idf_counter)%
     +  slitshape%l3=idf_realquantity_aux
        return
      end if
      end if
      end if
      if (trim(adjustl(idf_tag%name)).eq.'slitdistancetosample'.and.trim(adjustl(idfopentags(5))).eq.'slitsbeforesample') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%beam%slitsbeforesample%slit(nslits_idf_counter)%
     +  slitdistancetosample=idf_realquantity_aux
        return
      end if

c     spectra - beamfoil
      if (trim(adjustl(idf_tag%name)).eq.'foildistancetosample'.and.trim(adjustl(idfopentags(2))).eq.'spectra'.and.
     +trim(adjustl(idfopentags(5))).eq.'beamfoil') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%beam%beamfoil%foildistancetosample=idf_realquantity_aux
        return
      end if
c     beamfoil - layer
      if (trim(adjustl(idfopentags(5))).eq.'beamfoil'.and.trim(adjustl(idfopentags(2))).eq.'spectra'.and.
     +idfnopentags.eq.7) then
      if (trim(adjustl(idfopentags(7))).eq.'layer') then
      if (trim(adjustl(idf_tag%name)).eq.'layerthickness') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%beam%beamfoil%foillayers%layer(nfoillayers_idf_counter)%layerthickness
     +  =idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'layeruniformity') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%beam%beamfoil%foillayers%layer(nfoillayers_idf_counter)%layeruniformity
     +  =idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'layerdensity') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%beam%beamfoil%foillayers%layer(nfoillayers_idf_counter)%layerdensity
     +  =idf_realquantity_aux
        return
      end if
      end if
      end if
c     beamfoil - layerelements
      if (trim(adjustl(idfopentags(5))).eq.'beamfoil'.and.trim(adjustl(idfopentags(2))).eq.'spectra'.and.
     +idfnopentags.eq.9) then
      if (trim(adjustl(idfopentags(9))).eq.'layerelement') then
      if (trim(adjustl(idf_tag%name)).eq.'name') then
        sample%spectra%spectrum(nspectra_idf_counter)%beam%beamfoil%foillayers%layer(nfoillayers_idf_counter)%
     +  layerelements%layerelement(nfoilels_idf_counter)%name=trim(adjustl(idf_tag%content))
        return
      else if (trim(adjustl(idf_tag%name)).eq.'concentration') then
        call read_idf_realquantity
        sample%spectra%spectrum(nspectra_idf_counter)%beam%beamfoil%foillayers%layer(nfoillayers_idf_counter)%
     +  layerelements%layerelement(nfoilels_idf_counter)%concentration=idf_realquantity_aux
        return
      end if
      end if
      end if

c     spectra - geometry
      if (trim(adjustl(idfopentags(4))).eq.'geometry'.and.trim(adjustl(idfopentags(2))).eq.'spectra') then
c      write(*,*)'xaxa',trim(adjustl(idf_tag%name)),trim(adjustl(idf_tag%content)),nspectra_idf_counter
c      pause
      if (trim(adjustl(idf_tag%name)).eq.'geometrytype') then
        sample%spectra%spectrum(nspectra_idf_counter)%geometry%geometrytype=trim(adjustl(idf_tag%content))
        return
      else if (trim(adjustl(idf_tag%name)).eq.'incidenceangle') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%geometry%incidenceangle=idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'scatteringangle') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%geometry%scatteringangle=idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'exitangle') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%geometry%exitangle=idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'shape') then
        sample%spectra%spectrum(nspectra_idf_counter)%geometry%spot%shape=trim(adjustl(idf_tag%content))
        return
      else if (trim(adjustl(idf_tag%name)).eq.'l1') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%geometry%spot%l1=idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'l2') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%geometry%spot%l2=idf_realquantity_aux
        return
      end if
      end if

30    continue
c     instrument
      if (trim(adjustl(idfopentags(4))).eq.'instrument'.and.trim(adjustl(idfopentags(2))).eq.'spectra') then
c      write(*,*)'instrument',trim(adjustl(idf_tag%name))
c      pause
      if (trim(adjustl(idf_tag%name)).eq.'ionsource') then
        sample%spectra%spectrum(nspectra_idf_counter)%instrument%ionsource=trim(adjustl(idf_tag%content))
        return
      else if (trim(adjustl(idf_tag%name)).eq.'accelerator') then
        sample%spectra%spectrum(nspectra_idf_counter)%instrument%accelerator=trim(adjustl(idf_tag%content))
        return
      else if (trim(adjustl(idf_tag%name)).eq.'beamline') then
        sample%spectra%spectrum(nspectra_idf_counter)%instrument%beamline=trim(adjustl(idf_tag%content))
        return
      else if (trim(adjustl(idf_tag%name)).eq.'chamber') then
        sample%spectra%spectrum(nspectra_idf_counter)%instrument%chamber=trim(adjustl(idf_tag%content))
        return
      else if (trim(adjustl(idf_tag%name)).eq.'sampleholder') then
        sample%spectra%spectrum(nspectra_idf_counter)%instrument%sampleholder=trim(adjustl(idf_tag%content))
        return
      end if
      end if

c     detection

c     spectra - slitsaftersample
      if (trim(adjustl(idfopentags(5))).eq.'slitsaftersample'.and.trim(adjustl(idfopentags(2))).eq.'spectra'.and.
     +idfnopentags.eq.7) then
      if (trim(adjustl(idfopentags(7))).eq.'slitshape') then
      if (trim(adjustl(idf_tag%name)).eq.'shape') then
        sample%spectra%spectrum(nspectra_idf_counter)%detection%slitsaftersample%slit(nslits_idf_counter)%
     +  slitshape%shape=trim(adjustl(idf_tag%content))
        return
      else if (trim(adjustl(idf_tag%name)).eq.'l1') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%slitsaftersample%slit(nslits_idf_counter)%
     +  slitshape%l1=idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'l2') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%slitsaftersample%slit(nslits_idf_counter)%
     +  slitshape%l2=idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'l3') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%slitsaftersample%slit(nslits_idf_counter)%
     +  slitshape%l3=idf_realquantity_aux
        return
      end if
      end if
      end if
      if (trim(adjustl(idf_tag%name)).eq.'slitdistancetosample'.and.trim(adjustl(idfopentags(5))).eq.'slitsaftersample') then
c      write(*,*)'idf_attributes%n',idf_attributes%n,idfquantitytype(idfntag)
c      write(*,*)'name',trim(adjustl(idf_attributes%attribute(1)%name)),trim(adjustl(idf_attributes%attribute(2)%name))
c      write(*,*)'content',trim(adjustl(idf_attributes%attribute(1)%content)),trim(adjustl(idf_attributes%attribute(2)%content))
c          if (trim(adjustl(idf_attributes%attribute(i)%name)).eq.idfattr(i,1)) then
c            read(idf_attributes%attribute(i)%content
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%slitsaftersample%slit(nslits_idf_counter)%
     +  slitdistancetosample=idf_realquantity_aux
        return
      end if

c     spectra - stoppingfoil
      if (trim(adjustl(idfopentags(5))).eq.'stoppingfoil'.and.trim(adjustl(idfopentags(2))).eq.'spectra') then
      if (trim(adjustl(idf_tag%name)).eq.'foildistancetosample') then
c      write(*,*)'stoppingfoil',nspectra_idf_counter,trim(adjustl(idf_tag%name)),trim(adjustl(idf_tag%content))
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%stoppingfoil%foildistancetosample=idf_realquantity_aux
        return
      end if
c     stoppingfoil - layer
      if (idfnopentags.eq.7.and.trim(adjustl(idfopentags(7))).eq.'layer') then
c      write(*,*)'nfoillayers_idf_counter',nspectra_idf_counter,nfoillayers_idf_counter,trim(adjustl(idf_tag%name)),
c     +trim(adjustl(idf_tag%content))
      if (trim(adjustl(idf_tag%name)).eq.'layerthickness') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%stoppingfoil%foillayers%layer(nfoillayers_idf_counter)%
     +  layerthickness=idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'layeruniformity') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%stoppingfoil%foillayers%layer(nfoillayers_idf_counter)%
     +  layeruniformity=idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'layerdensity') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%stoppingfoil%foillayers%layer(nfoillayers_idf_counter)%
     +  layerdensity=idf_realquantity_aux
        return
      end if
      end if
c     stoppingfoil - layerelements
      if (idfnopentags.eq.9.and.trim(adjustl(idfopentags(9))).eq.'layerelement') then
      if (trim(adjustl(idf_tag%name)).eq.'name') then
c      write(*,*)'nfoilels_idf_counter name',nspectra_idf_counter,nfoillayers_idf_counter,nfoilels_idf_counter,
c     +trim(adjustl(idf_tag%name)),trim(adjustl(idf_tag%content))
        sample%spectra%spectrum(nspectra_idf_counter)%detection%stoppingfoil%foillayers%layer(nfoillayers_idf_counter)%
     +  layerelements%layerelement(nfoilels_idf_counter)%name=trim(adjustl(idf_tag%content))
        return
      else if (trim(adjustl(idf_tag%name)).eq.'concentration') then
c      write(*,*)'nfoilels_idf_counter conc',nspectra_idf_counter,nfoillayers_idf_counter,nfoilels_idf_counter,
c     +trim(adjustl(idf_tag%name)),trim(adjustl(idf_tag%content))
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%stoppingfoil%foillayers%layer(nfoillayers_idf_counter)%
     +  layerelements%layerelement(nfoilels_idf_counter)%concentration=idf_realquantity_aux
        return
      end if
      end if
      end if

c     spectra - detection - detector. This if serves for everything inside the detector tag
      if (trim(adjustl(idfopentags(5))).eq.'detector'.and.trim(adjustl(idfopentags(2))).eq.'spectra') then
c      detector - detectortype
      if (trim(adjustl(idf_tag%name)).eq.'detectortype') then
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%detectortype=trim(adjustl(idf_tag%content))
        return
c      detector - solidangle
      else if (trim(adjustl(idf_tag%name)).eq.'solidangle') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
         sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%solidangle=idf_realquantity_aux
        return
      end if

c     detector - detectorshape
      if (trim(adjustl(idfopentags(6))).eq.'detectorshape') then
      if (trim(adjustl(idf_tag%name)).eq.'shape') then
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%detectorshape%shape
     +  =trim(adjustl(idf_tag%content))
        return
      else if (trim(adjustl(idf_tag%name)).eq.'l1') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%detectorshape%l1
     +  =idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'l2') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%detectorshape%l2
     +  =idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'l3') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%detectorshape%l3
     +  =idf_realquantity_aux
        return
      end if
      end if

c     detector - deadlayer
      if (trim(adjustl(idfopentags(6))).eq.'deadlayer') then
      if (trim(adjustl(idf_tag%name)).eq.'layerthickness') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%deadlayer%
     +  layerthickness=idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'layeruniformity') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%deadlayer%
     +  layeruniformity=idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'layerdensity') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%deadlayer%
     +  layerdensity=idf_realquantity_aux
        return
      end if
      end if
c     detector - layerelements
      if (idfnopentags.eq.8.and.trim(adjustl(idfopentags(8))).eq.'layerelement') then
c      write(*,*)'detector',nspectra_idf_counter,nfoilels_idf_counter
      if (trim(adjustl(idf_tag%name)).eq.'name') then
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%deadlayer%
     +  layerelements%layerelement(nfoilels_idf_counter)%name=trim(adjustl(idf_tag%content))
        return
      else if (trim(adjustl(idf_tag%name)).eq.'concentration') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%deadlayer%
     +  layerelements%layerelement(nfoilels_idf_counter)%concentration=idf_realquantity_aux
        return
      end if
      end if
c     detector - entrancewindow
      if (trim(adjustl(idfopentags(6))).eq.'entrancewindow') then
c     entrancewindow - layer
      if (idfnopentags.eq.7.and.trim(adjustl(idfopentags(7))).eq.'layer') then
      if (trim(adjustl(idf_tag%name)).eq.'layerthickness') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%entrancewindow%layer(nfoillayers_idf_counter)%
     +  layerthickness=idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'layeruniformity') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%entrancewindow%layer(nfoillayers_idf_counter)%
     +  layeruniformity=idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'layerdensity') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%entrancewindow%layer(nfoillayers_idf_counter)%
     +  layerdensity=idf_realquantity_aux
        return
      end if
      end if
c     entrancewindow - layerelements
      if (idfnopentags.eq.9.and.trim(adjustl(idfopentags(9))).eq.'layerelement') then
      if (trim(adjustl(idf_tag%name)).eq.'name') then
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%entrancewindow%layer(nfoillayers_idf_counter)%
     +  layerelements%layerelement(nfoilels_idf_counter)%name=trim(adjustl(idf_tag%content))
        return
      else if (trim(adjustl(idf_tag%name)).eq.'concentration') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%entrancewindow%layer(nfoillayers_idf_counter)%
     +  layerelements%layerelement(nfoilels_idf_counter)%concentration=idf_realquantity_aux
        return
      end if
      end if
      end if
c     detector - detectorlayers
      if (trim(adjustl(idfopentags(6))).eq.'detectorlayers') then
c     detectorlayers - layer
      if (idfnopentags.eq.7.and.trim(adjustl(idfopentags(7))).eq.'layer') then
      if (trim(adjustl(idf_tag%name)).eq.'layerthickness') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%detectorlayers%layer(nfoillayers_idf_counter)%
     +  layerthickness=idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'layeruniformity') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%detectorlayers%layer(nfoillayers_idf_counter)%
     +  layeruniformity=idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'layerdensity') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%detectorlayers%layer(nfoillayers_idf_counter)%
     +  layerdensity=idf_realquantity_aux
        return
      end if
      end if
c     detectorlayers - layerelements
      if (idfnopentags.eq.9.and.trim(adjustl(idfopentags(9))).eq.'layerelement') then
      if (trim(adjustl(idf_tag%name)).eq.'name') then
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%detectorlayers%layer(nfoillayers_idf_counter)%
     +  layerelements%layerelement(nfoilels_idf_counter)%name=trim(adjustl(idf_tag%content))
        return
      else if (trim(adjustl(idf_tag%name)).eq.'concentration') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%detectorlayers%layer(nfoillayers_idf_counter)%
     +  layerelements%layerelement(nfoilels_idf_counter)%concentration=idf_realquantity_aux
        return
      end if
      end if
      end if

c     detector - tof
      if (trim(adjustl(idfopentags(6))).eq.'tof') then
      if (trim(adjustl(idf_tag%name)).eq.'toflength') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%tof%toflength=idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'toftimeresolution') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%tof%toftimeresolution=idf_realquantity_aux
        return
      end if
      end if
c     detector - startfoil
      if (trim(adjustl(idfopentags(7))).eq.'startfoil') then
c     startfoil - layer
      if (idfnopentags.eq.8.and.trim(adjustl(idfopentags(8))).eq.'layer') then
      if (trim(adjustl(idf_tag%name)).eq.'layerthickness') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%tof%startfoil%layer(nfoillayers_idf_counter)%
     +  layerthickness=idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'layeruniformity') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%tof%startfoil%layer(nfoillayers_idf_counter)%
     +  layeruniformity=idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'layerdensity') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%tof%startfoil%layer(nfoillayers_idf_counter)%
     +  layerdensity=idf_realquantity_aux
        return
      end if
      end if
c     startfoil - layerelements
      if (idfnopentags.eq.10.and.trim(adjustl(idfopentags(10))).eq.'layerelement') then
      if (trim(adjustl(idf_tag%name)).eq.'name') then
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%tof%startfoil%layer(nfoillayers_idf_counter)%
     +  layerelements%layerelement(nfoilels_idf_counter)%name=trim(adjustl(idf_tag%content))
        return
      else if (trim(adjustl(idf_tag%name)).eq.'concentration') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%tof%startfoil%layer(nfoillayers_idf_counter)%
     +  layerelements%layerelement(nfoilels_idf_counter)%concentration=idf_realquantity_aux
        return
      end if
      end if
      end if
c     detector - stopfoil
      if (trim(adjustl(idfopentags(7))).eq.'stopfoil') then
c     stopfoil - layer
      if (idfnopentags.eq.8.and.trim(adjustl(idfopentags(8))).eq.'layer') then
      if (trim(adjustl(idf_tag%name)).eq.'layerthickness') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%tof%stopfoil%layer(nfoillayers_idf_counter)%
     +  layerthickness=idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'layeruniformity') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%tof%stopfoil%layer(nfoillayers_idf_counter)%
     +  layeruniformity=idf_realquantity_aux
        return
      else if (trim(adjustl(idf_tag%name)).eq.'layerdensity') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%tof%stopfoil%layer(nfoillayers_idf_counter)%
     +  layerdensity=idf_realquantity_aux
        return
      end if
      end if
c     stopfoil - layerelements
      if (idfnopentags.eq.10.and.trim(adjustl(idfopentags(10))).eq.'layerelement') then
      if (trim(adjustl(idf_tag%name)).eq.'name') then
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%tof%stopfoil%layer(nfoillayers_idf_counter)%
     +  layerelements%layerelement(nfoilels_idf_counter)%name=trim(adjustl(idf_tag%content))
        return
      else if (trim(adjustl(idf_tag%name)).eq.'concentration') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%detector%tof%stopfoil%layer(nfoillayers_idf_counter)%
     +  layerelements%layerelement(nfoilels_idf_counter)%concentration=idf_realquantity_aux
        return
      end if
      end if
      end if
c     end if of detection - detector
      end if

c     detection - electronics
      if (trim(adjustl(idfopentags(5))).eq.'electronics'.and.trim(adjustl(idfopentags(2))).eq.'spectra') then
c     amplifier
      if (trim(adjustl(idfopentags(6))).eq.'amplifier') then
c     electronics - amplifiertype
      if (trim(adjustl(idf_tag%name)).eq.'amplifiertype') then
        sample%spectra%spectrum(nspectra_idf_counter)%detection%electronics%amplifier%amplifiertype=
     +  trim(adjustl(idf_tag%content))
        return
c     electronics - pulseshape
      else if (trim(adjustl(idf_tag%name)).eq.'pulseshape') then
        sample%spectra%spectrum(nspectra_idf_counter)%detection%electronics%amplifier%pulseshape=trim(adjustl(idf_tag%content))
        return
c     electronics - shapingtime
      else if (trim(adjustl(idf_tag%name)).eq.'shapingtime') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%electronics%amplifier%shapingtime=idf_realquantity_aux
        return
c     electronics - risetime
      else if (trim(adjustl(idf_tag%name)).eq.'risetime') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%electronics%amplifier%risetime=idf_realquantity_aux
        return
c     electronics - flattoptime
      else if (trim(adjustl(idf_tag%name)).eq.'flattoptime') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%electronics%amplifier%flattoptime=idf_realquantity_aux
        return
c     electronics - pur
      else if (trim(adjustl(idf_tag%name)).eq.'pur') then
        sample%spectra%spectrum(nspectra_idf_counter)%detection%electronics%amplifier%pur=trim(adjustl(idf_tag%content))
        return
c     electronics - pulsespurtimehape
      else if (trim(adjustl(idf_tag%name)).eq.'purtime') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%detection%electronics%amplifier%purtime=idf_realquantity_aux
        return
      end if
      end if
      end if

c     spectrum - calibrations - detectorefficiencies
      if (trim(adjustl(idfopentags(5))).eq.'detectorefficiencies'.and.trim(adjustl(idfopentags(2))).eq.'spectra') then
c     calibrations -  efficiencyion
      if (trim(adjustl(idf_tag%name)).eq.'efficiencyion') then
        sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%
     +  detectorefficiency(ndetectorefficiency_idf_counter)%efficiencyion=trim(adjustl(idf_tag%content))
        return
c     calibrations -  efficiencymode
      else if (trim(adjustl(idf_tag%name)).eq.'efficiencymode') then
        sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%
     +  detectorefficiency(ndetectorefficiency_idf_counter)%efficiencymode=trim(adjustl(idf_tag%content))
        return
      end if

c     read the simpledata structure - first efficiency
      if (trim(adjustl(idfopentags(7))).eq.'efficiency') then
c     axisname within efficiency
      if (trim(adjustl(idf_tag%name)).eq.'axisname'.and.idfnopentags.eq.8) then
        if (trim(adjustl(idfopentags(8))).eq.'xaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%
     +    detectorefficiency(ndetectorefficiency_idf_counter)%efficiency%xaxis%axisname=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(8))).eq.'xerroraxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%
     +    detectorefficiency(ndetectorefficiency_idf_counter)%efficiency%xerroraxis%axisname=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(8))).eq.'yaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%
     +    detectorefficiency(ndetectorefficiency_idf_counter)%efficiency%yaxis%axisname=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(8))).eq.'yerroraxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%
     +    detectorefficiency(ndetectorefficiency_idf_counter)%efficiency%yerroraxis%axisname=trim(adjustl(idf_tag%content))
          return
        end if
      end if
c     axisunit within efficiency
      if (trim(adjustl(idf_tag%name)).eq.'axisunit'.and.idfnopentags.eq.8) then
        if (trim(adjustl(idfopentags(8))).eq.'xaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%
     +    detectorefficiency(ndetectorefficiency_idf_counter)%efficiency%xaxis%axisunit=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(8))).eq.'xerroraxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%
     +    detectorefficiency(ndetectorefficiency_idf_counter)%efficiency%xerroraxis%axisunit=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(8))).eq.'yaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%
     +    detectorefficiency(ndetectorefficiency_idf_counter)%efficiency%yaxis%axisunit=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(8))).eq.'yerroraxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%
     +    detectorefficiency(ndetectorefficiency_idf_counter)%efficiency%yerroraxis%axisunit=trim(adjustl(idf_tag%content))
          return
        end if
      end if
c     x within pbp within efficiency
      if (idfnopentags.eq.7) then
c      write(*,*)'trim(adjustl(idf_tag%name)) ',trim(adjustl(idf_tag%name))
c      pause
        if (trim(adjustl(idf_tag%name)).eq.'x') then
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%calibrations%
     +    detectorefficiencies%detectorefficiency(ndetectorefficiency_idf_counter)%efficiency%x)
          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%
     +    detectorefficiencies%detectorefficiency(ndetectorefficiency_idf_counter)%efficiency%n=ndatapoints_intag_idf
          return
        else if (trim(adjustl(idf_tag%name)).eq.'xerror') then
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%calibrations%
     +    detectorefficiencies%detectorefficiency(ndetectorefficiency_idf_counter)%efficiency%xerror)
c          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%detectorefficiency(ndetectorefficiency_idf_counter)%efficiency%n=ndatapoints_intag_idf
          return
        else if (trim(adjustl(idf_tag%name)).eq.'y') then
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%calibrations%
     +    detectorefficiencies%detectorefficiency(ndetectorefficiency_idf_counter)%efficiency%y)
c          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%detectorefficiency(ndetectorefficiency_idf_counter)%efficiency%n=ndatapoints_intag_idf
          return
        else if (trim(adjustl(idf_tag%name)).eq.'yerror') then
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%calibrations%
     +    detectorefficiencies%detectorefficiency(ndetectorefficiency_idf_counter)%efficiency%yerror)
c          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%detectorefficiency(ndetectorefficiency_idf_counter)%efficiency%n=ndatapoints_intag_idf
          return
        end if
      end if

c     read the simpledata structure - now lineefficiency
      else if (trim(adjustl(idfopentags(7))).eq.'efficiency'.or.trim(adjustl(idfopentags(7))).eq.'lineefficiency') then
c     axisname within lineefficiency
      if (trim(adjustl(idf_tag%name)).eq.'axisname'.and.idfnopentags.eq.8) then
        if (trim(adjustl(idfopentags(8))).eq.'xaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%
     +    detectorefficiency(ndetectorefficiency_idf_counter)%lineefficiency%xaxis%axisname=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(8))).eq.'xerroraxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%
     +    detectorefficiency(ndetectorefficiency_idf_counter)%lineefficiency%xerroraxis%axisname=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(8))).eq.'yaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%
     +    detectorefficiency(ndetectorefficiency_idf_counter)%lineefficiency%yaxis%axisname=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(8))).eq.'yerroraxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%
     +    detectorefficiency(ndetectorefficiency_idf_counter)%lineefficiency%yerroraxis%axisname=trim(adjustl(idf_tag%content))
          return
        end if
      end if
c     axisunit within lineefficiency
      if (trim(adjustl(idf_tag%name)).eq.'axisunit'.and.idfnopentags.eq.8) then
        if (trim(adjustl(idfopentags(8))).eq.'xaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%
     +    detectorefficiency(ndetectorefficiency_idf_counter)%lineefficiency%xaxis%axisunit=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(8))).eq.'xerroraxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%
     +    detectorefficiency(ndetectorefficiency_idf_counter)%lineefficiency%xerroraxis%axisunit=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(8))).eq.'yaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%
     +    detectorefficiency(ndetectorefficiency_idf_counter)%lineefficiency%yaxis%axisunit=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(8))).eq.'yerroraxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%
     +    detectorefficiency(ndetectorefficiency_idf_counter)%lineefficiency%yerroraxis%axisunit=trim(adjustl(idf_tag%content))
          return
        end if
      end if
c     x within pbp within lineefficiency
      if (idfnopentags.eq.7) then
c      write(*,*)'trim(adjustl(idf_tag%name)) ',trim(adjustl(idf_tag%name))
c      pause
        if (trim(adjustl(idf_tag%name)).eq.'x') then
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%calibrations%
     +    detectorefficiencies%detectorefficiency(ndetectorefficiency_idf_counter)%lineefficiency%x)
          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%
     +    detectorefficiencies%detectorefficiency(ndetectorefficiency_idf_counter)%lineefficiency%n=ndatapoints_intag_idf
          return
        else if (trim(adjustl(idf_tag%name)).eq.'xerror') then
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%calibrations%
     +    detectorefficiencies%detectorefficiency(ndetectorefficiency_idf_counter)%lineefficiency%xerror)
c          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%detectorefficiency(ndetectorefficiency_idf_counter)%lineefficiency%n=ndatapoints_intag_idf
          return
        else if (trim(adjustl(idf_tag%name)).eq.'y') then
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%calibrations%
     +    detectorefficiencies%detectorefficiency(ndetectorefficiency_idf_counter)%lineefficiency%y)
c          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%detectorefficiency(ndetectorefficiency_idf_counter)%lineefficiency%n=ndatapoints_intag_idf
          return
        else if (trim(adjustl(idf_tag%name)).eq.'yerror') then
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%calibrations%
     +    detectorefficiencies%detectorefficiency(ndetectorefficiency_idf_counter)%lineefficiency%yerror)
c          sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%detectorefficiency(ndetectorefficiency_idf_counter)%lineefficiency%n=ndatapoints_intag_idf
          return
        else if (trim(adjustl(idf_tag%name)).eq.'line') then
          call get_character_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%calibrations%
     +    detectorefficiencies%detectorefficiency(ndetectorefficiency_idf_counter)%lineefficiency%line)
c      write(*,*)'pbp ',sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorefficiencies%
c     +detectorefficiency(ndetectorefficiency_idf_counter)%lineefficiency%line
c      pause
          return
        end if
      end if
      end if

c     end of detectorefficiencies big block
      end if

c     spectrum - calibrations - detectorresolutions
      if (trim(adjustl(idfopentags(5))).eq.'detectorresolutions'.and.trim(adjustl(idfopentags(2))).eq.'spectra') then
c     calibrations -  resolutionion
      if (trim(adjustl(idf_tag%name)).eq.'resolutionion') then
c      write(*,*)'resolutionion',nspectra_idf_counter,ndetectorresolution_idf_counter,trim(adjustl(idf_tag%content))
c      pause
        sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorresolutions%
     +  detectorresolution(ndetectorresolution_idf_counter)%resolutionion=trim(adjustl(idf_tag%content))
        return
      end if
c     resolutionparameter in calibrations: increase the nparameter_idf_counter counter that tells how many resolutionparameter so far
      if (trim(adjustl(idf_tag%name)).eq.'resolutionparameter'.and.idfopentags(idfnopentags).eq.'resolutionparameters') then
        nparameter_idf_counter=nparameter_idf_counter+1
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%calibrations%detectorresolutions%detectorresolution
     +  (ndetectorresolution_idf_counter)%resolutionparameters%resolutionparameter(nparameter_idf_counter)=idf_realquantity_aux
        return
      end if
c     end of detectorresolutions block
      end if

c     spectrum - calibrations - energycalibrations
      if (trim(adjustl(idfopentags(5))).eq.'energycalibrations'.and.trim(adjustl(idfopentags(2))).eq.'spectra') then
c     calibrations -  calibrationion
      if (trim(adjustl(idf_tag%name)).eq.'calibrationion') then
c      write(*,*)'resolutionion',nspectra_idf_counter,nenergycalibration_idf_counter,trim(adjustl(idf_tag%content))
c      pause
        sample%spectra%spectrum(nspectra_idf_counter)%calibrations%energycalibrations%
     +  energycalibration(nenergycalibration_idf_counter)%calibrationion=trim(adjustl(idf_tag%content))
        return
      end if
      if (trim(adjustl(idf_tag%name)).eq.'calibrationmode') then
        sample%spectra%spectrum(nspectra_idf_counter)%calibrations%energycalibrations%
     +  energycalibration(nenergycalibration_idf_counter)%calibrationmode=trim(adjustl(idf_tag%content))
        return
      end if
c     calibrationparameter in calibrations: increase the nparameter_idf_counter counter that tells how many calibrationparameter so far
      if (trim(adjustl(idf_tag%name)).eq.'calibrationparameter'.and.idfopentags(idfnopentags).eq.'calibrationparameters') then
        nparameter_idf_counter=nparameter_idf_counter+1
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%calibrations%energycalibrations%energycalibration
     +  (nenergycalibration_idf_counter)%calibrationparameters%calibrationparameter(nparameter_idf_counter)=idf_realquantity_aux
        return
      end if
c     end of energycalibrations block
      end if

c     spectrum - reactions
      if (trim(adjustl(idfopentags(4))).eq.'reactions') then
c     spectrum - reactions - technique
      if (trim(adjustl(idf_tag%name)).eq.'technique') then
        sample%spectra%spectrum(nspectra_idf_counter)%reactions%technique=trim(adjustl(idf_tag%content))
        return
      end if
c     spectrum - reactions - reaction
      if (trim(adjustl(idfopentags(6))).eq.'reaction') then
      if (trim(adjustl(idf_tag%name)).eq.'initialtargetparticle') then
        sample%spectra%spectrum(nspectra_idf_counter)%reactions%reactionlist%reaction(nreaction_idf_counter)%
     +  initialtargetparticle=trim(adjustl(idf_tag%content))
        return
      else  if (trim(adjustl(idf_tag%name)).eq.'incidentparticle') then
        sample%spectra%spectrum(nspectra_idf_counter)%reactions%reactionlist%reaction(nreaction_idf_counter)%
     +  incidentparticle=trim(adjustl(idf_tag%content))
        return
      else  if (trim(adjustl(idf_tag%name)).eq.'exitparticle') then
        sample%spectra%spectrum(nspectra_idf_counter)%reactions%reactionlist%reaction(nreaction_idf_counter)%
     +  exitparticle=trim(adjustl(idf_tag%content))
        return
      else  if (trim(adjustl(idf_tag%name)).eq.'finaltargetparticle') then
        sample%spectra%spectrum(nspectra_idf_counter)%reactions%reactionlist%reaction(nreaction_idf_counter)%
     +  finaltargetparticle=trim(adjustl(idf_tag%content))
        return
      else  if (trim(adjustl(idf_tag%name)).eq.'reactionQ') then
        call read_idf_realquantity
        if (.not.idf_ok) goto 1001
        sample%spectra%spectrum(nspectra_idf_counter)%reactions%reactionlist%reaction(nreaction_idf_counter)%
     +  reactionQ=idf_realquantity_aux
        return
      end if
      end if
      end if

c     spectrum - data big block
      if (trim(adjustl(idfopentags(4))).eq.'data') then
c     spectrum - data - datamode
      if (trim(adjustl(idf_tag%name)).eq.'datamode') then
        sample%spectra%spectrum(nspectra_idf_counter)%data%datamode=trim(adjustl(idf_tag%content))
        return
      end if
c     spectrum - data - channelmode
      if (trim(adjustl(idf_tag%name)).eq.'channelmode') then
        sample%spectra%spectrum(nspectra_idf_counter)%data%channelmode=trim(adjustl(idf_tag%content))
        return
      end if
c     spectrum - data - datafile
      if (trim(adjustl(idf_tag%name)).eq.'filename') then
        if (trim(adjustl(sample%spectra%spectrum(nspectra_idf_counter)%data%datamode)).ne.'datafile') then
          idf_ok=.false.
	    idf_error='datafile entry with datamode '//trim(adjustl(sample%spectra%spectrum(nspectra_idf_counter)%data%datamode))
	    return
        end if
        sample%spectra%spectrum(nspectra_idf_counter)%data%datafile%filename=trim(adjustl(idf_tag%content))
        sample%spectra%spectrum(nspectra_idf_counter)%data%datamode='datafile'
        return
      end if
      if (trim(adjustl(idf_tag%name)).eq.'fileformat') then
        if (trim(adjustl(sample%spectra%spectrum(nspectra_idf_counter)%data%datamode)).ne.'datafile') then
          idf_ok=.false.
	    idf_error='datafile entry with datamode '//trim(adjustl(sample%spectra%spectrum(nspectra_idf_counter)%data%datamode))
	    return
        end if
        sample%spectra%spectrum(nspectra_idf_counter)%data%datafile%fileformat=trim(adjustl(idf_tag%content))
        return
      end if
      if (trim(adjustl(idf_tag%name)).eq.'filesource') then
        if (trim(adjustl(sample%spectra%spectrum(nspectra_idf_counter)%data%datamode)).ne.'datafile') then
          idf_ok=.false.
	    idf_error='datafile entry with datamode '//trim(adjustl(sample%spectra%spectrum(nspectra_idf_counter)%data%datamode))
	    return
        end if
        sample%spectra%spectrum(nspectra_idf_counter)%data%datafile%filesource=trim(adjustl(idf_tag%content))
        return
      end if

c     spectrum - data - simpledata
      if (trim(adjustl(idfopentags(5))).eq.'simpledata') then
        sample%spectra%spectrum(nspectra_idf_counter)%data%datamode='simple'
c     axisname within simpledata
      if (trim(adjustl(idf_tag%name)).eq.'axisname'.and.idfnopentags.eq.6) then
        if (trim(adjustl(idfopentags(6))).eq.'xaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%data%simpledata%xaxis%axisname=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(6))).eq.'xerroraxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%data%simpledata%xerroraxis%axisname=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(6))).eq.'yaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%data%simpledata%yaxis%axisname=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(6))).eq.'yerroraxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%data%simpledata%yerroraxis%axisname=trim(adjustl(idf_tag%content))
          return
        end if
      end if
c     axisunit within simpledata
      if (trim(adjustl(idf_tag%name)).eq.'axisunit'.and.idfnopentags.eq.6) then
        if (trim(adjustl(idfopentags(6))).eq.'xaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%data%simpledata%xaxis%axisunit=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(6))).eq.'xerroraxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%data%simpledata%xerroraxis%axisunit=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(6))).eq.'yaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%data%simpledata%yaxis%axisunit=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(6))).eq.'yerroraxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%data%simpledata%yerroraxis%axisunit=trim(adjustl(idf_tag%content))
          return
        end if
      end if
c     x within simpledata
      if (idfnopentags.eq.5) then
        if (trim(adjustl(idf_tag%name)).eq.'x') then
c      write(*,*)'simpledata x',nspectra_idf_counter
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%data%simpledata%x)
          if (ndatapoints_intag_idf.ne.ndatapoints_idf(nspectra_idf_counter)) then
            idf_ok=.false.
            idf_error=
     +      'Number of points in sample%spectra%spectrum(nspectra_idf_counter)%data%simpledata%x not equal to ndatapoints_idf'
          end if
          return
        else if (trim(adjustl(idf_tag%name)).eq.'xerror') then
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%data%simpledata%xerror)
          if (ndatapoints_intag_idf.ne.ndatapoints_idf(nspectra_idf_counter)) then
            idf_ok=.false.
            idf_error=
     +    'Number of points in sample%spectra%spectrum(nspectra_idf_counter)%data%simpledata%xerror not equal to ndatapoints_idf'
          end if
          return
        else if (trim(adjustl(idf_tag%name)).eq.'y') then
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%data%simpledata%y)
          if (ndatapoints_intag_idf.ne.ndatapoints_idf(nspectra_idf_counter)) then
            idf_ok=.false.
            idf_error=
     +      'Number of points in sample%spectra%spectrum(nspectra_idf_counter)%data%simpledata%y not equal to ndatapoints_idf'
          end if
          return
        else if (trim(adjustl(idf_tag%name)).eq.'yerror') then
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%data%simpledata%yerror)
          if (ndatapoints_intag_idf.ne.ndatapoints_idf(nspectra_idf_counter)) then
            idf_ok=.false.
            idf_error=
     +    'Number of points in sample%spectra%spectrum(nspectra_idf_counter)%data%simpledata%yerror not equal to ndatapoints_idf'
          end if
          return
        end if
      end if

c     spectrum - data - linedata
      else if (trim(adjustl(idfopentags(5))).eq.'linedata') then
        sample%spectra%spectrum(nspectra_idf_counter)%data%datamode='line'
c     axisname within linedata
      if (trim(adjustl(idf_tag%name)).eq.'axisname'.and.idfnopentags.eq.6) then
        if (trim(adjustl(idfopentags(6))).eq.'lineaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%data%linedata%lineaxis%axisname=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(6))).eq.'yaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%data%linedata%yaxis%axisname=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(6))).eq.'yerroraxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%data%linedata%yerroraxis%axisname=trim(adjustl(idf_tag%content))
          return
        end if
      end if
c     axisunit within linedata
      if (trim(adjustl(idf_tag%name)).eq.'axisunit'.and.idfnopentags.eq.6) then
        if (trim(adjustl(idfopentags(6))).eq.'lineaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%data%linedata%lineaxis%axisunit=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(6))).eq.'yaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%data%linedata%yaxis%axisunit=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(6))).eq.'yerroraxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%data%linedata%yerroraxis%axisunit=trim(adjustl(idf_tag%content))
          return
        end if
      end if
c     line within linedata
      if (idfnopentags.eq.5) then
        if (trim(adjustl(idf_tag%name)).eq.'line') then
          call get_character_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%data%linedata%line)
          if (ndatapoints_intag_idf.ne.ndatapoints_idf(nspectra_idf_counter)) then
            idf_ok=.false.
            idf_error=
     +      'Number of points in sample%spectra%spectrum(nspectra_idf_counter)%data%linedata%x not equal to ndatapoints_idf'
          end if
          return
        else if (trim(adjustl(idf_tag%name)).eq.'y') then
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%data%linedata%y)
          if (ndatapoints_intag_idf.ne.ndatapoints_idf(nspectra_idf_counter)) then
            idf_ok=.false.
            idf_error=
     +      'Number of points in sample%spectra%spectrum(nspectra_idf_counter)%data%linedata%y not equal to ndatapoints_idf'
          end if
          return
        else if (trim(adjustl(idf_tag%name)).eq.'yerror') then
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%data%linedata%yerror)
          if (ndatapoints_intag_idf.ne.ndatapoints_idf(nspectra_idf_counter)) then
            idf_ok=.false.
            idf_error=
     +      'Number of points in sample%spectra%spectrum(nspectra_idf_counter)%data%linedata%yerror not equal to ndatapoints_idf'
          end if
          return
        end if
      end if

c     spectrum - data - complexdata
      else if (trim(adjustl(idfopentags(5))).eq.'complexdata') then
        sample%spectra%spectrum(nspectra_idf_counter)%data%datamode='complex'
        if (trim(adjustl(idf_tag%name)).eq.'datadimensionx') then
          read(idf_tag%content,*)sample%spectra%spectrum(nspectra_idf_counter)%data%complexdata%datadimensions%datadimensionx
          return
        end if
        if (trim(adjustl(idf_tag%name)).eq.'datadimensiony') then
          read(idf_tag%content,*)sample%spectra%spectrum(nspectra_idf_counter)%data%complexdata%datadimensions%datadimensiony
          return
        end if
c      if (trim(adjustl(idf_tag%name)).eq.'axisname') write(*,*)'idfopentags(7):',trim(adjustl(idfopentags(7)))
        if (trim(adjustl(idf_tag%name)).eq.'axisname'.and.trim(adjustl(idfopentags(6))).eq.'xaxes') then
c      write(*,*)'datadimension_idf_counter x ',datadimension_idf_counter,
c     +sample%spectra%spectrum(nspectra_idf_counter)%data%complexdata%datadimensions%datadimensionx
          if (datadimension_idf_counter.gt.
     +    sample%spectra%spectrum(nspectra_idf_counter)%data%complexdata%datadimensions%datadimensionx) then
            idf_ok=.false.
            idf_error='More xaxes entries than specified in datadimensionx in a complexdata'
            return
          end if
          sample%spectra%spectrum(nspectra_idf_counter)%data%complexdata%xaxes%axis(datadimension_idf_counter)%axisname=
     +    trim(adjustl(idf_tag%content))
          return
        end if
        if (trim(adjustl(idf_tag%name)).eq.'axisunit'.and.trim(adjustl(idfopentags(6))).eq.'xaxes') then
          if (datadimension_idf_counter.gt.
     +    sample%spectra%spectrum(nspectra_idf_counter)%data%complexdata%datadimensions%datadimensionx) then
            idf_ok=.false.
            idf_error='More xaxes entries than specified in datadimensionx in a complexdata'
            return
          end if
          sample%spectra%spectrum(nspectra_idf_counter)%data%complexdata%xaxes%axis(datadimension_idf_counter)%axisunit=
     +    trim(adjustl(idf_tag%content))
          return
        end if
        if (trim(adjustl(idf_tag%name)).eq.'axisname'.and.trim(adjustl(idfopentags(6))).eq.'yaxes') then
c      write(*,*)'datadimension_idf_counter y ',datadimension_idf_counter,
c     +sample%spectra%spectrum(nspectra_idf_counter)%data%complexdata%datadimensions%datadimensiony
          if (datadimension_idf_counter.gt.
     +    sample%spectra%spectrum(nspectra_idf_counter)%data%complexdata%datadimensions%datadimensiony) then
            idf_ok=.false.
            idf_error='More yaxes entries than specified in datadimensiony in a complexdata'
            return
          end if
          sample%spectra%spectrum(nspectra_idf_counter)%data%complexdata%yaxes%axis(datadimension_idf_counter)%axisname=
     +    trim(adjustl(idf_tag%content))
          return
        end if
        if (trim(adjustl(idf_tag%name)).eq.'axisunit'.and.trim(adjustl(idfopentags(6))).eq.'yaxes') then
          if (datadimension_idf_counter.gt.
     +    sample%spectra%spectrum(nspectra_idf_counter)%data%complexdata%datadimensions%datadimensiony) then
            idf_ok=.false.
            idf_error='More yaxes entries than specified in datadimensiony in a complexdata'
            return
          end if
          sample%spectra%spectrum(nspectra_idf_counter)%data%complexdata%yaxes%axis(datadimension_idf_counter)%axisunit=
     +    trim(adjustl(idf_tag%content))
          return
        end if
        if (trim(adjustl(idf_tag%name)).eq.'timestamp') then
          sample%spectra%spectrum(nspectra_idf_counter)%data%complexdata%dataentries%dataentry(ndatapoints_idf_counter)%
     +    timestamp=trim(adjustl(idf_tag%content))
          ndatatimestamp_idf(nspectra_idf_counter)=1
          return
        end if
        if (trim(adjustl(idf_tag%name)).eq.'line') then
          sample%spectra%spectrum(nspectra_idf_counter)%data%complexdata%dataentries%dataentry(ndatapoints_idf_counter)%
     +    line=trim(adjustl(idf_tag%content))
          ndataline_idf(nspectra_idf_counter)=1
          return
        end if
        if (trim(adjustl(idf_tag%name)).eq.'dataitem') then
          datadimension_idf_counter=datadimension_idf_counter+1
c      write(*,*)'dataitem',nspectra_idf_counter,ndatapoints_idf_counter,datadimension_idf_counter
          if (datadimension_idf_counter.gt.sample%spectra%spectrum(nspectra_idf_counter)%data%complexdata%datadimensions%
     +    datadimensionx+sample%spectra%spectrum(nspectra_idf_counter)%data%complexdata%datadimensions%datadimensiony) then
            idf_ok=.false.
            idf_error='More dataitem than specified in datadimensionx+datadimensiony in a complexdata'
            return
          end if
          read(idf_tag%content,*)sample%spectra%spectrum(nspectra_idf_counter)%data%complexdata%dataentries%
     +    dataentry(ndatapoints_idf_counter)%dataitem(datadimension_idf_counter)
          return
        end if
      end if

c     end of spectrum - data big block
      end if

c     here starts huge spectrum - group process
      if (trim(adjustl(idfopentags(4))).eq.'process') then

c     here starts group process - physicsdefaults
      if (trim(adjustl(idfopentags(5))).eq.'physicsdefaults') then
c      write(*,*)'physicsdefaults ',trim(adjustl(idf_tag%name))
c      pause
c     process - physicsdefaults - crosssectiondefault
      if (trim(adjustl(idfopentags(6))).eq.'crosssectiondefault') then
        if (trim(adjustl(idf_tag%name)).eq.'Rutherford') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%physicsdefaults%crosssectiondefault%Rutherford=
     +    trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'screening') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%physicsdefaults%crosssectiondefault%screening=
     +    trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'name') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%physicsdefaults%crosssectiondefault%computercode%name=
     +    trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'version') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%physicsdefaults%crosssectiondefault%computercode%version=
     +    trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'builddate') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%physicsdefaults%crosssectiondefault%computercode%builddate=
     +    trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'releasedate') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%physicsdefaults%crosssectiondefault%computercode%releasedate=
     +    trim(adjustl(idf_tag%content))
          return
        end if
c     end of process - physicsdefaults - crosssectiondefault
c     process - physicsdefaults - stoppingpowerdefault
      else if (trim(adjustl(idfopentags(6))).eq.'stoppingpowerdefault') then
        if (trim(adjustl(idf_tag%name)).eq.'name') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%physicsdefaults%stoppingpowerdefault%computercode%name=
     +    trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'version') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%physicsdefaults%stoppingpowerdefault%computercode%version=
     +    trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'builddate') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%physicsdefaults%stoppingpowerdefault%computercode%builddate=
     +    trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'releasedate') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%physicsdefaults%stoppingpowerdefault%computercode%releasedate=
     +    trim(adjustl(idf_tag%content))
          return
        end if
c     end of process - physicsdefaults - stoppingpowerdefault
c     process - physicsdefaults - energyspreaddefault
      else if (trim(adjustl(idfopentags(6))).eq.'energyspreaddefault') then
        if (trim(adjustl(idf_tag%name)).eq.'energylossstraggling') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%physicsdefaults%energyspreaddefault%energylossstraggling=
     +    trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'multiplescattering') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%physicsdefaults%energyspreaddefault%multiplescattering=
     +    trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'Dopplereffect') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%physicsdefaults%energyspreaddefault%Dopplereffect=
     +    trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'beamangularspread') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%physicsdefaults%energyspreaddefault%beamangularspread=
     +    trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'beamsize') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%physicsdefaults%energyspreaddefault%geometricspread%
     +    beamsize=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'detectoraperture') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%physicsdefaults%energyspreaddefault%geometricspread%
     +    detectoraperture=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'Tschalareffect') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%physicsdefaults%energyspreaddefault%Tschalareffect=
     +    trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'name') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%physicsdefaults%energyspreaddefault%computercode%name=
     +    trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'version') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%physicsdefaults%energyspreaddefault%computercode%version=
     +    trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'builddate') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%physicsdefaults%energyspreaddefault%computercode%builddate=
     +    trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'releasedate') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%physicsdefaults%energyspreaddefault%computercode%releasedate=
     +    trim(adjustl(idf_tag%content))
          return
        end if
c     end of process - physicsdefaults - energyspreaddefault
      end if
      end if
c     end of group process - physicsdefaults

c     here starts group process - crosssections
      if (trim(adjustl(idfopentags(8))).eq.'crosssections') then
c      write(*,*)'crosssections:',trim(adjustl(idf_tag%name)),nspectra_idf_counter,nsimulation_idf_counter,
c     +ncrosssection_idf_counter
        if (trim(adjustl(idf_tag%name)).eq.'crosssectionframe') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    crosssections%crosssection(ncrosssection_idf_counter)%crosssectionframe=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'crosssectiontype') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    crosssections%crosssection(ncrosssection_idf_counter)%crosssectiontype=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'energyminimum') then
          call read_idf_realquantity
          if (.not.idf_ok) goto 1001
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    crosssections%crosssection(ncrosssection_idf_counter)%energyminimum=idf_realquantity_aux
          return
        else if (trim(adjustl(idf_tag%name)).eq.'energymaximum') then
          call read_idf_realquantity
          if (.not.idf_ok) goto 1001
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    crosssections%crosssection(ncrosssection_idf_counter)%energymaximum=idf_realquantity_aux
          return
        else if (trim(adjustl(idf_tag%name)).eq.'initialtargetparticle') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    crosssections%crosssection(ncrosssection_idf_counter)%reaction%initialtargetparticle=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'incidentparticle') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    crosssections%crosssection(ncrosssection_idf_counter)%reaction%incidentparticle=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'exitparticle') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    crosssections%crosssection(ncrosssection_idf_counter)%reaction%exitparticle=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'finaltargetparticle') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    crosssections%crosssection(ncrosssection_idf_counter)%reaction%finaltargetparticle=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'reactionQ') then
          call read_idf_realquantity
          if (.not.idf_ok) goto 1001
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    crosssections%crosssection(ncrosssection_idf_counter)%reaction%reactionQ=idf_realquantity_aux
          return
        else if (trim(adjustl(idf_tag%name)).eq.'filename') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    crosssections%crosssection(ncrosssection_idf_counter)%crosssectionfile%filename=trim(adjustl(idf_tag%content))
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    physics%crosssections%crosssection(ncrosssection_idf_counter)%mode='file'
          return
        else if (trim(adjustl(idf_tag%name)).eq.'fileformat') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    crosssections%crosssection(ncrosssection_idf_counter)%crosssectionfile%fileformat=trim(adjustl(idf_tag%content))
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    physics%crosssections%crosssection(ncrosssection_idf_counter)%mode='file'
          return
        else if (trim(adjustl(idf_tag%name)).eq.'filesource') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    crosssections%crosssection(ncrosssection_idf_counter)%crosssectionfile%filesource=trim(adjustl(idf_tag%content))
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    physics%crosssections%crosssection(ncrosssection_idf_counter)%mode='file'
          return
        else if (trim(adjustl(idfopentags(10))).eq.'crosssectionoverride') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    physics%crosssections%crosssection(ncrosssection_idf_counter)%mode='override'
          if (trim(adjustl(idf_tag%name)).eq.'Rutherford') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    crosssections%crosssection(ncrosssection_idf_counter)%crosssectionoverride%Rutherford=
     +    trim(adjustl(idf_tag%content))
          return
          else if (trim(adjustl(idf_tag%name)).eq.'name') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    crosssections%crosssection(ncrosssection_idf_counter)%crosssectionoverride%computercode%name=
     +    trim(adjustl(idf_tag%content))
          return
          else if (trim(adjustl(idf_tag%name)).eq.'version') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    crosssections%crosssection(ncrosssection_idf_counter)%crosssectionoverride%computercode%version=
     +    trim(adjustl(idf_tag%content))
          return
          else if (trim(adjustl(idf_tag%name)).eq.'builddate') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    crosssections%crosssection(ncrosssection_idf_counter)%crosssectionoverride%computercode%builddate=
     +    trim(adjustl(idf_tag%content))
          return
          else if (trim(adjustl(idf_tag%name)).eq.'releasedate') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    crosssections%crosssection(ncrosssection_idf_counter)%crosssectionoverride%computercode%releasedate=
     +    trim(adjustl(idf_tag%content))
          return
          end if
        else if (trim(adjustl(idfopentags(10))).eq.'crosssectiondata') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    physics%crosssections%crosssection(ncrosssection_idf_counter)%mode='data'
c         crosssectiondata within crosssections

c         axisname within crosssectiondata
          if (trim(adjustl(idf_tag%name)).eq.'axisname') then
c      write(*,*)'axisname:',trim(adjustl(idf_tag%name)),':',trim(adjustl(idfopentags(idfnopentags))),nspectra_idf_counter,
c     +nsimulation_idf_counter,ncrosssection_idf_counter
            if (trim(adjustl(idfopentags(idfnopentags))).eq.'xaxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        crosssections%crosssection(ncrosssection_idf_counter)%crosssectiondata%xaxis%axisname=
     +        trim(adjustl(idf_tag%content))
              return
            else if (trim(adjustl(idfopentags(idfnopentags))).eq.'xerroraxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        crosssections%crosssection(ncrosssection_idf_counter)%crosssectiondata%xerroraxis%axisname=
     +        trim(adjustl(idf_tag%content))
              return
            else if (trim(adjustl(idfopentags(idfnopentags))).eq.'yaxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        crosssections%crosssection(ncrosssection_idf_counter)%crosssectiondata%yaxis%axisname=
     +        trim(adjustl(idf_tag%content))
              return
            else if (trim(adjustl(idfopentags(idfnopentags))).eq.'yerroraxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        crosssections%crosssection(ncrosssection_idf_counter)%crosssectiondata%yerroraxis%axisname=
     +        trim(adjustl(idf_tag%content))
              return
            end if
          end if
c         axisunit within crosssectiondata
          if (trim(adjustl(idf_tag%name)).eq.'axisunit') then
            if (trim(adjustl(idfopentags(idfnopentags))).eq.'xaxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        crosssections%crosssection(ncrosssection_idf_counter)%crosssectiondata%xaxis%axisunit=
     +        trim(adjustl(idf_tag%content))
              return
            else if (trim(adjustl(idfopentags(idfnopentags))).eq.'xerroraxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        crosssections%crosssection(ncrosssection_idf_counter)%crosssectiondata%xerroraxis%axisunit=
     +        trim(adjustl(idf_tag%content))
              return
            else if (trim(adjustl(idfopentags(idfnopentags))).eq.'yaxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        crosssections%crosssection(ncrosssection_idf_counter)%crosssectiondata%yaxis%axisunit=
     +        trim(adjustl(idf_tag%content))
              return
            else if (trim(adjustl(idfopentags(idfnopentags))).eq.'yerroraxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        crosssections%crosssection(ncrosssection_idf_counter)%crosssectiondata%yerroraxis%axisunit=
     +        trim(adjustl(idf_tag%content))
              return
            end if
          end if
c         x within crosssectiondata
          if (trim(adjustl(idf_tag%name)).eq.'x') then
            call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation
     +      (nsimulation_idf_counter)%physics%crosssections%crosssection(ncrosssection_idf_counter)%crosssectiondata%x)
            if (ndatapoints_intag_idf.ne.ncrosssectionpoints_idf(nspectra_idf_counter,nsimulation_idf_counter,
     +        ncrosssection_idf_counter)) then
              idf_ok=.false.
              idf_error=
     +        'Number of points in cross section not equal to ncrosssectionpoints_idf'
            end if
            return
          else if (trim(adjustl(idf_tag%name)).eq.'xerror') then
            call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation
     +      (nsimulation_idf_counter)%physics%crosssections%crosssection(ncrosssection_idf_counter)%crosssectiondata%xerror)
            if (ndatapoints_intag_idf.ne.ncrosssectionpoints_idf(nspectra_idf_counter,nsimulation_idf_counter,
     +        ncrosssection_idf_counter)) then
              idf_ok=.false.
              idf_error=
     +        'Number of points in cross section not equal to ncrosssectionpoints_idf'
            end if
            return
          else if (trim(adjustl(idf_tag%name)).eq.'y') then
            call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation
     +      (nsimulation_idf_counter)%physics%crosssections%crosssection(ncrosssection_idf_counter)%crosssectiondata%y)
            if (ndatapoints_intag_idf.ne.ncrosssectionpoints_idf(nspectra_idf_counter,nsimulation_idf_counter,
     +        ncrosssection_idf_counter)) then
              idf_ok=.false.
              idf_error=
     +        'Number of points in cross section not equal to ncrosssectionpoints_idf'
            end if
            return
          else if (trim(adjustl(idf_tag%name)).eq.'yerror') then
            call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation
     +      (nsimulation_idf_counter)%physics%crosssections%crosssection(ncrosssection_idf_counter)%crosssectiondata%yerror)
            if (ndatapoints_intag_idf.ne.ncrosssectionpoints_idf(nspectra_idf_counter,nsimulation_idf_counter,
     +        ncrosssection_idf_counter)) then
              idf_ok=.false.
              idf_error=
     +        'Number of points in cross section not equal to ncrosssectionpoints_idf'
            end if
            return
          end if
c         end of crosssectiondata within crosssections
        end if
      end if
c     end of group process - crosssections

c     here starts group process - stoppingpowers
      if (trim(adjustl(idfopentags(8))).eq.'stoppingpowers') then
c      write(*,*)'stoppingpowers:',trim(adjustl(idf_tag%name)),nspectra_idf_counter,nsimulation_idf_counter,
c     +nstoppingpower_idf_counter
        if (trim(adjustl(idf_tag%name)).eq.'ion') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%ion=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'ionchargestate') then
          call read_idf_realquantity
          if (.not.idf_ok) goto 1001
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%ionchargestate=idf_realquantity_aux
          return
        else if (trim(adjustl(idf_tag%name)).eq.'targetelement') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%targetelement=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'targetmolecule ') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%targetmolecule =trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'stoppingmode') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%stoppingmode=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'filename') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%stoppingpowerfile%filename=trim(adjustl(idf_tag%content))
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    physics%stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%mode='file'
          return
        else if (trim(adjustl(idf_tag%name)).eq.'fileformat') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%stoppingpowerfile%fileformat=trim(adjustl(idf_tag%content))
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    physics%stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%mode='file'
          return
        else if (trim(adjustl(idf_tag%name)).eq.'filesource') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%stoppingpowerfile%filesource=trim(adjustl(idf_tag%content))
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    physics%stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%mode='file'
          return
        else if (trim(adjustl(idfopentags(10))).eq.'stoppingpoweroverride') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    physics%stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%mode='override'
          if (trim(adjustl(idf_tag%name)).eq.'name') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%stoppingpoweroverride%computercode%name=
     +    trim(adjustl(idf_tag%content))
          return
          else if (trim(adjustl(idf_tag%name)).eq.'version') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%stoppingpoweroverride%computercode%version=
     +    trim(adjustl(idf_tag%content))
          return
          else if (trim(adjustl(idf_tag%name)).eq.'builddate') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%stoppingpoweroverride%computercode%builddate=
     +    trim(adjustl(idf_tag%content))
          return
          else if (trim(adjustl(idf_tag%name)).eq.'releasedate') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%stoppingpoweroverride%computercode%releasedate=
     +    trim(adjustl(idf_tag%content))
          return
          end if
        else if (trim(adjustl(idfopentags(10))).eq.'stoppingpowerdata') then
c         stoppingpowerdata within stoppingpowers
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    physics%stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%mode='data'

c         axisname within stoppingpowerdata
          if (trim(adjustl(idf_tag%name)).eq.'axisname') then
c      write(*,*)'axisname:',trim(adjustl(idf_tag%name)),':',trim(adjustl(idfopentags(idfnopentags))),nspectra_idf_counter,
c     +nsimulation_idf_counter,nstoppingpower_idf_counter
            if (trim(adjustl(idfopentags(idfnopentags))).eq.'xaxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%stoppingpowerdata%xaxis%axisname=
     +        trim(adjustl(idf_tag%content))
              return
            else if (trim(adjustl(idfopentags(idfnopentags))).eq.'xerroraxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%stoppingpowerdata%xerroraxis%axisname=
     +        trim(adjustl(idf_tag%content))
              return
            else if (trim(adjustl(idfopentags(idfnopentags))).eq.'yaxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%stoppingpowerdata%yaxis%axisname=
     +        trim(adjustl(idf_tag%content))
              return
            else if (trim(adjustl(idfopentags(idfnopentags))).eq.'yerroraxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%stoppingpowerdata%yerroraxis%axisname=
     +        trim(adjustl(idf_tag%content))
              return
            end if
          end if
c         axisunit within stoppingpowerdata
          if (trim(adjustl(idf_tag%name)).eq.'axisunit') then
            if (trim(adjustl(idfopentags(idfnopentags))).eq.'xaxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%stoppingpowerdata%xaxis%axisunit=
     +        trim(adjustl(idf_tag%content))
              return
            else if (trim(adjustl(idfopentags(idfnopentags))).eq.'xerroraxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%stoppingpowerdata%xerroraxis%axisunit=
     +        trim(adjustl(idf_tag%content))
              return
            else if (trim(adjustl(idfopentags(idfnopentags))).eq.'yaxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%stoppingpowerdata%yaxis%axisunit=
     +        trim(adjustl(idf_tag%content))
              return
            else if (trim(adjustl(idfopentags(idfnopentags))).eq.'yerroraxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%stoppingpowerdata%yerroraxis%axisunit=
     +        trim(adjustl(idf_tag%content))
              return
            end if
          end if
c         x within stoppingpowerdata
          if (trim(adjustl(idf_tag%name)).eq.'x') then
            call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation
     +      (nsimulation_idf_counter)%physics%stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%stoppingpowerdata%x)
            if (ndatapoints_intag_idf.ne.nstoppingpowerpoints_idf(nspectra_idf_counter,nsimulation_idf_counter,
     +        nstoppingpower_idf_counter)) then
              idf_ok=.false.
              idf_error=
     +        'Number of points in cross section not equal to nstoppingpowerpoints_idf'
            end if
            return
          else if (trim(adjustl(idf_tag%name)).eq.'xerror') then
            call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation
     +      (nsimulation_idf_counter)%physics%stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%stoppingpowerdata%xerror)
            if (ndatapoints_intag_idf.ne.nstoppingpowerpoints_idf(nspectra_idf_counter,nsimulation_idf_counter,
     +        nstoppingpower_idf_counter)) then
              idf_ok=.false.
              idf_error=
     +        'Number of points in cross section not equal to nstoppingpowerpoints_idf'
            end if
            return
          else if (trim(adjustl(idf_tag%name)).eq.'y') then
            call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation
     +      (nsimulation_idf_counter)%physics%stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%stoppingpowerdata%y)
            if (ndatapoints_intag_idf.ne.nstoppingpowerpoints_idf(nspectra_idf_counter,nsimulation_idf_counter,
     +        nstoppingpower_idf_counter)) then
              idf_ok=.false.
              idf_error=
     +        'Number of points in cross section not equal to nstoppingpowerpoints_idf'
            end if
            return
          else if (trim(adjustl(idf_tag%name)).eq.'yerror') then
            call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation
     +      (nsimulation_idf_counter)%physics%stoppingpowers%stoppingpower(nstoppingpower_idf_counter)%stoppingpowerdata%yerror)
            if (ndatapoints_intag_idf.ne.nstoppingpowerpoints_idf(nspectra_idf_counter,nsimulation_idf_counter,
     +        nstoppingpower_idf_counter)) then
              idf_ok=.false.
              idf_error=
     +        'Number of points in cross section not equal to nstoppingpowerpoints_idf'
            end if
            return
          end if
c         end of stoppingpowerdata within stoppingpowers
        end if
      end if
c     end of group process - stoppingpowers

c     here starts group process - energyspreads
      if (trim(adjustl(idfopentags(8))).eq.'energyspreads') then
c      write(*,*)'energyspreads:',trim(adjustl(idf_tag%name)),nspectra_idf_counter,nsimulation_idf_counter,
c     +nenergyspread_idf_counter
        if (trim(adjustl(idf_tag%name)).eq.'ion') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    energyspreads%energyspread(nenergyspread_idf_counter)%ion=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'ionchargestate') then
          call read_idf_realquantity
          if (.not.idf_ok) goto 1001
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    energyspreads%energyspread(nenergyspread_idf_counter)%ionchargestate=idf_realquantity_aux
          return
        else if (trim(adjustl(idf_tag%name)).eq.'targetelement') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    energyspreads%energyspread(nenergyspread_idf_counter)%targetelement=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'energyspreadmode') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    energyspreads%energyspread(nenergyspread_idf_counter)%energyspreadmode =trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idf_tag%name)).eq.'filename') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    energyspreads%energyspread(nenergyspread_idf_counter)%energyspreadfile%filename=trim(adjustl(idf_tag%content))
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    physics%energyspreads%energyspread(nenergyspread_idf_counter)%mode='file'
          return
        else if (trim(adjustl(idf_tag%name)).eq.'fileformat') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    energyspreads%energyspread(nenergyspread_idf_counter)%energyspreadfile%fileformat=trim(adjustl(idf_tag%content))
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    physics%energyspreads%energyspread(nenergyspread_idf_counter)%mode='file'
          return
        else if (trim(adjustl(idf_tag%name)).eq.'filesource') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    energyspreads%energyspread(nenergyspread_idf_counter)%energyspreadfile%filesource=trim(adjustl(idf_tag%content))
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    physics%energyspreads%energyspread(nenergyspread_idf_counter)%mode='file'
          return
        else if (trim(adjustl(idfopentags(10))).eq.'energyspreadoverride') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    physics%energyspreads%energyspread(nenergyspread_idf_counter)%mode='override'
          if (trim(adjustl(idf_tag%name)).eq.'energylossstraggling') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    energyspreads%energyspread(nenergyspread_idf_counter)%energyspreadoverride%energylossstraggling=
     +    trim(adjustl(idf_tag%content))
          return
          else if (trim(adjustl(idf_tag%name)).eq.'multiplescattering') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    energyspreads%energyspread(nenergyspread_idf_counter)%energyspreadoverride%multiplescattering=
     +    trim(adjustl(idf_tag%content))
          return
          else if (trim(adjustl(idf_tag%name)).eq.'Dopplereffect') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    energyspreads%energyspread(nenergyspread_idf_counter)%energyspreadoverride%Dopplereffect=
     +    trim(adjustl(idf_tag%content))
          return
          else if (trim(adjustl(idf_tag%name)).eq.'beamangularspread') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    energyspreads%energyspread(nenergyspread_idf_counter)%energyspreadoverride%beamangularspread=
     +    trim(adjustl(idf_tag%content))
          return
          else if (trim(adjustl(idf_tag%name)).eq.'beamsize') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    energyspreads%energyspread(nenergyspread_idf_counter)%energyspreadoverride%geometricspread%beamsize=
     +    trim(adjustl(idf_tag%content))
          return
          else if (trim(adjustl(idf_tag%name)).eq.'detectoraperture') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    energyspreads%energyspread(nenergyspread_idf_counter)%energyspreadoverride%geometricspread%detectoraperture=
     +    trim(adjustl(idf_tag%content))
          return
          else if (trim(adjustl(idf_tag%name)).eq.'Tschalareffect') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    energyspreads%energyspread(nenergyspread_idf_counter)%energyspreadoverride%Tschalareffect=
     +    trim(adjustl(idf_tag%content))
          return
          else if (trim(adjustl(idf_tag%name)).eq.'name') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    energyspreads%energyspread(nenergyspread_idf_counter)%energyspreadoverride%computercode%name=
     +    trim(adjustl(idf_tag%content))
          return
          else if (trim(adjustl(idf_tag%name)).eq.'version') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    energyspreads%energyspread(nenergyspread_idf_counter)%energyspreadoverride%computercode%version=
     +    trim(adjustl(idf_tag%content))
          return
          else if (trim(adjustl(idf_tag%name)).eq.'builddate') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    energyspreads%energyspread(nenergyspread_idf_counter)%energyspreadoverride%computercode%builddate=
     +    trim(adjustl(idf_tag%content))
          return
          else if (trim(adjustl(idf_tag%name)).eq.'releasedate') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +    energyspreads%energyspread(nenergyspread_idf_counter)%energyspreadoverride%computercode%releasedate=
     +    trim(adjustl(idf_tag%content))
          return
          end if
        else if (trim(adjustl(idfopentags(10))).eq.'energyspreaddata') then
c         energyspreaddata within energyspreads
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    physics%energyspreads%energyspread(nenergyspread_idf_counter)%mode='data'

c         axisname within energyspreaddata
          if (trim(adjustl(idf_tag%name)).eq.'axisname') then
c      write(*,*)'axisname:',trim(adjustl(idf_tag%name)),':',trim(adjustl(idfopentags(idfnopentags))),nspectra_idf_counter,
c     +nsimulation_idf_counter,nenergyspread_idf_counter
            if (trim(adjustl(idfopentags(idfnopentags))).eq.'xaxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        energyspreads%energyspread(nenergyspread_idf_counter)%energyspreaddata%xaxis%axisname=
     +        trim(adjustl(idf_tag%content))
              return
            else if (trim(adjustl(idfopentags(idfnopentags))).eq.'xerroraxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        energyspreads%energyspread(nenergyspread_idf_counter)%energyspreaddata%xerroraxis%axisname=
     +        trim(adjustl(idf_tag%content))
              return
            else if (trim(adjustl(idfopentags(idfnopentags))).eq.'yaxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        energyspreads%energyspread(nenergyspread_idf_counter)%energyspreaddata%yaxis%axisname=
     +        trim(adjustl(idf_tag%content))
              return
            else if (trim(adjustl(idfopentags(idfnopentags))).eq.'yerroraxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        energyspreads%energyspread(nenergyspread_idf_counter)%energyspreaddata%yerroraxis%axisname=
     +        trim(adjustl(idf_tag%content))
              return
            end if
          end if
c         axisunit within energyspreaddata
          if (trim(adjustl(idf_tag%name)).eq.'axisunit') then
            if (trim(adjustl(idfopentags(idfnopentags))).eq.'xaxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        energyspreads%energyspread(nenergyspread_idf_counter)%energyspreaddata%xaxis%axisunit=
     +        trim(adjustl(idf_tag%content))
              return
            else if (trim(adjustl(idfopentags(idfnopentags))).eq.'xerroraxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        energyspreads%energyspread(nenergyspread_idf_counter)%energyspreaddata%xerroraxis%axisunit=
     +        trim(adjustl(idf_tag%content))
              return
            else if (trim(adjustl(idfopentags(idfnopentags))).eq.'yaxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        energyspreads%energyspread(nenergyspread_idf_counter)%energyspreaddata%yaxis%axisunit=
     +        trim(adjustl(idf_tag%content))
              return
            else if (trim(adjustl(idfopentags(idfnopentags))).eq.'yerroraxis') then
              sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%physics%
     +        energyspreads%energyspread(nenergyspread_idf_counter)%energyspreaddata%yerroraxis%axisunit=
     +        trim(adjustl(idf_tag%content))
              return
            end if
          end if
c         x within energyspreaddata
          if (trim(adjustl(idf_tag%name)).eq.'x') then
            call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation
     +      (nsimulation_idf_counter)%physics%energyspreads%energyspread(nenergyspread_idf_counter)%energyspreaddata%x)
            if (ndatapoints_intag_idf.ne.nenergyspreadpoints_idf(nspectra_idf_counter,nsimulation_idf_counter,
     +        nenergyspread_idf_counter)) then
              idf_ok=.false.
              idf_error=
     +        'Number of points in cross section not equal to nenergyspreadpoints_idf'
            end if
            return
          else if (trim(adjustl(idf_tag%name)).eq.'xerror') then
            call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation
     +      (nsimulation_idf_counter)%physics%energyspreads%energyspread(nenergyspread_idf_counter)%energyspreaddata%xerror)
            if (ndatapoints_intag_idf.ne.nenergyspreadpoints_idf(nspectra_idf_counter,nsimulation_idf_counter,
     +        nenergyspread_idf_counter)) then
              idf_ok=.false.
              idf_error=
     +        'Number of points in cross section not equal to nenergyspreadpoints_idf'
            end if
            return
          else if (trim(adjustl(idf_tag%name)).eq.'y') then
            call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation
     +      (nsimulation_idf_counter)%physics%energyspreads%energyspread(nenergyspread_idf_counter)%energyspreaddata%y)
            if (ndatapoints_intag_idf.ne.nenergyspreadpoints_idf(nspectra_idf_counter,nsimulation_idf_counter,
     +        nenergyspread_idf_counter)) then
              idf_ok=.false.
              idf_error=
     +        'Number of points in cross section not equal to nenergyspreadpoints_idf'
            end if
            return
          else if (trim(adjustl(idf_tag%name)).eq.'yerror') then
            call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation
     +      (nsimulation_idf_counter)%physics%energyspreads%energyspread(nenergyspread_idf_counter)%energyspreaddata%yerror)
            if (ndatapoints_intag_idf.ne.nenergyspreadpoints_idf(nspectra_idf_counter,nsimulation_idf_counter,
     +        nenergyspread_idf_counter)) then
              idf_ok=.false.
              idf_error=
     +        'Number of points in cross section not equal to nenergyspreadpoints_idf'
            end if
            return
          end if
c         end of energyspreaddata within energyspreads
        end if
      end if
c     end of group process - energyspreads


cXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
cXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
cXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
cXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
cXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

c     process - simulation big block
      if (trim(adjustl(idfopentags(6))).eq.'simulation') then
c     process - simulation - simulationtype
      if (trim(adjustl(idf_tag%name)).eq.'simulationtype') then
        sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%simulationtype=
     +  trim(adjustl(idf_tag%content))
        return
      end if
c     process - simulation - targetlayer
      if (trim(adjustl(idf_tag%name)).eq.'targetlayer') then
        read(idf_tag%content,*)
     +  sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%targetlayer
        return
      end if
c     process - simulation - datamode
      if (trim(adjustl(idf_tag%name)).eq.'datamode') then
        sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%datamode=
     +  trim(adjustl(idf_tag%content))
        return
      end if
c     process - simulation - channelmode
      if (trim(adjustl(idf_tag%name)).eq.'channelmode') then
        sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%channelmode=
     +  trim(adjustl(idf_tag%content))
        return
      end if

c     process - simulation - initialtargetparticle
      if (trim(adjustl(idf_tag%name)).eq.'initialtargetparticle'.and.idfnopentags.eq.6) then
        sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +  initialtargetparticle=trim(adjustl(idf_tag%content))
        return
      end if

c     process - simulation - reaction
      if (trim(adjustl(idfopentags(7))).eq.'reaction') then
      if (trim(adjustl(idf_tag%name)).eq.'initialtargetparticle') then
        sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%reaction%
     +  initialtargetparticle=trim(adjustl(idf_tag%content))
        return
      else  if (trim(adjustl(idf_tag%name)).eq.'incidentparticle') then
        sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%reaction%
     +  incidentparticle=trim(adjustl(idf_tag%content))
        return
      else  if (trim(adjustl(idf_tag%name)).eq.'exitparticle') then
        sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%reaction%
     +  exitparticle=trim(adjustl(idf_tag%content))
        return
      else  if (trim(adjustl(idf_tag%name)).eq.'finaltargetparticle') then
        sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%reaction%
     +  finaltargetparticle=trim(adjustl(idf_tag%content))
        return
      end if
      end if


c     process - simulation - datafile
      if (trim(adjustl(idf_tag%name)).eq.'filename') then
        if (trim(adjustl(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    datamode)).ne.'datafile') then
          idf_ok=.false.
	    idf_error='datafile entry with datamode '//trim(adjustl(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%
     +    simulation(nsimulation_idf_counter)%datamode))
	    return
        end if
        sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%datafile%filename=
     +  trim(adjustl(idf_tag%content))
        sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%datamode='datafile'
        return
      end if
      if (trim(adjustl(idf_tag%name)).eq.'fileformat') then
        if (trim(adjustl(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    datamode)).ne.'datafile') then
          idf_ok=.false.
	    idf_error='datafile entry with datamode '//trim(adjustl(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%
     +    simulation(nsimulation_idf_counter)%datamode))
	    return
        end if
        sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    datafile%fileformat=trim(adjustl(idf_tag%content))
        return
      end if
      if (trim(adjustl(idf_tag%name)).eq.'filesource') then
        if (trim(adjustl(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    datamode)).ne.'datafile') then
          idf_ok=.false.
	    idf_error='datafile entry with datamode '//trim(adjustl(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%
     +    simulation(nsimulation_idf_counter)%datamode))
	    return
        end if
        sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    datafile%filesource=trim(adjustl(idf_tag%content))
        return
      end if

c     process - simulation - simpledata
      if (trim(adjustl(idfopentags(7))).eq.'simpledata') then
        if (trim(adjustl(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    datamode)).ne.'simple') then
          idf_ok=.false.
	    idf_error='simpledata entry with datamode '//trim(adjustl(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%
     +    simulation(nsimulation_idf_counter)%datamode))
	    return
        end if
c        sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%datamode='simple'
c     axisname within simpledata
      if (trim(adjustl(idf_tag%name)).eq.'axisname'.and.idfnopentags.eq.8) then
        if (trim(adjustl(idfopentags(8))).eq.'xaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    simpledata%xaxis%axisname=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(8))).eq.'xerroraxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    simpledata%xerroraxis%axisname=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(8))).eq.'yaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    simpledata%yaxis%axisname=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(8))).eq.'yerroraxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    simpledata%yerroraxis%axisname=trim(adjustl(idf_tag%content))
          return
        end if
      end if
c     axisunit within simpledata
      if (trim(adjustl(idf_tag%name)).eq.'axisunit'.and.idfnopentags.eq.8) then
        if (trim(adjustl(idfopentags(8))).eq.'xaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    simpledata%xaxis%axisunit=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(8))).eq.'xerroraxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    simpledata%xerroraxis%axisunit=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(8))).eq.'yaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    simpledata%yaxis%axisunit=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(8))).eq.'yerroraxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    simpledata%yerroraxis%axisunit=trim(adjustl(idf_tag%content))
          return
        end if
      end if
c     x within simpledata
      if (idfnopentags.eq.7) then
        if (trim(adjustl(idf_tag%name)).eq.'x') then
c      write(*,*)'simpledata x',nspectra_idf_counter
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%
     +    simulation(nsimulation_idf_counter)%simpledata%x)
          if (ndatapoints_intag_idf.ne.nsimpoints_idf(nspectra_idf_counter,nsimulation_idf_counter)) then
            idf_ok=.false.
            idf_error=
     +      'Number of points in sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%
     +    simulation(nsimulation_idf_counter)%simpledata%x not equal to nsimpoints_idf'
          end if
          return
        else if (trim(adjustl(idf_tag%name)).eq.'xerror') then
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%
     +    simulation(nsimulation_idf_counter)%simpledata%xerror)
          if (ndatapoints_intag_idf.ne.nsimpoints_idf(nspectra_idf_counter,nsimulation_idf_counter)) then
            idf_ok=.false.
            idf_error=
     +    'Number of points in sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%
     +    simulation(nsimulation_idf_counter)%simpledata%xerror not equal to nsimpoints_idf'
          end if
          return
        else if (trim(adjustl(idf_tag%name)).eq.'y') then
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%
     +    simulation(nsimulation_idf_counter)%simpledata%y)
          if (ndatapoints_intag_idf.ne.nsimpoints_idf(nspectra_idf_counter,nsimulation_idf_counter)) then
            idf_ok=.false.
            idf_error=
     +      'Number of points in sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%
     +    simulation(nsimulation_idf_counter)%simpledata%y not equal to nsimpoints_idf'
          end if
          return
        else if (trim(adjustl(idf_tag%name)).eq.'yerror') then
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%
     +    simulation(nsimulation_idf_counter)%simpledata%yerror)
          if (ndatapoints_intag_idf.ne.nsimpoints_idf(nspectra_idf_counter,nsimulation_idf_counter)) then
            idf_ok=.false.
            idf_error=
     +    'Number of points in sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%
     +    simulation(nsimulation_idf_counter)%simpledata%yerror not equal to nsimpoints_idf'
          end if
          return
        end if
      end if

c     process - simulation - linedata
      else if (trim(adjustl(idfopentags(7))).eq.'linedata') then
        if (trim(adjustl(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    datamode)).ne.'line') then
          idf_ok=.false.
	    idf_error='linedata entry with datamode '//trim(adjustl(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%
     +    simulation(nsimulation_idf_counter)%datamode))
	    return
        end if
c        sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%datamode='line'
c     axisname within linedata
      if (trim(adjustl(idf_tag%name)).eq.'axisname'.and.idfnopentags.eq.8) then
        if (trim(adjustl(idfopentags(8))).eq.'lineaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    linedata%lineaxis%axisname=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(8))).eq.'yaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    linedata%yaxis%axisname=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(8))).eq.'yerroraxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    linedata%yerroraxis%axisname=trim(adjustl(idf_tag%content))
          return
        end if
      end if
c     axisunit within linedata
      if (trim(adjustl(idf_tag%name)).eq.'axisunit'.and.idfnopentags.eq.8) then
        if (trim(adjustl(idfopentags(8))).eq.'lineaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    linedata%lineaxis%axisunit=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(8))).eq.'yaxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    linedata%yaxis%axisunit=trim(adjustl(idf_tag%content))
          return
        else if (trim(adjustl(idfopentags(8))).eq.'yerroraxis') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    linedata%yerroraxis%axisunit=trim(adjustl(idf_tag%content))
          return
        end if
      end if
c     line within linedata
      if (idfnopentags.eq.7) then
        if (trim(adjustl(idf_tag%name)).eq.'line') then
          call get_character_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%
     +    simulation(nsimulation_idf_counter)%linedata%line)
          if (ndatapoints_intag_idf.ne.nsimpoints_idf(nspectra_idf_counter,nsimulation_idf_counter)) then
            idf_ok=.false.
            idf_error=
     +      'Number of points in sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%
     +    simulation(nsimulation_idf_counter)%linedata%x not equal to nsimpoints_idf'
          end if
          return
        else if (trim(adjustl(idf_tag%name)).eq.'y') then
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%
     +    simulation(nsimulation_idf_counter)%linedata%y)
          if (ndatapoints_intag_idf.ne.nsimpoints_idf(nspectra_idf_counter,nsimulation_idf_counter)) then
            idf_ok=.false.
            idf_error=
     +      'Number of points in sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%
     +    simulation(nsimulation_idf_counter)%linedata%y not equal to nsimpoints_idf'
          end if
          return
        else if (trim(adjustl(idf_tag%name)).eq.'yerror') then
          call get_real_array_intag_idf(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%
     +    simulation(nsimulation_idf_counter)%linedata%yerror)
          if (ndatapoints_intag_idf.ne.nsimpoints_idf(nspectra_idf_counter,nsimulation_idf_counter)) then
            idf_ok=.false.
            idf_error=
     +      'Number of points in sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%
     +    simulation(nsimulation_idf_counter)%linedata%yerror not equal to nsimpoints_idf'
          end if
          return
        end if
      end if

c     process - simulation - complexdata
      else if (trim(adjustl(idfopentags(7))).eq.'complexdata') then
        if (trim(adjustl(sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    datamode)).ne.'complex') then
          idf_ok=.false.
	    idf_error='complexdata entry with datamode '//trim(adjustl(sample%spectra%spectrum(nspectra_idf_counter)%process%
     +    simulations%simulation(nsimulation_idf_counter)%datamode))
	    return
        end if
        sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%datamode='complex'
        if (trim(adjustl(idf_tag%name)).eq.'datadimensionx') then
          read(idf_tag%content,*)sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%
     +    simulation(nsimulation_idf_counter)%complexdata%datadimensions%datadimensionx
          return
        end if
        if (trim(adjustl(idf_tag%name)).eq.'datadimensiony') then
          read(idf_tag%content,*)sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%
     +    simulation(nsimulation_idf_counter)%complexdata%datadimensions%datadimensiony
          return
        end if
c      if (trim(adjustl(idf_tag%name)).eq.'axisname') write(*,*)'idfopentags(7):',trim(adjustl(idfopentags(7)))
        if (trim(adjustl(idf_tag%name)).eq.'axisname'.and.trim(adjustl(idfopentags(8))).eq.'xaxes') then
c      write(*,*)'datadimension_idf_counter x ',datadimension_idf_counter,
c     +sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%complexdata%datadimensions%datadimensionx
          if (datadimension_idf_counter.gt.
     +    sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    complexdata%datadimensions%datadimensionx) then
            idf_ok=.false.
            idf_error='More xaxes entries than specified in datadimensionx in a complexdata'
            return
          end if
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    complexdata%xaxes%axis(datadimension_idf_counter)%axisname=
     +    trim(adjustl(idf_tag%content))
          return
        end if
        if (trim(adjustl(idf_tag%name)).eq.'axisunit'.and.trim(adjustl(idfopentags(8))).eq.'xaxes') then
          if (datadimension_idf_counter.gt.
     +    sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    complexdata%datadimensions%datadimensionx) then
            idf_ok=.false.
            idf_error='More xaxes entries than specified in datadimensionx in a complexdata'
            return
          end if
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    complexdata%xaxes%axis(datadimension_idf_counter)%axisunit=
     +    trim(adjustl(idf_tag%content))
          return
        end if
        if (trim(adjustl(idf_tag%name)).eq.'axisname'.and.trim(adjustl(idfopentags(8))).eq.'yaxes') then
c      write(*,*)'datadimension_idf_counter y ',datadimension_idf_counter,
c     +sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%complexdata%datadimensions%datadimensiony
          if (datadimension_idf_counter.gt.
     +    sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    complexdata%datadimensions%datadimensiony) then
            idf_ok=.false.
            idf_error='More yaxes entries than specified in datadimensiony in a complexdata'
            return
          end if
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    complexdata%yaxes%axis(datadimension_idf_counter)%axisname=
     +    trim(adjustl(idf_tag%content))
          return
        end if
        if (trim(adjustl(idf_tag%name)).eq.'axisunit'.and.trim(adjustl(idfopentags(8))).eq.'yaxes') then
          if (datadimension_idf_counter.gt.
     +    sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    complexdata%datadimensions%datadimensiony) then
            idf_ok=.false.
            idf_error='More yaxes entries than specified in datadimensiony in a complexdata'
            return
          end if
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    complexdata%yaxes%axis(datadimension_idf_counter)%axisunit=
     +    trim(adjustl(idf_tag%content))
          return
        end if
        if (trim(adjustl(idf_tag%name)).eq.'timestamp') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    complexdata%dataentries%dataentry(ndatapoints_idf_counter)%
     +    timestamp=trim(adjustl(idf_tag%content))
          return
        end if
        if (trim(adjustl(idf_tag%name)).eq.'line') then
          sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%
     +    complexdata%dataentries%dataentry(ndatapoints_idf_counter)%
     +    line=trim(adjustl(idf_tag%content))
          return
        end if
        if (trim(adjustl(idf_tag%name)).eq.'dataitem') then
          datadimension_idf_counter=datadimension_idf_counter+1
c      write(*,*)'dataitem',nspectra_idf_counter,ndatapoints_idf_counter,datadimension_idf_counter,
c     +sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%complexdata%
c     +datadimensions%datadimensionx,
c     +sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%complexdata%
c     +datadimensions%datadimensiony
          if (datadimension_idf_counter.gt.
     +    sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%complexdata%
     +    datadimensions%datadimensionx+
     +    sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%simulation(nsimulation_idf_counter)%complexdata%
     +    datadimensions%datadimensiony) then
            idf_ok=.false.
            idf_error='More dataitem than specified in datadimensionx+datadimensiony in a complexdata'
            return
          end if
          read(idf_tag%content,*)sample%spectra%spectrum(nspectra_idf_counter)%process%simulations%
     +    simulation(nsimulation_idf_counter)%complexdata%dataentries%
     +    dataentry(ndatapoints_idf_counter)%dataitem(datadimension_idf_counter)
          return
        end if
      end if

c     end of spectrum - data big block
      end if
cXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
cXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
cXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
cXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
cXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX

      end if
c     end of huge spectrum - group process

1001  continue
	return
1000  continue
      idf_error='error in read_file_idf_actuallyreadonevalue'
	return
	end

c-----------------------------------------------------------------------
      subroutine get_character_array_intag_idf(x)
c     gets the number of data points in a array tag entry.
	use IDFCOM
	implicit none
	character*(*) x(1)
	integer i,j,eox78 !,i1,i2
c-----------------------------------------------------------------------
	idf_entry_aux=' '
	ndatapoints_intag_idf=0
c	save input line, it will not be changed
	idf_entry_aux=trim(adjustl(idf_tag%content))

101	continue
	eox78=index(idf_entry_aux,char(9))
	if (eox78.gt.0) then
	  idf_entry_aux(eox78:eox78)=' '
	  goto 101
	end if

100	continue
c	check if there is still at least one word left
	if (verify(idf_entry_aux,' ').eq.0) return
c	cut out initial blanks
	idf_entry_aux=adjustl(idf_entry_aux)
	eox78=index(idf_entry_aux,' ')-1
c     read value
	ndatapoints_intag_idf=ndatapoints_intag_idf+1
c	write(*,*)'ndatapoints_intag_idf',ndatapoints_intag_idf,eox78
	x(ndatapoints_intag_idf)(1:eox78)=idf_entry_aux(1:eox78)
c	cut out word just read from the line
      idf_entry_aux=idf_entry_aux(eox78+1:len_trim(idf_entry_aux))
c	check for a new word
	goto 100

	end

c-----------------------------------------------------------------------
      subroutine get_real_array_intag_idf(x)
c     gets the number of data points in a array tag entry.
	use IDFCOM
	implicit none
	real x(1)
	integer i,j,eox78 !,i1,i2
c-----------------------------------------------------------------------
	idf_entry_aux=' '
	ndatapoints_intag_idf=0
c	save input line, it will not be changed
	idf_entry_aux=trim(adjustl(idf_tag%content))

101	continue
	eox78=index(idf_entry_aux,char(9))
	if (eox78.gt.0) then
	  idf_entry_aux(eox78:eox78)=' '
	  goto 101
	end if

100	continue
c	check if there is still at least one word left
	if (verify(idf_entry_aux,' ').eq.0) return
c	cut out initial blanks
	idf_entry_aux=adjustl(idf_entry_aux)
	eox78=index(idf_entry_aux,' ')-1
c     read value
	ndatapoints_intag_idf=ndatapoints_intag_idf+1
c	write(*,*)'ndatapoints_intag_idf',ndatapoints_intag_idf
	read(idf_entry_aux(1:eox78),*)x(ndatapoints_intag_idf)
c	cut out word just read from the line
      idf_entry_aux=idf_entry_aux(eox78+1:len_trim(idf_entry_aux))
c	check for a new word
	goto 100

	end

c-----------------------------------------------------------------------
	subroutine read_idf_realquantity
c     gets the value and attributes currently in idf_tag%content and idf_attributes%attribute
	use IDFCOM
	implicit none
	integer i,j,nparts
	character a72*72
c-----------------------------------------------------------------------
      idf_ok=.false.
      idf_error=' '

      idf_realquantity_aux=idf_realquantity_null
      read(idf_tag%content,*,err=1000)idf_realquantity_aux%value
      if (idfquantitytype(idfntag).eq.'q') then
      if (trim(adjustl(idf_tag%name)).eq.'slitdistancetosample'.and.trim(adjustl(idfopentags(5))).eq.'slitsaftersample') then
c      write(*,*)'idf_attributes%n',idf_attributes%n,idfquantitytype(idfntag)
c      write(*,*)'name',trim(adjustl(idf_attributes%attribute(1)%name)),trim(adjustl(idf_attributes%attribute(2)%name))
c      write(*,*)'content',trim(adjustl(idf_attributes%attribute(1)%content)),trim(adjustl(idf_attributes%attribute(2)%content))
c      write(*,*)'idfattr',idfattr(i,:)
      end if
       do i=1,idf_attributes%n
c      write(*,*)'iattr',i,trim(adjustl(idf_attributes%attribute(i)%name)),trim(adjustl(idfattr(idfntag,1)))
          if (trim(adjustl(idf_attributes%attribute(i)%name)).eq.trim(adjustl(idfattr(idfntag,1)))) then
           idf_realquantity_aux%units=trim(adjustl(idf_attributes%attribute(i)%content))
          else if (trim(adjustl(idf_attributes%attribute(i)%name)).eq.trim(adjustl(idfattr(idfntag,2)))) then
            read(idf_attributes%attribute(i)%content,*,err=1000)idf_realquantity_aux%quantity
          else if (trim(adjustl(idf_attributes%attribute(i)%name)).eq.trim(adjustl(idfattr(idfntag,3)))) then
            read(idf_attributes%attribute(i)%content,*,err=1000)idf_realquantity_aux%uncertainty
          else if (trim(adjustl(idf_attributes%attribute(i)%name)).eq.trim(adjustl(idfattr(idfntag,4)))) then
            read(idf_attributes%attribute(i)%content,*,err=1000)idf_realquantity_aux%uncertaintyA
          else if (trim(adjustl(idf_attributes%attribute(i)%name)).eq.trim(adjustl(idfattr(idfntag,5)))) then
            read(idf_attributes%attribute(i)%content,*,err=1000)idf_realquantity_aux%uncertaintyB
          else if (trim(adjustl(idf_attributes%attribute(i)%name)).eq.trim(adjustl(idfattr(idfntag,6)))) then
            read(idf_attributes%attribute(i)%content,*,err=1000)idf_realquantity_aux%uncertaintyplus
          else if (trim(adjustl(idf_attributes%attribute(i)%name)).eq.trim(adjustl(idfattr(idfntag,7)))) then
            read(idf_attributes%attribute(i)%content,*,err=1000)idf_realquantity_aux%uncertaintyminus
          end if
        end do
      else  if (idfquantitytype(idfntag).eq.'s') then
        do i=1,idf_attributes%n
          if (trim(adjustl(idf_attributes%attribute(i)%name)).eq.trim(adjustl(idfattr(idfntag,1)))) then
            read(idf_attributes%attribute(i)%content,*,err=1000)idf_realquantity_aux%units
          else if (trim(adjustl(idf_attributes%attribute(i)%name)).eq.trim(adjustl(idfattr(idfntag,8)))) then
            read(idf_attributes%attribute(i)%content,*,err=1000)idf_realquantity_aux%mode
          else if (trim(adjustl(idf_attributes%attribute(i)%name)).eq.trim(adjustl(idfattr(idfntag,2)))) then
            read(idf_attributes%attribute(i)%content,*,err=1000)idf_realquantity_aux%quantity
          else if (trim(adjustl(idf_attributes%attribute(i)%name)).eq.trim(adjustl(idfattr(idfntag,3)))) then
            read(idf_attributes%attribute(i)%content,*,err=1000)idf_realquantity_aux%uncertainty
          else if (trim(adjustl(idf_attributes%attribute(i)%name)).eq.trim(adjustl(idfattr(idfntag,4)))) then
            read(idf_attributes%attribute(i)%content,*,err=1000)idf_realquantity_aux%uncertaintyA
          else if (trim(adjustl(idf_attributes%attribute(i)%name)).eq.trim(adjustl(idfattr(idfntag,5)))) then
            read(idf_attributes%attribute(i)%content,*,err=1000)idf_realquantity_aux%uncertaintyB
          else if (trim(adjustl(idf_attributes%attribute(i)%name)).eq.trim(adjustl(idfattr(idfntag,6)))) then
            read(idf_attributes%attribute(i)%content,*,err=1000)idf_realquantity_aux%uncertaintyplus
          else if (trim(adjustl(idf_attributes%attribute(i)%name)).eq.trim(adjustl(idfattr(idfntag,7)))) then
            read(idf_attributes%attribute(i)%content,*,err=1000)idf_realquantity_aux%uncertaintyminus
          end if
        end do
      end if
      idf_ok=.true.

1001  continue
	return
1000  continue
      idf_error='error in read_idf_realquantity, when reading tag '//trim(adjustl(idf_tag%name))//' with content '//
     +trim(adjustl(idf_tag%content))
	return
	end

