c	Copyright (C) 2008-2013 and onwards  Nuno Pessoa Barradas
c	Campus Tecnolgico e Nuclear / Instituto Superior Tcnico
c	E.N. 10, Apartado 21, 2686-953 Sacavm, Portugal
c	Tel. +351 219946150 e-mail: nunoni@ctn.ist.utl.pt

c	This program is free software: you can redistribute it and/or modify
c	it under the terms of the GNU General Public License as published by
c	the Free Software Foundation, either version 3 of the License, or
c	any later version.

c	This program is distributed in the hope that it will be useful,
c	but WITHOUT ANY WARRANTY; without even the implied warranty of
c	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c	GNU General Public License for more details.

c	You should have received a copy of the GNU General Public License
c	along with this program.  If not, see <http://www.gnu.org/licenses/>.

c	The copyright owner (N.P. Barradas) is also the author of the non-GPL code NDF.
c	These routines are also used by NDF under a special agreement.

c     Release 1.02 13 february 2013
c-----------------------------------------------------------------------
	module IDFCOM
c	a statement "use IDFCOM" must be included in any routine that uses the subroutines in this package

c     error and OK
!DEC$ ATTRIBUTES DLLEXPORT::idf_ok,idf_error
c     control variables associated with file idf_tags
!DEC$ ATTRIBUTES DLLEXPORT::idf_nsamples
c     actual IDF variables: integer, scalar
!DEC$ ATTRIBUTES DLLEXPORT::idfnelements, idfnmolecules,nlayers_idf,idfnspectra,npbp_element_idf,nlayerfoil_aux_idf
c     actual IDF variables: integer, allocatable
!DEC$ ATTRIBUTES DLLEXPORT::nslitsbeforesample_idf,npbp_idf,nlayerspbp_idf
!DEC$ ATTRIBUTES DLLEXPORT::nbeamfoillayers_idf,nstoppingfoillayers_idf,nbeamfoilels_idf,nstoppingfoilels_idf,nslitsaftersample_idf
!DEC$ ATTRIBUTES DLLEXPORT::ndeadlayer_idf,nentrancewindow_idf,ndetectorlayers_idf,ndeadlayerels_idf,nentrancewindowels_idf
!DEC$ ATTRIBUTES DLLEXPORT::ndetectorlayersels_idf,ntofstartfoil_idf,ntofstartfoilels_idf,ntofstopfoil_idf,ntofstopfoilels_idf
!DEC$ ATTRIBUTES DLLEXPORT::ndetectorefficiency_idf,ndetectorefficiencyentries_idf,ndetectorresolution_idf,nresolutionparameter_idf
!DEC$ ATTRIBUTES DLLEXPORT::nenergycalibration_idf,ncalibrationparameter_idf,nreaction_idf,ndatapoints_idf,ndatatimestamp_idf
!DEC$ ATTRIBUTES DLLEXPORT::ndataline_idf,datadimensionx_idf,datadimensiony_idf,nsimulation_idf,ncrosssection_idf
!DEC$ ATTRIBUTES DLLEXPORT::ncrosssectionpoints_idf,nstoppingpower_idf,nstoppingpowerpoints_idf,nenergyspread_idf
!DEC$ ATTRIBUTES DLLEXPORT::nenergyspreadpoints_idf,simdimensionx_idf,simdimensiony_idf,nsimpoints_idf
c     IDF output variables
!DEC$ ATTRIBUTES DLLEXPORT::sample,attributes,usersnotes

c     control variables associated with file idf_tags
	integer idfntags,idfntag,idfnchildrenmax,idfnopentags,idfnopentagsmax,idf_nsamples,idfnusersmax,idfnnotesmax,idfnelements,
     +idfnmolecules,idfnattrmax,idfntag_opentag,idfnamespacesmax,idfnnamespaces,idfncontentallowedmax,idfnunitsmax,
     +idfnquantities,idfnupdatetimemax
c     internal variables used during read: integer, scalar
      integer nlayerspbpmax_idf,ndatapoints_intag_idf
      integer nels_idf_counter, nmols_idf_counter,nlayers_idf_counter,ndatapoints_intag_idf_counter,nnr_max_idf_counter,
     +nspectra_idf_counter,nlayerspbpmax_idf_counter,user_counter,note_counter,
     +ndatapoints_max_idf_counter,ndatapointsaux_idf_counter,
     +datadimensionx_max_idf_counter,datadimensiony_max_idf_counter,
     +nsimpointsaux_idf_counter,npbp_max_idf_counter,
     +npbp_element_idf_counter,nlayerbeamfoil_aux_idf_counter,nslits_idf_counter,nfoillayers_idf_counter,
     +nfoilels_idf_counter,ndetectorefficiency_idf_counter,ndetectorresolution_idf_counter,nparameter_idf_counter,
     +nenergycalibration_idf_counter,nreaction_idf_counter,ndatapoints_idf_counter,datadimension_idf_counter,
     +nsimulation_idf_counter,ncrosssection_idf_counter,nstoppingpower_idf_counter,nenergyspread_idf_counter
c     internal variables used during read: integer, allocatable
	integer,allocatable::idfnchildren(:),idfnattr(:),idfncontentallowed(:),idfnunits(:)
c     actual IDF variables: integer, scalar
      integer nlayers_idf,idfnspectra,npbp_element_idf,nlayerfoil_aux_idf,idfnfoillayers,
     +idfndetectorefficiency
c     actual IDF variables: integer, allocatable
	integer,allocatable::nslitsbeforesample_idf(:),npbp_idf(:),nlayerspbp_idf(:,:),
     +nbeamfoillayers_idf(:),nstoppingfoillayers_idf(:),nbeamfoilels_idf(:,:),nstoppingfoilels_idf(:,:),nslitsaftersample_idf(:),
     +ndeadlayer_idf(:),nentrancewindow_idf(:),ndetectorlayers_idf(:),ndeadlayerels_idf(:),nentrancewindowels_idf(:,:),
     +ndetectorlayersels_idf(:,:),ntofstartfoil_idf(:),ntofstartfoilels_idf(:,:),ntofstopfoil_idf(:),ntofstopfoilels_idf(:,:),
     +ndetectorefficiency_idf(:),ndetectorefficiencyentries_idf(:,:),ndetectorresolution_idf(:),nresolutionparameter_idf(:,:),
     +nenergycalibration_idf(:),ncalibrationparameter_idf(:,:),nreaction_idf(:),ndatapoints_idf(:),ndatatimestamp_idf(:),
     +ndataline_idf(:),datadimensionx_idf(:),datadimensiony_idf(:),nsimulation_idf(:),ncrosssection_idf(:,:),
     +ncrosssectionpoints_idf(:,:,:),nstoppingpower_idf(:,:),nstoppingpowerpoints_idf(:,:,:),nenergyspread_idf(:,:),
     +nenergyspreadpoints_idf(:,:,:),simdimensionx_idf(:,:),simdimensiony_idf(:,:),nsimpoints_idf(:,:),nbeamchargestate_idf(:)
c     internal variables used during read: character
	character namespaceinentry*72,section_idf*72
	character,allocatable::idfchildren(:,:)*72,idfattr(:,:)*72,idftags(:)*72,idfopentags(:)*72,idfcontenttype(:)*2,
     +idfquantitytype(:)*1,idfopennamespace(:)*72,idfnamespaces(:)*72,idfcontentallowed(:,:)*72,idfquantities(:)*72,
     +idfunits(:,:)*72,idftagquantities(:)*72,idfambiguousparent(:)*72
c     internal variables used during read: logical
      logical,allocatable::idfambiguous(:)
c     actual IDF variables: character
	character,allocatable::efficiencymode_idf(:,:)*6,datamode_idf(:)*8,simmode_idf(:,:)*8
c     internal variables used during read: logical
	logical defined_tags_idf,defined_units_idf,nsimpoints_flag,nlayerfoil_flag,verbosity_IDF
	logical,allocatable::idfflaggroup(:),idf_tagopen(:)
c     internal parameters. May be changed during read
      data idfnelements, idfnmolecules, idfnopentagsmax, 
     +idffileunit, idfnamespacesmax, idfnspectra, idfnfoillayers, idfndetectorefficiency 
     +/92, 92, 20, 90, 20, 1000, 20, 20/
	parameter (idfnusersmax=10, idfnnotesmax=10, idfnattrmax=8, idfnupdatetimemax=100)
c	parameter (idfnusersmax=10, idfnnotesmax=10, idfnelements=92, idfnmolecules=92, idfnattrmax=8, idfnopentagsmax=20, 
c     +idffileunit=90, idfnamespacesmax=20, idfnspectra=1000, idfnfoillayers=20, idfndetectorefficiency=20)

c     variables associated with manipulation of the idf_file
c     131072=16*8*1024 is max length of lines
      type idf_tagattribute_definition
	  character*72 name
	  character*16384 content    !16*8*1024
      end type idf_tagattribute_definition
      type idf_tagattribute_array_definition
	  integer n
        type(idf_tagattribute_definition) attribute(idfnattrmax)
      end type idf_tagattribute_array_definition

      type(idf_tagattribute_definition) :: idf_attribute,idf_tag
      type(idf_tagattribute_array_definition) :: idf_idf_attributes,idf_attributes

	integer idf_idf_nattributes,idf_nattributes
	character idf_path*300,idf_error*300,idf_newline*16384,idf_entry*16384,idf_entry_aux*16384,idf_entry_leftover*16384,idf_tag1*72
	logical idf_ok,validated_file_idf,idf_fulltaginentry,idf_closingtaginentry,idf_openingtaginentry,
     +idf_fulltaginline,idf_closingtaginline,idf_notaginline,idf_openingtaginline
c     +idf_fulltaginline_save,idf_closingtaginline_save,idf_openingtaginline_save

c     basic idf definitions
c      type idf_string3
c	  character*1000 string3
c      end type idf_string3
c      type idf_string2
c	  character*100 string2
c      end type idf_string2
c      type idf_string1
c	  character*10 string1
c      end type idf_string1

c     groups and tags used in IDF
      type idf_users
	  integer n
        character*100,allocatable::user(:)
      end type idf_users
      type idf_notes
	  integer n
        character*100,allocatable::note(:)
      end type idf_notes

      type idf_usersnotes
        type(idf_users)::users
        type(idf_notes)::notes
      end type idf_usersnotes

c     attribute mode is included for ease of programming - it is always an empty string
      type idf_realquantity_or_spread
        real::value
        character*100::units
        character*10::mode
        character*100::quantity
        real::uncertainty
        real::uncertaintyA
        real::uncertaintyB
        real::uncertaintyplus
        real::uncertaintyminus
      end type idf_realquantity_or_spread

      type(idf_realquantity_or_spread)::idf_realquantity_null,idf_realquantity_aux

c      type idf_realspread
c        real::value
c        character*100::units
c        character*10::mode
c        character*100::quantity
c        real::uncertainty
c        real::uncertaintyA
c        real::uncertaintyB
c        real::uncertaintyplus
c        real::uncertaintyminus
c      end type idf_realspread

      type idf_axis
        type(idf_usersnotes)::usersnotes
        character*100::axisname
        character*100::axisunit
      end type idf_axis

c      type idf_simplelinedata
c        type(idf_usersnotes)::usersnotes
c        type(idf_axis)::xaxis
c        type(idf_axis)::xerroraxis
c        type(idf_axis)::yaxis
c        type(idf_axis)::yerroraxis
c        integer::n
c	  character*20,allocatable::line(:)
c	  real,allocatable::y(:)
c	  real,allocatable::yerror(:)
c	  integer::ndfidf_iong
c      end type idf_simplelinedata

c      type idf_simpledata_iong
c        type(idf_usersnotes)::usersnotes
c        type(idf_axis)::xaxis
c        type(idf_axis)::xerroraxis
c        type(idf_axis)::yaxis
c        type(idf_axis)::yerroraxis
c        integer::nc
c	  real,allocatable::x(:)
c	  real,allocatable::xerror(:)
c	  real,allocatable::y(:)
c	  real,allocatable::yerror(:)
c	  integer::ndfidf_iong
c      end type idf_simpledata_iong

      type idf_simpledata
        type(idf_usersnotes)::usersnotes
        type(idf_axis)::lineaxis
        type(idf_axis)::xaxis
        type(idf_axis)::xerroraxis
        type(idf_axis)::yaxis
        type(idf_axis)::yerroraxis
        integer::n
	  character*20,allocatable::line(:)
	  real,allocatable::x(:)
	  real,allocatable::xerror(:)
	  real,allocatable::y(:)
	  real,allocatable::yerror(:)
	  integer::ndfidf_iong
      end type idf_simpledata

	type(idf_simpledata)::pbp_aux

      type idf_datadimensions
        type(idf_usersnotes)::usersnotes
        integer::datadimensionx
        integer::datadimensiony
      end type idf_datadimensions

      type idf_axes
        type(idf_usersnotes)::usersnotes
        type(idf_axis),allocatable::axis(:)
      end type idf_axes

      type idf_dataentry
        character*100::timestamp
	  character*20::line
        real,allocatable::dataitem(:)
      end type idf_dataentry

      type idf_dataentries
        type(idf_usersnotes)::usersnotes
        integer::n
        type (idf_dataentry),allocatable::dataentry(:)
      end type idf_dataentries

      type idf_complexdata
        type(idf_usersnotes)::usersnotes
        type (idf_datadimensions)::datadimensions
        type(idf_axes)::xaxes
        type(idf_axes)::yaxes
        type(idf_dataentries)::dataentries
	  integer::ndfidf_iong
      end type idf_complexdata

      type idf_datafile
        type(idf_usersnotes)::usersnotes
	  character*1000::filename
	  character*1000::fileformat
	  character*1000::filesource
      end type idf_datafile

      type idf_logicelement_conc
        character*100::name
        type(idf_realquantity_or_spread)::concentration
      end type idf_logicelement_conc

      type idf_logicelement_dens
        character*100::name
        type(idf_realquantity_or_spread)::density
      end type idf_logicelement_dens

      type idf_elements
        type(idf_usersnotes)::usersnotes
        type(idf_logicelement_dens),allocatable::element(:)
      end type idf_elements

      type idf_molecules
        type(idf_usersnotes)::usersnotes
        type(idf_logicelement_dens),allocatable::molecule(:)
      end type idf_molecules

      type idf_elementsandmolecules
        type(idf_usersnotes)::usersnotes
	  integer nelements
	  integer nmolecules
        type(idf_elements)::elements
        type(idf_molecules)::molecules
      end type idf_elementsandmolecules

      type idf_layerelements
        type(idf_usersnotes)::usersnotes
	  integer::n
        type(idf_logicelement_conc),allocatable::layerelement(:)
      end type idf_layerelements

      type idf_layermolecules
        type(idf_usersnotes)::usersnotes
	  integer::n
        type(idf_logicelement_conc),allocatable::layermolecule(:)
      end type idf_layermolecules

      type idf_layer
        type(idf_usersnotes)::usersnotes
	  type(idf_realquantity_or_spread)::layerthickness
	  type(idf_realquantity_or_spread)::layeruniformity
	  type(idf_realquantity_or_spread)::layerdensity 
        type(idf_layerelements)::layerelements
        type(idf_layermolecules)::layermolecules
      end type idf_layer

      type idf_layers
        type(idf_usersnotes)::usersnotes
	  integer::n
	  type(idf_layer),allocatable::layer(:)
      end type idf_layers

      type idf_layeredstructure
        type(idf_usersnotes)::usersnotes
	  integer nlayers
	  type(idf_layers)::layers
        character*1000::equationoverlays
        character*1000::roughness
      end type idf_layeredstructure

      type idf_pbpelement
        type(idf_usersnotes)::usersnotes
	  integer::n
        character*100::elementname
	  type(idf_simpledata),allocatable::pbp(:)
      end type idf_pbpelement

      type idf_pointbypointstructure
        type(idf_usersnotes)::usersnotes
	  integer::n
	  type(idf_pbpelement),allocatable::pbpelement(:)
      end type idf_pointbypointstructure

      type idf_structure
        type(idf_usersnotes)::usersnotes
	  character*100::crystalstructure
        type(idf_layeredstructure)::layeredstructure
        type(idf_pointbypointstructure)::pointbypointstructure
      end type idf_structure

      type idf_log
        type(idf_usersnotes)::usersnotes
	  character*100::realtime
	  character*100::livetime
	  character*100::deadtime
	  character*100::starttime
	  character*100::stoptime
      end type idf_log

      type idf_environment
        type(idf_usersnotes)::usersnotes
	  type(idf_realquantity_or_spread)::temperature
	  type(idf_realquantity_or_spread)::pressure
      end type idf_environment

      type idf_shape
        type(idf_usersnotes)::usersnotes
	  character*11::shape
	  type(idf_realquantity_or_spread)::l1
	  type(idf_realquantity_or_spread)::l2
	  type(idf_realquantity_or_spread)::l3
      end type idf_shape

	type(idf_shape)::idf_shape_aux

      type idf_slit
        type(idf_usersnotes)::usersnotes
	  type(idf_shape)::slitshape
	  type(idf_realquantity_or_spread)::slitdistancetosample
      end type idf_slit

      type idf_slits
        type(idf_usersnotes)::usersnotes
	  integer::n
	  type(idf_slit),allocatable::slit(:)
      end type idf_slits

      type idf_foil
        type(idf_usersnotes)::usersnotes
	  type(idf_realquantity_or_spread)::foildistancetosample 
	  type(idf_layers)::foillayers
      end type idf_foil

      type idf_beam
        type(idf_usersnotes)::usersnotes
	  character*10::beamparticle
	  integer::beamZ
	  type(idf_realquantity_or_spread)::beammass
	  type(idf_realquantity_or_spread)::beamenergy 
	  type(idf_realquantity_or_spread)::beamenergyspread
	  type(idf_simpledata)::beamchargestate
	  type(idf_realquantity_or_spread)::beamfluence
	  type(idf_realquantity_or_spread)::beamcurrent
	  type(idf_realquantity_or_spread)::beamangularspread
	  type(idf_shape)::beamshape
	  type(idf_slits)::slitsbeforesample
	  type(idf_foil)::beamfoil
      end type idf_beam

      type idf_geometry
        type(idf_usersnotes)::usersnotes
	  character*10::geometrytype
	  type(idf_realquantity_or_spread)::incidenceangle
	  type(idf_realquantity_or_spread)::scatteringangle
	  type(idf_realquantity_or_spread)::exitangle
	  type(idf_shape)::spot
      end type idf_geometry

      type idf_instrument
        type(idf_usersnotes)::usersnotes
        character*1000::ionsource
        character*1000::accelerator
        character*1000::beamline
        character*1000::chamber
        character*1000::sampleholder
      end type idf_instrument

      type idf_tof
        type(idf_usersnotes)::usersnotes
	  type(idf_realquantity_or_spread)::toflength
	  type(idf_realquantity_or_spread)::toftimeresolution
	  type(idf_layers)::startfoil
	  type(idf_layers)::stopfoil
	  type(idf_realquantity_or_spread)::distancedetectortosample
      end type idf_tof

      type idf_detector
        type(idf_usersnotes)::usersnotes
        character*10::detectortype
	  type(idf_realquantity_or_spread)::solidangle
	  type(idf_shape)::detectorshape
	  type(idf_layer)::deadlayer
	  type(idf_layers)::entrancewindow
	  type(idf_layers)::detectorlayers
	  type(idf_tof)::tof
      end type idf_detector

      type idf_amplifier
        type(idf_usersnotes)::usersnotes
        character*10::amplifiertype
        character*10::pulseshape
	  type(idf_realquantity_or_spread)::shapingtime
	  type(idf_realquantity_or_spread)::risetime
	  type(idf_realquantity_or_spread)::flattoptime
	  character*10::pur
	  type(idf_realquantity_or_spread)::purtime
      end type idf_amplifier

      type idf_electronics
        type(idf_usersnotes)::usersnotes
	  type(idf_amplifier)::amplifier
      end type idf_electronics

      type idf_detection
        type(idf_usersnotes)::usersnotes
	  type(idf_slits)::slitsaftersample
	  type(idf_foil)::stoppingfoil
	  type(idf_detector)::detector
	  type(idf_electronics)::electronics
      end type idf_detection

      type idf_detectorefficiency
        type(idf_usersnotes)::usersnotes
	  character*5::efficiencyion
	  character*6::efficiencymode
	  type(idf_simpledata)::efficiency
	  type(idf_simpledata)::lineefficiency
      end type idf_detectorefficiency

      type idf_detectorefficiencies
        type(idf_usersnotes)::usersnotes
        integer::n
	  type(idf_detectorefficiency),allocatable::detectorefficiency(:)
      end type idf_detectorefficiencies

      type idf_resolutionparameters
        type(idf_usersnotes)::usersnotes
        integer::n
	  type(idf_realquantity_or_spread),allocatable::resolutionparameter(:)
      end type idf_resolutionparameters

      type idf_detectorresolution
        type(idf_usersnotes)::usersnotes
	  character*5::resolutionion
	  type(idf_resolutionparameters)::resolutionparameters
      end type idf_detectorresolution

      type idf_detectorresolutions
        type(idf_usersnotes)::usersnotes
        integer::n
	  type(idf_detectorresolution),allocatable::detectorresolution(:)
      end type idf_detectorresolutions

      type idf_calibrationparameters
        type(idf_usersnotes)::usersnotes
        integer::n
	  type(idf_realquantity_or_spread),allocatable::calibrationparameter(:)
      end type idf_calibrationparameters

      type idf_energycalibration
        type(idf_usersnotes)::usersnotes
	  character*5::calibrationion
	  character*6::calibrationmode
	  type(idf_calibrationparameters)::calibrationparameters
      end type idf_energycalibration

      type idf_energycalibrations
        type(idf_usersnotes)::usersnotes
        integer::n
	  type(idf_energycalibration),allocatable::energycalibration(:)
      end type idf_energycalibrations

      type idf_calibrations
        type(idf_usersnotes)::usersnotes
	  type(idf_detectorefficiencies)::detectorefficiencies
	  type(idf_detectorresolutions)::detectorresolutions
	  type(idf_energycalibrations)::energycalibrations
      end type idf_calibrations

      type idf_reaction
        type(idf_usersnotes)::usersnotes
	  character*5::initialtargetparticle
	  character*5::incidentparticle
	  character*5::exitparticle
	  character*5::finaltargetparticle
	  type(idf_realquantity_or_spread)::reactionQ
      end type idf_reaction

      type idf_reactionlist
        type(idf_usersnotes)::usersnotes
        integer::n
	  type(idf_reaction),allocatable::reaction(:)
      end type idf_reactionlist

      type idf_reactions
        type(idf_usersnotes)::usersnotes
	  character*5::technique
	  type(idf_reactionlist)::reactionlist
      end type idf_reactions

      type idf_data
        type(idf_usersnotes)::usersnotes
	  character*8::datamode
	  character*7::channelmode
	  type(idf_simpledata)::simpledata
	  type(idf_simpledata)::linedata
	  type(idf_complexdata)::complexdata
	  type(idf_datafile)::datafile
      end type idf_data

      type idf_computercode
        type(idf_usersnotes)::usersnotes
	  character*100::name
	  character*100::version
	  character*100::builddate
	  character*100::releasedate
      end type idf_computercode

      type idf_crosssectiondefault
        type(idf_usersnotes)::usersnotes
	  character*5::Rutherford
	  character*11::screening
        type(idf_computercode)::computercode
      end type idf_crosssectiondefault

      type idf_onlycomputercode
        type(idf_usersnotes)::usersnotes
        type(idf_computercode)::computercode
      end type idf_onlycomputercode

      type idf_geometricspread
        type(idf_usersnotes)::usersnotes
	  character*5::beamsize
	  character*5::detectoraperture
      end type idf_geometricspread

      type idf_energyspreaddefault
	  character*4::energylossstraggling
	  character*5::multiplescattering
	  character*5::Dopplereffect
	  character*5::beamangularspread
        type(idf_geometricspread)::geometricspread
	  character*5::Tschalareffect
        type(idf_usersnotes)::usersnotes
        type(idf_computercode)::computercode
      end type idf_energyspreaddefault

      type idf_physicsdefaults
        type(idf_usersnotes)::usersnotes
        type(idf_crosssectiondefault)::crosssectiondefault
        type(idf_onlycomputercode)::stoppingpowerdefault
        type(idf_energyspreaddefault)::energyspreaddefault
      end type idf_physicsdefaults

      type idf_crosssection
        type(idf_usersnotes)::usersnotes
	  character*8::mode
	  character*3::crosssectionframe
	  character*12::crosssectiontype
	  type(idf_realquantity_or_spread)::energyminimum
	  type(idf_realquantity_or_spread)::energymaximum
        type(idf_reaction)::reaction
        type(idf_datafile)::crosssectionfile
	  type(idf_simpledata)::crosssectiondata
        type(idf_crosssectiondefault)::crosssectionoverride
      end type idf_crosssection

      type idf_crosssections
        type(idf_usersnotes)::usersnotes
        integer::n
        type(idf_crosssection),allocatable::crosssection(:)
      end type idf_crosssections

      type idf_stoppingpower
        type(idf_usersnotes)::usersnotes
	  character*8::mode
	  character*5::ion
	  type(idf_realquantity_or_spread)::ionchargestate
	  character*5::targetelement
	  character*1000::targetmolecule
	  character*10::stoppingmode
        type(idf_datafile)::stoppingpowerfile
	  type(idf_simpledata)::stoppingpowerdata
        type(idf_onlycomputercode)::stoppingpoweroverride
      end type idf_stoppingpower

      type idf_stoppingpowers
        type(idf_usersnotes)::usersnotes
        integer::n
        type(idf_stoppingpower),allocatable::stoppingpower(:)
      end type idf_stoppingpowers

      type idf_energyspread
        type(idf_usersnotes)::usersnotes
	  character*8::mode
	  character*5::ion
	  type(idf_realquantity_or_spread)::ionchargestate
	  character*5::targetelement
	  character*10::energyspreadmode 
        type(idf_datafile)::energyspreadfile
	  type(idf_simpledata)::energyspreaddata
        type(idf_energyspreaddefault)::energyspreadoverride
      end type idf_energyspread

      type idf_energyspreads
        type(idf_usersnotes)::usersnotes
        integer::n
        type(idf_energyspread),allocatable::energyspread(:)
      end type idf_energyspreads

      type idf_physics
        type(idf_usersnotes)::usersnotes
        type(idf_crosssections)::crosssections
        type(idf_stoppingpowers)::stoppingpowers
        type(idf_energyspreads)::energyspreads
      end type idf_physics

      type idf_simulation
        type(idf_usersnotes)::usersnotes
        type(idf_physics)::physics
        character*14::simulationtype
	  character*5::initialtargetparticle
        type(idf_reaction)::reaction
	  integer::targetlayer
	  character*7::datamode
	  character*7::channelmode
	  type(idf_simpledata)::simpledata
	  type(idf_simpledata)::linedata
	  type(idf_complexdata)::complexdata
        type(idf_datafile)::datafile
      end type idf_simulation

      type idf_simulations
        type(idf_usersnotes)::usersnotes
        integer::n
        type(idf_simulation),allocatable::simulation(:)
      end type idf_simulations

      type idf_process
        type(idf_usersnotes)::usersnotes
        type(idf_physicsdefaults)::physicsdefaults
        type(idf_simulations)::simulations
      end type idf_process

      type idf_spectrum
        type(idf_usersnotes)::usersnotes
	  type(idf_log)::log
	  type(idf_environment)::environment
	  type(idf_beam)::beam
	  type(idf_geometry)::geometry
	  type(idf_instrument)::instrument
	  type(idf_detection)::detection
	  type(idf_calibrations)::calibrations
	  type(idf_reactions)::reactions
	  type(idf_data)::data
	  type(idf_process)::process
      end type idf_spectrum

      type idf_spectra
        type(idf_usersnotes)::usersnotes
        integer::n
	  type(idf_spectrum),allocatable::spectrum(:)
      end type idf_spectra

      type idf_sample
        type(idf_usersnotes)::usersnotes
        character*100::description
        type(idf_elementsandmolecules)::elementsandmolecules
        type(idf_structure)::structure
        type(idf_spectra)::spectra
      end type idf_sample

      type(idf_sample)::sample

      type idf_updatetimes
        type(idf_usersnotes)::usersnotes
        integer::n
        character*100::updatetime(idfnupdatetimemax)
      end type idf_updatetimes

      type idf__attributes
        type(idf_usersnotes)::usersnotes
        character*100::idfversion
        character*1000::filename
        character*100::createtime
        type(idf_updatetimes)::updatetimes
        character*100::code
        character*100::version
      end type idf__attributes

      type(idf__attributes)::attributes

      type(idf_usersnotes)::usersnotes

	end module IDFCOM
c-----------------------------------------------------------------------
