c	Copyright (C) 2008-2013 and onwards  Nuno Pessoa Barradas
c	Campus Tecnolgico e Nuclear / Instituto Superior Tcnico
c	E.N. 10, Apartado 21, 2686-953 Sacavm, Portugal
c	Tel. +351 219946150 e-mail: nunoni@ctn.ist.utl.pt

c	This program is free software: you can redistribute it and/or modify
c	it under the terms of the GNU General Public License as published by
c	the Free Software Foundation, either version 3 of the License, or
c	any later version.

c	This program is distributed in the hope that it will be useful,
c	but WITHOUT ANY WARRANTY; without even the implied warranty of
c	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c	GNU General Public License for more details.

c	You should have received a copy of the GNU General Public License
c	along with this program.  If not, see <http://www.gnu.org/licenses/>.

c	The copyright owner (N.P. Barradas) is also the author of the non-GPL code NDF.
c	These routines are also used by NDF under a special agreement.

c     Release 1.02 13 february 2013
c-----------------------------------------------------------------------
	subroutine write_file_idf(u,idf_file)
      !DEC$ ATTRIBUTES DLLEXPORT::write_file_idf
c	writes a idf file, that contains one single sample, into unit u
c     requires that define_tags_idf and define_units_idf have been called beforehand
c     does not check for validity of file
	use IDFCOM
	implicit none
      type(idf_realquantity_or_spread)::rcontent
      real realcontent
	integer u,nattributes,level,i,j,k,k1,icontent,n
	character idf_file*300
	character*512 tag,content,content1,content2
	character attribute_names(20)*100,attribute_values(20)*100
	logical writezero
c-----------------------------------------------------------------------
      idf_ok=.false.
      idf_error=' '

	open(u,file=idf_file)

c-----------------------------------------------------------------------
c-----------------------------------------------------------------------
c     opening statements
c-----------------------------------------------------------------------
c-----------------------------------------------------------------------

c     open idf tag
	write(u,0001)
0001  format('<idf ',/,
     +'xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" ',/,
     +'xmlns="http://idf.schemas.itn.pt" ',/,
     +'xmlns:idf="http://idf.schemas.itn.pt" ',/,
     +'xmlns:ndf="http:/ndf.schemas.itn.pt" ',/,
     +'xsi:schemaLocation="http://idf.schemas.itn.pt idfv1.xsd http://ndf.schemas.itn.pt ndfv1.xsd">')

c     main users/user tag, including NDF tags
c     IDF_noattributes removes any attributes given in the attribute_names,attribute_values,nattributes variables
      call IDF_noattributes(attribute_names,attribute_values,nattributes)
c     writezero is a logical variable; when writing a numerical tag, it should be set to .TRUE. if a zero value should be written as zero, or to .FALSE. if it should not be written
      writezero=.false.
      if (usersnotes%users%n.gt.0) then
      level=1
      tag='users'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=2
      tag='user'
      do i=1,usersnotes%users%n
      content=trim(adjustl(usersnotes%users%user(i)))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      end do
c      content=trim(adjustl(licensee))//' ('//trim(adjustl(licenseaccel))//'), '//trim(adjustl(licenseInst))
c      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content)
c      tag='ndf:licensee'
c      content=trim(adjustl(licensee))
c      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content)
c      tag='ndf:licenseaccel'
c      content=trim(adjustl(licenseaccel))
c      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content)
c      tag='ndf:licenseInst'
c      content=trim(adjustl(licenseInst))
c      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content)
cc      tag='ndf:licensenum'
cc      content=trim(adjustl(licensenum))
cc      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content)
      level=1
      tag='users'
      call IDF_closetag(u,level,tag)
      end if

c     we put the batch file name inside the main notes tag the idf; so, a idf file can not have samples from different ndf spc files.
      if (usersnotes%notes%n.gt.0) then
      level=1
      tag='notes'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
c      level=2
c      tag='ndf:batch'
c      content=trim(adjustl(namebatch))
c      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content)
      level=2
      tag='note'
      do i=1,usersnotes%notes%n
      content=trim(adjustl(usersnotes%notes%note(i)))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      end do
      level=1
      tag='notes'
      call IDF_closetag(u,level,tag)
      end if

c     attributes
      level=1
      tag='attributes'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=2
      tag='idfversion'
      content=trim(adjustl(attributes%idfversion))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='filename'
      content=trim(adjustl(attributes%filename))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='createtime'
      content=trim(adjustl(attributes%createtime))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      if (attributes%updatetimes%n.gt.0) then
      tag='updatetimes'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=3
      tag='updatetime'
      do i=1,attributes%updatetimes%n
      content=trim(adjustl(attributes%updatetimes%updatetime(i)))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      end do
      level=2
      tag='updatetimes'
      call IDF_closetag(u,level,tag)
      end if
      tag='code'
      content=trim(adjustl(attributes%code))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='version'
      content=trim(adjustl(attributes%version))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      level=1
      tag='attributes'
      call IDF_closetag(u,level,tag)

c----------------------------------------------------------------------------------------------------------------------------------------------
c----------------------------------------------------------------------------------------------------------------------------------------------
c     main sample tag
c----------------------------------------------------------------------------------------------------------------------------------------------
c----------------------------------------------------------------------------------------------------------------------------------------------
      level=1
      tag='sample'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)

c     usersnotes
      if (sample%usersnotes%users%n.gt.0) then
      level=2
      tag='users'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=3
      tag='user'
      do i=1,sample%usersnotes%users%n
      content=trim(adjustl(sample%usersnotes%users%user(i)))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      end do
      level=2
      tag='users'
      call IDF_closetag(u,level,tag)
      end if
      if (sample%usersnotes%notes%n.gt.0) then
      level=2
      tag='notes'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=3
      tag='note'
      do i=1,sample%usersnotes%notes%n
      content=trim(adjustl(sample%usersnotes%notes%note(i)))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      end do
      level=2
      tag='notes'
      call IDF_closetag(u,level,tag)
      end if

c     description
      if (len_trim(adjustl(sample%description)).gt.0) then
      level=2
      tag='description'
      content=trim(adjustl(sample%description))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      end if

c     elementsandmolecules
c----------------------------------------------------------------------------------------------------------------------------------------------
      if (sample%elementsandmolecules%nelements.gt.0.or.sample%elementsandmolecules%nmolecules.gt.0) then
      level=2
      tag='elementsandmolecules'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
c     elements
      if (sample%elementsandmolecules%nelements.gt.0) then
      level=3
      tag='elements'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=4
      tag='nelements'
      icontent=sample%elementsandmolecules%nelements
      call IDF_writetagwithcontent_integer(u,level,tag,attribute_names,attribute_values,nattributes,icontent,writezero)
      do i=1,sample%elementsandmolecules%nelements
      level=4
      tag='element'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      if (len_trim(adjustl(sample%elementsandmolecules%elements%element(i)%name)).gt.0) then
      level=5
      tag='name'
      content=trim(adjustl(sample%elementsandmolecules%elements%element(i)%name))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='density'
      rcontent=sample%elementsandmolecules%elements%element(i)%density
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      end if
      level=4
      tag='element'
      call IDF_closetag(u,level,tag)
      end do
c     close elements
      level=3
      tag='elements'
      call IDF_closetag(u,level,tag)
      end if
c     molecules
      if (sample%elementsandmolecules%nmolecules.gt.0) then
      level=3
      tag='molecules'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=4
      tag='nmolecules'
      icontent=sample%elementsandmolecules%nmolecules
      call IDF_writetagwithcontent_integer(u,level,tag,attribute_names,attribute_values,nattributes,icontent,writezero)
      do i=1,sample%elementsandmolecules%nmolecules
      level=4
      tag='molecule'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      if (len_trim(adjustl(sample%elementsandmolecules%molecules%molecule(i)%name)).gt.0) then
      level=5
      tag='name'
      content=trim(adjustl(sample%elementsandmolecules%molecules%molecule(i)%name))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='density'
      rcontent=sample%elementsandmolecules%molecules%molecule(i)%density
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      end if
      level=4
      tag='molecule'
      call IDF_closetag(u,level,tag)
      end do
c     close molecules
      level=3
      tag='molecules'
      call IDF_closetag(u,level,tag)
      end if
c     close elementsandmolecules
      level=2
      tag='elementsandmolecules'
      call IDF_closetag(u,level,tag)
      end if
c     end elementsandmolecules
c----------------------------------------------------------------------------------------------------------------------------------------------

c     structure
c----------------------------------------------------------------------------------------------------------------------------------------------
      level=2
      tag='structure'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=3
      tag='crystalstructure'
      content=trim(adjustl(sample%structure%crystalstructure))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
c     layeredstructure
      if (sample%structure%layeredstructure%nlayers.gt.0) then
      level=3
      tag='layeredstructure'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=4
      tag='nlayers'
      icontent=sample%structure%layeredstructure%nlayers
      call IDF_writetagwithcontent_integer(u,level,tag,attribute_names,attribute_values,nattributes,icontent,writezero)
      level=4
      tag='layers'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      do i=1,sample%structure%layeredstructure%nlayers
        level=5
        tag='layer'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=6
        tag='layerthickness'
        rcontent=sample%structure%layeredstructure%layers%layer(i)%layerthickness
        call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        tag='layeruniformity'
        rcontent=sample%structure%layeredstructure%layers%layer(i)%layeruniformity
        call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        tag='layerdensity'
        rcontent=sample%structure%layeredstructure%layers%layer(i)%layerdensity
        call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        if (sample%structure%layeredstructure%layers%layer(i)%layerelements%n.gt.0) then
        level=6
        tag='layerelements'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        do j=1,sample%structure%layeredstructure%layers%layer(i)%layerelements%n
          level=7
          tag='namelayerelement'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=8
          tag='name'
          content=trim(adjustl(sample%structure%layeredstructure%layers%layer(i)%layerelements%layerelement(j)%name))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='concentration'
          rcontent=sample%structure%layeredstructure%layers%layer(i)%layerelements%layerelement(j)%concentration
          call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
          level=7
          tag='layerelement'
          call IDF_closetag(u,level,tag)
        end do
        level=6
        tag='layerelements'
        call IDF_closetag(u,level,tag)
        end if
        if (sample%structure%layeredstructure%layers%layer(i)%layermolecules%n.gt.0) then
        level=6
        tag='layermolecules'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        do j=1,sample%structure%layeredstructure%layers%layer(i)%layermolecules%n
          level=7
          tag='namelayermolecule'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=8
          tag='name'
          content=trim(adjustl(sample%structure%layeredstructure%layers%layer(i)%layermolecules%layermolecule(j)%name))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='concentration'
          rcontent=sample%structure%layeredstructure%layers%layer(i)%layermolecules%layermolecule(j)%concentration
          call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
          level=7
          tag='layermolecule'
          call IDF_closetag(u,level,tag)
        end do
        level=6
        tag='layermolecules'
        call IDF_closetag(u,level,tag)
        end if
        level=5
        tag='layer'
        call IDF_closetag(u,level,tag)
      end do
      level=4
      tag='layers'
      call IDF_closetag(u,level,tag)
      tag='equationoverlays'
      content=trim(adjustl(sample%structure%layeredstructure%equationoverlays))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='roughness'
      content=trim(adjustl(sample%structure%layeredstructure%roughness))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
c     close layeredstructure
      level=3
      tag='layeredstructure'
      call IDF_closetag(u,level,tag)
      end if

c     pointbypointstructure
      if (sample%structure%pointbypointstructure%n.gt.0) then
      level=3
      tag='pointbypointstructure'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      do i=1,sample%structure%pointbypointstructure%n
        level=4
        tag='pbpelement'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=5
        tag='elementname'
        content=trim(adjustl(sample%structure%pointbypointstructure%pbpelement(i)%elementname))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        do j=1,sample%structure%pointbypointstructure%pbpelement(i)%n
          level=5
          tag='pbp'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          if (len_trim(adjustl(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%xaxis%axisname)).gt.0.or.
     +    len_trim(adjustl(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%xaxis%axisunit)).gt.0) then
          level=6
          tag='xaxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=7
          tag='axisname'
          content=trim(adjustl(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%xaxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisname'
          content=trim(adjustl(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%xaxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=6
          tag='xaxis'
          call IDF_closetag(u,level,tag)
          end if
          if (len_trim(adjustl(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%xerroraxis%axisname)).gt.0.or.
     +    len_trim(adjustl(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%xerroraxis%axisunit)).gt.0) then
          level=6
          tag='xerroraxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=7
          tag='axisname'
          content=trim(adjustl(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%xerroraxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisname'
          content=trim(adjustl(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%xerroraxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=6
          tag='xerroraxis'
          call IDF_closetag(u,level,tag)
          end if
          if (len_trim(adjustl(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%yaxis%axisname)).gt.0.or.
     +    len_trim(adjustl(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%yaxis%axisunit)).gt.0) then
          level=6
          tag='yaxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=7
          tag='axisname'
          content=trim(adjustl(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%yaxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisname'
          content=trim(adjustl(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%yaxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=6
          tag='yaxis'
          call IDF_closetag(u,level,tag)
          end if
          if (len_trim(adjustl(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%yerroraxis%axisname)).gt.0.or.
     +    len_trim(adjustl(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%yerroraxis%axisunit)).gt.0) then
          level=6
          tag='yerroraxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=7
          tag='axisname'
          content=trim(adjustl(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%yerroraxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisname'
          content=trim(adjustl(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%yerroraxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=6
          tag='yerroraxis'
          call IDF_closetag(u,level,tag)
          end if
          if (sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%n.gt.0) then
          n=sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%n
          level=6
          tag='x'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          call IDF_writearray_real(u,level,sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%x,n)
          call IDF_closetag(u,level,tag)
          tag='xerror'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          call IDF_writearray_real(u,level,sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%x,n)
          call IDF_closetag(u,level,tag)
          tag='y'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          call IDF_writearray_real(u,level,sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%x,n)
          call IDF_closetag(u,level,tag)
          tag='yerror'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          call IDF_writearray_real(u,level,sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%x,n)
          call IDF_closetag(u,level,tag)
          end if
          level=5
          tag='pbp'
          call IDF_closetag(u,level,tag)
        end do
        level=4
        tag='pbpelement'
        call IDF_closetag(u,level,tag)
      end do
c     close pointbypointstructure
      level=3
      tag='pointbypointstructure'
      call IDF_closetag(u,level,tag)
      end if
c     end of pointbypointstructure

c     close structure
      level=2
      tag='structure'
      call IDF_closetag(u,level,tag)
c     end structure
c----------------------------------------------------------------------------------------------------------------------------------------------

c     main spectra tag
c----------------------------------------------------------------------------------------------------------------------------------------------
c----------------------------------------------------------------------------------------------------------------------------------------------
c----------------------------------------------------------------------------------------------------------------------------------------------
      if (sample%spectra%n.gt.0) then
      level=2
      tag='spectra'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      do i=1,sample%spectra%n
      level=3
      tag='spectrum'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
c     log
c----------------------------------------------------------------------------------------------------------------------------------------------
      level=4
      tag='log'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=5
      tag='realtime'
      content=trim(adjustl(sample%spectra%spectrum(i)%log%realtime))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='livetime'
      content=trim(adjustl(sample%spectra%spectrum(i)%log%livetime))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='deadtime'
      content=trim(adjustl(sample%spectra%spectrum(i)%log%deadtime))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='starttime'
      content=trim(adjustl(sample%spectra%spectrum(i)%log%starttime))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='stoptime'
      content=trim(adjustl(sample%spectra%spectrum(i)%log%stoptime))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      level=4
      tag='log'
      call IDF_closetag(u,level,tag)
c     environment
c----------------------------------------------------------------------------------------------------------------------------------------------
      level=4
      tag='environment'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=5
      tag='temperature'
      rcontent=sample%spectra%spectrum(i)%environment%temperature
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='pressure'
      rcontent=sample%spectra%spectrum(i)%environment%pressure
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      level=4
      tag='environment'
      call IDF_closetag(u,level,tag)

c     beam
c----------------------------------------------------------------------------------------------------------------------------------------------
      level=4
      tag='beam'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=5
      tag='beamparticle'
      content=trim(adjustl(sample%spectra%spectrum(i)%beam%beamparticle))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='beamZ'
      icontent=sample%spectra%spectrum(i)%beam%beamZ
      call IDF_writetagwithcontent_integer(u,level,tag,attribute_names,attribute_values,nattributes,icontent,writezero)
      tag='beammass'
      rcontent=sample%spectra%spectrum(i)%beam%beammass
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='beamenergy'
      rcontent=sample%spectra%spectrum(i)%beam%beamenergy
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='beamenergyspread'
      rcontent=sample%spectra%spectrum(i)%beam%beamenergyspread
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
c     beamchargestate
      if (sample%spectra%spectrum(i)%beam%beamchargestate%n.gt.0) then
      level=5
      tag='beamchargestate'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
c      do j=1,sample%spectra%spectrum(i)%beam%beamchargestate%n
        level=6
        tag='x'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%beam%beamchargestate%x,
     +  sample%spectra%spectrum(i)%beam%beamchargestate%n)
        call IDF_closetag(u,level,tag)
        tag='xerror'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%beam%beamchargestate%xerror,
     +  sample%spectra%spectrum(i)%beam%beamchargestate%n)
        call IDF_closetag(u,level,tag)
        tag='y'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%beam%beamchargestate%y,
     +  sample%spectra%spectrum(i)%beam%beamchargestate%n)
        call IDF_closetag(u,level,tag)
        tag='yerror'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%beam%beamchargestate%yerror,
     +  sample%spectra%spectrum(i)%beam%beamchargestate%n)
        call IDF_closetag(u,level,tag)
c      end do
      level=5
      tag='beamchargestate'
      call IDF_closetag(u,level,tag)
      end if
      tag='beamfluence'
      rcontent=sample%spectra%spectrum(i)%beam%beamfluence
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='beamcurrent'
      rcontent=sample%spectra%spectrum(i)%beam%beamcurrent
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='beamangularspread'
      rcontent=sample%spectra%spectrum(i)%beam%beamangularspread
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
c     beamshape
      level=5
      tag='beamshape'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      content=trim(adjustl(sample%spectra%spectrum(i)%beam%beamshape%shape))
      level=6
      tag='shape'
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='l1'
      rcontent=sample%spectra%spectrum(i)%beam%beamshape%l1
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='l2'
      rcontent=sample%spectra%spectrum(i)%beam%beamshape%l2
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      level=5
      tag='beamshape'
      call IDF_closetag(u,level,tag)
c     slitsbeforesample
      if (sample%spectra%spectrum(i)%beam%slitsbeforesample%n.gt.0) then
      level=5
      tag='slitsbeforesample'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      do j=1,sample%spectra%spectrum(i)%beam%slitsbeforesample%n
        level=6
        tag='slit'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=7
        tag='slitshape'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=8
        tag='shape'
        content=trim(adjustl(sample%spectra%spectrum(i)%beam%slitsbeforesample%slit(j)%slitshape%shape))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='l1'
        rcontent=sample%spectra%spectrum(i)%beam%slitsbeforesample%slit(j)%slitshape%l1
        call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        tag='l2'
        rcontent=sample%spectra%spectrum(i)%beam%slitsbeforesample%slit(j)%slitshape%l2
        call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        tag='l3'
        rcontent=sample%spectra%spectrum(i)%beam%slitsbeforesample%slit(j)%slitshape%l3
        call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        level=7
        tag='slitshape'
        call IDF_closetag(u,level,tag)
        tag='slitdistancetosample'
        rcontent=sample%spectra%spectrum(i)%beam%slitsbeforesample%slit(j)%slitdistancetosample
        call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        level=6
        tag='slit'
        call IDF_closetag(u,level,tag)
      end do
      level=5
      tag='slitsbeforesample'
      call IDF_closetag(u,level,tag)
      end if
c     beamfoil
      if (sample%spectra%spectrum(i)%beam%beamfoil%foillayers%n.gt.0) then
      level=5
      tag='beamfoil'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=6
      tag='foildistancetosample'
      rcontent=sample%spectra%spectrum(i)%beam%beamfoil%foildistancetosample
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      level=6
      tag='foillayers'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      do j=1,sample%spectra%spectrum(i)%beam%beamfoil%foillayers%n
        level=7
        tag='layer'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=8
        tag='layerthickness'
        rcontent=sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layerthickness
        call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        tag='layeruniformity'
        rcontent=sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layeruniformity
        call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        tag='layerdensity'
        rcontent=sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layerdensity
        call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        if (sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layerelements%n.gt.0) then
        level=8
        tag='layerelements'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        do k=1,sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layerelements%n
          level=9
          tag='layerelement'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=10
          tag='name'
          content=trim(adjustl(sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layerelements%layerelement(k)%name))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='concentration'
          rcontent=sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layerelements%layerelement(k)%concentration
          call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
          level=9
          tag='layerelement'
          call IDF_closetag(u,level,tag)
        end do
        level=8
        tag='layerelements'
        call IDF_closetag(u,level,tag)
        end if
        level=7
        tag='layer'
        call IDF_closetag(u,level,tag)
      end do
      level=6
      tag='foillayers'
      call IDF_closetag(u,level,tag)
      level=5
      tag='beamfoil'
      call IDF_closetag(u,level,tag)
      end if
      level=4
      tag='beam'
      call IDF_closetag(u,level,tag)
c     end of beam
c----------------------------------------------------------------------------------------------------------------------------------------------

c     geometry
c----------------------------------------------------------------------------------------------------------------------------------------------
      level=4
      tag='geometry'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=5
      tag='geometrytype'
      content=trim(adjustl(sample%spectra%spectrum(i)%geometry%geometrytype))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='incidenceangle'
      rcontent=sample%spectra%spectrum(i)%geometry%incidenceangle
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='scatteringangle'
      rcontent=sample%spectra%spectrum(i)%geometry%scatteringangle
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='exitangle'
      rcontent=sample%spectra%spectrum(i)%geometry%exitangle
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      level=5
      tag='spot'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=6
      tag='shape'
      content=trim(adjustl(sample%spectra%spectrum(i)%geometry%spot%shape))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='l1'
      rcontent=sample%spectra%spectrum(i)%geometry%spot%l1
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='l2'
      rcontent=sample%spectra%spectrum(i)%geometry%spot%l2
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      level=5
      tag='spot'
      call IDF_closetag(u,level,tag)
      level=4
      tag='geometry'
      call IDF_closetag(u,level,tag)
c     end of geometry
c----------------------------------------------------------------------------------------------------------------------------------------------

c     instrument
c----------------------------------------------------------------------------------------------------------------------------------------------
      level=4
      tag='instrument'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=5
      tag='ionsource'
      content=trim(adjustl(sample%spectra%spectrum(i)%instrument%ionsource))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='accelerator'
      content=trim(adjustl(sample%spectra%spectrum(i)%instrument%accelerator))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='beamline'
      content=trim(adjustl(sample%spectra%spectrum(i)%instrument%beamline))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='chamber'
      content=trim(adjustl(sample%spectra%spectrum(i)%instrument%chamber))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='sampleholder'
      content=trim(adjustl(sample%spectra%spectrum(i)%instrument%sampleholder))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      level=4
      tag='instrument'
      call IDF_closetag(u,level,tag)
c     end of instrument
c----------------------------------------------------------------------------------------------------------------------------------------------

c     detection
c----------------------------------------------------------------------------------------------------------------------------------------------
      level=4
      tag='detection'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
c     slitsaftersample
      if (sample%spectra%spectrum(i)%detection%slitsaftersample%n.gt.0) then
      level=5
      tag='slitsaftersample'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      do j=1,sample%spectra%spectrum(i)%detection%slitsaftersample%n
        level=6
        tag='slit'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=7
        tag='slitshape'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=8
        tag='shape'
        content=trim(adjustl(sample%spectra%spectrum(i)%detection%slitsaftersample%slit(j)%slitshape%shape))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='l1'
        rcontent=sample%spectra%spectrum(i)%detection%slitsaftersample%slit(j)%slitshape%l1
        call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        tag='l2'
        rcontent=sample%spectra%spectrum(i)%detection%slitsaftersample%slit(j)%slitshape%l2
        call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        tag='l3'
        rcontent=sample%spectra%spectrum(i)%detection%slitsaftersample%slit(j)%slitshape%l3
        call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        level=7
        tag='slitshape'
        call IDF_closetag(u,level,tag)
        tag='slitdistancetosample'
        rcontent=sample%spectra%spectrum(i)%detection%slitsaftersample%slit(j)%slitdistancetosample
        call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        level=6
        tag='slit'
        call IDF_closetag(u,level,tag)
      end do
      level=5
      tag='slitsaftersample'
      call IDF_closetag(u,level,tag)
      end if

c     stoppingfoil
      if (sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%n.gt.0) then
      level=5
      tag='stoppingfoil'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      tag='foildistancetosample'
      rcontent=sample%spectra%spectrum(i)%detection%stoppingfoil%foildistancetosample
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      level=6
      tag='foillayers'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      do j=1,sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%n
        level=7
        tag='layer'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=8
        tag='layerthickness'
        rcontent=sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%layerthickness
        call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        tag='layeruniformity'
        rcontent=sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%layeruniformity
        call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        tag='layerdensity'
        rcontent=sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%layerdensity
        call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        if (sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%layerelements%n.gt.0) then
        level=8
        tag='layerelements'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        do k=1,sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%layerelements%n
          level=9
          tag='layerelement'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=10
          tag='name'
          content=
     +    trim(adjustl(sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%layerelements%layerelement(k)%name))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='concentration'
          rcontent=sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%layerelements%layerelement(k)%concentration
          call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
          level=9
          tag='layerelement'
          call IDF_closetag(u,level,tag)
        end do
        level=8
        tag='layerelements'
        call IDF_closetag(u,level,tag)
        end if
        level=7
        tag='layer'
        call IDF_closetag(u,level,tag)
      end do
      level=6
      tag='foillayers'
      call IDF_closetag(u,level,tag)
      level=5
      tag='stoppingfoil'
      call IDF_closetag(u,level,tag)
      end if

c     detector
      level=5
      tag='detector'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=6
      tag='detectortype'
      content=trim(adjustl(sample%spectra%spectrum(i)%detection%detector%detectortype))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='solidangle'
      rcontent=sample%spectra%spectrum(i)%detection%detector%solidangle
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      level=6
      tag='detectorshape'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=7
      tag='shape'
      content=trim(adjustl(sample%spectra%spectrum(i)%detection%detector%detectorshape%shape))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='l1'
      rcontent=sample%spectra%spectrum(i)%detection%detector%detectorshape%l1
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='l2'
      rcontent=sample%spectra%spectrum(i)%detection%detector%detectorshape%l2
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='l3'
      rcontent=sample%spectra%spectrum(i)%detection%detector%detectorshape%l3
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      level=6
      tag='detectorshape'
      call IDF_closetag(u,level,tag)
c     detector - deadlayer
      if (ndeadlayer_idf(i).gt.0.or.sample%spectra%spectrum(i)%detection%detector%deadlayer%layerelements%n.gt.0) then
      level=6
      tag='deadlayer'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=7
      tag='layerthickness'
      rcontent=sample%spectra%spectrum(i)%detection%detector%deadlayer%layerthickness
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='layeruniformity'
      rcontent=sample%spectra%spectrum(i)%detection%detector%deadlayer%layeruniformity
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='layerdensity'
      rcontent=sample%spectra%spectrum(i)%detection%detector%deadlayer%layerdensity
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      if (sample%spectra%spectrum(i)%detection%detector%deadlayer%layerelements%n.gt.0) then
        level=7
        tag='layerelements'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        do j=1,sample%spectra%spectrum(i)%detection%detector%deadlayer%layerelements%n
          level=8
          tag='layerelement'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=9
          tag='name'
          content=trim(adjustl(sample%spectra%spectrum(i)%detection%detector%deadlayer%layerelements%layerelement(j)%name))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='concentration'
          rcontent=sample%spectra%spectrum(i)%detection%detector%deadlayer%layerelements%layerelement(j)%concentration
          call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
          level=8
          tag='layerelement'
          call IDF_closetag(u,level,tag)
        end do
        level=7
        tag='layerelements'
        call IDF_closetag(u,level,tag)
      end if
      level=6
      tag='deadlayer'
      call IDF_closetag(u,level,tag)
      end if
c     detector - entrancewindow
      if (sample%spectra%spectrum(i)%detection%detector%entrancewindow%n.gt.0) then
      level=6
      tag='entrancewindow'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      do j=1,sample%spectra%spectrum(i)%detection%detector%entrancewindow%n
      level=7
      tag='layer'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=8
      tag='layerthickness'
      rcontent=sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%layerthickness
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='layeruniformity'
      rcontent=sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%layeruniformity
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='layerdensity'
      rcontent=sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%layerdensity
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      if (sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%layerelements%n.gt.0) then
        level=8
        tag='layerelements'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        do k=1,sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%layerelements%n
          level=9
          tag='layerelement'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=10
          tag='name'
          content=
     +    trim(adjustl(sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%layerelements%layerelement(k)%name))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='concentration'
          rcontent=sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%layerelements%layerelement(k)%concentration
          call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
          level=9
          tag='layerelement'
          call IDF_closetag(u,level,tag)
        end do
        level=8
        tag='layerelements'
        call IDF_closetag(u,level,tag)
      end if
      level=7
      tag='layer'
      call IDF_closetag(u,level,tag)
      end do
      level=6
      tag='entrancewindow'
      call IDF_closetag(u,level,tag)
      end if
c     detector - detectorlayers
      if (sample%spectra%spectrum(i)%detection%detector%detectorlayers%n.gt.0) then
      level=6
      tag='detectorlayers'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      do j=1,sample%spectra%spectrum(i)%detection%detector%detectorlayers%n
      level=7
      tag='layer'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=8
      tag='layerthickness'
      rcontent=sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%layerthickness
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='layeruniformity'
      rcontent=sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%layeruniformity
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='layerdensity'
      rcontent=sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%layerdensity
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      if (sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%layerelements%n.gt.0) then
        level=8
        tag='layerelements'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        do k=1,sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%layerelements%n
          level=9
          tag='layerelement'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=10
          tag='name'
          content=
     +    trim(adjustl(sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%layerelements%layerelement(k)%name))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='concentration'
          rcontent=sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%layerelements%layerelement(k)%concentration
          call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
          level=9
          tag='layerelement'
          call IDF_closetag(u,level,tag)
        end do
        level=8
        tag='layerelements'
        call IDF_closetag(u,level,tag)
      end if
      level=7
      tag='layer'
      call IDF_closetag(u,level,tag)
      end do
      level=6
      tag='detectorlayers'
      call IDF_closetag(u,level,tag)
      end if
c     detector - tof
      if (sample%spectra%spectrum(i)%detection%detector%tof%startfoil%n.gt.0.or.
     +sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%n.gt.0) then
      level=6
      tag='tof'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=7
      tag='toflength'
      rcontent=sample%spectra%spectrum(i)%detection%detector%tof%toflength
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      tag='toftimeresolution'
      rcontent=sample%spectra%spectrum(i)%detection%detector%tof%toftimeresolution
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
c     detector - startfoil
      if (sample%spectra%spectrum(i)%detection%detector%tof%startfoil%n.gt.0) then
      level=7
      tag='startfoil'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      do j=1,sample%spectra%spectrum(i)%detection%detector%tof%startfoil%n
      level=8
      tag='layer'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=9
      tag='layerthickness'
      rcontent=sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%layerthickness
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='layeruniformity'
      rcontent=sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%layeruniformity
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='layerdensity'
      rcontent=sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%layerdensity
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      if (sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%layerelements%n.gt.0) then
        level=9
        tag='layerelements'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        do k=1,sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%layerelements%n
          level=10
          tag='layerelement'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=11
          tag='name'
          content=
     +    trim(adjustl(sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%layerelements%layerelement(k)%name))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='concentration'
          rcontent=sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%layerelements%layerelement(k)%concentration
          call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
          level=10
          tag='layerelement'
          call IDF_closetag(u,level,tag)
        end do
        level=9
        tag='layerelements'
        call IDF_closetag(u,level,tag)
      end if
      level=8
      tag='layer'
      call IDF_closetag(u,level,tag)
      end do
      level=7
      tag='startfoil'
      call IDF_closetag(u,level,tag)
      end if
c     detector - stopfoil
      if (sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%n.gt.0) then
      level=7
      tag='stopfoil'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      do j=1,sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%n
      level=8
      tag='layer'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=9
      tag='layerthickness'
      rcontent=sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%layerthickness
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='layeruniformity'
      rcontent=sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%layeruniformity
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='layerdensity'
      rcontent=sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%layerdensity
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      if (sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%layerelements%n.gt.0) then
        level=9
        tag='layerelements'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        do k=1,sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%layerelements%n
          level=10
          tag='layerelement'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=11
          tag='name'
          content=
     +    trim(adjustl(sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%layerelements%layerelement(k)%name))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='concentration'
          rcontent=sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%layerelements%layerelement(k)%concentration
          call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
          level=10
          tag='layerelement'
          call IDF_closetag(u,level,tag)
        end do
        level=9
        tag='layerelements'
        call IDF_closetag(u,level,tag)
      end if
      level=8
      tag='layer'
      call IDF_closetag(u,level,tag)
      end do
      level=7
      tag='stopfoil'
      call IDF_closetag(u,level,tag)
      level=6
      tag='tof'
      call IDF_closetag(u,level,tag)
      end if
      end if
      level=6
      tag='distancedetectortosample'
      rcontent=sample%spectra%spectrum(i)%detection%detector%tof%distancedetectortosample
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      level=5
      tag='detector'
      call IDF_closetag(u,level,tag)
c     detection - amplifier
      level=5
      tag='electronics'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=6
      tag='amplifier'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=7
      tag='amplifiertype'
      content=trim(adjustl(sample%spectra%spectrum(i)%detection%electronics%amplifier%amplifiertype))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='pulseshape'
      content=trim(adjustl(sample%spectra%spectrum(i)%detection%electronics%amplifier%pulseshape))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='shapingtime'
      rcontent=sample%spectra%spectrum(i)%detection%electronics%amplifier%shapingtime
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='risetime'
      rcontent=sample%spectra%spectrum(i)%detection%electronics%amplifier%risetime
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='flattoptime'
      rcontent=sample%spectra%spectrum(i)%detection%electronics%amplifier%flattoptime
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      tag='pur'
      content=trim(adjustl(sample%spectra%spectrum(i)%detection%electronics%amplifier%pur))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='purtime'
      rcontent=sample%spectra%spectrum(i)%detection%electronics%amplifier%purtime
      call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      level=6
      tag='amplifier'
      call IDF_closetag(u,level,tag)
      level=5
      tag='electronics'
      call IDF_closetag(u,level,tag)
      level=4
      tag='detection'
      call IDF_closetag(u,level,tag)
c     end of detection
c----------------------------------------------------------------------------------------------------------------------------------------------

c     calibrations
c----------------------------------------------------------------------------------------------------------------------------------------------
      if (sample%spectra%spectrum(i)%calibrations%detectorefficiencies%n.gt.0.or.
     +sample%spectra%spectrum(i)%calibrations%detectorresolutions%n.gt.0.or.
     +sample%spectra%spectrum(i)%calibrations%energycalibrations%n.gt.0) then
      level=4
      tag='calibrations'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)

c     spectrum - calibrations - detectorefficiencies
      if (sample%spectra%spectrum(i)%calibrations%detectorefficiencies%n.gt.0.) then
      level=5
      tag='detectorefficiencies'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      do j=1,sample%spectra%spectrum(i)%calibrations%detectorefficiencies%n
        level=6
        tag='detectorefficiency'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=7
        tag='efficiencyion'
        content=trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiencyion))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='efficiencymode'
        content=trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiencymode))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
c       for energy/efficiency
        if (trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiencymode)).eq.
     +  'energy') then
          level=7
          tag='efficiency'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          if (len_trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +    efficiency%xaxis%axisname)).gt.0.or.
     +    len_trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +    efficiency%xaxis%axisunit)).gt.0) then
            level=8
            tag='xaxis'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            level=9
            tag='axisname'
            content=trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +      efficiency%xaxis%axisname))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            tag='axisunit'
            content=trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +      efficiency%xaxis%axisunit))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            level=8
            tag='xaxis'
            call IDF_closetag(u,level,tag)
          end if
          if (len_trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +    efficiency%xerroraxis%axisname)).gt.0.or.
     +    len_trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +    efficiency%xerroraxis%axisunit)).gt.0) then
            level=8
            tag='xerroraxis'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            level=9
            tag='axisname'
            content=trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +      efficiency%xerroraxis%axisname))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            tag='axisunit'
            content=trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +      efficiency%xerroraxis%axisunit))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            level=8
            tag='xerroraxis'
            call IDF_closetag(u,level,tag)
          end if
          if (len_trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +    efficiency%yaxis%axisname)).gt.0.or.
     +    len_trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +    efficiency%yaxis%axisunit)).gt.0) then
            level=8
            tag='yaxis'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            level=9
            tag='axisname'
            content=trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +      efficiency%yaxis%axisname))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            tag='axisunit'
            content=trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +      efficiency%yaxis%axisunit))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            level=8
            tag='yaxis'
            call IDF_closetag(u,level,tag)
          end if
          if (len_trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +    efficiency%yerroraxis%axisname)).gt.0.or.
     +    len_trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +    efficiency%yerroraxis%axisunit)).gt.0) then
            level=8
            tag='yerroraxis'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            level=9
            tag='axisname'
            content=trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +      efficiency%yerroraxis%axisname))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            tag='axisunit'
            content=trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +      efficiency%yerroraxis%axisunit))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            level=8
            tag='yerroraxis'
            call IDF_closetag(u,level,tag)
          end if
          if (sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%n.gt.0) then
            level=8
            tag='x'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +      efficiency%x,sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%n)
            call IDF_closetag(u,level,tag)
            tag='xerror'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +      efficiency%xerror,sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%n)
            call IDF_closetag(u,level,tag)
            tag='y'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +      efficiency%y,sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%n)
            call IDF_closetag(u,level,tag)
            tag='yerror'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +      efficiency%yerror,sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%n)
            call IDF_closetag(u,level,tag)
          end if
          level=7
          tag='efficiency'
          call IDF_closetag(u,level,tag)
c       for line/efficiency
        else if (trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiencymode))
     +  .eq.'line') then
          level=7
          tag='lineefficiency'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          if (len_trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +    lineefficiency%xaxis%axisname)).gt.0.or.
     +    len_trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +    lineefficiency%xaxis%axisunit)).gt.0) then
            level=8
            tag='xaxis'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            level=9
            tag='axisname'
            content=trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +      lineefficiency%xaxis%axisname))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            tag='axisunit'
            content=trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +      lineefficiency%xaxis%axisunit))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            level=8
            tag='xaxis'
            call IDF_closetag(u,level,tag)
          end if
          if (len_trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +    lineefficiency%yaxis%axisname)).gt.0.or.
     +    len_trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +    lineefficiency%yaxis%axisunit)).gt.0) then
            level=8
            tag='yaxis'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            level=9
            tag='axisname'
            content=trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +      lineefficiency%yaxis%axisname))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            tag='axisunit'
            content=trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +      lineefficiency%yaxis%axisunit))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            level=8
            tag='yaxis'
            call IDF_closetag(u,level,tag)
          end if
          if (len_trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +    lineefficiency%yerroraxis%axisname)).gt.0.or.
     +    len_trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +    lineefficiency%yerroraxis%axisunit)).gt.0) then
            level=8
            tag='yerroraxis'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            level=9
            tag='axisname'
            content=trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +      lineefficiency%yerroraxis%axisname))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            tag='axisunit'
            content=trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +      lineefficiency%yerroraxis%axisunit))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            level=8
            tag='yerroraxis'
            call IDF_closetag(u,level,tag)
          end if
          if (sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%n.gt.0) then
            level=8
            tag='line'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            call IDF_writearray_string(u,level,sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +      lineefficiency%line,sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%n)
            call IDF_closetag(u,level,tag)
            tag='y'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +      lineefficiency%y,sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%n)
            call IDF_closetag(u,level,tag)
            tag='yerror'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%
     +      lineefficiency%yerror,
     +      sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%n)
            call IDF_closetag(u,level,tag)
          end if
          level=7
          tag='lineefficiency'
          call IDF_closetag(u,level,tag)
        end if
        level=6
        tag='detectorefficiency'
        call IDF_closetag(u,level,tag)
      end do
      level=5
      tag='detectorefficiencies'
      call IDF_closetag(u,level,tag)
c     end of spectrum - calibrations - detectorefficiencies
      end if

c     spectrum - calibrations - detectorresolutions
      if (sample%spectra%spectrum(i)%calibrations%detectorresolutions%n.gt.0) then
      level=5
      tag='detectorresolutions'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      do j=1,sample%spectra%spectrum(i)%calibrations%detectorresolutions%n
        level=6
        tag='detectorresolution'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=7
        tag='resolutionion'
        content=trim(adjustl(sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%resolutionion))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        if (sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%resolutionparameters%n.gt.0) then
        level=7
        tag='resolutionparameters'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        do k=1,sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%resolutionparameters%n
          level=8
          tag='resolutionparameter'
          rcontent=sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%
     +    resolutionparameters%resolutionparameter(k)
          call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        end do
        level=7
        tag='resolutionparameters'
        call IDF_closetag(u,level,tag)
        end if
        level=6
        tag='detectorresolution'
        call IDF_closetag(u,level,tag)
      end do
      level=5
      tag='detectorresolutions'
      call IDF_closetag(u,level,tag)
c     end of spectrum - calibrations - detectorresolutions
      end if

c     spectrum - calibrations - energycalibrations
      if (sample%spectra%spectrum(i)%calibrations%energycalibrations%n.gt.0) then
      level=5
      tag='energycalibrations'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      do j=1,sample%spectra%spectrum(i)%calibrations%energycalibrations%n
        level=6
        tag='energycalibration'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=7
        tag='calibrationion'
        content=trim(adjustl(sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%calibrationion))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        if (sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%calibrationparameters%n.gt.0) then
        level=7
        tag='calibrationparameters'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        do k=1,sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%calibrationparameters%n
          level=8
          tag='calibrationparameter'
          rcontent=sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%
     +    calibrationparameters%calibrationparameter(k)
          call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        end do
        level=7
        tag='calibrationparameters'
        call IDF_closetag(u,level,tag)
        end if
        level=6
        tag='energycalibration'
        call IDF_closetag(u,level,tag)
      end do
      level=5
      tag='energycalibrations'
      call IDF_closetag(u,level,tag)
c     end of spectrum - calibrations - energycalibrations
      end if

      level=4
      tag='calibrations'
      call IDF_closetag(u,level,tag)
      end if
c     end of calibrations
c----------------------------------------------------------------------------------------------------------------------------------------------

c     reactions
c----------------------------------------------------------------------------------------------------------------------------------------------
      if (len_trim(adjustl(sample%spectra%spectrum(i)%reactions%technique)).gt.0.or.
     +sample%spectra%spectrum(i)%reactions%reactionlist%n.gt.0) then
      level=4
      tag='reactions'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=5
      tag='technique'
      content=trim(adjustl(sample%spectra%spectrum(i)%reactions%technique))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      if (sample%spectra%spectrum(i)%reactions%reactionlist%n.gt.0) then
      level=5
      tag='reactionlist'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=6
      tag='reaction'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      do j=1,sample%spectra%spectrum(i)%reactions%reactionlist%n
        level=7
        tag='initialtargetparticle'
        content=trim(adjustl(sample%spectra%spectrum(i)%reactions%reactionlist%reaction(j)%initialtargetparticle))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='incidentparticle'
        content=trim(adjustl(sample%spectra%spectrum(i)%reactions%reactionlist%reaction(j)%incidentparticle))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='exitparticle'
        content=trim(adjustl(sample%spectra%spectrum(i)%reactions%reactionlist%reaction(j)%exitparticle))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='finaltargetparticle'
        content=trim(adjustl(sample%spectra%spectrum(i)%reactions%reactionlist%reaction(j)%finaltargetparticle))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='reactionQ'
        rcontent=sample%spectra%spectrum(i)%reactions%reactionlist%reaction(j)%reactionQ
        call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
      end do
      level=6
      tag='reaction'
      call IDF_closetag(u,level,tag)
      level=5
      tag='reactionlist'
      call IDF_closetag(u,level,tag)
      end if
      level=4
      tag='reactions'
      call IDF_closetag(u,level,tag)
      end if
c     end of reactions
c----------------------------------------------------------------------------------------------------------------------------------------------

c     data
c----------------------------------------------------------------------------------------------------------------------------------------------
c     build auxiliary variable ndatapoints_idf(i)
      if (sample%spectra%spectrum(i)%data%datamode.eq.'simple') then
        ndatapoints_idf(i)=sample%spectra%spectrum(i)%data%simpledata%n
      else if (sample%spectra%spectrum(i)%data%datamode.eq.'line') then
        ndatapoints_idf(i)=sample%spectra%spectrum(i)%data%linedata%n
      else if (sample%spectra%spectrum(i)%data%datamode.eq.'complex') then
        ndatapoints_idf(i)=sample%spectra%spectrum(i)%data%complexdata%dataentries%n
      else if (sample%spectra%spectrum(i)%data%datamode.eq.'datafile') then
        ndatapoints_idf(i)=0
      end if

      if (len_trim(adjustl(sample%spectra%spectrum(i)%data%datamode)).gt.0.or.
     +len_trim(adjustl(sample%spectra%spectrum(i)%data%channelmode)).gt.0.or.ndatapoints_idf(i).gt.0) then
      level=4
      tag='data'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=5
      tag='datamode'
      content=trim(adjustl(sample%spectra%spectrum(i)%data%datamode))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='channelmode'
      content=trim(adjustl(sample%spectra%spectrum(i)%data%channelmode))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)

c     spectrum - data - simpledata
      if (trim(adjustl(sample%spectra%spectrum(i)%data%datamode)).eq.'simple') then
        level=5
        tag='simpledata'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        if (len_trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%xaxis%axisname)).gt.0.or.
     +  len_trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%xaxis%axisunit)).gt.0) then
          level=6
          tag='xaxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=7
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%xaxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%xaxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=6
          tag='xaxis'
          call IDF_closetag(u,level,tag)
        end if
        if (len_trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%xerroraxis%axisname)).gt.0.or.
     +  len_trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%xerroraxis%axisunit)).gt.0) then
          level=6
          tag='xerroraxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=7
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%xerroraxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%xerroraxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=6
          tag='xerroraxis'
          call IDF_closetag(u,level,tag)
        end if
        if (len_trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%yaxis%axisname)).gt.0.or.
     +  len_trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%yaxis%axisunit)).gt.0) then
          level=6
          tag='yaxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=7
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%yaxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%yaxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=6
          tag='yaxis'
          call IDF_closetag(u,level,tag)
        end if
        if (len_trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%yerroraxis%axisname)).gt.0.or.
     +  len_trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%yerroraxis%axisunit)).gt.0) then
          level=6
          tag='yerroraxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=7
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%yerroraxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%data%simpledata%yerroraxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=6
          tag='yerroraxis'
          call IDF_closetag(u,level,tag)
        end if
        if (ndatapoints_idf(i).gt.0) then
          level=5
          tag='x'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%data%simpledata%x,ndatapoints_idf(i))
          call IDF_closetag(u,level,tag)
          tag='xerror'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%data%simpledata%xerror,ndatapoints_idf(i))
          call IDF_closetag(u,level,tag)
          tag='y'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%data%simpledata%y,ndatapoints_idf(i))
          call IDF_closetag(u,level,tag)
          tag='yerror'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%data%simpledata%yerror,ndatapoints_idf(i))
          call IDF_closetag(u,level,tag)
        end if
        level=5
        tag='simpledata'
        call IDF_closetag(u,level,tag)
c     for line/efficiency
      else if (trim(adjustl(sample%spectra%spectrum(i)%data%datamode)).eq.'line') then
        level=5
        tag='linedata'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        if (len_trim(adjustl(sample%spectra%spectrum(i)%data%linedata%lineaxis%axisname)).gt.0.or.
     +  len_trim(adjustl(sample%spectra%spectrum(i)%data%linedata%lineaxis%axisunit)).gt.0) then
          level=6
          tag='lineaxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=7
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%data%linedata%lineaxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%data%linedata%lineaxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=6
          tag='lineaxis'
          call IDF_closetag(u,level,tag)
        end if
        if (len_trim(adjustl(sample%spectra%spectrum(i)%data%linedata%yaxis%axisname)).gt.0.or.
     +  len_trim(adjustl(sample%spectra%spectrum(i)%data%linedata%yaxis%axisunit)).gt.0) then
          level=6
          tag='yaxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=7
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%data%linedata%yaxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%data%linedata%yaxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=6
          tag='yaxis'
          call IDF_closetag(u,level,tag)
        end if
        if (len_trim(adjustl(sample%spectra%spectrum(i)%data%linedata%yerroraxis%axisname)).gt.0.or.
     +  len_trim(adjustl(sample%spectra%spectrum(i)%data%linedata%yerroraxis%axisunit)).gt.0) then
          level=6
          tag='yerroraxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=7
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%data%linedata%yerroraxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%data%linedata%yerroraxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=6
          tag='yerroraxis'
          call IDF_closetag(u,level,tag)
        end if
        if (ndatapoints_idf(i).gt.0) then
          level=5
          tag='line'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          call IDF_writearray_string(u,level,sample%spectra%spectrum(i)%data%linedata%line,ndatapoints_idf(i))
          tag='y'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%data%linedata%y,ndatapoints_idf(i))
          call IDF_closetag(u,level,tag)
          tag='yerror'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%data%linedata%yerror,ndatapoints_idf(i))
          call IDF_closetag(u,level,tag)
        end if
        level=5
        tag='linedata'
        call IDF_closetag(u,level,tag)
c     spectrum - data - complexdata
      else if (trim(adjustl(sample%spectra%spectrum(i)%data%datamode)).eq.'complex') then
        level=5
        tag='complexdata'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=6
        tag='datadimensions'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=7
        tag='datadimensionx'
        icontent=sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensionx
        call IDF_writetagwithcontent_integer(u,level,tag,attribute_names,attribute_values,nattributes,icontent,writezero)
        tag='datadimensiony'
        icontent=sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensiony
        call IDF_writetagwithcontent_integer(u,level,tag,attribute_names,attribute_values,nattributes,icontent,writezero)
        level=6
        tag='datadimensions'
        call IDF_closetag(u,level,tag)
        if (sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensionx.gt.0) then
          level=6
          tag='xaxes'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          do j=1,sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensionx
            level=7
            tag='axis'
            call IDF_closetag(u,level,tag)
            level=8
            tag='axisname'
            content=trim(adjustl(sample%spectra%spectrum(i)%data%complexdata%xaxes%axis(j)%axisname))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            tag='axisunit'
            content=trim(adjustl(sample%spectra%spectrum(i)%data%complexdata%xaxes%axis(j)%axisunit))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            level=7
            tag='axis'
            call IDF_closetag(u,level,tag)
          end do
          level=6
          tag='xaxes'
          call IDF_closetag(u,level,tag)
        end if
        if (sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensiony.gt.0) then
          level=6
          tag='yaxes'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          do j=1,sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensiony
            level=7
            tag='axis'
            call IDF_closetag(u,level,tag)
            level=8
            tag='axisname'
            content=trim(adjustl(sample%spectra%spectrum(i)%data%complexdata%yaxes%axis(j)%axisname))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            tag='axisunit'
            content=trim(adjustl(sample%spectra%spectrum(i)%data%complexdata%yaxes%axis(j)%axisunit))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            level=7
            tag='axis'
            call IDF_closetag(u,level,tag)
          end do
          level=6
          tag='yaxes'
          call IDF_closetag(u,level,tag)
        end if
        if (ndatapoints_idf(i).gt.0) then
          level=6
          tag='dataentries'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          do j=1,ndatapoints_idf(i)
            level=7
            tag='dataentry'
            call IDF_closetag(u,level,tag)
            if (ndatatimestamp_idf(i).gt.0.or.
     +      len_trim(adjustl(sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry(1)%timestamp)).gt.0) then
              level=8
              tag='timestamp'
              content=trim(adjustl(sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry(j)%timestamp))
              call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            end if
            if (ndataline_idf(i).gt.0.or.
     +      len_trim(adjustl(sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry(1)%line)).gt.0) then
              level=8
              tag='line'
              content=trim(adjustl(sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry(j)%line))
              call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            end if
            do k=1,sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensionx+
     +      sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensiony
              level=8
              tag='dataitem'
              realcontent=sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry(j)%dataitem(k)
              call IDF_writetagwithcontent_real(u,level,tag,attribute_names,attribute_values,nattributes,realcontent,writezero)
            end do
            level=7
            tag='dataentry'
            call IDF_closetag(u,level,tag)
          end do
          level=6
          tag='dataentries'
          call IDF_closetag(u,level,tag)
        end if
        level=5
        tag='complexdata'
        call IDF_closetag(u,level,tag)
c     spectrum - data - datafile
      else if (trim(adjustl(sample%spectra%spectrum(i)%data%datamode)).eq.'datafile') then
        level=5
        tag='datafile'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=6
        tag='filename'
        content=trim(adjustl(sample%spectra%spectrum(i)%data%datafile%filename))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='fileformat'
        content=trim(adjustl(sample%spectra%spectrum(i)%data%datafile%fileformat))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='filesource'
        content=trim(adjustl(sample%spectra%spectrum(i)%data%datafile%filesource))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        level=5
        tag='datafile'
        call IDF_closetag(u,level,tag)
      end if
      level=4
      tag='data'
      call IDF_closetag(u,level,tag)
      end if
c     end of data
c----------------------------------------------------------------------------------------------------------------------------------------------

c----------------------------------------------------------------------------------------------------------------------------------------------
c     process
c----------------------------------------------------------------------------------------------------------------------------------------------
      level=4
      tag='process'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)

c     process - physicsdefaults
c----------------------------------------------------------------------------------------------------------------------------------------------
      level=5
      tag='physicsdefaults'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
c     process - physicsdefaults - crosssectiondefault
      if (len_trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%crosssectiondefault%Rutherford)).gt.0.or.
     +len_trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%crosssectiondefault%screening)).gt.0.or.
     +len_trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%crosssectiondefault%computercode%name)).gt.0) then
        level=6
        tag='crosssectiondefault'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=7
        tag='Rutherford'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%crosssectiondefault%Rutherford))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='screening'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%crosssectiondefault%screening))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        if (len_trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%crosssectiondefault%computercode%name)).gt.0) then
          level=7
          tag='computercode'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=8
          tag='name'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%crosssectiondefault%computercode%name))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='version'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%crosssectiondefault%computercode%version))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='builddate'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%crosssectiondefault%computercode%builddate))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='releasedate'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%crosssectiondefault%computercode%releasedate))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=7
          tag='computercode'
          call IDF_closetag(u,level,tag)
        end if
        level=6
        tag='crosssectiondefault'
        call IDF_closetag(u,level,tag)
      end if

c     process - physicsdefaults - crosssectiondefault
      if (len_trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%stoppingpowerdefault%computercode%name)).gt.0) then
        level=6
        tag='stoppingpowerdefault'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        if (len_trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%stoppingpowerdefault%computercode%name)).gt.0) then
          level=7
          tag='computercode'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=8
          tag='name'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%stoppingpowerdefault%computercode%name))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='version'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%stoppingpowerdefault%computercode%version))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='builddate'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%stoppingpowerdefault%computercode%builddate))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='releasedate'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%stoppingpowerdefault%computercode%releasedate))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=7
          tag='computercode'
          call IDF_closetag(u,level,tag)
        end if
        level=6
        tag='stoppingpowerdefault'
        call IDF_closetag(u,level,tag)
      end if

c     process - physicsdefaults - energyspreaddefault
      if (len_trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%energylossstraggling)).gt.0.or.
     +len_trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%multiplescattering)).gt.0.or.
     +len_trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%Dopplereffect)).gt.0.or.
     +len_trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%beamangularspread)).gt.0.or.
     +len_trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%geometricspread%beamsize)).gt.0.or.
     +len_trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%geometricspread%detectoraperture))
     +.gt.0.or.
     +len_trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%Tschalareffect)).gt.0.or.
     +len_trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%computercode%name)).gt.0) then
        level=6
        tag='energyspreaddefault'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=7
        tag='energylossstraggling'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%energylossstraggling))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='multiplescattering'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%multiplescattering))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='Dopplereffect'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%Dopplereffect))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='beamangularspread'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%beamangularspread))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        if (
     +  len_trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%geometricspread%beamsize)).gt.0.or.
     +  len_trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%geometricspread%detectoraperture))
     +  .gt.0) then
        level=7
        tag='geometricspread'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=8
        tag='beamsize'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%geometricspread%beamsize))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='detectoraperture'
        content=
     +  trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%geometricspread%detectoraperture))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        level=7
        tag='geometricspread'
        call IDF_closetag(u,level,tag)
        end if
        level=7
        tag='Tschalareffect'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%Tschalareffect))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        if (len_trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%computercode%name)).gt.0) then
          level=7
          tag='computercode'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=8
          tag='name'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%computercode%name))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='version'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%computercode%version))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='builddate'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%computercode%builddate))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='releasedate'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%physicsdefaults%energyspreaddefault%computercode%releasedate))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=7
          tag='computercode'
          call IDF_closetag(u,level,tag)
        end if
        level=6
        tag='energyspreaddefault'
        call IDF_closetag(u,level,tag)
      end if
      level=5
      tag='physicsdefaults'
      call IDF_closetag(u,level,tag)
c     end of process - physicsdefaults
c----------------------------------------------------------------------------------------------------------------------------------------------

c     process - simulations
c----------------------------------------------------------------------------------------------------------------------------------------------
c-------------------------------------------------------------------------------
      if (sample%spectra%spectrum(i)%process%simulations%n.gt.0) then
      level=5
      tag='simulations'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      do j=1,sample%spectra%spectrum(i)%process%simulations%n
      level=6
      tag='simulation'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
c     process - simulations - physics
c----------------------------------------------------------------------------------------------------------------------------------------------
      level=7
      tag='physics'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
c     process - crosssections
      if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%n.gt.0) then
      level=8
      tag='crosssections'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      do k=1,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%n
        level=9
        tag='crosssection'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=10
        tag='crosssectionframe'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +  crosssection(k)%crosssectionframe))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='crosssectiontype'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +  crosssection(k)%crosssectiontype))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='energyminimum'
        rcontent=sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +  crosssection(k)%energyminimum
        call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        tag='energymaximum'
        rcontent=sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +  crosssection(k)%energymaximum
        call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        level=10
        tag='reaction'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=11
        tag='initialtargetparticle'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +  crosssections%crosssection(k)%reaction%initialtargetparticle))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='incidentparticle'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +  crosssections%crosssection(k)%reaction%incidentparticle))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='exitparticle'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +  crosssections%crosssection(k)%reaction%exitparticle))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='finaltargetparticle'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +  crosssections%crosssection(k)%reaction%finaltargetparticle))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='reactionQ'
        rcontent=sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +  crosssections%crosssection(k)%reaction%reactionQ
        call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        level=10
        tag='reaction'
        call IDF_closetag(u,level,tag)
        if (trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +  mode)).eq.'file') then
          level=10
          tag='crosssectionfile'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=11
          tag='filename'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +    crosssections%crosssection(k)%crosssectionfile%filename))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='fileformat'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +    crosssections%crosssection(k)%crosssectionfile%fileformat))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='filesource'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +    crosssections%crosssection(k)%crosssectionfile%filesource))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=10
          tag='crosssectionfile'
          call IDF_closetag(u,level,tag)
        else if (trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +  mode)).eq.'data') then
          level=10
          tag='crosssectiondata'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +    crosssection(k)%crosssectiondata%xaxis%axisname)).gt.0.or.
     +    len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +    crosssection(k)%crosssectiondata%xaxis%axisunit)).gt.0) then
          level=11
          tag='xaxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=12
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +    crosssection(k)%crosssectiondata%xaxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +    crosssection(k)%crosssectiondata%xaxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=11
          tag='xaxis'
          call IDF_closetag(u,level,tag)
          end if
          if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +    crosssection(k)%crosssectiondata%xerroraxis%axisname)).gt.0.or.
     +    len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +    crosssection(k)%crosssectiondata%xerroraxis%axisunit)).gt.0) then
          level=11
          tag='xerroraxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=12
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +    crosssection(k)%crosssectiondata%xerroraxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +    crosssection(k)%crosssectiondata%xerroraxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=11
          tag='xerroraxis'
          call IDF_closetag(u,level,tag)
          end if
          if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +    crosssection(k)%crosssectiondata%yaxis%axisname)).gt.0.or.
     +    len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +    crosssection(k)%crosssectiondata%yaxis%axisunit)).gt.0) then
          level=11
          tag='yaxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=12
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +    crosssection(k)%crosssectiondata%yaxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +    crosssection(k)%crosssectiondata%yaxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=11
          tag='yaxis'
          call IDF_closetag(u,level,tag)
          end if
          if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +    crosssection(k)%crosssectiondata%yerroraxis%axisname)).gt.0.or.
     +    len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +    crosssection(k)%crosssectiondata%yerroraxis%axisunit)).gt.0) then
          level=11
          tag='yerroraxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=12
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +    crosssection(k)%crosssectiondata%yerroraxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +    crosssection(k)%crosssectiondata%yerroraxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=11
          tag='yerroraxis'
          call IDF_closetag(u,level,tag)
          end if
          if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +    crosssectiondata%n.gt.0) then
            level=12
            tag='x'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +      crosssection(k)%crosssectiondata%x,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      crosssections%crosssection(k)%crosssectiondata%n)
            tag='xerror'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +      crosssection(k)%crosssectiondata%xerror,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      crosssections%crosssection(k)%crosssectiondata%n)
            call IDF_closetag(u,level,tag)
            tag='y'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +      crosssection(k)%crosssectiondata%y,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      crosssections%crosssection(k)%crosssectiondata%n)
            tag='yerror'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%
     +      crosssection(k)%crosssectiondata%yerror,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      crosssections%crosssection(k)%crosssectiondata%n)
            call IDF_closetag(u,level,tag)
          end if
          level=10
          tag='crosssectiondata'
          call IDF_closetag(u,level,tag)
        else if (trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +  mode)).eq. 'override') then
          level=10
          tag='crosssectionoverride'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=11
          tag='Rutherford'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +    crosssections%crosssection(k)%crosssectionoverride%Rutherford))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='screening'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +    crosssections%crosssection(k)%crosssectionoverride%screening))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +    crosssections%crosssection(k)%crosssectionoverride%computercode%name)).gt.0) then
            level=11
            tag='computercode'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            level=12
            tag='name'
            content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      crosssections%crosssection(k)%crosssectionoverride%computercode%name))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            tag='version'
            content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      crosssections%crosssection(k)%crosssectionoverride%computercode%version))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            tag='builddate'
            content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      crosssections%crosssection(k)%crosssectionoverride%computercode%builddate))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            tag='releasedate'
            content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      crosssections%crosssection(k)%crosssectionoverride%computercode%releasedate))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            level=11
            tag='computercode'
            call IDF_closetag(u,level,tag)
          end if
          level=10
          tag='crosssectionoverride'
          call IDF_closetag(u,level,tag)
        end if
        level=9
        tag='crosssection'
        call IDF_closetag(u,level,tag)
      end do
      level=8
      tag='crosssections'
      call IDF_closetag(u,level,tag)
      end if
c     end of process - crosssections
c     process - stoppingpowers
      if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%n.gt.0) then
      level=8
      tag='stoppingpowers'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      do k=1,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%n
        level=9
        tag='stoppingpower'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=10
        tag='ion'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +  stoppingpower(k)%ion))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='ionchargestate'
        rcontent=sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +  stoppingpower(k)%ionchargestate
        call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        tag='targetelement'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +  stoppingpower(k)%targetelement))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='targetmolecule'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +  stoppingpower(k)%targetmolecule))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='stoppingmode'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +  stoppingpower(k)%stoppingmode))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)

        if (trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower(k)%
     +  mode)).eq.'file') then
          level=10
          tag='stoppingpowerfile'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=11
          tag='filename'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +    stoppingpowers%stoppingpower(k)%stoppingpowerfile%filename))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='fileformat'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +    stoppingpowers%stoppingpower(k)%stoppingpowerfile%fileformat))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='filesource'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +    stoppingpowers%stoppingpower(k)%stoppingpowerfile%filesource))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=10
          tag='stoppingpowerfile'
          call IDF_closetag(u,level,tag)
        else if (trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower(k)%
     +  mode)).eq.'data') then
          level=10
          tag='stoppingpowerdata'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +    stoppingpower(k)%stoppingpowerdata%xaxis%axisname)).gt.0.or.
     +    len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +    stoppingpower(k)%stoppingpowerdata%xaxis%axisunit)).gt.0) then
          level=11
          tag='xaxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=12
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +    stoppingpower(k)%stoppingpowerdata%xaxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +    stoppingpower(k)%stoppingpowerdata%xaxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=11
          tag='xaxis'
          call IDF_closetag(u,level,tag)
          end if
          if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +    stoppingpower(k)%stoppingpowerdata%xerroraxis%axisname)).gt.0.or.
     +    len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +    stoppingpower(k)%stoppingpowerdata%xerroraxis%axisunit)).gt.0) then
          level=11
          tag='xerroraxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=12
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +    stoppingpower(k)%stoppingpowerdata%xerroraxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +    stoppingpower(k)%stoppingpowerdata%xerroraxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=11
          tag='xerroraxis'
          call IDF_closetag(u,level,tag)
          end if
          if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +    stoppingpower(k)%stoppingpowerdata%yaxis%axisname)).gt.0.or.
     +    len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +    stoppingpower(k)%stoppingpowerdata%yaxis%axisunit)).gt.0) then
          level=11
          tag='yaxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=12
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +    stoppingpower(k)%stoppingpowerdata%yaxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +    stoppingpower(k)%stoppingpowerdata%yaxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=11
          tag='yaxis'
          call IDF_closetag(u,level,tag)
          end if
          if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +    stoppingpower(k)%stoppingpowerdata%yerroraxis%axisname)).gt.0.or.
     +    len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +    stoppingpower(k)%stoppingpowerdata%yerroraxis%axisunit)).gt.0) then
          level=11
          tag='yerroraxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=12
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +    stoppingpower(k)%stoppingpowerdata%yerroraxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +    stoppingpower(k)%stoppingpowerdata%yerroraxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=11
          tag='yerroraxis'
          call IDF_closetag(u,level,tag)
          end if
          if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +    stoppingpowers%stoppingpower(k)%stoppingpowerdata%n.gt.0) then
            level=12
            tag='x'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +      stoppingpower(k)%stoppingpowerdata%x,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      stoppingpowers%stoppingpower(k)%stoppingpowerdata%n)
            tag='xerror'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +      stoppingpower(k)%stoppingpowerdata%xerror,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      stoppingpowers%stoppingpower(k)%stoppingpowerdata%n)
            call IDF_closetag(u,level,tag)
            tag='y'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +      stoppingpower(k)%stoppingpowerdata%y,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      stoppingpowers%stoppingpower(k)%stoppingpowerdata%n)
            tag='yerror'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%
     +      stoppingpower(k)%stoppingpowerdata%yerror,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      stoppingpowers%stoppingpower(k)%stoppingpowerdata%n)
            call IDF_closetag(u,level,tag)
          end if
          level=10
          tag='stoppingpowerdata'
          call IDF_closetag(u,level,tag)
        else if (trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower(k)%
     +  mode)).eq. 'override') then
          level=10
          tag='stoppingpoweroverride'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +    stoppingpowers%stoppingpower(k)%stoppingpoweroverride%computercode%name)).gt.0) then
            level=11
            tag='computercode'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            level=12
            tag='name'
            content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      stoppingpowers%stoppingpower(k)%stoppingpoweroverride%computercode%name))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            tag='version'
            content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      stoppingpowers%stoppingpower(k)%stoppingpoweroverride%computercode%version))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            tag='builddate'
            content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      stoppingpowers%stoppingpower(k)%stoppingpoweroverride%computercode%builddate))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            tag='releasedate'
            content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      stoppingpowers%stoppingpower(k)%stoppingpoweroverride%computercode%releasedate))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            level=11
            tag='computercode'
            call IDF_closetag(u,level,tag)
          end if
          level=10
          tag='stoppingpoweroverride'
          call IDF_closetag(u,level,tag)
        end if
        level=9
        tag='stoppingpower'
        call IDF_closetag(u,level,tag)
      end do
      level=8
      tag='stoppingpowers'
      call IDF_closetag(u,level,tag)
      end if
c     end of process - stoppingpowers
c     process - energyspreads
      if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%n.gt.0) then
      level=8
      tag='energyspreads'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      do k=1,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%n
        level=9
        tag='energyspread'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=10
        tag='ion'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +  energyspread(k)%ion))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='ionchargestate'
        rcontent=sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +  energyspread(k)%ionchargestate
        call IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,rcontent,writezero)
        tag='targetelement'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +  energyspread(k)%targetelement))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='energyspreadmode'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +  energyspread(k)%energyspreadmode))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)

        if (trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread(k)%
     +  mode)).eq.'file') then
          level=10
          tag='energyspreadfile'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=11
          tag='filename'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +    energyspreads%energyspread(k)%energyspreadfile%filename))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='fileformat'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +    energyspreads%energyspread(k)%energyspreadfile%fileformat))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='filesource'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +    energyspreads%energyspread(k)%energyspreadfile%filesource))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=10
          tag='energyspreadfile'
          call IDF_closetag(u,level,tag)
        else if (trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread(k)%
     +  mode)).eq.'data') then
          level=10
          tag='energyspreaddata'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreaddata%xaxis%axisname)).gt.0.or.
     +    len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreaddata%xaxis%axisunit)).gt.0) then
          level=11
          tag='xaxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=12
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreaddata%xaxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreaddata%xaxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=11
          tag='xaxis'
          call IDF_closetag(u,level,tag)
          end if
          if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreaddata%xerroraxis%axisname)).gt.0.or.
     +    len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreaddata%xerroraxis%axisunit)).gt.0) then
          level=11
          tag='xerroraxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=12
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreaddata%xerroraxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreaddata%xerroraxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=11
          tag='xerroraxis'
          call IDF_closetag(u,level,tag)
          end if
          if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreaddata%yaxis%axisname)).gt.0.or.
     +    len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreaddata%yaxis%axisunit)).gt.0) then
          level=11
          tag='yaxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=12
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreaddata%yaxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreaddata%yaxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=11
          tag='yaxis'
          call IDF_closetag(u,level,tag)
          end if
          if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreaddata%yerroraxis%axisname)).gt.0.or.
     +    len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreaddata%yerroraxis%axisunit)).gt.0) then
          level=11
          tag='yerroraxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=12
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreaddata%yerroraxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreaddata%yerroraxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=11
          tag='yerroraxis'
          call IDF_closetag(u,level,tag)
          end if
          if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +    energyspreads%energyspread(k)%energyspreaddata%n.gt.0) then
            level=12
            tag='x'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +      energyspread(k)%energyspreaddata%x,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      energyspreads%energyspread(k)%energyspreaddata%n)
            tag='xerror'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +      energyspread(k)%energyspreaddata%xerror,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      energyspreads%energyspread(k)%energyspreaddata%n)
            call IDF_closetag(u,level,tag)
            tag='y'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +      energyspread(k)%energyspreaddata%y,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      energyspreads%energyspread(k)%energyspreaddata%n)
            tag='yerror'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            call IDF_writearray_real(u,level,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +      energyspread(k)%energyspreaddata%yerror,sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      energyspreads%energyspread(k)%energyspreaddata%n)
            call IDF_closetag(u,level,tag)
          end if
          level=10
          tag='energyspreaddata'
          call IDF_closetag(u,level,tag)
        else if (trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread(k)%
     +  mode)).eq. 'override') then
          level=10
          tag='energyspreadoverride'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=11
          tag='energylossstraggling'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreadoverride%energylossstraggling))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='multiplescattering'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreadoverride%multiplescattering))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='Dopplereffect'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreadoverride%Dopplereffect))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='beamangularspread'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreadoverride%beamangularspread))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          if (
     +    len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreadoverride%geometricspread%beamsize)).gt.0.or.
     +    len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreadoverride%geometricspread%detectoraperture))
     +    .gt.0) then
          level=11
          tag='geometricspread'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=12
          tag='beamsize'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreadoverride%geometricspread%beamsize))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='detectoraperture'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreadoverride%geometricspread%detectoraperture))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=11
          tag='geometricspread'
          call IDF_closetag(u,level,tag)
          end if
          level=11
          tag='Tschalareffect'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%
     +    energyspread(k)%energyspreadoverride%Tschalareffect))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +    energyspreads%energyspread(k)%energyspreadoverride%computercode%name)).gt.0) then
            level=11
            tag='computercode'
            call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
            level=12
            tag='name'
            content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      energyspreads%energyspread(k)%energyspreadoverride%computercode%name))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            tag='version'
            content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      energyspreads%energyspread(k)%energyspreadoverride%computercode%version))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            tag='builddate'
            content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      energyspreads%energyspread(k)%energyspreadoverride%computercode%builddate))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            tag='releasedate'
            content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +      energyspreads%energyspread(k)%energyspreadoverride%computercode%releasedate))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            level=11
            tag='computercode'
            call IDF_closetag(u,level,tag)
          end if
          level=10
          tag='energyspreadoverride'
          call IDF_closetag(u,level,tag)
        end if
        level=9
        tag='energyspread'
        call IDF_closetag(u,level,tag)
      end do
      level=8
      tag='energyspreads'
      call IDF_closetag(u,level,tag)
      end if
c     end of process - energyspreads
      level=7
      tag='physics'
      call IDF_closetag(u,level,tag)
c     end of process - simulations - physics
c----------------------------------------------------------------------------------------------------------------------------------------------
c     simulationtype etc - prelude to the actual simulation
      level=7
      tag='simulationtype'
      content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simulationtype))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      if (trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simulationtype)).eq.'partialelement') then
        tag='initialtargetparticle'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%initialtargetparticle))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      else if (trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simulationtype)).eq.'reaction') then
        level=7
        tag='reaction'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=8
        tag='initialtargetparticle'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%reaction%initialtargetparticle))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='incidentparticle'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%reaction%incidentparticle))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='exitparticle'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%reaction%exitparticle))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='finaltargetparticle'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%reaction%finaltargetparticle))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        level=7
        tag='reaction'
        call IDF_closetag(u,level,tag)
      end if
      tag='targetlayer'
      icontent=sample%spectra%spectrum(i)%process%simulations%simulation(j)%targetlayer
      call IDF_writetagwithcontent_integer(u,level,tag,attribute_names,attribute_values,nattributes,icontent,writezero)
      tag='datamode'
      content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%datamode))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
      tag='channelmode'
      content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%channelmode))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)


c     simulation data
c----------------------------------------------------------------------------------------------------------------------------------------------
c     initialise variable nsimpoints_idf(i,j)
        if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%datamode.eq.'simple') then
          nsimpoints_idf(i,j)=sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%n
        else if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%datamode.eq.'line') then
          nsimpoints_idf(i,j)=sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%n
        else if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%datamode.eq.'complex') then
          nsimpoints_idf(i,j)=sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%dataentries%n
        else if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%datamode.eq.'datafile') then
          nsimpoints_idf(i,j)=0
       end if

      if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%datamode)).gt.0.or.
     +len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%channelmode)).gt.0.or.nsimpoints_idf(i,j).gt.0) 
     +then
      level=7
      tag='data'
      call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
      level=8
      tag='channelmode'
      content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%channelmode))
      call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)

c     spectrum - simulation - simpledata
      if (trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%datamode)).eq.'simple') then
        level=8
        tag='simpledata'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%xaxis%axisname)).gt.0.or.
     +  len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%xaxis%axisunit)).gt.0) then
          level=9
          tag='xaxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=10
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%xaxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%xaxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=9
          tag='xaxis'
          call IDF_closetag(u,level,tag)
        end if
        if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%xerroraxis%axisname)).gt.0.or.
     +  len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%xerroraxis%axisunit)).gt.0) then
          level=9
          tag='xerroraxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=10
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%xerroraxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%xerroraxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=9
          tag='xerroraxis'
          call IDF_closetag(u,level,tag)
        end if
        if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yaxis%axisname)).gt.0.or.
     +  len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yaxis%axisunit)).gt.0) then
          level=9
          tag='yaxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=10
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yaxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yaxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=9
          tag='yaxis'
          call IDF_closetag(u,level,tag)
        end if
        if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yerroraxis%axisname)).gt.0.or.
     +  len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yerroraxis%axisunit)).gt.0) then
          level=9
          tag='yerroraxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=10
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yerroraxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yerroraxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=9
          tag='yerroraxis'
          call IDF_closetag(u,level,tag)
        end if
        if (nsimpoints_idf(i,j).gt.0) then
          level=8
          tag='x'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          call IDF_writearray_real(u,level,
     +    sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%x,nsimpoints_idf(i,j))
          call IDF_closetag(u,level,tag)
          tag='xerror'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          call IDF_writearray_real(u,level,
     +    sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%xerror,nsimpoints_idf(i,j))
          call IDF_closetag(u,level,tag)
          tag='y'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          call IDF_writearray_real(u,level,
     +    sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%y,nsimpoints_idf(i,j))
          call IDF_closetag(u,level,tag)
          tag='yerror'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          call IDF_writearray_real(u,level,
     +    sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yerror,nsimpoints_idf(i,j))
          call IDF_closetag(u,level,tag)
        end if
        level=8
        tag='simpledata'
        call IDF_closetag(u,level,tag)
c     for line/efficiency
      else if (trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%datamode)).eq.'line') then
        level=8
        tag='linedata'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%lineaxis%axisname)).gt.0.or.
     +  len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%lineaxis%axisunit)).gt.0) then
          level=9
          tag='lineaxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=10
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%lineaxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%lineaxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=9
          tag='lineaxis'
          call IDF_closetag(u,level,tag)
        end if
        if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yaxis%axisname)).gt.0.or.
     +  len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yaxis%axisunit)).gt.0) then
          level=9
          tag='yaxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=10
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yaxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yaxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=9
          tag='yaxis'
          call IDF_closetag(u,level,tag)
        end if
        if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yerroraxis%axisname)).gt.0.or.
     +  len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yerroraxis%axisunit)).gt.0) then
          level=9
          tag='yerroraxis'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          level=10
          tag='axisname'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yerroraxis%axisname))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          tag='axisunit'
          content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yerroraxis%axisunit))
          call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
          level=9
          tag='yerroraxis'
          call IDF_closetag(u,level,tag)
        end if
        if (nsimpoints_idf(i,j).gt.0) then
          level=8
          tag='line'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          call IDF_writearray_string(u,level,
     +    sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%line,nsimpoints_idf(i,j))
          tag='y'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          call IDF_writearray_real(u,level,
     +    sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%y,nsimpoints_idf(i,j))
          call IDF_closetag(u,level,tag)
          tag='yerror'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          call IDF_writearray_real(u,level,
     +    sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yerror,nsimpoints_idf(i,j))
          call IDF_closetag(u,level,tag)
        end if
        level=8
        tag='linedata'
        call IDF_closetag(u,level,tag)
c     spectrum - simulation - complexdata
      else if (trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%datamode)).eq.'complex') then
        level=8
        tag='complexdata'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=9
        tag='datadimensions'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=10
        tag='datadimensionx'
        icontent=sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensionx
        call IDF_writetagwithcontent_integer(u,level,tag,attribute_names,attribute_values,nattributes,icontent,writezero)
        tag='datadimensiony'
        icontent=sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensiony
        call IDF_writetagwithcontent_integer(u,level,tag,attribute_names,attribute_values,nattributes,icontent,writezero)
        level=9
        tag='datadimensions'
        call IDF_closetag(u,level,tag)
        if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensionx.gt.0) then
          level=9
          tag='xaxes'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          do k=1,sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensionx
            level=10
            tag='axis'
            call IDF_closetag(u,level,tag)
            level=11
            tag='axisname'
            content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%xaxes%axis(k)%axisname))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            tag='axisunit'
            content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%xaxes%axis(k)%axisunit))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            level=10
            tag='axis'
            call IDF_closetag(u,level,tag)
          end do
          level=9
          tag='xaxes'
          call IDF_closetag(u,level,tag)
        end if
        if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensiony.gt.0) then
          level=9
          tag='yaxes'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          do k=1,sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensiony
            level=10
            tag='axis'
            call IDF_closetag(u,level,tag)
            level=11
            tag='axisname'
            content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%yaxes%axis(k)%axisname))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            tag='axisunit'
            content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%yaxes%axis(k)%axisunit))
            call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            level=10
            tag='axis'
            call IDF_closetag(u,level,tag)
          end do
          level=9
          tag='yaxes'
          call IDF_closetag(u,level,tag)
        end if
        if (nsimpoints_idf(i,j).gt.0) then
          level=9
          tag='dataentries'
          call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
          do k=1,nsimpoints_idf(i,j)
            level=10
            tag='dataentry'
            call IDF_closetag(u,level,tag)
            if (ndatatimestamp_idf(i).gt.0.or.
     +      len_trim(adjustl(sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry(1)%timestamp)).gt.0) then
              level=11
              tag='timestamp'
              content=trim(adjustl(
     +        sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%dataentries%dataentry(k)%timestamp))
              call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            end if
            if (ndataline_idf(i).gt.0.or.
     +      len_trim(adjustl(sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry(1)%line)).gt.0) then
              level=11
              tag='line'
              content=trim(adjustl(
     +        sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%dataentries%dataentry(k)%line))
              call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
            end if
            do k1=1,sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensionx+
     +      sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensiony
              level=11
              tag='dataitem'
              realcontent=
     +        sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%dataentries%dataentry(k)%dataitem(k1)
              call IDF_writetagwithcontent_real(u,level,tag,attribute_names,attribute_values,nattributes,realcontent,writezero)
            end do
            level=10
            tag='dataentry'
            call IDF_closetag(u,level,tag)
          end do
          level=9
          tag='dataentries'
          call IDF_closetag(u,level,tag)
        end if
        level=8
        tag='complexdata'
        call IDF_closetag(u,level,tag)
c     spectrum - data - datafile
      else if (trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%datamode)).eq.'datafile') then
        level=8
        tag='datafile'
        call IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
        level=9
        tag='filename'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%datafile%filename))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='fileformat'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%datafile%fileformat))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        tag='filesource'
        content=trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%datafile%filesource))
        call IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
        level=8
        tag='datafile'
        call IDF_closetag(u,level,tag)
      end if
      level=7
      tag='data'
      call IDF_closetag(u,level,tag)
      end if
c     end of simulation data
c----------------------------------------------------------------------------------------------------------------------------------------------

      level=6
      tag='simulation'
      call IDF_closetag(u,level,tag)
      end do
      level=5
      tag='simulations'
      call IDF_closetag(u,level,tag)
      end if
c     end of process - simulations
c----------------------------------------------------------------------------------------------------------------------------------------------
c-------------------------------------------------------------------------------

      level=4
      tag='process'
      call IDF_closetag(u,level,tag)
c----------------------------------------------------------------------------------------------------------------------------------------------
c     end of process
c----------------------------------------------------------------------------------------------------------------------------------------------

      level=3
      tag='spectrum'
      call IDF_closetag(u,level,tag)
      end do
c     close spectra
      level=2
      tag='spectra'
      call IDF_closetag(u,level,tag)
      end if
c     end of main spectra tag
c----------------------------------------------------------------------------------------------------------------------------------------------
c----------------------------------------------------------------------------------------------------------------------------------------------
c----------------------------------------------------------------------------------------------------------------------------------------------

c----------------------------------------------------------------------------------------------------------------------------------------------
c----------------------------------------------------------------------------------------------------------------------------------------------
c     close main sample tag and main idf tag
c----------------------------------------------------------------------------------------------------------------------------------------------
c----------------------------------------------------------------------------------------------------------------------------------------------
      level=1
      tag='sample'
      call IDF_closetag(u,level,tag)
      write(u,0002)
0002  format('</idf>')

1001  continue
      close(u)
	return
1000  continue
      close(u)
      idf_error='error in read_idf_realquantity, when reading tag '//trim(adjustl(idf_tag%name))//' with content '//
     +trim(adjustl(idf_tag%content))
	return
	end


c-----------------------------------------------------------------------
      subroutine IDF_opentag(u,level,tag,attribute_names,attribute_values,nattributes)
c     opens a tag with its attributes
c-----------------------------------------------------------------------
	integer u,level,nattributes
	character tag*(*),attribute_names(1)*(*),attribute_values(1)*(*)
c-----------------------------------------------------------------------
      write(u,1)trim(adjustl(tag))
1     format(<level>x,'<',a,$)
      if (nattributes.gt.0) then
        do i=1,nattributes
          write(u,2)trim(adjustl(attribute_names(i))),trim(adjustl(attribute_values(i)))
        end do
2       format(1x,a,'="',a,'"',$)
      else
      end if
      write(u,3)
3     format('>')

      return
      end

c-----------------------------------------------------------------------
      subroutine IDF_closetag(u,level,tag)
c     closes a tag
c-----------------------------------------------------------------------
	integer u,level
	character tag*(*)
c-----------------------------------------------------------------------
      write(u,1)trim(adjustl(tag))
1     format(<level>x,'</',a,'>')
      return
      end

c-----------------------------------------------------------------------
      subroutine IDF_write_stringplusspace(u,level,content)
c     writes out a string
c-----------------------------------------------------------------------
	integer u,level
	character content*(*)
c-----------------------------------------------------------------------
      write(u,1)trim(adjustl(content))
1     format(a,' ',$)

      return
      end

c-----------------------------------------------------------------------
      subroutine IDF_writetagwithcontent_string(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
c     writes out a tag together with its attributes and content
c-----------------------------------------------------------------------
	integer u,level,nattributes
	character tag*(*),attribute_names(1)*(*),attribute_values(1)*(*),content*(*)
	logical writezero
c-----------------------------------------------------------------------
c      if (trim(adjustl(tag)).eq.'geometrytype') 
c     +write(*,*)'geometrytype',len_trim(adjustl(content)),'x',trim(adjustl(content)),'x'
      if (len_trim(adjustl(content)).eq.0.and..not.writezero) return
      write(u,1)trim(adjustl(tag))
1     format(<level>x,'<',a,$)
      if (nattributes.gt.0) then
        do i=1,nattributes
          write(u,2)trim(adjustl(attribute_names(i))),trim(adjustl(attribute_values(i)))
        end do
2       format(1x,a,'="',a,'"',$)
      else
      end if
      write(u,3)trim(adjustl(content)),trim(adjustl(tag))
3     format('>',a,'</',a,'>')

      return
      end

c-----------------------------------------------------------------------
      subroutine IDF_writetagwithcontent_integer(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
c     writes out a tag together with its attributes and content
c-----------------------------------------------------------------------
	integer u,level,nattributes
	integer content
	character tag*(*),attribute_names(1)*(*),attribute_values(1)*(*)
	logical writezero
c-----------------------------------------------------------------------
      if (content.eq.0.and..not.writezero) return
      write(u,1)trim(adjustl(tag))
1     format(<level>x,'<',a,$)
      if (nattributes.gt.0) then
        do i=1,nattributes
          write(u,2)trim(adjustl(attribute_names(i))),trim(adjustl(attribute_values(i)))
        end do
2       format(1x,a,'="',a,'"',$)
      else
      end if
c     zero and negative must be treated specially!
      if (content.gt.0) then
        write(u,3)content,trim(adjustl(tag))
3       format('>',i<ceiling(log10(float(content)))+1>,'</',a,'>')
      else if (content.lt.0) then
        write(u,5)content,trim(adjustl(tag))
5       format('>',i<1+ceiling(log10(float(abs(content))))+1>,'</',a,'>')
      else
        write(u,4)trim(adjustl(tag))
4       format('>0</',a,'>')
      end if

      return
      end

c-----------------------------------------------------------------------
      subroutine IDF_writetagwithcontent_realquantity_or_spread(u,level,tag,content,writezero)
c     writes out a tag together with its attributes and content
c-----------------------------------------------------------------------
	integer u,level
      type idf_realquantity_or_spread
        real::value
        character*100::units
        character*10::mode
        character*100::quantity
        real::uncertainty
        real::uncertaintyA
        real::uncertaintyB
        real::uncertaintyplus
        real::uncertaintyminus
      end type idf_realquantity_or_spread
      type(idf_realquantity_or_spread)::content
	character tag*(*)
	logical writezero
c-----------------------------------------------------------------------
      if (content%value.eq.0..and..not.writezero) return
      write(u,1)trim(adjustl(tag))
1     format(<level>x,'<',a,$)
      if (len_trim(adjustl(content%units)).gt.0) write(u,2)'units',trim(adjustl(content%units))
      if (len_trim(adjustl(content%mode)).gt.0) write(u,2)'mode',trim(adjustl(content%mode))
      if (len_trim(adjustl(content%quantity)).gt.0) write(u,2)'quantity',trim(adjustl(content%quantity))
      if (content%uncertainty.ne.0.) write(u,4)'uncertainty',content%uncertainty
      if (content%uncertaintyA.ne.0.) write(u,4)'uncertaintyA',content%uncertaintyA
      if (content%uncertaintyB.ne.0.) write(u,4)'uncertaintyB',content%uncertaintyB
      if (content%uncertaintyplus.ne.0.) write(u,4)'uncertaintyplus',content%uncertaintyplus
      if (content%uncertaintyminus.ne.0.) write(u,4)'uncertaintyminus',content%uncertaintyminus
2     format(1x,a,'="',a,'"',$)
4     format(1x,a,'="',e14.7,'"',$)
      write(u,3)content%value,trim(adjustl(tag))
3     format('>',e14.7,'</',a,'>')

      return
      end

c-----------------------------------------------------------------------
      subroutine IDF_writetagwithcontent_real(u,level,tag,attribute_names,attribute_values,nattributes,content,writezero)
c     writes out a tag together with its attributes and content
c-----------------------------------------------------------------------
	integer u,level,nattributes
	real content
	character tag*(*),attribute_names(1)*(*),attribute_values(1)*(*)
	logical writezero
c-----------------------------------------------------------------------
      if (content.eq.0..and..not.writezero) return
      write(u,1)trim(adjustl(tag))
1     format(<level>x,'<',a,$)
      if (nattributes.gt.0) then
        do i=1,nattributes
          write(u,2)trim(adjustl(attribute_names(i))),trim(adjustl(attribute_values(i)))
        end do
2       format(1x,a,'="',a,'"',$)
      else
      end if
      write(u,3)content,trim(adjustl(tag))
3     format('>',e14.7,'</',a,'>')

      return
      end

c-----------------------------------------------------------------------
      subroutine IDF_writetagwithcontent_datetime
     +(u,level,tag,attribute_names,attribute_values,nattributes,yy,mo,dd,hh,mm,ss,writezero)
c     writes out a tag together with its attributes and content
c-----------------------------------------------------------------------
	integer u,level,nattributes
	integer yy,mo,dd,hh,mm,ss
	character tag*(*),attribute_names(1)*(*),attribute_values(1)*(*)
	logical writezero
c-----------------------------------------------------------------------
      write(u,1)trim(adjustl(tag))
1     format(<level>x,'<',a,$)
      if (nattributes.gt.0) then
        do i=1,nattributes
          write(u,2)trim(adjustl(attribute_names(i))),trim(adjustl(attribute_values(i)))
        end do
2       format(1x,a,'="',a,'"',$)
      else
      end if
      write(u,3)yy,mo,dd,hh,mm,ss,trim(adjustl(tag))
3     format('>',i4,'-',i2.2,'-',i2.2,'T',i2.2,':',i2.2,':',i2.2,'</',a,'>')

      return
      end

c-----------------------------------------------------------------------
      subroutine IDF_writearray_real(u,level,x,n)
c     writes out a tag together with its attributes and content
c-----------------------------------------------------------------------
	real x(1)
	integer u,level,n,i,j,k
c-----------------------------------------------------------------------
c      write(*,*)'IDF_writearray_real',n
      i=int(n/8)
      do k=1,i
      write(u,3)(x((k-1)*8+j),j=1,8)
      end do
      j=n-i*8
      if (j.gt.0) write(u,3)(x((k-1)*8+i),i=1,j)
3     format(8(e14.7,1x))

      return
      end

c-----------------------------------------------------------------------
      subroutine IDF_writearray_string(u,level,x,n)
c     writes out a tag together with its attributes and content
c-----------------------------------------------------------------------
      character x(1)*(*)
	integer u,level,n,i,j,k
c-----------------------------------------------------------------------
      i=int(n/8)
      do k=1,i
      write(u,3)(trim(adjustl(x((k-1)*8+j))),j=1,8)
      end do
      j=n-i*8
      if (j.gt.0) write(u,3)(trim(adjustl(x((k-1)*8+i))),i=1,j)
3     format(8(a,1x))

      return
      end

c-----------------------------------------------------------------------
      subroutine IDF_writearray_realasinteger(u,level,x,n)
c     writes out a tag together with its attributes and content
c-----------------------------------------------------------------------
	real x(1)
	integer u,level,n,i,j,k
c-----------------------------------------------------------------------
      i=int(n/8)
      do k=1,i
      write(u,3)(int(x((k-1)*8+j)+.5),j=1,8)
      end do
      j=n-i*8
      if (j.gt.0) write(u,3)(x((k-1)*8+i),i=1,j)
3     format(8(i8,1x))

      return
      end
      
c-----------------------------------------------------------------------
      subroutine IDF_noattributes(attribute_names,attribute_values,nattributes)
c     states there are no attributes
c-----------------------------------------------------------------------
	integer nattributes
	character attribute_names(1)*(*),attribute_values(1)*(*)
c-----------------------------------------------------------------------
      attribute_names=' '
      attribute_values=' '
      nattributes=0
      return
      end

c-----------------------------------------------------------------------
	subroutine get_auxiliary_variables_idf
      !DEC$ ATTRIBUTES DLLEXPORT::get_auxiliary_variables_idf
c     gets some basic variables, that mostly control the dimentions of the problem, from what is in the current "sample" data structure
c     if any of these basic variables previously existed, they all get erased, and then they are defined anew
	use IDFCOM
	implicit none
	integer i,j,k
c-----------------------------------------------------------------------
      if (sample%spectra%n.gt.0) then
        idfnspectra=sample%spectra%n
      else
        idfnspectra=size(sample%spectra%spectrum)
        sample%spectra%n=idfnspectra
      end if
      idfnelements=sample%elementsandmolecules%nelements
      idfnmolecules=sample%elementsandmolecules%nmolecules
c     these two are hard coded, which should not be necessary and should be changed in the future
      idfnfoillayers=20
      idfndetectorefficiency=20

c     this now allocates the basic variables based on the five basic variables given above.
      call allocate_secondary_variables_idf

c     now all basic variables must be filed with values, based on what is in the current "sample" data structure
c     first variables that do not depend on spectrum
c     pointbypointstructure
      npbp_element_idf=0
      if (sample%structure%pointbypointstructure%n.gt.0) then
        npbp_element_idf=sample%structure%pointbypointstructure%n
      else if (allocated(sample%structure%pointbypointstructure%pbpelement)) then
        npbp_element_idf=size(sample%structure%pointbypointstructure%pbpelement)
        sample%structure%pointbypointstructure%n=npbp_element_idf
      end if
      do i=1,npbp_element_idf
        if (sample%structure%pointbypointstructure%pbpelement(i)%n.gt.0) then
          npbp_idf(i)=sample%structure%pointbypointstructure%pbpelement(i)%n
        else if (allocated(sample%structure%pointbypointstructure%pbpelement(i)%pbp)) then
          npbp_idf(i)=size(sample%structure%pointbypointstructure%pbpelement(i)%pbp)
          sample%structure%pointbypointstructure%pbpelement(i)%n=npbp_idf(i)
        end if
        do j=1,idfnelements
c         nlayerspbp_idf is in fact not needed, it should come from %n
          if (sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%n.gt.0) then
            nlayerspbp_idf(i,j)=sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%n
          else if (allocated(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%x)) then
            nlayerspbp_idf(i,j)=size(sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%x)
            sample%structure%pointbypointstructure%pbpelement(i)%pbp(j)%n=nlayerspbp_idf(i,j)
          end if
        end do
      end do

c     all this requires spectrum to be allocated! But if it is, then sample%spectra%n>0
c     now spectrum vectors
      do i=1,sample%spectra%n
c       first integer variables
c       stoppingfoil
        if (sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%n.gt.0) then
          nstoppingfoillayers_idf(i)=sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%n
        else if (allocated(sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer)) then
          nstoppingfoillayers_idf(i)=size(sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer)
          sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%n=nstoppingfoillayers_idf(i)
        end if
        do j=1,nstoppingfoillayers_idf(i)
          if (sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%layerelements%n.gt.0) then
            nstoppingfoilels_idf(i,j)=sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%layerelements%n
          else if (allocated(sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%layerelements%layerelement)) then
            nstoppingfoilels_idf(i,j)=
     +      size(sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%layerelements%layerelement)
            sample%spectra%spectrum(i)%detection%stoppingfoil%foillayers%layer(j)%layerelements%n=nstoppingfoilels_idf(i,j)
          end if
        end do
c       beamchargestate
        if (sample%spectra%spectrum(i)%beam%beamchargestate%n.gt.0) then
          nbeamchargestate_idf(i)=sample%spectra%spectrum(i)%beam%beamchargestate%n
        else if (allocated(sample%spectra%spectrum(i)%beam%beamchargestate%x)) then
          nbeamfoillayers_idf(i)=size(sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer)
          sample%spectra%spectrum(i)%beam%beamchargestate%n=nbeamchargestate_idf(i)
        end if
c       beamfoil
        if (sample%spectra%spectrum(i)%beam%beamfoil%foillayers%n.gt.0) then
          nbeamfoillayers_idf(i)=sample%spectra%spectrum(i)%beam%beamfoil%foillayers%n
        else if (allocated(sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer)) then
          nbeamfoillayers_idf(i)=size(sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer)
          sample%spectra%spectrum(i)%beam%beamfoil%foillayers%n=nbeamfoillayers_idf(i)
        end if
        do j=1,nbeamfoillayers_idf(i)
          if (sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layerelements%n.gt.0) then
            nbeamfoilels_idf(i,j)=sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layerelements%n
          else if (allocated(sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layerelements%layerelement)) then
            nbeamfoilels_idf(i,j)=size(sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layerelements%layerelement)
            sample%spectra%spectrum(i)%beam%beamfoil%foillayers%layer(j)%layerelements%n=nbeamfoilels_idf(i,j)
          end if
        end do
c       entrancewindow
        if (sample%spectra%spectrum(i)%detection%detector%entrancewindow%n.gt.0) then
          nentrancewindow_idf(i)=sample%spectra%spectrum(i)%detection%detector%entrancewindow%n
        else if (allocated(sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer)) then
          nentrancewindow_idf(i)=size(sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer)
          sample%spectra%spectrum(i)%detection%detector%entrancewindow%n=nentrancewindow_idf(i)
        end if
        do j=1,nentrancewindow_idf(i)
          if (sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%layerelements%n.gt.0) then
            nentrancewindowels_idf(i,j)=sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%layerelements%n
          else if (allocated(sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%layerelements%layerelement)) then
            nentrancewindowels_idf(i,j)=
     +      size(sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%layerelements%layerelement)
            sample%spectra%spectrum(i)%detection%detector%entrancewindow%layer(j)%layerelements%n=nentrancewindowels_idf(i,j)
          end if
        end do
c       detectorlayers
        if (sample%spectra%spectrum(i)%detection%detector%detectorlayers%n.gt.0) then
          ndetectorlayers_idf(i)=sample%spectra%spectrum(i)%detection%detector%detectorlayers%n
        else if (allocated(sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer)) then
          ndetectorlayers_idf(i)=size(sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer)
          sample%spectra%spectrum(i)%detection%detector%detectorlayers%n=ndetectorlayers_idf(i)
        end if
        do j=1,ndetectorlayers_idf(i)
          if (sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%layerelements%n.gt.0) then
            ndetectorlayersels_idf(i,j)=sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%layerelements%n
          else if (allocated(sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%layerelements%layerelement)) then
            ndetectorlayersels_idf(i,j)=
     +      size(sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%layerelements%layerelement)
            sample%spectra%spectrum(i)%detection%detector%detectorlayers%layer(j)%layerelements%n=ndetectorlayersels_idf(i,j)
          end if
        end do
c       startfoil
        if (sample%spectra%spectrum(i)%detection%detector%tof%startfoil%n.gt.0) then
          ntofstartfoil_idf(i)=sample%spectra%spectrum(i)%detection%detector%tof%startfoil%n
        else if (allocated(sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer)) then
          ntofstartfoil_idf(i)=size(sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer)
          sample%spectra%spectrum(i)%detection%detector%tof%startfoil%n=ntofstartfoil_idf(i)
        end if
        do j=1,ntofstartfoil_idf(i)
          if (sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%layerelements%n.gt.0) then
            ntofstartfoilels_idf(i,j)=sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%layerelements%n
          else if (allocated(sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%layerelements%layerelement)) then
            ntofstartfoilels_idf(i,j)=
     +      size(sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%layerelements%layerelement)
            sample%spectra%spectrum(i)%detection%detector%tof%startfoil%layer(j)%layerelements%n=ntofstartfoilels_idf(i,j)
          end if
        end do
c       stopfoil
        if (sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%n.gt.0) then
          ntofstopfoil_idf(i)=sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%n
        else if (allocated(sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer)) then
          ntofstopfoil_idf(i)=size(sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer)
          sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%n=ntofstopfoil_idf(i)
        end if
        do j=1,ntofstopfoil_idf(i)
          if (sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%layerelements%n.gt.0) then
            ntofstopfoilels_idf(i,j)=sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%layerelements%n
          else if (allocated(sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%layerelements%layerelement)) then
            ntofstopfoilels_idf(i,j)=
     +      size(sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%layerelements%layerelement)
            sample%spectra%spectrum(i)%detection%detector%tof%stopfoil%layer(j)%layerelements%n=ntofstopfoilels_idf(i,j)
          end if
        end do
c       slitsaftersample
        if (sample%spectra%spectrum(i)%detection%slitsaftersample%n.gt.0) then
          nslitsaftersample_idf(i)=sample%spectra%spectrum(i)%detection%slitsaftersample%n
        else if (allocated(sample%spectra%spectrum(i)%detection%slitsaftersample%slit)) then
          nslitsaftersample_idf(i)=size(sample%spectra%spectrum(i)%detection%slitsaftersample%slit)
          sample%spectra%spectrum(i)%detection%slitsaftersample%n=nslitsaftersample_idf(i)
        end if
c       slitsbeforesample
        if (sample%spectra%spectrum(i)%beam%slitsbeforesample%n.gt.0) then
          nslitsbeforesample_idf(i)=sample%spectra%spectrum(i)%beam%slitsbeforesample%n
        else if (allocated(sample%spectra%spectrum(i)%beam%slitsbeforesample%slit)) then
          nslitsbeforesample_idf(i)=size(sample%spectra%spectrum(i)%beam%slitsbeforesample%slit)
          sample%spectra%spectrum(i)%beam%slitsbeforesample%n=nslitsbeforesample_idf(i)
        end if
c       deadlayer
        if (sample%spectra%spectrum(i)%detection%detector%deadlayer%layerelements%n.gt.0) then
          ndeadlayerels_idf(i)=sample%spectra%spectrum(i)%detection%detector%deadlayer%layerelements%n
          ndeadlayer_idf(i)=1
        else if (allocated(sample%spectra%spectrum(i)%detection%detector%deadlayer%layerelements%layerelement)) then
          ndeadlayerels_idf(i)=size(sample%spectra%spectrum(i)%detection%detector%deadlayer%layerelements%layerelement)
          ndeadlayer_idf(i)=1
          sample%spectra%spectrum(i)%detection%detector%deadlayer%layerelements%n=ndeadlayerels_idf(i)
        end if
c       detectorefficiency
        if (sample%spectra%spectrum(i)%calibrations%detectorefficiencies%n.gt.0) then
          ndetectorefficiency_idf(i)=sample%spectra%spectrum(i)%calibrations%detectorefficiencies%n
        else if (allocated(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency)) then
          ndetectorefficiency_idf(i)=size(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency)
          sample%spectra%spectrum(i)%calibrations%detectorefficiencies%n=ndetectorefficiency_idf(i)
        end if
        do j=1,ndetectorefficiency_idf(i)
          if (sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%n.gt.0) then
            ndetectorefficiencyentries_idf(i,j)=
     +      sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%n
            efficiencymode_idf(i,j)='energy'
          else if (sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%n.gt.0) then
            ndetectorefficiencyentries_idf(i,j)=
     +      sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%n
            efficiencymode_idf(i,j)='line'
          else if (allocated(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency)) then
            if (allocated(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%x)) then
              ndetectorefficiencyentries_idf(i,j)=
     +        size(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%x)
              sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%efficiency%n=
     +        ndetectorefficiencyentries_idf(i,j)
              efficiencymode_idf(i,j)='energy'
            else if 
     +      (allocated(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%line)) then
              ndetectorefficiencyentries_idf(i,j)=
     +        size(sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%line)
              sample%spectra%spectrum(i)%calibrations%detectorefficiencies%detectorefficiency(j)%lineefficiency%n=
     +        ndetectorefficiencyentries_idf(i,j)
              efficiencymode_idf(i,j)='line'
            end if
          end if
        end do
c       detectorresolution
        if (sample%spectra%spectrum(i)%calibrations%detectorresolutions%n.gt.0) then
          ndetectorresolution_idf(i)=sample%spectra%spectrum(i)%calibrations%detectorresolutions%n
        else if (allocated(sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution)) then
          ndetectorresolution_idf(i)=size(sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution)
          sample%spectra%spectrum(i)%calibrations%detectorresolutions%n=ndetectorresolution_idf(i)
        end if
        do j=1,ndetectorresolution_idf(i)
          if (sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%resolutionparameters%n.gt.0) then
            nresolutionparameter_idf(i,j)=sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%
     +      resolutionparameters%n
          else if (allocated(sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%
     +    resolutionparameters%resolutionparameter)) then
            nresolutionparameter_idf(i,j)=size(sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%
     +      resolutionparameters%resolutionparameter)
            sample%spectra%spectrum(i)%calibrations%detectorresolutions%detectorresolution(j)%resolutionparameters%n
     +      =nresolutionparameter_idf(i,j)
          end if
        end do
c       energycalibration
        if (sample%spectra%spectrum(i)%calibrations%energycalibrations%n.gt.0) then
          nenergycalibration_idf(i)=sample%spectra%spectrum(i)%calibrations%energycalibrations%n
        else if (allocated(sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration)) then
          nenergycalibration_idf(i)=size(sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration)
          sample%spectra%spectrum(i)%calibrations%energycalibrations%n=nenergycalibration_idf(i)
        end if
        do j=1,nenergycalibration_idf(i)
          if (sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%calibrationparameters%n.gt.0) then
            ncalibrationparameter_idf(i,j)=
     +      sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%calibrationparameters%n
          else if (allocated(sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%
     +    calibrationparameters%calibrationparameter)) then
            ncalibrationparameter_idf(i,j)=size(sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%
     +      calibrationparameters%calibrationparameter)
            sample%spectra%spectrum(i)%calibrations%energycalibrations%energycalibration(j)%calibrationparameters%n
     +      =ncalibrationparameter_idf(i,j)
          end if
        end do
c       reactionlist
        if (sample%spectra%spectrum(i)%reactions%reactionlist%n.gt.0) then
          nreaction_idf(i)=sample%spectra%spectrum(i)%reactions%reactionlist%n
        else if (allocated(sample%spectra%spectrum(i)%reactions%reactionlist%reaction)) then
          nreaction_idf(i)=size(sample%spectra%spectrum(i)%reactions%reactionlist%reaction)
          sample%spectra%spectrum(i)%reactions%reactionlist%n=nreaction_idf(i)
        end if

c       data
        if (sample%spectra%spectrum(i)%data%simpledata%n.gt.0) then
          sample%spectra%spectrum(i)%data%datamode='simple'
          datamode_idf(i)='simple'
          ndatapoints_idf(i)=sample%spectra%spectrum(i)%data%simpledata%n
        else if (sample%spectra%spectrum(i)%data%linedata%n.gt.0) then
          sample%spectra%spectrum(i)%data%datamode='line'
          datamode_idf(i)='line'
          ndatapoints_idf(i)=sample%spectra%spectrum(i)%data%linedata%n
        else if (sample%spectra%spectrum(i)%data%complexdata%dataentries%n.gt.0) then
          sample%spectra%spectrum(i)%data%datamode='complex'
          datamode_idf(i)='complex'
          ndatapoints_idf(i)=sample%spectra%spectrum(i)%data%complexdata%dataentries%n
          if (sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensionx.gt.0) then
            datadimensionx_idf(i)=sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensionx
          else if (allocated(sample%spectra%spectrum(i)%data%complexdata%xaxes%axis)) then
            datadimensionx_idf(i)=size(sample%spectra%spectrum(i)%data%complexdata%xaxes%axis)
            sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensionx=datadimensionx_idf(i)
          end if
          if (sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensiony.gt.0) then
            datadimensiony_idf(i)=sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensiony
          else if (allocated(sample%spectra%spectrum(i)%data%complexdata%yaxes%axis)) then
            datadimensiony_idf(i)=size(sample%spectra%spectrum(i)%data%complexdata%yaxes%axis)
            sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensiony=datadimensiony_idf(i)
          end if
        else if (len_trim(adjustl(sample%spectra%spectrum(i)%data%datafile%filename)).gt.0) then
          sample%spectra%spectrum(i)%data%datamode='datafile'
          datamode_idf(i)='datafile'
        else
          if (allocated(sample%spectra%spectrum(i)%data%simpledata%x)) then
            ndatapoints_idf(i)=size(sample%spectra%spectrum(i)%data%simpledata%x)
            sample%spectra%spectrum(i)%data%simpledata%n=ndatapoints_idf(i)
          else if (allocated(sample%spectra%spectrum(i)%data%simpledata%xerror)) then
            ndatapoints_idf(i)=size(sample%spectra%spectrum(i)%data%simpledata%xerror)
            sample%spectra%spectrum(i)%data%simpledata%n=ndatapoints_idf(i)
          else if (allocated(sample%spectra%spectrum(i)%data%simpledata%y)) then
            ndatapoints_idf(i)=size(sample%spectra%spectrum(i)%data%simpledata%y)
            sample%spectra%spectrum(i)%data%simpledata%n=ndatapoints_idf(i)
          else if (allocated(sample%spectra%spectrum(i)%data%simpledata%yerror)) then
            ndatapoints_idf(i)=size(sample%spectra%spectrum(i)%data%simpledata%yerror)
            sample%spectra%spectrum(i)%data%simpledata%n=ndatapoints_idf(i)
          else if (allocated(sample%spectra%spectrum(i)%data%linedata%line)) then
            ndatapoints_idf(i)=size(sample%spectra%spectrum(i)%data%linedata%line)
            sample%spectra%spectrum(i)%data%linedata%n=ndatapoints_idf(i)
          else if (allocated(sample%spectra%spectrum(i)%data%linedata%y)) then
            ndatapoints_idf(i)=size(sample%spectra%spectrum(i)%data%linedata%y)
            sample%spectra%spectrum(i)%data%linedata%n=ndatapoints_idf(i)
          else if (allocated(sample%spectra%spectrum(i)%data%linedata%yerror)) then
            ndatapoints_idf(i)=size(sample%spectra%spectrum(i)%data%linedata%yerror)
            sample%spectra%spectrum(i)%data%linedata%n=ndatapoints_idf(i)
          else if (allocated(sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry)) then
            ndatapoints_idf(i)=size(sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry)
            sample%spectra%spectrum(i)%data%linedata%n=ndatapoints_idf(i)
            if (sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensionx.gt.0) then
              datadimensionx_idf(i)=sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensionx
            else if (allocated(sample%spectra%spectrum(i)%data%complexdata%xaxes%axis)) then
              datadimensionx_idf(i)=size(sample%spectra%spectrum(i)%data%complexdata%xaxes%axis)
              sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensionx=datadimensionx_idf(i)
            end if
            if (sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensiony.gt.0) then
              datadimensiony_idf(i)=sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensiony
            else if (allocated(sample%spectra%spectrum(i)%data%complexdata%yaxes%axis)) then
              datadimensiony_idf(i)=size(sample%spectra%spectrum(i)%data%complexdata%yaxes%axis)
              sample%spectra%spectrum(i)%data%complexdata%datadimensions%datadimensiony=datadimensiony_idf(i)
            end if
          end if
        end if

c       simulation big group
        if (sample%spectra%spectrum(i)%process%simulations%n.gt.0) then
          nsimulation_idf(i)=sample%spectra%spectrum(i)%process%simulations%n
        else if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation)) then
          nsimulation_idf(i)=size(sample%spectra%spectrum(i)%process%simulations%simulation)
          sample%spectra%spectrum(i)%process%simulations%n=nsimulation_idf(i)
        end if
        do j=1,nsimulation_idf(i)
c         crosssections
          if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%n.gt.0) then
            ncrosssection_idf(i,j)=sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%n
          else if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection)) then
            ncrosssection_idf(i,j)=
     +      size(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection)
            sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%n=ncrosssection_idf(i,j)
          end if
          do k=1,ncrosssection_idf(i,j)
            if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +      crosssectiondata%n.gt.0) then
              ncrosssectionpoints_idf(i,j,k)=sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +        crosssections%crosssection(k)%crosssectiondata%n
            else if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%
     +      crosssectiondata%x)) then
              ncrosssectionpoints_idf(i,j,k)=size(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +        crosssections%crosssection(k)%crosssectiondata%x)
              sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%crosssections%crosssection(k)%crosssectiondata%n
     +        =ncrosssectionpoints_idf(i,j,k)
            end if
          end do
c         stoppingpowers
          if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%n.gt.0) then
            nstoppingpower_idf(i,j)=sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%n
          else if 
     +    (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower)) then
            nstoppingpower_idf(i,j)=
     +      size(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower)
            sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%n=nstoppingpower_idf(i,j)
          end if
          do k=1,nstoppingpower_idf(i,j)
            if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower(k)%
     +      stoppingpowerdata%n.gt.0) then
              nstoppingpowerpoints_idf(i,j,k)=sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +        stoppingpowers%stoppingpower(k)%stoppingpowerdata%n
            else if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%stoppingpowers%stoppingpower(k)%
     +      stoppingpowerdata%x)) then
              nstoppingpowerpoints_idf(i,j,k)=size(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +        stoppingpowers%stoppingpower(k)%stoppingpowerdata%x)
              sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +        stoppingpowers%stoppingpower(k)%stoppingpowerdata%n=nstoppingpowerpoints_idf(i,j,k)
            end if
          end do
c         energyspreads
          if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%n.gt.0) then
            nenergyspread_idf(i,j)=sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%n
          else if 
     +    (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread)) then
            nenergyspread_idf(i,j)=
     +      size(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread)
            sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%n=nenergyspread_idf(i,j)
          end if
          do k=1,nenergyspread_idf(i,j)
            if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread(k)%
     +      energyspreaddata%n.gt.0) then
              nenergyspreadpoints_idf(i,j,k)=sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +        energyspreads%energyspread(k)%energyspreaddata%n
            else if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread(k)%
     +      energyspreaddata%x)) then
              nenergyspreadpoints_idf(i,j,k)=
     +        size(sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%energyspreads%energyspread(k)%
     +        energyspreaddata%x)
              sample%spectra%spectrum(i)%process%simulations%simulation(j)%physics%
     +        energyspreads%energyspread(k)%energyspreaddata%n=nenergyspreadpoints_idf(i,j,k)
            end if
          end do
c         simulation data
          if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%n.gt.0) then
            sample%spectra%spectrum(i)%process%simulations%simulation(j)%datamode='simple'
            simmode_idf(i,j)='simple'
            nsimpoints_idf(i,j)=sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%n
          else if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%n.gt.0) then
            sample%spectra%spectrum(i)%process%simulations%simulation(j)%datamode='line'
            simmode_idf(i,j)='line'
            nsimpoints_idf(i,j)=sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%n
          else if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%dataentries%n.gt.0) then
            sample%spectra%spectrum(i)%process%simulations%simulation(j)%datamode='complex'
            simmode_idf(i,j)='complex'
            nsimpoints_idf(i,j)=sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%dataentries%n
            if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensionx.gt.0) then
              simdimensionx_idf(i,j)=
     +        sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensionx
            else if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%xaxes%axis)) then
              simdimensionx_idf(i,j)=size(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%xaxes%axis)
              sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensionx=
     +        simdimensionx_idf(i,j)
            end if
            if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensiony.gt.0) then
              simdimensiony_idf(i,j)=
     +        sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensiony
            else if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%yaxes%axis)) then
              simdimensiony_idf(i,j)=size(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%yaxes%axis)
              sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensiony=
     +        simdimensiony_idf(i,j)
            end if
          else if (len_trim(adjustl(sample%spectra%spectrum(i)%process%simulations%simulation(j)%datafile%filename)).gt.0) then
            sample%spectra%spectrum(i)%process%simulations%simulation(j)%datamode='datafile'
            simmode_idf(i,j)='datafile'
          else
            if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%x)) then
              simmode_idf(i,j)='simple'
              nsimpoints_idf(i,j)=size(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%x)
              sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%n=nsimpoints_idf(i,j)
            else if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%xerror)) then
              simmode_idf(i,j)='simple'
              nsimpoints_idf(i,j)=size(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%xerror)
              sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%n=nsimpoints_idf(i,j)
            else if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%y)) then
              simmode_idf(i,j)='simple'
              nsimpoints_idf(i,j)=size(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%y)
              sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%n=nsimpoints_idf(i,j)
            else if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yerror)) then
              simmode_idf(i,j)='simple'
              nsimpoints_idf(i,j)=size(sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%yerror)
              sample%spectra%spectrum(i)%process%simulations%simulation(j)%simpledata%n=nsimpoints_idf(i,j)
            else if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%line)) then
              simmode_idf(i,j)='line'
              nsimpoints_idf(i,j)=size(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%line)
              sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%n=nsimpoints_idf(i,j)
            else if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%y)) then
              simmode_idf(i,j)='line'
              nsimpoints_idf(i,j)=size(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%y)
              sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%n=nsimpoints_idf(i,j)
            else if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yerror)) then
              simmode_idf(i,j)='line'
              nsimpoints_idf(i,j)=size(sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%yerror)
              sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%n=nsimpoints_idf(i,j)
            else if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%dataentries%dataentry)) then
              simmode_idf(i,j)='complex'
              nsimpoints_idf(i,j)=
     +          size(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%dataentries%dataentry)
              sample%spectra%spectrum(i)%process%simulations%simulation(j)%linedata%n=nsimpoints_idf(i,j)
              if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensionx.gt.0) then
                datadimensionx_idf(i)=
     +          sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensionx
              else if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%xaxes%axis)) then
                datadimensionx_idf(i)=size(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%xaxes%axis)
                sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensionx=
     +          datadimensionx_idf(i)
              end if
              if (sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensiony.gt.0) then
                datadimensiony_idf(i)=
     +          sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensiony
              else if (allocated(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%yaxes%axis)) then
                datadimensiony_idf(i)=size(sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%yaxes%axis)
                sample%spectra%spectrum(i)%process%simulations%simulation(j)%complexdata%datadimensions%datadimensiony=
     +          datadimensiony_idf(i)
              end if
            end if
          end if
        end do

c       these are the remaining spectrum character quantities
        ndatatimestamp_idf(i)=0
        ndataline_idf(i)=0
        if (allocated(sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry)) then
        if (len_trim(adjustl(sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry(1)%timestamp)).gt.0) then
          ndatatimestamp_idf(i)=1
        end if
        if (len_trim(adjustl(sample%spectra%spectrum(i)%data%complexdata%dataentries%dataentry(1)%line)).gt.0) then
          ndataline_idf(i)=1
        end if
        end if
      end do

1000  continue
      idf_ok=.true.
      idf_error=' '
	return
	end
